
;daycount   defb 0   ; USED TO RANDOMIZE QUESTS BY DAY 0-27
;nighttime  defb 0   ; USED TO TELL IF IT IS DAY OR NIGHT
;season     defb 0   ; SEASON 0-3 SPRING SUMMER AUTUMN WINTER
;weekday    defb 0   ; WEEKDAY 0-6 

; INPUT
; HL = TIME
timestr: defb "TIME ",14:time
         defb 0,255
 
; INPUT 
; A = TIME
updatestatusbartime:
  ; DEBUG PRINT TIME ON STATUS BAR
  ;ld hl,screenadr+1600+160+4
  
  ;ld bc,(time)
  ;call kl_time_please
  ;ld a,h               ; CHANGE TO LD A,E (WAS LD A,H) TO GET LONGER TIME PERIODS
  ;call convbytetostr

  ;ld a,(bytetostring+0)
  ; IF TIME BYTE OVER 200, MAKE IT NIGHT TIME
  cp 200
  jr z,setdoingpenswapday
  cp 255
  jr z,setdoingpenswapnight
 
  ;ld hl,timestr
  ;call statusbarprintparagraphnoscroll

  ; CHECK IF WE ARE STILL DOING PEN SWAP BUT NOT STARTING IT (A = NOT 0 OR 200)
  ld a,0:doingdaychange
  or a
  ret z
  cp 1
  jr z,changenighttoday
  cp 2
  jr z,changedaytonight

; PALETTE SELECTOR FOR NIGHT TIME
; BIT 0 SET   = NIGHT
; BIT 0 CLEAR = DAY
; BIT 1 SET   = UNDERWATER
; BIT 1 CLEAR = LAND
; COPIES OF ABOVE BITS STORED SO WE KNOW WHAT CURRENT SCREEN PALETTE IS SET TO - SAVES US HAVING TO CHANGE PALETTE EVERY TIME
; BIT 2       = CURRENT PALLETE DAY NIGHT
; BIT 3       = CURRENT PALLETE LAND UNDERWATER

changedaytonight:
  ; CHECK IF WE ARE UNDERWATER, IF SO USE THAT PALETTE
  ld a,(nighttime)
  bit 1,a
  jr z,setlandnightpalette
  ld hl,penswater_night
  set 0,a
  jr dopensswap

  ; OTHERWISE USE NIGHT PALETTE
  setlandnightpalette:
  ld hl,pens_night
  set 0,a
  jr dopensswap

changenighttoday:
  ; CHECK IF WE ARE UNDERWATER, IF SO USE THAT PALETTE
  ld a,(nighttime)
  bit 1,a
  jr z,setlanddaypalette
  ld hl,penswater
  res 0,a
  jr dopensswap

  setlanddaypalette:
  ld hl,pens
  res 0,a

  dopensswap:
  ld (nighttime),a
  push af   ; STORE NIGHT DAY TIME VAR
  ; CHANGE PEN ONE AT A TIME
  ld a,(changedpenid-1)
  ld c,a
  ld b,0
  ; FIND PEN TO CHANGE
  add hl,bc
  ; SET INK
  ld c,(hl)   
  ld b,c  
  call scr_set_ink

  pop af     ; CHECK IF DAY OR NIGHT
  bit 0,a
  jr z,decrementpen

  ; INCREMENT PEN (MAKE DAY)
  ld a,(changedpenid-1)
  inc a
  cp 16
  jr z,setfinishedpenswap
  setchangedpen:
  ld (changedpenid-1),a
ret
; IF 0, WE DO NOT NEED TO DO ANYTHING
; IF 1, WE NEED TO CHANGE PENS

setdoingpenswapday:
  ld a,1
  ld (doingdaychange-1),a
ret
setdoingpenswapnight:
  ld a,2
  ld (doingdaychange-1),a
ret
setfinishedpenswap:
  xor a
  ld (doingdaychange-1),a
ret

incrementdaycount:
  ; RESET SHOP INVENTORIES
  call decrementinventoryeachday

  ld a,0:daycount
  inc a
  ld (daycount-1),a
  ; INCREMENT WEEK DAY
  ld hl,weekday
  inc (hl)
  ;ld (weekday),a
  
  call printseason           ; CHECK IF SEASON NEEDS CHANGED
  call clearcompletedquests  ; CLEAR COMPLETED RANDOM QUESTS
  call clearkilledcharacters ; CLEAR DEAD CHARACTERS SO WE HAVE ROOM FOR MORE SPRITES
  xor a
  ld (changedpenid-1),a
  jr setchangedpen

; FIND CHANGED PEN
; INPUTS
; D = CHECK FOR DAY 0 OR NIGHT 1
decrementpen:
  ld a,0:changedpenid
  dec a
  cp 255  ; DON'T GO BEYOND PEN 0
  jr z,setfinishedpenswap
  ld (changedpenid-1),a
  or a
  jr z,incrementdaycount
  jr setchangedpen

resetdaycount:
  xor a
  ld (daycount-1),a
ret
resetweekday:
  xor a
  ld (weekday),a
ret
setnewseason:
  ; INC SEASON
  ld a,(season)
  inc a
  cp 4
  jr nz,saveseason
  xor a
  saveseason:
  ld (season),a
  jr resetdaycount

printseason:
  ; PRINT SEASON ON STATUS BAR
  ;call clearstatusbaricon
  ld hl,seasonlist

  ld a,(daycount-1)
  cp 29 ; 28 DAYS IN EACH MONTH
  call z,setnewseason
  ld a,(season)
  call vectorlookup
  ld hl,space_seasonpos
  call gra_wr_string2

  ; PRINT DAY ON STATUS BAR
  ld hl,daylist
  ld a,(weekday)
  cp 7 ; 7 DAYS IN EACH WEEK
  call z,resetweekday
  call vectorlookup
  ld hl,space_iconpos
  call gra_wr_string2

  ; PRINT DAY NUMBER
  ld a,(daycount-1)
  inc a
  call convbytetostr
  ld de,bytetostring+1
  ld hl,space_iconpos+10
  jp gra_wr_string2

txt_spring:  defb "SPRING",255
txt_summer:  defb "SUMMER",255
txt_autumn:  defb "AUTUMN",255
txt_winter:  defb "WINTER",255

seasonlist:
  defw txt_spring
  defw txt_summer
  defw txt_autumn
  defw txt_winter

txt_sun:  defb "SUN",255
txt_mon:  defb "MON",255
txt_tue:  defb "TUE",255
txt_wed:  defb "WED",255
txt_thu:  defb "THU",255
txt_fri:  defb "FRI",255
txt_sat:  defb "SAT",255

daylist:
  defw txt_sun
  defw txt_mon
  defw txt_tue
  defw txt_wed
  defw txt_thu
  defw txt_fri
  defw txt_sat