; GENERATING TOWNS
; TAKE BLOCK SEED
;   GENERATE TOWN SEED BY TWISTING
;     TOWN SEED NEEDS TO CONTAIN GLOBAL COORDINATE OF TOWN IE 0-99,0-99
;     BE USED TO GENERATE TOWN NAME
;
;     CAN SEED BE BASED ON A SUM OF GLOBAL AND LOCAL MAP COORDINATES?
;     IF SO HOW TO STOP ALL ROWS HAVING SAME TOWN NAME ENDING?

;     SEED BE STORED IN A LIST FOR QUESTS
;     SEED SHOULD ONLY BE STORED IN LIST IF WE CAN PHYSICALLY BUILD THE TOWN

genlocalgamemaps:
  ; CLEAR OLD DATA
  call cleargamemap
  call buildthesea

  ; MAKE SURE WE ARE CALCULATING BASED ON CURRENT BLOCK ID
  call resetpseudorandomblock 
  ; INSERT TILES THAT CAN BE BROKEN UP BY TOWNS
  call getranlocalmappos
  call doinsertforest_cf
  call getranlocalmappos
  call doinsertbigtown_cf

  ; INSERT SPRITE BLOCK DEFINITIONS INTO MAP IF THEY EXIST FOR THIS BLOCK ID
  call insertblockxy

  ; INSERT STATIC MAP DATA
  call checkstaticmapdefs
  ld ix,playerspritedata
  bit 7,(ix+2)
  call nz,checkstaticmapdefunderwater
 
  ; GENERATE RANDOM SCENERY, HILLS, FORESTS, ISLANDS
  ; THESE ARE LARGE TILES THAT CAN'T BE BROKEN UP BY TOWNS
  call getranlocalmappos
  call doinsertisland_cf
  call getranlocalmappos
  call doinsertmount_cf
  call getranlocalmappos
  call doinsertlake_cf

  ; GET RANDOM TOWN TYPE TO BUILD BASED ON ZONE
  ld hl,randomtownbyzone
  ld a,(currzonedata)
  ld b,0
  ld c,a
  add hl,bc
  ld c,(hl)  ; LOAD RANDOM TOWN IDENTIFIER INTO C
  
  ; INSERT RANDOM TOWN INTO MAP IF NEEDED
  ld h,gamemap2h
  ld b,30                        ; MAX NUMBER OF RANDOM POINTS TO GENERATE

  ; INPUTS
  ; B = NUMBER OF POINTS TO INSERT INTO BLOCK OF 10X10 (256 ALLOCATED TO MAKE IT SIMPLE)
  ; C = BYTE TO SET
  loopit:
    call rand      ; GET RAND OF 256
    ld l,a
    ld a,(hl)      ; DO NOT INSERT INTO MAP SQUARE IF IT IS ALREADY OCCUPIED
    or a
    jr nz,skipbyteinsert
    ld (hl),c      ; INSERT BYTE INTO MAP
    skipbyteinsert:
  djnz loopit
ret

;  defb 9,&FF     ; 0 zone_empty,PLAINS - GREEN
;  defb 9,&FF     ; 1 zone_forest,FOREST - GREEN
;  defb 9,&FF     ; 2 zone_indian,INDIAN - GREEN
;  defb 9,&FF     ; 3 zone_knights,KNIGHTS - GREEN
;  defb 15,&FC    ; 4 zone_western,WESTERN - ORANGE
;  defb 9,&FF     ; 5 zone_indian,TROPICAL - GREEN
;  defb 10,&0F    ; 6 zone_tropical,SEA - MAUVE
;  defb 10,&0F    ; 7 zone_sea,WINTER - BLUE
;  defb 9,&FF     ; 8 zone_winter,AUTUMN - GREEN
;  defb 9,&FF     ; 9 zone_autumn,AUTUMN - GREEN

mapdef_bigtown:
  defb 3;,3 ; WIDTH / HEIGHT
  defb 0,b_streetsnorth,0
  defb b_streetswest,b_streets,b_streetseast
  defb 0,b_streetssouth,0
  defb 255 ; END OF LIST

mapdef_abbey:
  defb 4;,4 ; WIDTH / HEIGHT
  defb b_stonewalltopleft,    b_stonewallhoriz,         b_stonewallhoriz, b_stonewalltopright
  defb b_stonewallvert,       b_buildabbeytl,           b_buildabbeytr,   b_stonewallvert
  defb b_stonewallvert,       b_buildabbeybl,           b_buildabbeybr,   b_stonewallvert
  defb b_stonewallbottomleft, b_stonewallarchwaycastle, b_stonewallhoriz, b_stonewallbottomright
  defb 255 ; END OF LIST

mapdef_island:
  defb 3;,3 ; WIDTH / HEIGHT
  defb b_islandtopleft,    b_lakebottom, b_islandtopright 
  defb b_lakeright,        b_nothing,    b_lakeleft   
  defb b_islandbottomleft, b_laketop,    b_islandbottomright
  defb 255 ; END OF LIST
;b_lakebottom
mapdef_homeisland:
  defb 4;,3 ; WIDTH / HEIGHT
  defb b_islandtopleft,    b_lakebottom, b_lakebottom, b_islandtopright 
  defb b_lakeright,        b_home,       b_mine,       b_lakeleft   
  defb b_islandbottomleft, b_laketop,    b_laketop,    b_islandbottomright
  defb 255 ; END OF LIST

mapdef_forest:
  defb 3;,3 ; WIDTH / HEIGHT
  defb 0,             b_buildforest, 0
  defb b_buildforest, b_buildforest, b_buildforest
  defb 0,             b_buildforest, 0
  defb 255 ; END OF LIST

mapdef_mount:
  defb 3;,3 ; WIDTH / HEIGHT
  defb b_buildmountainrangetop,    b_buildmountainrange,     0
  defb b_buildmountainrangebottom, b_buildmountainrangeleft, b_buildmountainrangeright
  defb 0,                          b_buildmountainrange,     0
  defb 255 ; END OF LIST

mapdef_lake:
  defb 3;,3 ; WIDTH / HEIGHT
  defb b_laketopleft,    b_laketop,    b_laketopright
  defb b_lakeleft,       b_lakemid,    b_lakeright
  defb b_lakebottomleft, b_lakebottom, b_lakebottomright
  defb 255 ; END OF LIST

mapdef_smalllake:
  defb 2;,2 ; WIDTH / HEIGHT
  defb b_laketopleft,    b_laketopright
  defb b_lakebottomleft, b_lakebottomright
  defb 255 ; END OF LIST

mapdef_maze:
  defb 3;,3 ; WIDTH / HEIGHT
  defb b_mazetopleft,    b_mazetopmid,    b_mazetopright    
  defb b_mazemidleft,    b_mazemid,       b_mazemidright   
  defb b_mazebottomleft, b_mazebottommid, b_mazebottomright
  defb 255 ; END OF LIST

mapdef_massivemount:
  defb 3;,3 ; WIDTH / HEIGHT
  defb b_buildmassivemountaintopleft,    b_buildmassivemountaintop,    b_buildmassivemountaintopright
  defb b_buildmassivemountainleft,       b_buildmassivemountaincentre, b_buildmassivemountainright
  defb b_buildmassivemountainbottomleft, b_buildmassivemountainbottom, b_buildmassivemountainbottomright
  defb 255 ; END OF LIST

;mapdef_stonewallenclosure
;  defb 3,3 ; WIDTH / HEIGHT
;  defb b_stonewalltopleft,    b_stonewallhoriz,         b_stonewalltopright
;  defb b_stonewallvert,       0,                        b_stonewallvert   
;  defb b_stonewallbottomleft, b_stonewallarchwaycastle, b_stonewallbottomright

mapdef_cemetry:
  defb 3;,3 ; WIDTH / HEIGHT
  defb b_stonewalltopleft,    b_stonewallhoriz,         b_stonewalltopright
  defb b_stonewallvert,       b_cemetry,                b_stonewallvert   
  defb b_stonewallbottomleft, b_stonewallarchwaycastle, b_stonewallbottomright
  defb 255 ; END OF LIST

mapdef_castle:
  defb 3;,4 ; WIDTH / HEIGHT
  defb b_stonewalltopleft,    b_stonewallhoriz,         b_stonewalltopright
  defb b_stonewallvert,       b_castle,                 b_stonewallvertdungeonentrance
  defb b_stonewallvert,       b_buildvertroad,          b_stonewallvert
  defb b_stonewallbottomleft, b_stonewallarchwaycastle, b_stonewallbottomright
  defb 255 ; END OF LIST

; BLOCK ID, TOP LEFT SCREEN ID LOCATION, LAND OR SEA TILE TO REPLACE, BLOCK DEFINITION
insertblockxydata:
  defb 11,11,0
  defw mapdef_maze               ; MAZE
  defb 0,0,5
  defw mapdef_homeisland         ; HOME
  defb 31,46,0
  defw mapdef_castle             ; CASTLE WESTERN ZONE - 16,35
  defb 29,51,0
  defw mapdef_castle             ; CASTLE KINGS CAPE - 52,19
  defb 77,44,0
  defw mapdef_abbey              ; ABBEY - 74,74
  defb 50,77,0
  defw mapdef_cemetry            ; CEMETRY
  defb 41,56,0
  defw mapdef_massivemount       ; BIG MOUNTAIN
  defb 255

; INSERT A SPRITE BLOCK INTO MAP BASED ON XY LOCATION
insertblockxy:
  ld hl,insertblockxydata
  ld bc,(currblockid) ; GET BLOCK AND SCREEN ID IN C
  insertblockxyloop:
    ld a,(hl)             
    cp 255                ; END OF LIST
    ret z                 
    cp c                  ; CHECK BLOCK ID
    jr nz,movenextblockid
 
    push bc
    inc hl
    ld c,(hl)             ; START TILENUM FOR INSERTION
    inc hl 
    ld a,(hl)             ; SEA OR LAND INSERTION
    inc hl
    ld e,(hl)             ; SPRITE BLOCK DEF
    inc hl
    ld d,(hl)
    inc hl
    push hl
    call insertspritedefinlocalmap_cf
    pop hl
    pop bc
    jr insertblockxyloop

    movenextblockid:
    inc hl
    inc hl
    inc hl
    inc hl
    inc hl
    jr insertblockxyloop
ret

;mapdef_roads:
;  defb 3,3 ; WIDTH / HEIGHT
;  defb 0, b_buildvertroad, 0
;  defb b_buildhorizroad,b_buildcrossroad,b_buildhorizroad
;  defb 0, b_buildvertroad, 0
;  defb 255 ; END OF LIST

; INSERT LAKE INTO LOCAL MAP
; INPUTS
; A  = CHECK OR INSERT
; C  = TILE ID TO START AT
; DE = SPRITE DEFINITION TO INSERT

doinsertbigtown_cf:
  xor a                        ; SIGNAL THAT WE WANT TO REPLACE LAND TILES ONLY
  ld de,mapdef_bigtown            ; LOAD SPRITE VALUES
  jr insertspritedefinlocalmap_land
doinsertisland_cf:
  ld a,5                         ; SIGNAL THAT WE WANT TO REPLACE SEA TILES ONLY
  ld de,mapdef_island            ; LOAD SPRITE VALUES
  jr insertspritedefinlocalmap_cf
doinsertmount_cf:
  ld de,mapdef_mount             ; LOAD SPRITE VALUES
  jr insertspritedefinlocalmap_land
doinsertlake_cf:
  ld de,mapdef_smalllake         ; LOAD SPRITE VALUES
  jr insertspritedefinlocalmap_land
doinsertforest_cf:
  ld de,mapdef_forest            ; LOAD SPRITE VALUES
  insertspritedefinlocalmap_land:
  xor a                          ; SIGNAL THAT WE WANT TO REPLACE EMPTY LAND TILES ONLY
  insertspritedefinlocalmap_cf:
  ld (tiletoreplaceminusone-1),a 
  push de
  ld a,1
  ld (checkdigitminusone-1),a    ; SIGNAL FUNCTION THAT WE ARE JUST CHECKIING IF INSERTION IS POSSIBLE
  call insertisland
  pop de              
  ret nc                         ; WE CANT INSERT AS THERE IS SOMETHING THERE
  xor a 
  ld (checkdigitminusone-1),a    ; SIGNAL FUNCTION THAT WE WANT TO INSERT

  insertisland:
  ld h,gamemap2h
  ld l,c
  ld a,(de) ; GET WIDTH OF SPRITE IN B
  ld b,a

  inc de
  ;inc de    ; SKIP HEIGHT
  insertlakelooprows:
    push bc
    push hl
    insertlakeloop:
      ld a,(de)
      cp 255 ; END OF SPRITE
      jr z,popoffnow
 
      ; CHECK DATA - SELF MODIFY CODE TO CHECK IF INSERTION IS POSSIBLE 
      ; 1 = CHECK IF INSERT POSSIBLE
      ; 0 = DO INSERT
      ld a,0:checkdigitminusone
      or a
      jr z,doblockinsert

      ; CHECK IF SEA
      ld a,5:tiletoreplaceminusone
      cp (hl)
      jr nz,popoffnow2
      jr skipblockinsert

      ; INSERT IF SEA
      doblockinsert:
      ld a,(de)
      ld (hl),a

      skipblockinsert:
      inc hl
      inc de
    djnz insertlakeloop
    pop hl
    ld bc,10   ; MOVE TO NEXT ROW IN MAP
    add hl,bc
    pop bc
  jr insertlakelooprows

  popoffnow:
    pop hl
    pop bc
    scf       ; SET CARRY FLAG
    ret       ; WE CAN INSERT
  popoffnow2:
    pop hl
    pop bc
    or a      ; RESET CARRY FLAG
    ret       ; WE CANT INSERT

; FIND OUT WHAT BLOCK OF TEN SQUARES WE CURRENTLY OCCUPY
; OUTPUTS
; C = X POS IN 10x10 BLOCK 
; B = Y POS IN 10x10 BLOCK
; D = TILE BLOCK NUMBER IN TABLE
getcurrworldmap:
  ; HORIZONTAL POSITION
  ld a,(tilemap_name+1)
  sub "0"
  ld c,a
  ld d,a
  
  ; VERTICAL POSITION
  ld a,(tilemap_name+5)
  sub "0"
  ld b,a
  
  call convxytoblockid
  ; SAVE BLOCK ID
  ld (currblockid),a
ret

; GET VALUE OF CURRENT MAP / ZONE BLOCK
; INPUTS
; HL = MAP OR ZONE TABLE
; OUTPUTS
; A = VALUE OF CURRENT BLOCK
getmapblockid:
  ld b,0
  ld a,(currblockid)
  ld c,a
  add hl,bc
  ld a,(hl)
ret

getcurrworldmapvalue:
  ; GET VALUE OF CURRENT MAP BLOCK TO E
  ld hl,gamemap
  call getmapblockid
  ld (currscreendata),a

  ; GET VALUE OF CURRENT ZONE BLOCK TO E
  ld hl,zonemap
  call getmapblockid
  ld (currzonedata),a
ret
; CONVERT MAP COORDINATE TO BLOCK ID
; C = X POS  
; B = Y POS
; D = TILE BLOCK NUMBER IN SECOND MAP TABLE
getcurrlocalmap:
  ld a,(tilemap_name+2)
  sub "0"
  ld c,a
  ld d,a
  ld (localscreenx),a
  ld a,(tilemap_name+6)
  sub "0"
  ld b,a
  ld (localscreeny),a

  call convxytoblockid
  ; SAVE SCREEN ID
  ld (currscreenid),a
ret
; GET BLOCK VALUE FROM BLOCK ID
getcurrlocalmapvalue:
  ; GET VALUE OF CURRENT TILE TO E
  ld hl,gamemap2
  ld b,0
  ld a,(currscreenid)
  ld c,a
  add hl,bc
  ld a,(hl)
  ld (currscreendata2),a
ret

; CONVERT A BLOCK X, Y COORDINATE TO A BLOCK ID NUMBER
; C = X POS  
; B = Y POS
; OUTPUT
; A = BLOCK ID
blockiddata:  defb 0,10,20,30,40,50,60,70,80,90

convxytoblockid:
  ld hl,blockiddata
  push bc
  ; GET ROW Y POS
  ld c,b
  ld b,0
  add hl,bc
  ld a,(hl)
  pop bc
  ; ADD COLUMN X POS
  add c
ret

; INDEXED ON WORLD MAP BLOCK ID
;  defw seamapsea                ; 0
;  defw seamapleftland           ; 1
;  defw seamaptopland            ; 2
;  defw seamaprightland          ; 3
;  defw seamapbottomland         ; 4
;  defw seamaptopleftland        ; 5
;  defw seamaptopleftsea         ; 6
;  defw seamaptoprightland       ; 7
;  defw seamaptoprightsea        ; 8
;  defw seamapbottomleftland     ; 9
;  defw seamapbottomleftsea      ; 10
;  defw seamapbottomrightland    ; 11
;  defw seamapbottomrightsea     ; 12
;  defw seamapland               ; 13

; PIXEL COLOURS OF ZONES FOR LOCAL AND WORLD MAPS
colzones: ; ROW 1
        DB      #F0 ; 0  seamapsea
        DB      #FA ; 1  seamapleftland
        DB      #FF ; 2  seamaptopland
        DB      #F5 ; 3  seamaprightland
        DB      #F0 ; 4  seamapbottomland
        DB      #FF ; 5  seamaptopleftland
        DB      #F0 ; 6  seamaptopleftsea
        DB      #FF ; 7  seamaptoprightland
        DB      #F0 ; 8  seamaptoprightsea
        DB      #FA ; 9  seamapbottomleftland
        DB      #F5 ; 10 seamapbottomleftsea
        DB      #F5 ; 11 seamapbottomrightland
        DB      #FA ; 12 seamapbottomrightsea
        DB      #FF ; 13 seamapland
        DB      #FF ; 14 seamaptopleftriver      
        DB      #FF ; 15 seamapbottomleftriver 
        DB      #FF ; 16 island 
        DB      #F0 ; 17 bloodylake 
colzones2: ; ROW 2
        DB      #F0 ; 0  seamapsea
        DB      #FA ; 1  seamapleftland
        DB      #F0 ; 2  seamaptopland
        DB      #F5 ; 3  seamaprightland
        DB      #FF ; 4  seamapbottomland
        DB      #FA ; 5  seamaptopleftland
        DB      #F5 ; 6  seamaptopleftsea
        DB      #F5 ; 7  seamaptoprightland
        DB      #FA ; 8  seamaptoprightsea
        DB      #FF ; 9  seamapbottomleftland
        DB      #F0;5 ; 10 seamapbottomleftsea
        DB      #FF;5 ; 11 seamapbottomrightland
        DB      #F0 ; 12 seamapbottomrightsea
        DB      #FF ; 13 seamapland
        DB      #FF ; 14 seamaptopleftriver      
        DB      #FF ; 15 seamapbottomleftriver 
        DB      #FF ; 16 island 
        DB      #F0 ; 17 bloodylake 

; F0 BLUE
; FA GREEN BLUE
; F5 BLUE GREEN

localcols:
        DB      #FF ;  0 b_nothing 
        DB      #FA ;  1 b_laketopleft
        DB      #F0 ;  2 b_laketop
        DB      #F5 ;  3 b_laketopright
        DB      #FA ;  4 b_lakeleft
        DB      #F0 ;  5 b_lakemid
        DB      #F5 ;  6 b_lakeright
        DB      #FA ;  7 b_lakebottomleft
        DB      #F0 ;  8 b_lakebottom
        DB      #F5 ;  9 b_lakebottomright
        DB      #FF ; 10 b_rivertopleft
        DB      #FF ; 11 b_riververtleft
        DB      #FF ; 12 b_rivertopright
        DB      #FF ; 13 b_riverhoriz
        DB      #FF ; 14 b_riverhoriz2
        DB      #FF ; 15 b_riverbottomleft
        DB      #FF ; 16 b_riverbottomright
        DB      #F0 ; 17 b_islandtopleft
        DB      #F0 ; 18 b_islandtopright
        DB      #F0 ; 19 b_islandbottomleft
        DB      #F0 ; 20 b_islandbottomright
        DB      #C0 ; 21 WHITE HOME
        DB      #3C ; 22 YELLOW TOWN
        DB      #3C ; 23 YELLOW TOWN
        DB      #3C ; 24 YELLOW TOWN
        DB      #3C ; 25 YELLOW TOWN
        DB      #3C ; 26 YELLOW TOWN
        DB      #30 ; 27 RED GAME ARCHERY
        DB      #F3 ; 28 TEAL MAZE
        DB      #F3 ; 29 TEAL MAZE
        DB      #F3 ; 30 TEAL MAZE
        DB      #F3 ; 31 TEAL MAZE
        DB      #30 ; 32 RED - MIDDLE MAZE
        DB      #F3 ; 33 TEAL MAZE
        DB      #F3 ; 34 TEAL MAZE
        DB      #F3 ; 35 TEAL MAZE
        DB      #F3 ; 36 TEAL MAZE
        DB      #30 ; 37 CASTLE - RED
        DB      #CC ; 38 MOUNTAINS - BROWN
        DB      #CC ; 39 MOUNTAINS - BROWN

;b_buildmountainrangetopleft equ 38
;b_buildmountainrangeleft    equ 39
;b_riverseatop               equ 42
;b_riverseabottom            equ 43
;b_buildforest               equ 44
;b_narniahouse               equ 45
;b_mountainblockbottom       equ 46 
;b_landfence                 equ 47
;b_sealandfenceleft          equ 48
;b_sealandfenceright         equ 49

        DB      #30 ; 40 RED
        DB      #30 ; 41 MINE 2 RED

        DB      #FF ; 42 b_riverseatop
        DB      #FF ; 43 b_riverseabottom
        DB      #03 ; 44 b_buildforest
        DB      #30 ; 45 b_narniahouse
        DB      #CC ; 46 b_mountainblockbottom
        DB      #FF ; 47 b_landfence
        DB      #F5 ; 48 b_sealandfenceleft
        DB      #FA ; 49 b_sealandfenceright 
        DB      #CC ; 50 b_buildmountainrange      
        DB      #CC ; 51 b_buildmountainrangeleft    
        DB      #CC ; 52 b_buildmountainrangeright 
        DB      #CC ; 53 b_buildcrossroad      
        DB      #CC ; 54 b_buildvertroad             
        DB      #CC ; 55 b_buildhorizroad         

        DB      #03 ; b_stonewalltopleft          equ 56
        DB      #03 ; b_stonewallhoriz            equ 57
        DB      #03 ; b_stonewalltopright         equ 58
        DB      #03 ; b_stonewallvert             equ 59
        DB      #03 ; b_stonewallbottomleft       equ 60
        DB      #03 ; b_stonewallbottomright      equ 61
        DB      #03 ; b_stonewallarchway          equ 62

        DB      #3F ; 63 SHIP - BROWN
        DB      #3F ; 64 DOCK - BROWN
        DB      #3F ; 65 DOCK - BROWN

        DB      #03 ; b_stonewallarchwaycastle          equ 66
        DB      #3F ;b_buildmassivemountainbottomleft  equ 67
        DB      #3F ;b_buildmassivemountainbottom      equ 68
        DB      #3F ;b_buildmassivemountainbottomright equ 69
        DB      #3F ;b_buildmassivemountainright       equ 70
        DB      #3F ;b_buildmassivemountainleft        equ 71
        DB      #3F ;b_buildmassivemountaintopleft     equ 72
        DB      #3F ;b_buildmassivemountaintopright    equ 73
        DB      #3F ;b_buildmassivemountaintop         equ 74

        ;DB      #3C ; 56 3C YELLOW
        ;DB      #FC ; 57 ORANGE
        ;DB      #03 ; 58 PURPLE
        ;DB      #C3 ; 59 CYAN
        ;DB      #0F ; 60 MAUVE
        ;DB      #CF ; 61 L GREEN
        ;DB      #33 ; 62 DULL GREEN

; DRAW CURRENT GAME MAPS TO SCREEN
drawmap:
  ld a,(inbuilding) ; DON'T DRAW MAP IF WE ARE IN BUILDING
  or a
  ret nz

  ld b,globalmap_id ; CHECK IF WE HAVE WORLD MAP - PLAYER MAY HAVE SOLD IT!
  call checkplayerinvrand_active_cf
  jr nc,skipworldmap

  ld hl,screenadr
  ld de,gamemap
  call drawmap1
  call plotuserposworld

  skipworldmap:
  ld b,localmap_id ; CHECK IF WE HAVE LOCAL MAP - PLAYER MAY HAVE SOLD IT!
  call checkplayerinvrand_active_cf
  ret nc

  ld hl,screenadr+80-10
  ld de,gamemap2
  call drawmap2
  jp plotuserposlocal

; DRAW MAP ON SCREEN
; INPUT
; BC = ZONE TABLE OF COLOURS TO USE
; HL = SCREEN POS
; DE = GAME MAP
drawmap1:
  ; SET MAP DRAW FUNCTION
  ld bc,colzones
  ld (zoneslookuptable-2),bc
  ld b,10
  dorow:
    push bc

    ; DRAW TOP ROW OF MAP BLOCK
    push de
    ld bc,colzones
    ld (zoneslookuptable-2),bc
    call plotmapline
    pop de
    ; DRAW BOTTOM ROW OF MAP BLOCK
    ld bc,colzones2
    ld (zoneslookuptable-2),bc
    call plotmapline 

    pop bc
  djnz dorow
ret

drawmap2:
  ; SET MAP DRAW FUNCTION
  ld bc,localcols
  ld (zoneslookuptable-2),bc
  ld b,10
  dorow2:
    push de
    call plotmapline
    pop de
    call plotmapline 
    ; DOUBLE LINES FOR READABILITY
  djnz dorow2
ret

plotmapline:
    push hl
    push bc
    ld b,10
    docol:
      call plotitlocalmap 
    djnz docol
    donextplotline:
    pop bc
    pop hl  
    push bc
    call scr_next_line_hl
    pop bc
ret

plotitlocalmap:
  push hl
  ld hl,localcols  :zoneslookuptable
  ld a,(de)
  push bc
  ld b,0
  ld c,a
  add hl,bc
  ld a,(hl)
  pop bc
  pop hl
  ld (hl),a
  inc hl
  inc de
ret

worldmapylookup:
  defw screenadr
  defw screenadr+&1000
  defw screenadr+&2000
  defw screenadr+&3000
  defw screenadr+&0050
  defw screenadr+&1050
  defw screenadr+&2050
  defw screenadr+&3050
  defw screenadr+&00A0
  defw screenadr+&10A0

plotuserposlocal:
  ld hl,worldmapylookup
  ; ADD ROWS DOWN
  ld a,(localscreeny)
  call vectorlookuphl
  ; ADD BYTES ACROSS
  ld a,(localscreenx)
  ld bc,70
  add hl,bc
  jp plotposonmap

plotuserposworld:
  ld hl,worldmapylookup
  ; ADD ROWS DOWN
  ld a,(tilemap_name+5)
  sub "0"
  call vectorlookuphl
  ; ADD BYTES ACROSS
  ld a,(tilemap_name+1)
  sub "0"
  plotposonmap:
  ld b,0
  ld c,a
  add hl,bc

  ld (hl),#30
  call scr_next_line_hl
  ld (hl),#30
ret