; OBJECTS THAT CAN BE PLACED DIRECTLY ON MAP

; LIST OF OBJECT IDS
; THESE CORRESPOND TO ORDER OF STRINGS IN INVENTORY DICTIONARY BELOW
inventoryiddictlookup:
  defb rabbitmeat   ; 1 - rabbit meat
  defb moneybag     ; 3 - money bag
  defb arrow        ; ARROW
  defb 62           ; 12 - LUMBER
  defb 152          ; TREASURE MAP
  defb 151          ; PICKAXE
  defb 255          ; end of list

; POINTERS TO NAMES OF OBJECTS THAT CAN BE PICKED UP
inventorydict:
  defw str_empty     ; WE NEED THIS SPACE TO MAKE ABOVE LOOKUP WORK
  defw str_rabbitmeat
  defw str_bagofgold
  defw str_arrow
  defw str_lumber
  defw str_treasuremap
  defw str_pickaxe

; CHECK PLAYER INVENTORY
; CURRENT LIMITS - ONLY ONE QTY PER ITEM
; MAX INVENTORY - 10 ITEMS
; INPUTS
; B = ITEM ID TO CHECK
; OUTPUTS
; CARRY FLAG = 0 = NOT FOUND, 1 = FOUND

checkplayerinvrand_cf:
  ld hl,player_inventory_rand
  invloop3:
    ld a,(hl)
    cp 255             ; END OF INVENTORY LIST
    jp z,returnfalse2
    cp b  
    jp z,returntrue2             ; FOUND ENTRY
    inc hl
    inc hl
    inc hl
  jr invloop3
; CHECK IF WE HAVE AN ITEM AND IT IS ACTIVE - E.G. WEAPON
checkplayerinvrand_active_cf:
  call checkplayerinvrand_cf
  ret nc
  inc hl
  inc hl
  ld a,(hl)
  cp "*"
  jp z,returntrue2
jp returnfalse2

; REWARD PLAYER BASE PRICE OF ITEM JUST TRADED
; INPUTS
; IY+8 = TRADABLE ITEM
rewardgold3:
  ;ld b,(iy+8)  ; GET BASE PRICE OF EXCHANGE OBJECT
  ; LOOKUP 
  ld hl,basepricesbyitemid
  ld c,(iy+8)
  ld b,0
  add hl,bc
  ld a,(hl)
  rlca        ; BE GENEROUS - LET'S DOUBLE NORMAL PRICE
  ; ADD CASH TO PLAYER PURSE
  ld c,a
  ld b,0
  ld hl,(player_cash2)
  add hl,bc
  ld (player_cash2),hl
  call updatestatusbarmoney
  scf ; MAKE SURE WE DON'T COMPLAIN OF NO ROOM FOR INVENTORY SINCE WE ARE JUST GIVING CASH
  ret

; B = ITEM ID TO ADD
; QTY ASSUMED 1
addplayerinvrand_cf:
  ; CHECK IF WE HAVE IT ALREADY, IF SO UPDATE QTY
  ld a,b
  cp 16 ; GIVING CASH
  jp z,rewardgold3
  call checkplayerinvrand_cf
  jr nc,addplayerinvrandnew_cf

  addplayerinvrandupd_cf:
  ld hl,player_inventory_rand
  invloop2:
    ld a,(hl)
    cp 255                       ; END OF INVENTORY LIST
    ret z ; WE DIDN'T HAVE ENOUGH ROOM TO PICK UP OBJECT 
    cp b
    jr nz,skiptonextinvitem

    ; INCREMENT ITEM QTY
    inc hl
    inc (hl) 
  
    scf
    ret ;    jp returntrue2      
             
    skiptonextinvitem:
    inc hl
    inc hl
    inc hl
  jr invloop2

  addplayerinvrandnew_cf:
  ; UPDATE EXISTING QTY
  ld hl,player_inventory_rand
  invloop6:
    ld a,(hl)
    cp 255            ; END OF INVENTORY LIST
    jp z,returnfalse2 ; WE DIDN'T HAVE ENOUGH ROOM TO PICK UP OBJECT 
    or a              ; EMPTY ENTRY
    jr nz,skiptonextinvitem2
    
    ; ADD NEW ITEM AND QTY
    ld (hl),b
    inc hl
    inc (hl) 

    ; CLEAR ACTIVE BIT
    inc hl
    ld (hl)," "

    ; IF WE ADDED BOW OR ARROW, WE NEED TO CHECK POWERS
    jp finishedchangeinventory_cf

    skiptonextinvitem2:
    inc hl
    inc hl
    inc hl
  jr invloop6

str_inventoryobject:
   defb 14,1:showinvqty
   defb " ",11," ",0:itemactive
   defb 255

; CHECK IF PLAYER HAS ANYTHING TO SELL
; OUTPUTS
; A = INVENTORY QTY
countplayerinventory:
  push bc
  ld b,0
  ld hl,player_inventory_rand
  checkinventoryemptyloop:
    ld a,(hl)
    cp 255
    jr z,finishedinventoryloop
    or a
    jr z,skipinventorycount
    inc b
    skipinventorycount:
    inc hl
    inc hl
    inc hl
  jr checkinventoryemptyloop
  finishedinventoryloop:
  ld a,b
  pop bc
ret

; SHOW PLAYERS RANDOM INVENTORY ITEMS
showinventory:
  ld ix,player_inventory_rand
  ld c,255 ; LINE COUNT
  showinventoryloop:
    ld a,(ix+0)
    cp 255                        ; END OF LIST
    jr z,finishprinttext
    or a
    jr z,skipinvitem

    inc c
    ld b,a                        ; STORE OBJECT ID

    ld a,(ix+1)                     ; GET QTY
    ld (showinvqty-1),a
    call getrandobjectstr         ; GET NAME IN DE
    
    ld a,(ix+2)                     ; GET ACTIVE OR INACTIVE
    ld (itemactive-1),a           ; SET IF ITEM ACTIVE OR NOT

    ld hl,str_inventoryobject
    call statusbarprintparagraphnoscroll
    
    skipinvitem:
    inc ix
    inc ix
    inc ix
  jr showinventoryloop

finishprinttext:
  ; SCROLL TEXT SO INVENTORY STARTS AT TOP
  ld a,c
  ld (linecount),a
  ; MAKE SURE WE KEEP NUMBER OF LINES IN SCROLL
  push af
  call scrolltopofpage
  pop af
ret
setactiveitem:
  inc a
  ret z ; IF EMPTY, DO NOT RUN ACTIVATION ROUTINE
  ; ALLOW PLAYER TO ACTIVATE OR DEACTIVATE ITEMS
  call waitoption_1_2_3_4_5ss
  call toggleactiveitem
  call clearmenu
  jp checknokeyspressed

; INPUT
; A = ITEM TO TOGGLE ACTIVE STATE
toggleactiveitem:
  ld hl,player_inventory_rand
  ld b,0
  ld c,a
  add hl,bc
  add hl,bc
  add hl,bc
  inc hl
  inc hl
  ld a,(hl)
  cp " "
  jr z,dosetactiveitem
  ; SET AS INACTIVE
  ld a," "
  ld (hl),a
ret
dosetactiveitem:
  ld a,"*"
  ld (hl),a
ret

; UPDATE PLAYER INVENTORY - ADD
; CURRENT LIMITS - ONLY ONE QTY PER ITEM
; MAX INVENTORY - 10 ITEMS
; INPUTS
; B = ITEM ID TO ADD (TILE GRAPHIC ID)
; C = TILENUMBER
addplayerinv_cf:
  ld a,b
  cp rabbitmeat
  jr z,rewardrabbitmeat
  cp moneybag            ; IF PICKED UP MONEY BAG
  jr z,rewardgold2
  cp arrow               ; IF PICKED UP ARROWS
  jr z,rewardarrows
  cp 62                  ; PICKED UP LUMBER
  jr z,rewardlumber
  cp 151                 ; PICKED UP AXE
  jr z,rewardpickaxe  
  cp 152                 ; PICKED UP TREASURE MAP
  jr z,rewardmap         
  ;cp 153                 ; PICKED UP PICKAXE
  ;jr z,rewardpickaxe 
ret
  ;ld hl,player_inventory
  ;invloop
  ;  ld a,(hl)
  ;  cp 255           ; END OF INVENTORY LIST
  ;  jp z,returnfalse ; WE DIDN'T HAVE ENOUGH ROOM TO PICK UP OBJECT 
  ;  or a             ; EMPTY ENTRY
  ;  jr z,addinvitem2
  ;  inc hl 
  ;  inc hl
  ;jr invloop

  ;addinvitem2
  ;  ld (hl),b
  ;  inc hl
  ;  ld (hl),1
  ;  call clearstatusbarinput ; CLEAR MONTH TEXT SO WE DON'T CORRUPT IT
  ;  call updatestatusbaricon ; DISPLAY ITEM WE HAVE BEEN GIVEN
  ;
  ;  finishedchangeinventory: ; CHECK POWERS
  ;  call checkpowers
  ;jp returntrue

rewardgold2:
  push bc              ; STORE B AS THIS CONTAINS OUR SPRITE ID
  ld hl,(player_cash2)
  ld bc,10
  add hl,bc
  ld (player_cash2),hl
  pop bc
  dostatusbar:
  push bc
  call updatestatusbarmoney
  pop bc
  ; CHECK IF THIS IS A BANK, IF SO MAKE PLAYER WANTED
  ld a,(inbuilding)
  cp 14
  jp z,makewanted_cf
  scf ; PICK UP EVEN IF WE HAVE NO ROOM IN INVENTORY
ret

rewardrabbitmeat:
  push bc
  ld b,12 ; LOAD TASTY MORSEL ID
  modifyplayerinvrand:
  call addplayerinvrand_cf
  pop bc
ret

str_mapsfound: defb "MAP ",14,0:maps_found
               defb " OF 12",255

rewardmap: 
  ld a,(maps_found-1)
  inc a
  ld (maps_found-1),a
  ld hl,str_mapsfound
  call statusbarprintparagraphnoscroll
  scf ; PICK UP EVEN IF WE HAVE NO ROOM IN INVENTORY
ret
rewardpickaxe: 
  push bc
  ld b,18;33 ; LOAD PICKAXE ID
  jr modifyplayerinvrand
rewardaxe: 
  push bc
  ld b,14;33 ; LOAD AXE ID
  jr modifyplayerinvrand
rewardlumber:
  push bc
  ld b,26 ; LOAD LUMBER ID
  jr modifyplayerinvrand
rewardarrows:
  push bc
  ld b,1 ; LOAD ARROW ID
  jr modifyplayerinvrand

; UPDATE PLAYER INVENTORY - REMOVE
; MAX INVENTORY - 5 ITEMS
; ITEM ID, QTY
; INPUTS
; B = ITEM ID TO REMOVE
remplayerinvrand:
  ld hl,player_inventory_rand
  invloop4:
    ld a,(hl)
    cp 255 ; END OF INVENTORY LIST
    ret z
    cp b   ; FOUND ENTRY
    jr z,decrementplayeritem
    inc hl
    inc hl
    inc hl
  jr invloop4

  decrementplayeritem:
    inc hl
    dec (hl)
    ; CHECK IF WE HAVE NONE LEFT, IF SO REMOVE ENTRY
    xor a
    cp (hl)
    ret nz
    dec hl
    ld (hl),0

    ; CHECK POWERS
    finishedchangeinventory_cf:
      call checkpowers_cf
      scf
      ret;  jp returntrue2
