cas_in_open   equ &BC77
cas_in_direct equ &BC83
cas_in_close  equ &BC7A

fname:
  defb "0000.DAT"

fnamelen equ 8

fullconvblock equ &9000

; INPUTS 
; A = CHAR ID
loaddatafile:
  ld a,(runquestchooser)    ; LOAD CHARACTER ID WE BUMPED INTO
  ; CHECK IF WE HAVE ALREADY LOADED DATA FILE IN MEMORY, IF SO DON'T LOAD AGAIN
  ld bc,(fullconvblock)
  cp b                      ; CHECK IF WE HAVE ALREADY LOADED CHARACTER ID
  jr nz,doloaddatafile
  push af
  ld a,(season)             ; CHECK IF WE HAVE ALREADY LOADED SEASON ID
  cp c
  pop af
  jr z,skipdatafileload

  doloaddatafile:
  ; FORM TEXT FILE NAME WE NEED TO LOOK FOR
  ; GET CHARACTER ID
  call convbytetostr
  ld a,(bytetostring+0)
  ld (fname+1),a
  ld a,(bytetostring+1)
  ld (fname+2),a
  ld a,(bytetostring+2)
  ld (fname+3),a

  ; GET SEASON
  ld a,(season)
  add "0"
  ld (fname),a

  ; GET DAY NUM
  ;ld a,(daycount)
  ;call convbytetostr
  ;ld a,(bytetostring+1)
  ;ld (fname+1),a
  ;ld a,(bytetostring+2)
  ;ld (fname+2),a
  
  ; LOAD TEXT FILE INTO ADDRESS AT &9000
  ld hl,fname
  ld b,fnamelen
  call loadfile
  or a
  jp z,returnfalse

  ; WE GOT A FILE, LOAD APPROPRIATE TEXT INTO HL FOR PRINT ROUTINE
  skipdatafileload:
  ld hl,fullconvblock+2 ; LOAD DAY LOOKUP LIST INTO HL
  ld a,(hl)             ; CHECK WHAT TYPE OF MODULE WE HAVE
 
  or a                  
  inc hl
  jr z,dofixedtextorder

  cp 2                  ; MODULE HAS OWN GENERATION ROUTINE  
  jr z,customroutine

  dorandomtextorder:    ; MODULE USES RANDOM ORDER FOR PHRASES
  ld b,28
  call rand32
  jp lookupmoduletext
  ;call vectorlookuphl
  ;jp returntrue

  dofixedtextorder:     ; MODULE USES FIXED DATE ORDER FOR PHRASES
  ld a,(daycount)       ; ADD OUR DAY COUNT TO GET SPECIFIC PHRASE
  lookupmoduletext:
  call vectorlookuphl
  jp returntrue

customroutine:
  call &9003
  jp returntrue

loadfile: 
  ld de,fullconvblock
  call cas_in_open
  jp nc,returnfalse ; NO FILE EXISTS
  ex de,hl
  call cas_in_direct
  call cas_in_close
  jp returntrue