cas_in_open   equ &BC77
cas_in_direct equ &BC83
cas_in_close  equ &BC7A

fname: defb "000.DAT"
fnamelen equ 7

fullconvblock equ &4000

; FIND OUT WHICH DATAFILE CURRENT DAY RELATES TO
daygroupid: defb 0
daydiff:    defb 0

getdatafileid:
  ld c,0
  ld a,(daycount-1)           ; LOAD DAY OF SEASON
  inc a                     ; START FROM 1
  datafileidloop:
    sub 4
    inc c
  jr nc,datafileidloop
  add 4
  ld (daydiff),a            ; WHICH DAY IN OUR GROUP OF FOUR WE HAVE SELECTED
  ld a,c
  ld (daygroupid),a         ; WHICH GROUP ID WE HAVE SELECTED
ret

loaddatafile:
  call getdatafileid        ; CHECK DAY OF SEASON
  ; CHECK IF WE HAVE ALREADY LOADED DATA FILE IN MEMORY, IF SO DON'T LOAD AGAIN
  ld bc,(fullconvblock)
  cp b                      ; CHECK IF WE HAVE ALREADY LOADED CHARACTER ID
  jr nz,doloaddatafile
  ld a,(season)             ; CHECK IF WE HAVE ALREADY LOADED SEASON ID
  cp c
  jr z,skipdatafileload

  doloaddatafile:
  ; GET SEASON
  ld a,(season)
  add "0"
  ld (fname),a

  ; GET DAY NUM
  ld a,(daygroupid)
  call convbytetostr
  ld a,(bytetostring+1)
  ld (fname+1),a
  ld a,(bytetostring+2)
  ld (fname+2),a
  
  ; LOAD TEXT FILE INTO ADDRESS AT &4000
  ld hl,fname
  ld b,fnamelen
  call loadfile
  or a
  jp z,returnfalse

  ; WE GOT A FILE, LOAD APPROPRIATE TEXT INTO HL FOR PRINT ROUTINE
  skipdatafileload:
  ; LOAD GROUP DAY LOOKUP LIST INTO HL
  ld hl,fullconvblock+2 
  ld b,0
  ld a,(daydiff)
  dec a          ; START FROM 0
  ld c,a      
  add hl,bc
  add hl,bc
  ; RESOLVE GROUP LOOKUP TO SINGLE DAY LOOKUP LIST
  ld a,(hl)
  inc hl
  ld h,(hl)
  ld l,a

  ; FIND IF WE HAVE CHAR ID IN SINGLE DAY LOOKUP LIST
  ld bc,(runquestchooser)
  charloopcheck:
    ld a,(hl)             ; CHECK WHAT TYPE OF MODULE WE HAVE
    cp 255                ; END OF LIST - USE RANDOM SAYING
    jr z,finishedloop
    cp c
    jr z,finishedloop
    inc hl                ; MOVE TO NEXT CHAR ID IN LIST
    inc hl
    inc hl
  jr charloopcheck

  finishedloop:
  ; GET ADDRESS OF TEXT INTO HL
  inc hl 
  ld a,(hl)
  inc hl
  ld h,(hl)
  ld l,a

  jp returntrue

; INPUTS
; HL = FILENAME
; B  = FILENAME LENGTH
loadfile: 
  ld de,fullconvblock
  call cas_in_open
  jp nc,returnfalse ; NO FILE EXISTS
  ex de,hl
  call cas_in_direct
  call cas_in_close
  jp returntrue