;is128k equ 1
;iscart equ 1
;isplus equ 1
isinter equ 1 ; ENABLE INTERRUPTS - NOT USABLE IF WE HAVE NO FIRMWARE E.G. CARTRIDGE???
;isnicemusic equ 1
;isoldmusic equ 1

; USE THIS CODE TO ASSEMBLE IN BASIC FOR 128k VERSION
; THEN
; SAVE "QUEST128.BIN",b,&0e00,&768D (or whatever the length is in ram)
; 64K
; SAVE "QUEST.BIN",b,&0e00,&94F1
; MEMORY BANKS LAYOUT FOR 128K
;
; BANK 4 = TILES   - ONLY SWAPPED IN FOR SCREEN REDRAW / TILE REDRAW
; BANK 5 = SPRITES - ONLY SWAPPED IN FOR SCREEN GENERATION
; BANK 6
; BANK 7


; MIMO'S QUEST
; ============

; IDEAS
; =====

; SAVE GAMES? PASSWORD TO STORE MONEY, INVENTORY, QUESTS, LOCATION?
; -----------------------------------------------------------------

; CONVERSATIONS RANDOMLY BUILT FROM WORD BANKS
; --------------------------------------------

;   "WATCH OUT FOR"          "PESKY"   "RABBITS"   "ARE NICE"          "AFTER A MEAL"
;   "BE CAREFUL OF"          "LARGE"   "PEARS"     "ARE NO GOOD"       "TO EAT"
;   "SOME PEOPLE THINK THAT" "TINY"    "BANANAS"   "ARE VERY NICE"     "THIS TIME OF YEAR"
;   "I HEAR THAT"            "GREAT"   "FLOWERS"   "ARE NOT SO NICE"   "IN THE SPRING"
;   "SOME SAY"               "RED"     "BIRDS"     "ARE GREAT"         "AT NIGHT"
;   "A WISE MAN SAID"        "BLUE"    "BERRIES"   "ARE TASTY"         "BEFORE SUPPER"
 
; CONVERSATIONS BASED ON SEASON, LOCATION 
; ---------------------------------------

; MARRIAGE
; --------
;   GIVE GIFTS TO GIRL, ANSWER QUESTIONS TO SHOW COMPATIBILITY, BUY HOUSE
;   HARVEST FESTIVAL 
;   POSSIBLY HAVE LOTS OF RANDOM GIRLS, AND TABLE OF GIRLS COMPATIBILITY
;   THAT CAN BE OVERWRITTEN IF NEEDED?

; COMPLETED QUESTS IMPROVE REPUTATION?
; ------------------------------------
;
;   DOING QUEST FOR INDIANS GAINS INDIAN REP
;   DOING QUEST FOR COWBOYS GAINS COWBOY REP
;   ARROW CAN DO DAMAGE TO PEOPLE? DESTROY REP?

; BUILDINGS
; ---------
;   BANK
;   JAIL
;   LUMBER
;
; BANK LOANS?
; 

;; width of a tile
tile_width equ 8
tile_width_bytes equ tile_width/2
font_width_bytes equ 4/2
;; height of a tile
tile_height equ 16
font_height equ 5
;; number of bytes used by tile (each tile uses same 
;; number of bytes and stored uncompressed in a formmn
;; that can be poked direct to screen)
tile_data_size equ tile_width_bytes*tile_height
font_data_size equ font_width_bytes*font_height

;ScreenSize equ &4000
;; width of screen in pixels
scr_width_pixels         equ tile_width*20
;scr_right_side equ scr_width_pixels-4
;; height of screen in pixels
scr_height_pixels        equ tile_height*10
scr_width_bytes          equ scr_width_pixels/2

scr_width_bytes_right    equ scr_width_bytes-4
scr_height_pixels_bottom equ scr_height_pixels-16

;; width of screen in tiles
tilemap_width_tiles      equ scr_width_bytes/tile_width_bytes
;; height of screen in tiles
tilemap_height_tiles     equ scr_height_pixels/tile_height
tilemap_total_tiles      equ tilemap_width_tiles*tilemap_height_tiles
tilemap_win_tiles        equ tilemap_width_tiles*tilemap_height_tiles

;; firmware functions we use

ifndef iscart
   scr_set_mode    equ &bc0e
endif
ifndef isplus
   scr_set_border  equ &bc38
   scr_set_ink     equ &bc32
endif
;mc_wait_flyback equ &bd19

;km_test_key     equ &bb1e ; CHECK FOR KEY AND WAIT FOR RESPONSE
;km_read_key     equ &bb1b ; CHECK FOR KEY BUT DON'T WAIT FOR RESPONSE
;km_read_char    equ &bb09
;km_reset        equ &bb03
;km_wait_char    equ &bb06
;km_set_delay    equ &bb3f
;km_wait_key     equ &bb18

;txt_set_paper     equ &bb96
;gra_set_paper     equ &bbe4
;gra_set_pen       equ &bbde
;gra_wr_char       equ &bbfc
;gra_move_absolute equ &bbc0

;kl_time_please    equ &bd0d
;kl_time_set       equ &bd10

org &0E00
nolist
;ifdef isinter
;  di
;endif
jp start


ifdef iscart
; READ CODE MODULES
read "reusablecode.asm"          ; CODE THAT ONLY NEEDS TO BE RUN ONCE - SO IT CAN BE ERASED AND USED FOR OTHER THINGS BY DATA BLOCKS
read "bankswitchcode.asm"        ; CODE FOR BANK SWITCHING AND LOADING TILE GRAPHICS - MUST BE IN RANGE $4000-7FFF

; MISC
read "speedup.asm"               ; MISC ASM SPEED UP  - MUST BE IN RANGE $4000-7FFF
read "data.asm"                  ; INITIALIZATION DATA

; GRAPHICS
read "graphics.asm"              ; MISC GRAPHICS FUNCTIONS - MUST NOT BE IN RANGE $4000-7FFF (ASIC)
read "tilemapdraw.asm"           ; SPRITE GRAPHICS - MUST BE IN RANGE $4000-7FFF
read "populatetilemap128k6.asm"  ; PROCEDURAL MAP GENERATION - MUST BE IN RANGE $4000-7FFF
read "populaterooms4.asm"        ; PROCEDURAL ROOM GENERATION - MUST BE IN RANGE $4000-7FFF
read "quests4.asm"               ; QUEST DATA - MUST BE IN RANGE $4000-7FFF
read "mazedata.asm"              ; STATIC ROOM GENERATION - MUST BE IN RANGE $4000-7FFF
; WORLD GENERATION
read "pseudorandom3.asm"         ; PSUEDO RANDOM GENERATOR - MUST BE IN RANGE $4000-7FFF
read "zonedefs4.asm"             ; ZONE DEFINITION TABLES - MUST BE IN RANGE $4000-7FFF
read "randomquests4.asm"         ; RANDOM QUEST DATA - MUST BE IN RANGE $4000-7FFF

read "generatetiles128k.asm"     ; MODIFY GRASS ETC
read "tilegraphicssprite.asm"    ; SPRITE GRAPHICS FOR MIMO
read "tilegraphicsletters.asm"   ; SPRITE GRAPHICS FOR LETTERS

read "statusbar2.asm"             ; STATUS BAR RENDERING
read "discoveredtowns.asm"       ; FOR KEEPING A LIST OF LOCAL TOWNS PLAYER CAN DO QUESTS AT


read "definitions.asm"           ; DEFINITIONS FOR 64k OR 128k
read "spritegraphics4_defs.asm"  
read "spritemovement128k.asm"    ; SPRITE MOVEMENT ROUTINES

; SPRITE MOVEMENT
read "examplekeyboard2.asm"      ; JOYSTICK READING CODE
read "collision.asm"             ; SPRITE MOVEMENT ROUTINES
read "spritemask.asm"            ; SPRITE MASK ROUTINE
read "gengamemap.asm"            ; GENERATE GAME MAP
read "seamaps.asm"               ; GENERATE INDIVIDUAL MAP SQUARES

read "daynight.asm"              ; CONTROL DAY AND NIGHT PALETTE
read "treedamage4.asm"            ; FOR RECORDING DAMAGE TO TREES WITH AXE
; CHARACTER INTERACTION
read "dictionarydefs.asm"        ; DICTIONARY OF WORDS DEFINITIONS
read "dictionary.asm"            ; DICTIONARY OF WORDS
read "inventory.asm"             ; INVENTORY CODE
read "sailingship.asm"           ; BOAT FUNCTIONS
read "shop.asm"                  ; SHOP CODE
read "aiconversations.asm"       ; STORY LINE DATA
read "wantedposter.asm"          ; BOUNTY HUNTER DATA
read "saloongame.asm"            ; PLAY SALOON GAME
read "minister.asm"              ; CHURCH MINISTER INTERACTION
; SOUND
;read "loaddatesensitivetextbyday.asm" ; DATE SENSITIVE STORY LINES
read "sound5.asm"                ; SOUND EFFECTS
read "tones.asm"                 ; MATCH NOTES TO PERIODS FOR SOUND
read "turretfire.asm"            ; TURRET FIRE

endif




ifndef iscart
read "definitions.asm"           ; DEFINITIONS FOR 64k OR 128k
read "spritegraphics4_defs.asm"  
read "reusablecode.asm"          ; CODE THAT ONLY NEEDS TO BE RUN ONCE - SO IT CAN BE ERASED AND USED FOR OTHER THINGS BY DATA BLOCKS
; READ CODE MODULES
; MEMORY
; BELOW CODE MUST NOT BE IN RANGE &4000-&7FFF

read "bankswitchcode.asm"        ; CODE FOR BANK SWITCHING AND LOADING TILE GRAPHICS - MUST NOT BE IN RANGE $4000-7FFF

; MISC
read "speedup.asm"               ; MISC ASM SPEED UP  - MUST NOT BE IN RANGE $4000-7FFF
read "data.asm"                  ; INITIALIZATION DATA

; GRAPHICS
read "tilemapdraw.asm"           ; SPRITE GRAPHICS - MUST NOT BE IN RANGE $4000-7FFF
read "populatetilemap128k6.asm"  ; PROCEDURAL MAP GENERATION - MUST NOT BE IN RANGE $4000-7FFF
read "populaterooms4.asm"        ; PROCEDURAL ROOM GENERATION - MUST NOT BE IN RANGE $4000-7FFF
read "quests4.asm"               ; QUEST DATA - MUST NOT BE IN RANGE $4000-7FFF
;read "wife.asm"                 ; WIFE INTERACTION - MUST NOT BE IN RANGE $4000-7FFF
read "mazedata.asm"              ; STATIC ROOM GENERATION - MUST NOT BE IN RANGE $4000-7FFF
; WORLD GENERATION
read "pseudorandom3.asm"         ; PSUEDO RANDOM GENERATOR - MUST NOT BE IN RANGE $4000-7FFF
read "zonedefs4.asm"             ; ZONE DEFINITION TABLES - MUST NOT BE IN RANGE $4000-7FFF
read "randomquests4.asm"         ; RANDOM QUEST DATA - MUST NOT BE IN RANGE $4000-7FFF
read "graphics.asm"              ; MISC GRAPHICS FUNCTIONS - MUST NOT BE IN RANGE $4000-7FFF

read "generatetiles128k.asm"     ; MODIFY GRASS ETC
read "tilegraphicssprite.asm"    ; SPRITE GRAPHICS FOR MIMO
read "tilegraphicsletters.asm"   ; SPRITE GRAPHICS FOR LETTERS

ifndef is128k
ifndef iscart
read "spritegraphics4.asm"        ; SPRITE DATA
read "spritegraphics4_table.asm"  ; SPRITE DATA LOOKUP TABLE
read "tilegraphicstable.asm"      ; MAIN SPRITE GRAPHICS LOOKUP
read "tilegraphicsmain2.asm"      ; SPRITE GRAPHICS 
endif
endif

; 128k BANKSWITCHING NOTE - 4000 STARTS AROUND HERE NOW!!! BELOW CODE MUST NOT BE ESSENTIAL FOR GENERATING/DRAWING SCREEN

read "spritemovement128k.asm"    ; SPRITE MOVEMENT ROUTINES

; SPRITE MOVEMENT
read "examplekeyboard2.asm"      ; JOYSTICK READING CODE
read "collision.asm"             ; SPRITE MOVEMENT ROUTINES
read "spritemask.asm"            ; SPRITE MASK ROUTINE
read "gengamemap.asm"            ; GENERATE GAME MAP
read "seamaps.asm"               ; GENERATE INDIVIDUAL MAP SQUARES

read "daynight.asm"              ; CONTROL DAY AND NIGHT PALETTE
read "treedamage4.asm"            ; FOR RECORDING DAMAGE TO TREES WITH AXE
; CHARACTER INTERACTION
read "dictionarydefs.asm"        ; DICTIONARY OF WORDS DEFINITIONS
read "dictionary.asm"            ; DICTIONARY OF WORDS
read "inventory.asm"             ; INVENTORY CODE
read "sailingship.asm"           ; BOAT FUNCTIONS
read "shop.asm"                  ; SHOP CODE
read "aiconversations.asm"       ; STORY LINE DATA
read "wantedposter.asm"          ; BOUNTY HUNTER DATA
read "saloongame.asm"            ; PLAY SALOON GAME
read "minister.asm"              ; CHURCH MINISTER INTERACTION

;read "storylines.asm"           ; STORY LINE DATA
; SOUND
;read "loaddatesensitivetextbyday.asm" ; DATE SENSITIVE STORY LINES
read "sound5.asm"                ; SOUND EFFECTS
read "tones.asm"                 ; MATCH NOTES TO PERIODS FOR SOUND
read "turretfire.asm"            ; TURRET FIRE
defb "SSSSS"
; 128k BANKSWITCHING NOTE - FOLLOWING CODE IS ESSENTIAL FOR DRAWING SCREEN. MUST NOT BE IN &4000-7FFF
ifndef iscart
ifdef is128k
  org &8000
endif
endif

read "statusbar2.asm"             ; STATUS BAR RENDERING
read "discoveredtowns.asm"       ; FOR KEEPING A LIST OF LOCAL TOWNS PLAYER CAN DO QUESTS AT
ifdef isnicemusic
  read "midi2ayexample.asm"
endif
endif

; -----------------------------------------------------------------
; END OF CODE AROUND $7200 SO FAR

restartgame:
  ld hl,str_restartgame
  call askyesnoplayer
  cp "n"
  ret z
  ld a,&58
  ld (tilenum_cur),a ; RESET ROOM PSEUDO RANDOM FOR HOME HOUSE
  jr mainloop1

start:
ifndef isinter
  di
endif
ifdef isnicemusic
  call play_music
endif

ifdef iscart
  ; SET STACK POINTER
  ld sp,&8000  
  ld a,&c9 ;(RET)
  ld hl,&0038
  ld (hl),a

  ; MOVE SCREEN MEMORY TO 8000-BFFF
  ld hl,0        ;; get scroll offset
  ld a,h
  or &20                    ;; This defines the "base" of the screen in 16k units.
                            ;; &00 -> screen uses &0000-&3fff
                            ;; &10 -> screen uses &4000-&7fff
                            ;; &20 -> screen uses &8000-&bfff
                            ;; &30 -> screen uses &c000-&ffff
  ld h,a
  ld bc,&bc0c                ;; select CRTC register 12
  out (c),c
  inc b                    ;; B = &BD
  out (c),h                ;; write to CRTC register 12
  dec b
  inc c                    ;; BC = &BC0D
  out (c),c                ;; select CRTC register 13
  inc b
  out (c),l                ;; write to CRTC register 13 
ifdef isinter
  ei
endif
  ;call unlockasic
endif
; ENABLE UPPER AND LOWER ROM
;ifdef iscart
;  ld b,&7f       ; SET rom/mode I=Interupts, U=Upper rom, L=Lower rom, MM=Mode
;  ld c,%10001001 ; OO-IULMM
;  out (c),c
;endif
  call createlookuptables
  call detectram
  ; WIPE REUSABLE DATA AREA &0E00 TO &0FFF
  ;ld hl,letters_ptr_table
  ;ld bc,4032 ; CLEAR FROM &0040 TO &1000
  ;call clearmem

mainloop1:
  ; INITIATE DATA AREAS OF MEMORY, STRINGS, ETC
  call initiatevars

  ld hl,intro
  call statusbarprintparagraphnoscroll
  ; 128k
  ;ld hl,onetwoeightk
  ;ld a,(hasextramem-1)
  ;or a
  ;call nz,statusbarprintparagraphnoscroll
  ; GENERATE TILEMAP
  call marktilemapchanged

;; the main loop which draws and updates sprite

main_loop:
  ;; check keys and update sprite position
  call check_keys

  ; SELF MODIFY - "CALL check_tilemap" WHEN TILEMAP CHANGES
  ; AFTER CALL COMPLETES, THIS CALL GETS CHANGED BACK TO 3 x NOPs.
  ; THIS SAVES A LOT OF PROCESSING POWER AS WE DON'T HAVE TO KEEP CHECKING A VARIABLE
  ; EACH TIME TO SEE IF ANYTHING HAS CHANGED.
  defb &CD           :tilemapcallfunc         ; &CD = CALL 
  defw check_tilemap :tilemapchangedfunc      ; = check_tilemap

  ; UPDATE ARROWS IN MAIN ROUTINE AS IT NEEDS TO MOVE FAST
  call updatecharacterspritesarrow

  ; FIRST INTERRUPT HANDLER
  ld a,10:interuptcounter_plus1
  dec a
  ld (interuptcounter_plus1-1),a
  or a
  jr nz,main_loop
  ld a,10
  ld (interuptcounter_plus1-1),a

  ; UPDATE SPRITE CHARACTERS IN SUB ROUTINE AS THEY NEED TO MOVE SLOW
  ; LOAD CHARACTER TABLE DATA
  call updatecharactersprites

  defb &CD             :tileanimcallfunc         ; &CD = CALL 
  defw updatetileanims :tileanimchangedfunc      ; = updatetileanims

  ; SECOND INTERRUPT HANDLER IS SLOWER THAN FIRST ONE - UPDATES EVERY SECOND

  ld a,5:interuptcounter2_plus1
  dec a
  ld (interuptcounter2_plus1-1),a
  or a
  jr nz,main_loop
  ld a,5
  ld (interuptcounter2_plus1-1),a

  ;ld hl,time
  ;inc (hl)
  ld a,(time)
  inc a
  ld (time),a

  defb &CD                 :timecallfunc         ; &CD = CALL 
  defw updatestatusbartime :timechangedfunc      ; = updatetileanims

  ;call updatestatusbartime
ifndef iscart
ifdef isoldmusic
  call playmusic
endif
endif

jr main_loop

list
defb "CHRIS2"