; INPUTS
; HL = DATA DEFINITION TO READ
; DE = SPRITE DATA TO USE AS MAZE OBJECT

buildstaticroomdefmazenew:
  inc hl
  ld (lastlineptr),hl
  dec hl
  jr buildstaticroomdefmazenews

buildstaticroomdefmazenewloop:
  ; BUILD ROOM
  ; GET LOCATION OF SPRITE
  ld a,(hl)
  cp 255 ; HAVE WE REACHED END OF LIST?
  ret z
  bit 7,a ; HAVE WE REACHED END OF LINE? GET NEW Y VARIABLE
  jr nz,getnewyvar

  ld c,a ; X POS
  inc hl

  push hl
  push bc
  call insertspritetilesxynocheck
  pop bc
  pop hl
  jr buildstaticroomdefmazenewloop

  getnewyvar:
    ;inc hl
    buildstaticroomdefmazenews:
    ld b,(hl) ; GET Y POS
    res 7,b   ; CLEAR END OF LINE MARKER
    bit 6,b  
    jr nz,skiplastlinestore ; DON'T RECORD OUR OWN LINE PTR IF WE ARE REPEATING PREV LINE

    inc hl
    ; STORE LAST LINE PTR
    ld (lastlineptr),hl
    jr buildstaticroomdefmazenewloop

    skiplastlinestore:
    res 6,b  ; CLEAR REPEAT LAST LINE MARKER

  repeatlastline:
    inc hl
    ld (currlineptr),hl   ; STORE CURR LINE PTR
    ld hl,(lastlineptr)   ; POINT HL TO LAST LINE

    lastlinecopy:
      ld a,(hl)
      bit 7,a ; CHECK FOR END OF LINE MARKER
      jr nz,finlastlinecopy
      ; PROCESS LAST LINE INTEGER
      ld c,a ; X POS
      inc hl
      push hl
      push bc
      ; WE NEED TO CHECK IF LOCATION ALREADY HAS OBJECT BEFORE INSERTION
      ; PLAYER MAY HAVE CHOPPED DOWN A TREE THAT CAN'T BE RESTORED
      call insertspritetilesxy 
      pop bc
      pop hl
      jr lastlinecopy
    finlastlinecopy:
    ; RESTORE CURRENT LINE PTR
    ld hl,(currlineptr)
    jr buildstaticroomdefmazenewloop

buildmazebottommid:
  ld hl,buildmazebottommiddatanew
  makestaticmazenew:
  ld de,s_pinetree
  call buildstaticroomdefmazenew
  jp jumpbackscreenfoliagey

buildmazemidleft:
  ld hl,buildmazemidleftdata
  jr makestaticmazenew

buildmazetopmid:
  ld hl,buildmazetopmiddata
  jr makestaticmazenew

buildmazetopright:
  ld hl,buildmazetoprightdata
  jr makestaticmazenew

buildmazemidright:
  ld hl,buildmazemidrightdata
  jr makestaticmazenew

buildmazebottomright:
  ld hl,buildmazebottomrightdata
  jr makestaticmazenew

buildmazebottomleft:
  ld hl,buildmazebottomleftdata
  jr makestaticmazenew

buildmazetopleft:
  ld hl,buildmazetopleftdata
  jr makestaticmazenew

buildmazemiddata2:
  defb 7+80 ; X
  defw s_roundhouse
  defb 7+102
  defw s_girlnarnia
  defb 255

buildmazemid:
  ld hl,buildmazemiddata2
  call buildstaticroomdef
  ld hl,buildmazemiddata
  jr makestaticmazenew

; END OF LINE IS MARKED BY BIT 7 SET IN Y POSITION BYTE
; THIS BIT IS CLEARED IN ORDER TO GET Y POSITION OF SPRITE ROW
;  1 = %10000001
;  2 = %10000010
;  3 = %10000011
;  4 = %10000100
;  5 = %10000101
;  6 = %10000110
;  7 = %10000111
;  8 = %10001000
;  9 = %10001001
; 10 = %10001010
; 11 = %10001011
; 12 = %10001100

; BIT 7 SET = NEW LINE Y POSITION MARKER
; BIT 6 SET = REPEAT PREVIOUS ROW

; OPTIMIZED
buildmazebottommiddatanew:
  defb %10001001,0,2,4,6,8,10,14,16,18    ; Y, X, X...
  defb %11000101                          ; Y, X, X...
  defb %11000011                          ; Y, X, X...
  defb %11000111                          ; Y, X, X...
  defb %10001001,12                       ; Y, X, X...
  defb %10000101,12                       ; Y, X, X...
  defb %10000011,12                       ; Y, X, X...
  defb %10001000,10                       ; Y, X, X...
  defb 255                                ; END OF LIST

buildmazemiddata:
  defb %10000010,0,2,4,6,8,10,12,14,16,18 
  defb 255                                ; END OF LIST

; OPTIMIZED
buildmazetopmiddata:
  defb %10001001,8,10
  defb %10001001,0,2,4,6,12,14,16,18  
  defb %11000011                  
  defb %11000111                  
  defb %10000100,6,12                 
  defb %11000101                  
  defb %11000110                  
  defb %10000101,0,2,16,18            
  defb 255                                ; END OF LIST

; OPTIMIZED
buildmazetoprightdata:
  defb %10000011,16,12,8,4       
  defb %11000110             
  defb %11001000             
  defb %11001010            
  defb %11001011            
  defb %11000101             
  defb %11001001             
  defb %11000111             
  defb %10000011,0,2,6,10,14     
  defb %10000101,0,2             
  defb %10001001,0,2             
  defb %10000111,0               
  defb %10000100,16,8            
  defb 255                   ; END OF LIST

; OPTIMIZED
buildmazemidrightdata:
  defb %10000110,16,12,8,4,0     
  defb %11000111             
  defb %11001000             
  defb %11001001             
  defb %11001010            
  defb %11001011            
  defb %11000010             
  defb %10000011,16,12,4,0       
  defb %11000101             
  defb %10000001,16,12,8,4       
  defb %11000100             
  defb %10000100,6,10,0          
  defb 255                   ; END OF LIST

; OPTIMIZED
buildmazebottomrightdata:
  defb %10000101,16,0,4,8,10,12  
  defb %11001001             
  defb %11000111             
  defb %10001001,2,6,14          
  defb %10000111,2,6             
  defb %10000101,14              
  defb %10000001,16,4,12,8       
  defb %11000010             
  defb %11000011             
  defb %10000011,0,2             
  defb %10000100,16,4,8          
  defb %10000110,16,4            
  defb %10001000,16              
  defb 255                   ; END OF LIST

; OPTIMIZED
buildmazemidleftdata:
  defb %10000010,2,6,10,14,18    
  defb %11000011             
  defb %11000100             
  defb %11001000             
  defb %11001001             
  defb %11001010            
  defb %11001011            
  defb %11000101             
  defb %11000111             
  defb %10000101,8               
  defb %10000111,12              
  defb %10000001,2,6,10,14       
  defb %10000110,2,6,14,18       
  defb 255                   ; END OF LIST

; OPTIMIZED
buildmazebottomleftdata:
  defb %10000001,2,6,10,14,18    
  defb %11000010             
  defb %11000011             
  defb %11001001             
  defb %11000101             
  defb %11000111             
  defb %10001001,4,8,12,16       
  defb %10000101,16              
  defb %10000111,8               
  defb %10000110,2,6,14          
  defb %11000100             
  defb %10000100,10              
  defb %10001000,2,14            
  defb 255                   ; END OF LIST

; OPTIMIZED
buildmazetopleftdata:
  defb %10001010,6,2,10,14      
  defb %11001011            
  defb %11001000             
  defb %11000011             
  defb %11000101             
  defb %11001001             
  defb %11000111             
  defb %10000101,8,12,16,18      
  defb %11000011             
  defb %10000011,4               
  defb %10001001,16,18           
  defb %10000111,18              
  defb %10000110,6,2,14          
  defb %10000100,2               
  defb 255                   ; END OF LIST

; AVENUE OF TREES FOR CASTLE
buildavenuedata2:
  defb %10000010,6,12 
  defb %11000100
  defb %11000110
  defb %11001000
  defb %11001010
  defb 255          ; END OF LIST

; STONE WALL HORIZONTAL
buildstonewallhorizdata2:
  defb %10000110,0,5,10,15 
  defb 255          ; END OF LIST

buildstonewallvertdata2:
  defb %10001010,13 
  defb %10000111,13
  defb %10000100,13 
  defb 255          ; END OF LIST