; ACTIVATE TILE ANIMATION
; INPUTS 
; B = SPRITE NUMBER IN ANIM VECTOR TABLE
; C = TILE NUM
; D = IS FLIPPED?
activatetileanim:
  ld ix,animtiles
  activatetileanimloop:
    ld a,(ix)
    cp 255  ; FOUND END OF LIST
    ret z
    or a    ; FOUND INACTIVE
    jr z,maketilenanimactive

    push bc
    ld bc,5
    add ix,bc
    pop bc
  jr activatetileanimloop

  maketilenanimactive:
  ld (ix+0),1 ; MAKE ACTIVE
  ld (ix+1),0 ; SPRITE ANIM OFFSET
  ld (ix+2),b ; SPRITE ID IN TABLE
  ld (ix+3),d ; IS FLIPPED
  ld (ix+4),c ; TILE NUM

  ; MARK AS PHYSICAL OBSTACLE ON OBJECT TILEMAP
  ld h,tilemap2h
  ld l,c
  ld (hl),1

  jp marktileanimactive ; ACTIVATE ROUTINE TO UPDATE TILE ANIMATIONS

; INPUTS
genrandomscreenname:
  call resetpseudorandomquest
  call genrandommanname        ; GENERATE WANTED MAN FOR THIS TOWN
  ld (currentwantedmanname),a
  call checkdiscoveredtown_cf  ; RECORD THAT WE DISCOVERED NEW TOWN
  ; RECORD THAT PLAYER HAS DISCOVERED TOWN
  ld hl,townname
  jp statusbarprintparagraphnoscroll

numtileanims equ 3
animtiletable:
  defw animtiles
  defw animtiles+5
  defw animtiles+10

deactivateanimations:
  ; DISABLE ROUTINE FOR UPDATING TILE ANIMS - CHANGE CALL FUNCTION IN MAIN LOOP TO NOPs
  xor a
  ld (tileanimcallfunc-1),a
  ld bc,0
  ld (tileanimchangedfunc-2),bc

  ld bc,deactivatetileanimsfunc
  jr dotileanims
updatetileanims:
  ld bc,updatetilenanimsfunc
  dotileanims:
  ld hl,animtiletable
  ld (spritefunc-2),bc
  ld b,numtileanims
  jp scanspritetable

deactivatetileanimsfunc:
  ld (hl),0
ret

updatetilenanimsfunc:
  ld a,(hl)
  or a    ; ANIM NOT ACTIVE
  ret z

  ; BUMP OFFSET
  inc hl
  ld a,(hl)
  inc a
  cp 2
  jr nz,skipdecoffset
  xor a
  skipdecoffset:
  ld (hl),a

  ; GET SPRITE DATA TO DE
  inc hl
  add (hl) ; ADD TILE ID TO OFFSET
  call vectorspritelookup
  push de               ; BACK UP TILE GRAPHICS
  
  ; FLIPPED
  inc hl
  ld a,(hl)
  or a
  inc hl
  ld l,(hl)
  jr z,drawnotflipped

  ; GET TILE POS
  call gettilepixelpos
  call get_scr_addr
  pop de
  jp tile_restore_flip    ;; now draw tile
  
  drawnotflipped:
  ; GET TILE POS
  call gettilepixelpos
  call get_scr_addr
  pop de
  jp tile_restore    ;; now draw tile

set_transp_col_buildingorzone:
  ; SET TRANSP COL BY BUILDING
  ld a,(inbuilding)
  or a
  jr z,set_transp_col_zone
set_transp_col:
  ; CLEAR SCREEN BY BACKGROUND COLOUR
  ld hl,building_transp_col
  ld a,(inbuilding)
  set_transp_col_zone2:
  ld b,0
  ld c,a
  add hl,bc

  ; GET INKS INTO B AND C - DAY AND NIGHT
  ld a,(hl)
  and %11110000 ; REMOVE NIGHT PEN
  rrca
  rrca
  rrca
  rrca
  ld b,a
  ld a,(hl)
  and %00001111 ; REMOVE DAY PEN
  ld c,a

  ; UPDATE PENS DAY / NIGHT TABLE SO WE REMEMBER TO CHANGE TO RIGHT COLOUR
  ld hl,pens
  ld (hl),b
  ld hl,pens_night
  ld (hl),c

  ; SET INK
  call checknighttime ; IF IT IS DAY
  jr z,setdayink
  
  ; SET NIGHT INK
  xor a
  ld b,c
  jr doclearscreen

  setdayink:
  ld c,b

  doclearscreen:
  call scr_set_ink
  xor a
  jp ClearScreen
set_transp_col_zone:
  ; CLEAR SCREEN BY BACKGROUND COLOUR
  ld a,(nighttime)
  bit 1,a
  jr z,dontsetseatransp

  ; SET SEA TRANSPARENCY
  bit 0,a ; CHECK IF IT IS NIGHT OR DAY
  jr z,setseatranspday
  ld b,4
  jr dosetseatransp
  setseatranspday:
  ld b,14
  dosetseatransp:
  ld c,b
  xor a
  jp scr_set_ink
  
  dontsetseatransp:
  ld a,(currscreendata2)
  cp 5                 ; DON'T CLEAR SCREEN IF JUST WATER (NOT TRANSPARENT WATER)
  ret z
  ld hl,zone_transp_col
  ld a,(currzonedata)
  jr set_transp_col_zone2
    
gentilemapa:
  ; RESET PSEUDO RANDOM NUMBER SEQUENCE
  call resetpseudorandom
  call gencoordstr

  call getcurrworldmap
  call getcurrworldmapvalue
  call checkscreenzoneclimate

  ; BANK SWITCH TO NORMAL
ifdef is128k
  ld a,&C0
  ld b,&7F
  out (c),a
endif
ifdef iscart
  call romswitchnormal
endif

  call getcurrlocalmap
  call getcurrlocalmapvalue
  call resetpseudorandom

  ; BANK SWITCH TO SPRITES
ifdef is128k
  ld a,&C5
  ld b,&7F
  out (c),a
endif
ifdef iscart
  call romswitchsprites
endif

jp populatetilemap

drawtilemap:
  ; SET TRANSP COL
  call set_transp_col_buildingorzone
  call checkdopenssealands ; CHECK WHICH PALETTE TO USE FOR CURRENT SCREEN - MUST BE RUN AFTER WE POPULATE THE TILEMAP
  ld a,(nighttime)
  bit 3,a
  jr nz,skipcheckifdrawingemptysea

  ; CHECK IF WE NEED TO DRAW SCREEN (NO IF JUST EMPTY WATER AND NOT UNDERGROUND IN DUNGEON!)
  ld a,(inbuilding)
  or a
  jr nz,skipcheckifdrawingemptysea
  ld a,(currscreendata2)
  cp 5 
  jr z,finisheddrawingtilemap

  skipcheckifdrawingemptysea:

  ld bc,tile_restore
  ld (tiledrawfunction_selfmod-2),bc

  ;call bankswitchtiles
  ; BANK SWITCH TO TILES
ifdef is128k
  ld a,&C4
  ld b,&7F
  out (c),a
endif
ifdef iscart
  call romswitchtiles
endif

  ld de,tilemap0     
  call tilemap_draw            ; DRAW GROUND LEVEL TILE MAP
  ld bc,tile_draw
  ld (tiledrawfunction_selfmod-2),bc

  ; MAKE SURE WE CAN INSERT TILES IN LAND AGAIN - WE MAY HAVE BEEN DOING IT IN SEA
  xor a
  ld (emptytileid2-1),a

  ld de,tilemap1
  call tilemap_draw            ; DRAW UPPER LEVEL TILE MAP

  ; BANK SWITCH TO NORMAL
ifdef is128k
  ld a,&C0
  ld b,&7F
  out (c),a
endif
ifdef iscart
  call romswitchnormal
endif

  ld hl,lastinsertpos          ; GET LOCATION OF SHOP
  ld de,str_shoptitle          ; DRAW TITLES ON SHOPS IF WE HAVE ANY
  call checkshoptitle          ; CLEAR LOCATION OF SHOP

  ld hl,lastinsertpossaloon    ; GET LOCATION OF SHOP
  ld de,str_saloontitle        ; DRAW TITLES ON SHOPS IF WE HAVE ANY
  call checkshoptitle          ; CLEAR LOCATION OF SHOP

  ld hl,lastinsertposbank      ; GET LOCATION OF SHOP
  ld de,str_banktitle          ; DRAW TITLES ON SHOPS IF WE HAVE ANY
  call checkshoptitle          ; CLEAR LOCATION OF SHOP

  ld hl,lastinsertposjail      ; GET LOCATION OF SHOP
  ld de,str_jailtitle          ; DRAW TITLES ON SHOPS IF WE HAVE ANY
  call checkshoptitle          ; CLEAR LOCATION OF SHOP

  finisheddrawingtilemap:

  call printroomdesc

  ;ld a,(viewmap)
  ;or a
  call drawmap

  jp updateplayersprite ; REDRAW PLAYER SPRITE

; CHECK TO SEE IF A SPRITE INSERTION POINT WAS RECORDED.
; IF SO, CONVERT THE TILE NUMBER TO A PIXEL LOCATION AND PRINT 
; THE SIGN
; INPUTS
; A  = LAST INSERT POS
; DE = STR TO INSERT
drawshoptitles:
  push de
  sub tilemap_width_tiles+1    ; MOVE UP ONE ROW FOR SHOP ROOF AND BACK ONE FOR CENTRING
  ld l,a
  call gettilepixelpos
  call get_scr_addr
  ld bc,&0050                  ; CENTRE ON ROOF
  add hl,bc
  pop de
  jp gra_wr_string2

; INPUT
; HL = LAST LOCATION OF BUILDING
; DE = TITLE OF BUILDING TO TYPE IN STRING
checkshoptitle:
  ld a,(hl)
  or a
  ret z
  push hl
  call drawshoptitles          ; DRAW TITLES ON SHOPS IF WE HAVE ANY
  pop hl
  ld (hl),0
ret

; PARSES GRASS TABLE ITEMS AND INSERTS THEM INTO TILEMAP
; INPUTS
; HL = TABLE DATA
loadgrasstable:
  ld a,(hl)
  cp 255           ; END OF LIST
  ret z
  ld b,a           ; GET MAX RAND IN B
  inc hl
  ld d,(hl)        ; GET SPRITE ID NUMBER IN D 
  inc hl
  push hl
  call dograsstile ; INSERT INTO MAP
  pop hl
jr loadgrasstable

dograssdata:
  defb 30,grass      ; MAX RAND INSERT, TILE ID
  defb 30,longgrass
  defb 255           ; END OF LIST
dograss:
  ld hl,dograssdata
  buildthegrass:
  call loadgrasstable
  jp buildgrassjumpback
dograssflowersdata:
  defb 10,flowers   ; MAX RAND INSERT, TILE ID
  defb 255          ; END OF LIST
dograssflowerstreesdata:
  defb 5,smalltree  ; MAX RAND INSERT, TILE ID
  defb 255          ; END OF LIST
dograssflowers:
  ld hl,dograssflowersdata
  call loadgrasstable
  dosmalltrees:
  ld hl,dograssflowerstreesdata
  call loadgrasstable
  jp dograss
dograsswesternnoflowersdata:
  defb 30,longgrass   ; MAX RAND INSERT, TILE ID
  defb 5,smallcactus
  defb 255            ; END OF LIST
dograsswesternnoflowers:
  ld hl,dograsswesternnoflowersdata
  jr buildthegrass
dograsswesterndata:
  defb 5,smallcactus  ; MAX RAND INSERT, TILE ID
  defb 2,skull
  defb 30,longgrass
  defb 255            ; END OF LIST
dograsswestern:
  ld hl,dograsswesterndata
  jr buildthegrass

; INSERT A RANDOM NUMBER OF GRASS TILES INTO TILE MAP
; INPUTS
; B = MAX RAND NUMBER OF TIMES TO INSERT TILE
; D = TILE NUMBER TO INSERT
dograsstile:
  call randmax32
  or a  ; RETURN IF WE AREN'T TO INSERT ANYTHING
  ret z
  ld b,a
  ld h,tilemap0h
  sgloop:
    call rand
    ld l,a
    ld (hl),d
  djnz sgloop
ret

; FILL MAP
; FILL GRAPHIC AND OBJECT MAP WITH SPECIFIC VALUES
; INPUTS
; A = START TILE NUM
; B = HEIGHT
; C = WIDTH
; D = VALUE
; E = VALUE FOR OBJECT MAP
fillmap:
  call filltilemap
  ld d,e
  fillobjectmap:
  ld hl,tilemap2
  jr filltilemap2

clearobjectmap:
  ld d,0
  jr fillobjectmap

; INPUTS
; A = START TILE NUM
; B = HEIGHT
; C = WIDTH
; D = VALUE

; FILL MAP WITH SPECIFIC TILE
filltilemap:
  ld h,tilemap0h
  filltilemap2:
  push af
  push bc
  call clearloopy
  pop bc
  pop af
  ret

; INPUTS
; A = START TILE NUM
; B = HEIGHT
; C = WIDTH

; FILL OBJECT MAP WITH VALUE
clearobjectmapbridge:
  ld h,tilemap2h
  ld d,254   ; TRANSVERSABLE OBJECT
  clearloopy:
     ld l,a ; FIND START TILE
     push bc
     ld b,c
     clearloopx:
       ld (hl),d  ; CLEAR OBJECT TILE - 254 MAKES OBJECT PASSABLE, E.G BRIDGE
       inc l
     djnz clearloopx
     pop bc
     add tilemap_width_tiles
  djnz clearloopy
ret

b_nothing                   equ 0
b_laketopleft               equ 1
b_laketop                   equ 2
b_laketopright              equ 3
b_lakeleft                  equ 4
b_lakemid                   equ 5
b_lakeright                 equ 6
b_lakebottomleft            equ 7
b_lakebottom                equ 8
b_lakebottomright           equ 9
b_rivertopleft              equ 10
b_riververtleft             equ 11
b_rivertopright             equ 12
b_riverhoriz                equ 13
b_riverhoriz2               equ 14
b_riverbottomleft           equ 15
b_riverbottomright          equ 16
b_islandtopleft             equ 17
b_islandtopright            equ 18
b_islandbottomleft          equ 19
b_islandbottomright         equ 20
b_home                      equ 21
b_randomtownwestern         equ 22
b_randomtownplains          equ 23
b_randomtownforest          equ 24
b_randomtownindian          equ 25
b_randomtownknights         equ 26
b_archeryrange              equ 27
b_mazetopleft               equ 28
b_mazetopmid                equ 29
b_mazetopright              equ 30
b_mazemidleft               equ 31
b_mazemid                   equ 32
b_mazemidright              equ 33
b_mazebottomleft            equ 34
b_mazebottommid             equ 35
b_mazebottomright           equ 36
b_castle                    equ 37
b_buildmountainrangetop     equ 38
b_buildmountainrangebottom  equ 39
b_mine                      equ 40
b_mine2                     equ 41
b_riverseatop               equ 42
b_riverseabottom            equ 43
b_buildforest               equ 44
b_narniahouse               equ 45
b_mountainblockbottom       equ 46
b_landfence                 equ 47
b_sealandfenceleft          equ 48
b_sealandfenceright         equ 49
b_buildmountainrange        equ 50
b_buildmountainrangeleft    equ 51
b_buildmountainrangeright   equ 52
b_jail                      equ 53 
b_buildvertroad             equ 54
b_churchwedding             equ 55
b_stonewalltopleft          equ 56
b_stonewallhoriz            equ 57
b_stonewalltopright         equ 58
b_stonewallvert             equ 59
b_stonewallbottomleft       equ 60
b_stonewallbottomright      equ 61
b_stonewallarchway          equ 62
b_dock                      equ 63 ; DOCK WITH SHIP
b_dock2                           equ 64 ; DOCK INTO SEA
b_dockempty                       equ 65 ; EMPTY DOCK
b_stonewallarchwaycastle          equ 66
b_buildmassivemountainbottomleft  equ 67
b_buildmassivemountainbottom      equ 68
b_buildmassivemountainbottomright equ 69
b_buildmassivemountainright       equ 70
b_buildmassivemountainleft        equ 71
b_buildmassivemountaintopleft     equ 72
b_buildmassivemountaintopright    equ 73
b_buildmassivemountaintop         equ 74
b_underwaterentrance              equ 75
b_underwaterruins                 equ 76
b_stonewalltopleftuw          equ 77
b_stonewallhorizuw            equ 78
b_stonewalltoprightuw         equ 79
b_stonewallvertuw             equ 80
b_stonewallbottomleftuw       equ 81
b_stonewallbottomrightuw      equ 82
b_stonewallarchwayuw          equ 83
b_cemetry                    equ 84
b_streets                    equ 85
b_buildwaterfall             equ 86
b_streetseast                equ 87
b_streetswest                equ 88
b_streetsnorth               equ 89
b_streetssouth               equ 90
b_buildabbeytl               equ 91     
b_buildabbeytr               equ 92
b_buildabbeybl               equ 93
b_buildabbeybr               equ 94
b_buildjunglecave            equ 95
b_buildmassivemountaincentre equ 96
b_stonewallvertdungeonentrance equ 97

static_map_table_underwater:
  defb 51,46,     b_underwaterentrance  
  defb 28,32,     b_underwaterruins ; RUINS AT KINGS CAPE
  defb 28,22,     b_underwaterruins ; RUINS AT KINGS CAPE
  defb 44,25,     b_underwaterruins ; ATLANTIS
  defb 44,35,     b_underwaterruins ; ATLANTIS
  defb 44,13,     b_stonewalltopleftuw
  defb 44,14,     b_stonewallhorizuw      
  defb 44,15,     b_stonewallhorizuw   
  defb 44,16,     b_stonewallhorizuw         
  defb 44,17,     b_stonewalltoprightuw        
  defb 44,23,     b_stonewallvertuw      
  defb 44,27,     b_stonewallvertuw    
  defb 44,33,     b_stonewallvertuw      
  defb 44,37,     b_stonewallvertuw               
  defb 44,33,     b_stonewallvertuw     
  defb 44,37,     b_stonewallvertuw   
  defb 44,43,     b_stonewallvertuw     
  defb 44,47,     b_stonewallvertuw   
  defb 44,53,     b_stonewallvertuw     
  defb 44,57,     b_stonewallvertuw 
  defb 44,63,     b_stonewallbottomleftuw   
  defb 44,64,     b_stonewallhorizuw  
  defb 44,65,     b_stonewallarchwayuw   
  defb 44,66,     b_stonewallhorizuw 
  defb 44,67,     b_stonewallbottomrightuw  
  defb 255                    ; END OF LIST 

; INSERT STATICALLY BUILT SCREENS INTO LOCAL MAP ON LOCAL MAP GENERATION
; NUMBERS ARE TILE IDS, NOT COORDINATES
static_map_table:
  ; HOME SWEET HOME

  ;defb 0,40, b_buildabbeytl
  ;defb 0,41, b_buildabbeytr
  ;defb 0,50, b_buildabbeybl
  ;defb 0,51, b_buildabbeybr

  ; WORLD MAP TILENUM, LOCAL MAP TILENUM, ROOM ID
  ;defb 0,13,      b_lakeleft
  ;defb 0,10,      b_lakeright
  ;defb 0,12,      b_streets
  ;defb 0,2,       b_streets

  ; TRANSPORT
  ; ---------

  ; HOME DOCK
  defb 0,21,      b_dock2     
  defb 0,31,      b_dockempty :homedock_selfmod
  ; BOAT IN BUCCANEERS BAY
  defb 60,59,     b_dock2     
  defb 60,69,     b_dock      :medievaldock_selfmod
  ; BOAT IN EMERALD ISLANDS
  defb 43,64,     b_dock2     
  defb 43,74,     b_dockempty :newworlddock_selfmod
  ; BOAT IN NEW PORT - X = 68 Y = 95
  defb 96,58,     b_dock2     
  defb 96,68,     b_dockempty :faminedock_selfmod
  ; BOAT IN FOREST LAND - X = 90 Y = 56
  defb 59,50,     b_dock2     
  defb 59,60,     b_dockempty :forestlanddock_selfmod

  ;defb 40,49,     b_churchwedding

  defb 61,96,     b_jail  ; X = 16, Y = 69

  ; LONELY ISLANDS
  ; ----------------

  ; LONELY ISLANDS
  ; ----------------

  defb 11,11,   b_mazetopleft    
  defb 11,12,   b_mazetopmid      
  defb 11,13,   b_mazetopright    
  defb 11,21,   b_mazemidleft     
  defb 11,22,   b_mazemid         
  defb 11,23,   b_mazemidright    
  defb 11,31,   b_mazebottomleft  
  defb 11,32,   b_mazebottommid   
  defb 11,33,   b_mazebottomright
  defb 42,3+90, b_narniahouse ; EXIT

;  defb 42,3+90, b_narniahouse ; EXIT

  ; CEMETRY
  ;defb 50,88, b_cemetry

  ; MEDIEVAL WORLD
  ; --------------

  defb 0, 6+60,  b_mine2 
  defb 61,  66,  b_archeryrange ; X = 16, Y = 66

  defb 53,76,    b_buildjunglecave ; X = 36, Y = 57

  defb 255                    ; END OF LIST

; TO CONVERT WORLD MAP, LOCAL MAP TO COORDINATE
; ADDING WORLD MAP NUMBERS GIVES YOU TENS DIGITS TILE ID
; ADDING LOCAL MAP NUMBERS GIVES YOU SINGLE DIGITS TILE ID

; STORING THE TILE LOCATION IN GLOBAL AND LOCAL MAP IDS MAKES IT FASTER
; YOU ONLY HAVE TO CHECK ONE NUMBER TO SEE IF THE SCREEN IS IN YOUR WORLD MAP
; RATHER THAN CHECKING X AND Y DIGITS

; WORLD MAP  X  +  Y  = 0 + 40 TENS
; LOCAL MAP  X  +  Y  = 8 + 70 UNITS
; COORD     00. - 04.    WORLD
; COORD     ..8 - ..7    LOCAL
; COORD     008 - 047   

; INSERT ESSENTIAL SPRITES INTO MAP
; THESE ARE REFERENCED BY STATIC MAP TABLE
landscapetable2:
  defw buildwaterjumpback        ; 0 BUILD NOTHING
  defw buildlaketopleft          ; 1
  defw buildlaketop              ; 2
  defw buildlaketopright         ; 3
  defw buildlakeleft             ; 4
  defw buildlakemid              ; 5
  defw buildlakeright            ; 6
  defw buildlakebottomleft       ; 7
  defw buildlakebottom           ; 8
  defw buildlakebottomright      ; 9
  defw buildrivertopleft         ; 10
  defw buildriververtleft        ; 11
  defw buildrivertopright        ; 12
  defw buildriverhoriz           ; 13
  defw buildriverhoriz2          ; 14
  defw buildriverbottomleft      ; 15
  defw buildriverbottomright     ; 16
  defw buildislandtopleft        ; 17
  defw buildislandtopright       ; 18
  defw buildislandbottomleft     ; 19
  defw buildislandbottomright    ; 20
  defw buildhome                 ; 21
  defw buildrandomtownwestern    ; 22
  defw buildrandomtownplains     ; 23
  defw buildrandomtownforest     ; 24
  defw buildrandomtownindian     ; 25
  defw buildrandomtownknights    ; 26
  defw buildarcheryrange         ; 27
  defw buildmazetopleft          ; 28
  defw buildmazetopmid           ; 29
  defw buildmazetopright         ; 30
  defw buildmazemidleft          ; 31
  defw buildmazemid              ; 32
  defw buildmazemidright         ; 33
  defw buildmazebottomleft       ; 34
  defw buildmazebottommid        ; 35
  defw buildmazebottomright      ; 36
  defw buildcastle               ; 37
  defw buildmountainrangetop     ; 38
  defw buildmountainrangebottom  ; 39
  defw buildminemountain         ; 40
  defw buildminemountain2        ; 41
  defw buildriverseatop          ; 42
  defw buildriverseabottom       ; 43
  defw buildforest               ; 44
  defw buildnarniahouse          ; 45
  defw buildmountainblockbottom  ; 46
  defw buildlandfence            ; 47
  defw buildsealandfenceleft     ; 48
  defw buildsealandfenceright    ; 49
  defw buildmountainrange        ; 50
  defw buildmountainrangeleft    ; 51
  defw buildmountainrangeright   ; 52
  defw buildjail                 ; 53 
  defw buildvertroad             ; 54
  defw 0;buildchurchwedding        ; 55 
  defw buildstonewalltopleft     ; 56
  defw buildstonewallhoriz       ; 57
  defw buildstonewalltopright    ; 58
  defw buildstonewallvert        ; 59
  defw buildstonewallbottomleft  ; 60
  defw buildstonewallbottomright ; 61
  defw buildstonewallarchway     ; 62
  defw builddock                 ; 63
  defw builddock2                ; 64
  defw builddockempty                  ; 65
  defw buildstonewallarchwaycastle     ; 66
  defw buildmassivemountainbottomleft  ; 67
  defw buildmassivemountainbottom      ; 68
  defw buildmassivemountainbottomright ; 69
  defw buildmassivemountainright       ; 70
  defw buildmassivemountainleft        ; 71
  defw buildmassivemountaintopleft     ; 72
  defw buildmassivemountaintopright    ; 73
  defw buildmassivemountaintop         ; 74
  defw buildunderwaterentrance         ; 75
  defw buildunderwaterruins            ; 76
  defw buildstonewalltopleftuw     ; 77
  defw buildstonewallhorizuw       ; 78
  defw buildstonewalltoprightuw    ; 79
  defw buildstonewallvertuw        ; 80
  defw buildstonewallbottomleftuw  ; 81
  defw buildstonewallbottomrightuw ; 82
  defw buildstonewallarchwayuw     ; 83
  defw buildcemetry          ; 84
  defw buildstreets          ; 85
  defw buildwaterfall        ; 86
  defw buildstreetseast      ; 87
  defw buildstreetswest      ; 88
  defw buildstreetsnorth     ; 89
  defw buildstreetssouth     ; 90
  defw buildabbeytl          ; 91
  defw buildabbeytr          ; 92
  defw buildabbeybl          ; 91
  defw buildabbeybr          ; 92
  defw buildjunglecave       ; 93
  defw buildmassivemountaincentre ; 96
  defw buildstonewallvertdungeonentrance; 97

; BUILDING CODES LISTED BY BUILDING ID
buildinglist:
  defw skipbuildingcheck       ;  0
  defw inlogcabin              ;  1
  defw inmine                  ;  2
  defw inwigwam                ;  3
  defw instonebuilding         ;  4
  defw buildroommine2                 ;  5
  defw buildroommine2reverse          ;  6
  defw inlogcabinwesternshop   ;  7
  defw inlogcabinwesternsaloon ;  8
  defw inchurch                ;  9
  defw inship                  ; 10
  defw indungeon               ; 11
  defw inbasement              ; 12
  defw buildroomjail           ; 13
  defw inbank                  ; 14
  defw 0;inchurchwedding         ; 15
  defw inlogcabinunderwater    ; 16
  defw incave                  ; 17

populatetilemap:
  ; SET TO USE LAND PALETTE BY DEFAULT - THIS MAY BE CHANGED BY MAP CODE BELOW!
  ld a,(nighttime)
  res 1,a
  ld (nighttime),a

  ; CLEAR ALL THREE TILE MAPS USING THE STACK POINTER
  ; TILEMAPS NEED TO ADD TO 3x256 BYTES AND MUST BE TOGETHER IN MEMORY
  call clearsp
  call resetpseudorandom ; MAKE SURE WE ARE CALCING RAND BASED ON MAP LOCATION

  ; BANK SWITCH TO SPRITES
;ifdef is128k
;  ld a,&C5
;  ld b,&7F
;  out (c),a
;endif

  ; CHECK IF WE ARE CURRENTLY IN A BUILDING
  ld a,(inbuilding)
  or a
  jr z,skipbuildingcheck
  ld hl,buildinglist
  jp vectortablelaunchcode

  skipbuildingcheck:

  ; BUILD GRASS
  ; INDEXED BY ZONE MAP ID VALUE
  ld a,(currzonedata)
  ld hl,landscapetable3
  jp vectortablelaunchcode

  buildgrassjumpback:   

  ; BUILD MAIN FEATURES - WATER / STATIC MAPS
  ; INDEXED BY LOCAL MAP ID VALUE
  ld a,(currscreendata2)
  ld hl,landscapetable2
  jp vectortablelaunchcode

  buildwaterjumpback:   

  ; QUEST SPRITES HAVE TO BE INSERTED BEFORE SCENERY FOR LUMBER
  ; BUT AFTER MAIN FEATURES LIKE BUILDINGS, MOUNTAINS, ETC, SO THEY DON'T CHANGE SCENERY
  xor a
  ld (doroomidcheck_minusone-1),a ; SKIP ROOM IDS FOR STATIC QUEST OBJECTS
  call checkinsertquestsprites
  ld a,1
  ld (doroomidcheck_minusone-1),a ; DO ROOM ID CHECK FOR RANDOM QUEST OBJECTS


  ; BUILD EXTRA NON ESSENTIAL SPRITES  - TREES ETC
  ; INDEXED BY ZONE MAP ID VALUE
  ld a,(currzonedata)
  ld hl,landscapetable
  jp vectortablelaunchcode

  ; GEN RANDOM QUEST ONLY SOMETIMES
  tilefinisheddorandomquest:
  call genrandomquest2

  ; THIS IS NEEDED IN CASE WE NEED TO INSERT A SECRET DOOR IN A BUILDING VIA THE STATIC OBJECTS
  ; EG NARNIA DOOR. 
  checkinsertstaticobjectsinbuilding:
  ; QUEST SPRITES HAVE TO BE INSERTED LAST
  ; CAN'T HAVE RANDOM QUEST SPRITES CHANGING MAP SCENERY
  xor a
  ld (doroomidcheck_minusone-1),a ; SKIP ROOM IDS FOR STATIC QUEST OBJECTS
  call checkinsertquestsprites

  jumpbackscreenfoliagey:

  ; DRAW STATUS BAR
  tilefinished:
  ; SKIP ROOM IDS FOR STATIC QUEST OBJECTS
  call checkinsertquestspritesstatic ; INSERT STATIC QUEST SPRITES
  ld a,1
  ld (doroomidcheck_minusone-1),a    ; DO ROOM ID CHECK FOR RANDOM QUEST OBJECTS
  call checkinsertquestspritesrandom ; INSERT RANDOMLY GENERATED QUEST SPRITES

  ; BANK SWITCH TO NORMAL
ifdef is128k
  ld a,&C0
  ld b,&7F
  out (c),a
endif
ifdef iscart
  call romswitchnormal
endif

  jp updatestatusbar

; BUILD NON ESSENTIAL LANDSCAPE FEATURES

  ; HORIZONTAL
  ;domyplainss
  ;  jp jumpbackscreenfoliagey

; INSERT FOLIAGE BY TABLES
; INPUTS 
; HL = FOLIAGE LIST
dofoliage:
  ld a,(hl)
  cp 255    ; END OF LIST
  ret z
  ld b,a    ; LOAD MAX RAND NUMBER INTO B
  inc hl

  ; USE LOOKUP TABLE TO LOAD SPRITE DEFINITION PTR INTO A
  ld a,(hl)
  inc hl

  push hl
  call insertspriterandtimes_dolookup
  pop hl
jr dofoliage

domyprairiedata:
  defb 3              ; MAX RAND OF TREES TO INSERT
  defb s_bush         ; SPRITE DEFINITION
  defb 2              ; MAX RAND OF TREES TO INSERT
  defb s_bushclump    ; SPRITE DEFINITION
  defb 6              ; MAX RAND OF TREES TO INSERT
  defb s_bigtree      ; SPRITE DEFINITION
  defb 2              ; MAX RAND OF TREES TO INSERT
  defb s_bigtreebare  ; SPRITE DEFINITION
  defb 255

  domyprairie:
    ld hl,domyprairiedata
    domyfoliage:
    call dofoliage
    jp jumpbackscreenfoliagey

domyforestdata:
  defb 30          ; MAX RAND OF TREES TO INSERT
  defb s_pinetree  ; SPRITE DEFINITION
  defb 10          ; MAX RAND OF TREES TO INSERT
  defb s_bigtree   ; SPRITE DEFINITION
  defb 255

  domyforest:
    ld hl,domyforestdata
    jr domyfoliage

domymountaindata:
  defb 2                 ; MAX RAND OF SPRITE TO INSERT
  defb s_smallmountain   ; SPRITE DEFINTION
  defb 2                 ; MAX RAND OF SPRITE TO INSERT
  defb s_bignewmountain  ; SPRITE DEFINITION
  defb 4                 ; MAX RAND OF SPRITE TO INSERT
  defb s_newmountain     ; SPRITE DEFINITION
  ;defb 2                 ; MAX RAND OF SPRITE TO INSERT
  ;defw s_cavemountain    ; SPRITE DEFINTION
  defb 255

  domymountain:
    ld hl,domymountaindata
    jr domyfoliage
  domyforestmountain:
    ld hl,domyforestdata
    call dofoliage
    ld hl,domymountaindata
    jr domyfoliage
  domywesternmountain:
    ld hl,domywesterndata
    call dofoliage
    ld hl,domymountaindata
    jr domyfoliage
    ;ld a,s_bigcactus;cavemountain
    ;ld bc,&0605
    ;call insertspritetilesxy_dolookup
    ;call insertspriterandonce_dolookup
    ;jp jumpbackscreenfoliagey
    ;s2_bigcactus equ &42E0
    ;scf
    ;ld de,s2_bigcactus
    ;ld bc,&805
    ;jp insertspritetilesxy

domylakedata:
  defb 2        ; MAX RAND TO INSERT
  defb s_water  ; SPRITE DEFINITION
  defb 255

  domylake:
    call randmax32 ; ONLY HAVE LAKES SOMETIMES
    sub 16
    jp nc,jumpbackscreenfoliagey
    ld hl,domylakedata
    jr domyfoliage

domytropicaldata:
  defb 6       ; MAX RAND OF TREES TO INSERT
  defb s_palm   ; SPRITE DEFINITION
  defb 2        ; MAX RAND TO INSERT
  defb s_water  ; SPRITE DEFINITION
  ;defb 2        
  ;defw s_pyramid
  defb 255

  domytropical:
    ld hl,domytropicaldata
    jr domyfoliage
  domytropicalmountain:
    ld hl,domytropicaldata
    call dofoliage
    ld hl,domymountaindata
    jr domyfoliage

domywesterndata:
  defb 6           ; MAX RAND OF TREES TO INSERT
  defb s_bigcactus ; SPRITE DEFINITION
  defb 2           ; MAX RAND OF TREES TO INSERT
  defb s_deadbush  ; SPRITE DEFINITION
  defb 255

  domywestern:
    ld hl,domywesterndata
    jr domyfoliage
  inlogcabin:
    ld a,(currzonedata)
    cp zone_western
    jr z,inlogcabinwestern
    call buildroomlogcabin
    jp tilefinisheddorandomquest
inlogcabinunderwater:
    call buildroomlogcabinunderwater
    jp tilefinisheddorandomquest
  inlogcabinwestern:
    call buildroomlogcabinwestern
    jp tilefinisheddorandomquest
  inlogcabinwesternshop:
    call buildroomstore
    jp tilefinisheddorandomquest
  inlogcabinwesternsaloon:
    call buildroomsaloon
    jp tilefinisheddorandomquest
  inbank:
    call buildroombank
    jp checkinsertstaticobjectsinbuilding ; DON'T MAKE RANDOM QUEST CHARACTER
  inchurch:
    call buildroomchurch
    jp tilefinisheddorandomquest
  ;inchurchwedding
  ;  call buildroomchurchwedding
  ;  jp tilefinisheddorandomquest
  inship:
    call buildroomship
    jp checkinsertstaticobjectsinbuilding ; DON'T MAKE RANDOM QUEST CHARACTER
  indungeon:
    call buildroomdungeon
    jp checkinsertstaticobjectsinbuilding ; DON'T MAKE RANDOM QUEST CHARACTER
  inbasement:
    call buildroombasement
    jp checkinsertstaticobjectsinbuilding ; DON'T MAKE RANDOM QUEST CHARACTER
  incave:
    call buildroomcave
    jp checkinsertstaticobjectsinbuilding ; DON'T MAKE RANDOM QUEST CHARACTER
  inwigwam:
    call buildroomwigwam
    call createmydirt
ifdef is128k
  ; BANK SWITCH SPRITES
  ld a,&C5
  ld b,&7F
  out (c),a
endif
ifdef iscart
  call romswitchsprites
endif
    jp tilefinisheddorandomquest
  instonebuilding:
    call buildroomstonebuilding
    jp tilefinisheddorandomquest
  inmine:
    call buildroommine
    jp tilefinished

; BUILD A FOREST OUT OF WHATEVER TREES OUR ZONE HAS
buildforesta:
  ld a,(currzonedata)
  ld hl,tabletrees
  call vectorlookupsingle ; GET SPRITE DATA INTO DE
  ld hl,spritelookuptable
  call vectorlookup
  ld b,30
  jp insertspriterandtimes

junglecavemountaindata:
  defb 7+100;,5         ; X, Y
  defb s_dungeonmountain ; SPRITE
  defb 255          ; END OF LIST

; BUILD JUNGLE CAVE OBSTRUCTED BY TREES
buildjunglecave:
  ld hl,junglecavemountaindata
  call buildstaticroomdef
buildforest:
  call buildforesta
  jp buildwaterjumpback

buildnarniahousedata:
  defb 7+80 ; X
  defb s_roundhouse
  defb 255
buildnarniahouse:
  ld hl,buildnarniahousedata
  call buildstaticroomdef
  jp buildwaterjumpback

; INPUT
; A = SPRITE DEFINITION
; B  = TOP RAND TIMES TO INSERT
insertspriterandtimes_dolookup:
  ; LOOKUP SPRITE DEFINITION
  ld hl,spritelookuptable
  call vectorlookup ; GET SPRITE DATA IN DE

; INPUT
; DE = SPRITE DATA
; B = TOP RAND TIMES TO INSERT
insertspriterandtimes:
  ; FIND RANDOM TIMES TO INSERT
  call randmax
  or a
  ret z
  
  ld b,a
  subrandloop2:
    call insspriterandpos
  djnz subrandloop2
ret

; INPUT
; A = SPRITE DEFINITION
; B  = TOP RAND TIMES TO INSERT
insertspriterandtimesbuildpositions_dolookup:
  ; LOOKUP SPRITE DEFINITION
  ld hl,spritelookuptable
  call vectorlookup ; GET SPRITE DATA IN DE
insertspriterandtimesbuildpositionss:
  call randmax
  or a
  ret z
  ld b,a
  insertspriterandtimesbuildpositionsloop:
    push bc
    call gettownbuildpos
    call insertspritetiles_cf
    pop bc
  djnz insertspriterandtimesbuildpositionsloop
ret

; RANDOMLY INSERT A SPRITE ONCE
; USED FOR SHOP, AS WE NEED TO KNOW IF WE HAVE INSERTED ONE OR NOT
; INPUT
; A = SPRITE DEFINITION PTR
; BC = (lastinsertpos) or (lastinsertpossaloon)
; OUTPUT
; (lastinsertpos2) = 0 NO SHOP
; (lastinsertpos2) = TILE ID = HAS SHOP
insertspriterandonce_dolookup:
  ; LOOKUP SPRITE DEFINITION
  ld hl,spritelookuptable
  call vectorlookup ; GET SPRITE DATA IN DE
insertspriterandonce:
  call randbool_cf
  ret nc
  push bc
 
  call gettownbuildpos
  call insertspritetiles_cf
  pop bc
  ret nc ; CHECK IF COULD NOT INSERT
  ; IF WE INSERTED, SAVE LAST INSERT POSITION TO WHATEVER VARIABLE WAS PASSED TO US
  ; SHOP OR SALOON, ETC
  ld a,(lastinsertpos2)
  ld (bc),a    
ret

buildcampfirewestern:
  ld b,anim_fire1 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,90         ; TILE NUMBER
  call activatetileanim 
  call genrandomquest2
  call resetpseudorandom ; MAKE SURE SCENERY ISN'T DISTURBED BY QUEST INSERTION
  jp buildwaterjumpback

; LIST OF TILE NUMBERS THAT BUILDINGS CAN BE PLACED ON WITHOUT BLOCKING
; ANYTHING. MAKES THINGS A LITTLE NEATER SO THERE IS A PROPER STREET LAYOUT
townbuildpositions equ 12
suitabletownbuildingpos:
  defb  2+60,  4+60,  7+60,  9+60,  12+60,  14+60
  defb 2+160, 4+160, 7+160, 9+160, 12+160, 14+160

; GET A RANDOM TOWN BUILDING POSITION FROM THE LIST OF POSSIBLE POSITIONS
; OUTPUT
; B = TILE NUMBER OF POSITION CHOSEN
gettownbuildpos:
  ld b,townbuildpositions
  call randmax
  ld hl,suitabletownbuildingpos
  ld b,0
  ld c,a
  add hl,bc
  ld b,(hl)
ret

buildrandomtownwestern:
  call rand  ; SOMETIMES BUILD CAMPFIRES IN WESTERN, BUT NOT ALWAYS
  sub 30
  jr c,buildcampfirewestern
  sub 60     ; SOMETIMES BUILD RANCH IN WESTERN, BUT NOT ALWAYS
  jr c,buildfarmplains
   
  ld bc,lastinsertpos
  ld a,s_generalstore
  call insertspriterandonce_dolookup
  
  ld bc,lastinsertpossaloon
  ld a,s_saloon
  call insertspriterandonce_dolookup

  ld bc,lastinsertposbank
  ld a,s_bank
  call insertspriterandonce_dolookup

  ld bc,lastinsertposjail
  ld a,s_jail
  call insertspriterandonce_dolookup
  
  ld b,4
  ld a,s_loghouse
  call insertspriterandtimesbuildpositions_dolookup
  ld b,2
  ld a,s_church
  buildrandtown:
  call insertspriterandtimesbuildpositions_dolookup
  ; BANK SWITCH TO NORMAL
ifdef is128k
  ld a,&C0
  ld b,&7F
  out (c),a
endif
ifdef iscart
  call romswitchnormal
endif
  call genrandomscreenname
  ; BANK SWITCH TO SPRITES
ifdef is128k
  ld a,&C5
  ld b,&7F
  out (c),a
endif
ifdef iscart
  call romswitchsprites
endif
  jp buildwaterjumpback

buildfarmplains:
  ld b,2
  ld a,s_farm
  call insertspriterandtimes_dolookup
  ; TRY CHURCH IF FARM WON'T FIT
  ld b,2
  ld a,s_church
  call insertspriterandtimesbuildpositions_dolookup
  jp buildwaterjumpback
buildrandomtownplains:
  call rand  ; SOMETIMES BUILD FARMS IN PLAINS, BUT NOT ALWAYS
  sub 100
  jr c,buildfarmplains
  ld b,4 ; MAX RAND OF HOUSES TO INSERT
  ld a,s_thatchhousefront
  call insertspriterandtimesbuildpositions_dolookup

  ;ld b,2
  ;ld de,s_church
  ;call insertspriterandtimesbuildpositions

  ld bc,lastinsertpos
  ld a,s_generalstore
  call insertspriterandonce_dolookup

  ;xor a
  ;ld (lastinsertpos),a   
  ;ld bc,lastinsertpos
  ;ld de,s_generalstore
  ;call insertspriterandonce

  ld b,2 ; MAX RAND OF WIGWAMS TO INSERT
  ld a,s_thatchhouse
  ;call insertspriterandtimesbuildpositions

  ;ld b,1 ; SOMETIMES BUILD FARMS IN PLAINS, BUT NOT ALWAYS
  ;ld de,s_farm
  ;call insertspriterandtimes

  jp buildrandtown
;buildfarmplains
;  ld b,1 ; SOMETIMES BUILD FARMS IN PLAINS, BUT NOT ALWAYS
;  ld de,s_farm
;  jp buildrandtown
buildrandomtownforest:
  ld b,3 ; MAX RAND OF WIGWAMS TO INSERT
  ld a,s_loghouse
  jp buildrandtown
buildrandomtownknights:
  ld b,3 ; MAX RAND OF WIGWAMS TO INSERT
  ld a,s_roundhouse
  jp buildrandtown
buildrandomtownindian:
  ; SOMETIMES BUILD CAMPFIRES IN WESTERN, BUT NOT ALWAYS
  call rand  
  sbc 50
  jp c,buildcampfirewestern
  ld b,6 ; MAX RAND OF WIGWAMS TO INSERT
  ld a,s_wigwam
  jp buildrandtown
 
  ; SOMETIMES BUILD HOSTILE INDIANS
  ;call rand  
  ;sbc 50
  ;ret c
  
  ;ld b,10 ; MAX RAND OF HOSTILES TO INSERT
  ;ld de,s_indianhostile
  ;call insertspriterandtimes
  ;ld b,50 ; MAX TARGET SQUARES TO INSERT
  ;ld de,s_indiantarget
  ;jp insertspriterandtimes
  
buildjail:
  ;ld bc,lastinsertposjail
  ld a,s_jail
  ;call gettownbuildpos
  ld b,14+60
  call insertspritetiles_cf_dolookup
  jp buildwaterjumpback

;buildchurchweddingdata
;  defb 7+100 ; X 7,6
;  defw s_churchwedding
;  defb 255 ; END OF LIST

;buildchurchwedding
;  ld hl,buildchurchweddingdata
;  jp buildstaticroomdef

buildhomedata:
  ;defb 12+80 
  ;defw s_stonebridge3
  ;defb 12+120 
  ;defw s_stonebridge2
  ;defb 12+140 
  ;defw s_stonebridge4
  ;defb 12+200 
  ;defw s_stonebridge
  ;defb 9+180 
  ;defw s_stonecastle
  ;defb 15+180 
  ;defb s_oldmansaloongame
  defb 7+100 ; X 7,6
  defb s_thatchhousefront
  defb 255 ; END OF LIST

buildhome:
  ld hl,buildhomedata
  call buildstaticroomdef
  ;ld hl,str_welcometo
  ;ld de,str_homesweethome
  ;call statusbarprintparagraphnoscroll
  jp buildwaterjumpback

; --- ABBEY ---

buildabbeytldata:
  defb 9+180 
  defb s_abbeytower
  defb 15+180 
  defb s_abbeyroof
  defb 255 ; END OF LIST
buildabbeytl:
  ld hl,buildcemetrydata2
  ld a,s_gravestone
  call buildstaticroomdefmazenew_dolookup

  ld hl,buildabbeytldata
  call buildstaticroomdef
  ; DON'T BUILD TREES
  jp jumpbackscreenfoliagey

buildabbeytrdata:
  defb 0+180 
  defb s_abbeyroof
  defb 5+180 
  defb s_abbeyroof
  defb 255 ; END OF LIST
buildabbeytr:
  ld hl,buildabbeytrdata
  call buildstaticroomdef
  ; DON'T BUILD TREES
  jp jumpbackscreenfoliagey

buildabbeybldata:
  defb 5+100 
  defb s_bigtree
  defb 9+120 
  defb s_abbeytowerbottom
  defb 15+100 
  defb s_abbeybuildingl
  defb 11+120
  defb s_abbeydoor
  defb 255 ; END OF LIST
buildabbeybl:
  ;ld hl,str_welcometo
  ;ld de,str_abbey
  ;call statusbarprintparagraphnoscroll
  ld hl,buildabbeybldata
  call buildstaticroomdef
  ; DON'T BUILD TREES
  jp jumpbackscreenfoliagey

buildabbeybrdata:
  defb 0+100 
  defb s_abbeybuildingr
  defb 255 ; END OF LIST
buildabbeybr:
  ld hl,buildabbeybrdata
  call buildstaticroomdef
  ; DON'T BUILD TREES
  jp jumpbackscreenfoliagey



buildstreetfencedataeast:
  defb 0+120
  defb s_fencehorizleft
  defb 0+60
  defb s_fencehorizleft
  defb 255

buildstreetfencedatawest:
  defb 12+120
  defb s_fencehoriz
  defb 12+60
  defb s_fencehoriz
  defb 255

buildstreetfencedatanorth:
  defb 7+180
  defb s_fencevertright
  defb 12+180
  defb s_fencevertleft
  defb 255

buildstreetfencedatasouth:
  defb 7+60
  defb s_fencevertright
  defb 12+60
  defb s_fencevertleft
  defb 255

buildstreetsnorth:
  ld hl,buildstreetfencedatanorth
  jp domystaticroomwater
buildstreetssouth:
  ld hl,buildstreetfencedatasouth
  jp domystaticroomwater
buildstreetseast:
  ld hl,buildstreetfencedataeast
  jp domystaticroomwater
buildstreetswest:
  ld hl,buildstreetfencedatawest
  jp domystaticroomwater

; BUILD A STREET OUTLINED BY FENCES
buildstreetfencedata:
  defb 7+180
  defb s_fencevertright
  defb 12+180
  defb s_fencevertleft
  defb 7+60
  defb s_fencevertright
  defb 12+60
  defb s_fencevertleft

  defb 0+120
  defb s_fencehorizleft
  defb 12+120
  defb s_fencehoriz
  defb 0+60
  defb s_fencehorizleft
  defb 12+60
  defb s_fencehoriz

  defb 255 ; END OF LIST

; BUILD A STREET OUTLINED BY HOUSES
buildstreetsdatatop:
  defb 0+60 ; X 7,6
  defb s_thatchhousefront
  defb 4+60 ; X 7,6
  defb s_thatchhousefront
  defb 12+60 ; X 7,6
  defb s_thatchhousefront
  defb 16+60 ; X 7,6
  defb s_thatchhousefront
  defb 255
buildstreetsdatabottom:
  defb 0+140 ; X 7,6
  defb s_thatchhouseback
  defb 4+140 ; X 7,6
  defb s_thatchhouseback
  defb 12+140 ; X 7,6
  defb s_thatchhouseback
  defb 16+140 ; X 7,6
  defb s_thatchhouseback
  defb 255 ; END OF LIST

buildstreetsvertdata:
  defb 5+180 ; X 7,6
  defb s_thatchhouse
  defb 12+180 ; X 7,6
  defb s_thatchhouse
  defb 255 ; END OF LIST

; START TILE, HEIGHT, WIDTH, GRAPHIC, OBJECT
buildstreetslanedata:
  defb 80,2,20,0,254
  defb 9,10,3,0,254
  defb 255           ; END OF LIST

buildstreets:
  ; CLEAR LANE OF OBJECTS
  ld hl,buildstreetslanedata
  call buildfill

  ; BUILD FENCE OUTLINING ROAD. THIS WILL BE REPLACED RANDOMLY BY HOUSES AND TREES AND BUSHES
  ld hl,buildstreetfencedata
  call buildstaticroomdef   
       
  ld a,1
  ld (movehedge_selfmod-1),a
  ld hl,buildstreetsdatabottom          ; DO RANDOM HORIZONTAL REPLACEMENTS
  call buildstaticroomdefrandomtree
  
  xor a
  ld (movehedge_selfmod-1),a
  ld hl,buildstreetsdatatop             ; DO RANDOM HORIZONTAL REPLACEMENTS
  call buildstaticroomdefrandomtree

  ld hl,buildstreetsvertdata               ; DO RANDOM VERTICAL REPLACEMENTS
  call buildstaticroomdefrandomtree;buildstaticroomdefrandomskip
  jp buildwaterjumpback

buildmassivemountainbottomdata:
  defb 0+140 ; X 9,10
  defb s_massivemountainbottom
  defb 5+140 ; X 9,10
  defb s_massivemountainbottomright
  defb 11+140 ; X 9,10
  defb s_massivemountainbottomleft
  defb 15+140 ; X 9,10
  defb s_massivemountainbottom

  defb 10+60 ; X 9,10
  defb s_massivemountainbottomleft2
  defb 6+60 ; X 9,10
  defb s_massivemountainbottomright2

  defb 255 ; END OF LIST

; START TILE, HEIGHT, WIDTH, GRAPHIC, OBJECT
mttopfilldata:
  defb 120,4,8,81,254
  defb 133,4,7,81,254
  defb 140,3,20,81,254
  defb 255
mttopleftfilldata:
  defb 134,4,6,81,254
  defb 255
mttoprightfilldata:
  defb 120,4,9,81,254
  defb 255
mtleftfilldata:
  defb 14,10,6,81,254
  defb 255
mtrightfilldata:
  defb 0,10,9,81,254
  defb 255
mtbottomleftfilldata:
  defb 14,1,5,81,254
  defb 19,5,1,81,254
  defb 255
mtbottomrightfilldata:
  defb 0,1,9,81,254
  defb 20,5,5,81,254
  defb 255
mtbottomfilldata:
  defb 0,1,20,81,254
  defb 20,4,6,81,254
  defb 34,4,6,81,254
  defb 255
; MAKE ALL ORANGE, TO MATCH REST OF MOUNTAIN
mttopcentrefilldata:
  defb 0,10,20,81,254
  defb 255
mttopcentredata:
  defb 9+100 ; X, Y
  defb s_roundhouse
  defw 255

buildmassivemountaincentre:
  ld hl,mttopcentrefilldata
  call dobuildfill
  ld hl,mttopcentredata
  jp domystaticroomwater

buildmassivemountainbottom:
  ld hl,mtbottomfilldata
  call buildfill
  ld hl,buildmassivemountainbottomdata
  jp domystaticroomwater
  ;call buildstaticroomdef
  ;jp buildwaterjumpback

buildmassivemountaintopdata:
  ; STOP BIG MOUNTAIN APPEARING IN UNFORTUNATE PLACE BY PLACING BUSH
  defb 3+120 ; X 9,10
  defb s_deadbush ;massivemountainorangeblock
  defb 0+100 ; X 9,10
  defb s_massivemountaintop
  defb 2+100 ; X 9,10
  defb s_massivemountaintop
  defb 15+100 ; X 9,10
  defb s_massivemountaintop
  defb 7+120 ; X 9,10
  defb s_massivemountaintopright
  defb 8+140 ; X 9,10
  defb s_massivemountaintop
  defb 11+120 ; X 9,10
  defb s_massivemountaintopleft
  defb 9+140 ; X 9,10
  defb s_massivemountaintop
  defb 255 ; END OF LIST

buildmassivemountaintop:
  ld hl,buildmassivemountaintopdata
  call buildstaticroomdef
  ld hl,mttopfilldata
  jp dobuildfill
  ;call buildfill
  ;jp buildwaterjumpback

buildmassivemountaintopleftdata:
  defb 11+180 ; X 9,10
  defb s_massivemountainleft
  defb 11+120 ; X 9,10
  defb s_massivemountaintopleft
  defb 15+100 ; X 9,10
  defb s_massivemountaintop
  defb 255 ; END OF LIST

buildmassivemountaintopleft:
  ld hl,buildmassivemountaintopleftdata
  call buildstaticroomdef
  ld hl,mttopleftfilldata
  jp dobuildfill
  ;call buildfill
  ;jp buildwaterjumpback

buildmassivemountaintoprightdata:
  defb 9+180 ; X 9,10
  defb s_massivemountainright
  defb 8+120 ; X 9,10
  defb s_massivemountaintopright
  defb 0+100 ; X 9,10
  defb s_massivemountaintop
  defb 4+100 ; X 9,10
  defb s_massivemountaintop
  defb 255 ; END OF LIST

buildmassivemountaintopright:
  ld hl,buildmassivemountaintoprightdata
  call buildstaticroomdef
  ld hl,mttoprightfilldata
  jp dobuildfill
  ;call buildfill
  ;jp buildwaterjumpback

buildmassivemountainrightdata:
  defb 4+80 ; X 9,10
  defb s_massivemountaintop
  defb 8+60 ; X 9,10
  defb s_massivemountainbottomright
  defb 4+60 ; X 9,10
  defb s_massivemountainbottomright2
  defb 8+100 ; X 9,10
  defb s_massivemountaintopright
  defb 9+180 ; X 9,10
  defb s_massivemountainright
  defb 255 ; END OF LIST

buildmassivemountainright:
  ld hl,mtrightfilldata
  call buildfill
  ld hl,buildmassivemountainrightdata
  jp domystaticroomwater
  ;call buildstaticroomdef
  ;jp buildwaterjumpback

buildmassivemountainleftdata:
  defb 14+80 ; X 9,10
  defb s_massivemountaintop
  defb 15+60 ; X 9,10
  defb s_massivemountainbottomleft2
  defb 11+60 ; X 9,10
  defb s_massivemountainbottomleft
  defb 11+100 ; X 9,10
  defb s_massivemountaintopleft
  defb 11+180 ; X 9,10
  defb s_massivemountainleft
  defb 255 ; END OF LIST

buildmassivemountainleft:
  ld hl,mtleftfilldata
  call buildfill
  ld hl,buildmassivemountainleftdata
  jp domystaticroomwater
  ;call buildstaticroomdef
  ;jp buildwaterjumpback

buildmassivemountainbottomrightdata:
  defb 0+140 ; X 9,10
  defb s_massivemountainbottom
  defb 4+140 ; X 9,10
  defb s_massivemountainbottomright
  defb 5+60 ; X 9,10
  defb s_massivemountainbottomright2
  defb 8+60 ; X 9,10
  defb s_massivemountainbottomright
  defb 255 ; END OF LIST

buildmassivemountainbottomright:
  ld hl,mtbottomrightfilldata
  call buildfill
  ld hl,buildmassivemountainbottomrightdata
  jp domystaticroomwater
  ;call buildstaticroomdef
  ;jp buildwaterjumpback

buildmassivemountainbottomleftdata:
  defb 11+60 ; X 9,10
  defb s_massivemountainbottomleft
  defb 15+60 ; X 9,10
  defb s_massivemountainbottomleft2
  defb 16+140 ; X 9,10
  defb s_massivemountainbottomleft
  defb 255 ; END OF LIST

buildmassivemountainbottomleft:
  ld hl,mtbottomleftfilldata
  call buildfill
  ld hl,buildmassivemountainbottomleftdata
  jp domystaticroomwater
  ;call buildstaticroomdef
  ;jp buildwaterjumpback

builddock2data:
  defb 11+140 ; X 16,9
  defb s_bridge
  defb 11+200 ; X, Y
  defb s_bridge
  defb 255 ; END OF LIST

builddock2:
  ld hl,buildriverhorizdata
  call buildstaticroomdef
  ld hl,laketopfilldata
  call buildfill
  ld hl,builddock2data
  call buildstaticroomdef

  ;ld b,12   ; HEIGHT
  ;ld c,2    ; WIDTH
  ld bc,&0c02
  ld a,72   ; START TILE
  call clearobjectmapbridge  
  jp buildwaterjumpback

builddockemptydata:
  defb 11+60 ; X 16,9
  defb s_bridge
  defb 11+100 ;
  defb s_tablelegs;
  defb 255 ; END OF LIST

builddockempty:
  ld hl,lakemidfilldata
  call buildfill
  ; CLEAR WITH BLUE - FASTER THAN REDRAWING EVERY TILE
  ld a,15
  call ClearScreen

  ld hl,builddockemptydata
  call buildstaticroomdef

  ld bc,&0402   ; HEIGHT / WIDTH
  ld a,12       ; START TILE
  call clearobjectmapbridge  
  jp buildwaterjumpback

builddockdata:
  defb 11+60 ; X 16,9
  defb s_bridge
  defb 6+60 ; X, Y
  defb s_shipwall
  defb 7+140 ; X, Y
  defb s_shipdeck
  defb 6+140 ; X, Y
  defb s_shipleftwall
  ;defb 7+140 ; X, Y
  ;defw s_shipleftwall2
  defb 17+140 ; X, Y
  defb s_shiprightwall
  ;defb 17+140 ; X, Y
  ;defw s_shiprightwall2
  defb 6+160 ; X, Y
  defb s_shipwall2
  defb 9+120 ; X, Y
  defb s_wheelhouse
  defb 255 ; END OF LIST

builddock:
  ld hl,lakemidfilldata
  call buildfill
  ; CLEAR WITH BLUE - FASTER THAN REDRAWING EVERY TILE
  ld a,15
  call ClearScreen

  ld hl,builddockdata
  call buildstaticroomdef

  ld bc,&0402   ; HEIGHT / WIDTH
  ld a,12       ; START TILE
  call clearobjectmapbridge  
  jp buildwaterjumpback

; BUILD CROSS ROAD FROM HEDGE ROWS
;buildcrossroaddata
;  defb 12+60       ; X 7,6
;  defw s_hedgehoriz 
;  defb 12+120       ; X 7,6
;  defw s_hedgehoriz 
;  defb 0+60         ; X 7,6
;  defw s_hedgehoriz 
;  defb 0+120         ; X 7,6
;  defw s_hedgehoriz 
;  defb 6+40         ; X 7,6
;  defw s_hedgevert 
;  defb 12+40         ; X 7,6
;  defw s_hedgevert 
;  defb 6+180         ; X 7,6
;  defw s_hedgevert 
;  defb 12+180         ; X 7,6
;  defw s_hedgevert 
;  defb 255          ; END OF LIST

;buildcrossroad
;  ld hl,buildcrossroaddata

domystaticroomwater:
  call buildstaticroomdef
  jp buildwaterjumpback

;buildhorizroaddata
;  defb 12+60       ; X 7,6
;  defw s_hedgehoriz 
;  defb 12+120       ; X 7,6
;  defw s_hedgehoriz 
;  defb 0+60         ; X 7,6
;  defw s_hedgehoriz 
;  defb 0+120         ; X 7,6
;  defw s_hedgehoriz 
;  defb 8+60         ; X 7,6
;  defw s_hedgehoriz 
;  defb 8+120         ; X 7,6
;  defw s_hedgehoriz 
;  defb 255          ; END OF LIST

;buildhorizroad
;  ld hl,buildhorizroaddata
;  jr domystaticroomwater

;buildvertroaddata:
;  defb 6+0         ; X 7,6
;  defw s_bush 
;  defb 12+0         ; X 7,6
;  defw s_bush 
;  defb 6+60         ; X 7,6
;  defw s_hedgevert 
;  defb 12+60         ; X 7,6
;  defw s_hedgevert 
;  defb 6+120         ; X 7,6
;  defw s_hedgevert 
;  defb 12+120         ; X 7,6
;  defw s_hedgevert 
;  defb 6+180         ; X 7,6
;  defw s_hedgevert 
;  defb 12+180         ; X 7,6
;  defw s_hedgevert 
;  defb 255          ; END OF LIST

lanefilldata:
  defb 8,5,4,0,254
  defb 255

buildvertroad:
  ;ld hl,lanefilldata
  ;call buildfill
  ld a,s_bigtree
  ld hl,buildavenuedata2
  call buildstaticroomdefmazenew_dolookup
  jp jumpbackscreenfoliagey; DONT MAKE TREESdomystaticroomwater

; ------------ STONE WALL ---------------

buildstonewalltopleftdata:
  defb 13+100         ; X 7,6
  defb s_stonewalltopleft 
  defb 15+100         ; X 7,6
  defb s_stonewallhoriz
  defb 13+180         ; X 7,6
  defb s_stonewallvert
  defb 255          ; END OF LIST

buildstonewalltopleftuw:
  call makeseapalette
  call buildstonewalltopleft
  jp buildkelp
buildstonewalltopleft:
  ld hl,buildstonewalltopleftdata
  jr domystaticroomwater

buildstonewalltoprightdata:
  defb 0+100         ; X 7,6
  defb s_stonewallhoriz
  defb 5+100         ; X 7,6
  defb s_stonewallhoriz
  defb 8+100         ; X 7,6
  defb s_stonewallhoriz
  defb 12+100         ; X 7,6
  defb s_stonewalltopright
  defb 13+180         ; X 7,6
  defb s_stonewallvert
  defb 255          ; END OF LIST

buildstonewalltoprightuw:
  call makeseapalette
  call buildstonewalltopright
  jp buildkelp
buildstonewalltopright:
  ld hl,buildstonewalltoprightdata
  jp domystaticroomwater

buildstonewallbottomleftdata:
  defb 13+80         ; X 7,6
  defb s_stonewallvert
  defb 13+100         ; X 7,6
  defb s_stonewallbottomleft 
  defb 15+100         ; X 7,6
  defb s_stonewallhoriz
  defb 13+40         ; X 7,6
  defb s_stonewallvert
  defb 255          ; END OF LIST

buildstonewallbottomleftuw:
  call makeseapalette
  call buildstonewallbottomleft
  jp buildkelp
buildstonewallbottomleft:
  ld hl,buildstonewallbottomleftdata
  jp domystaticroomwater

buildstonewallbottomrightdata:
  defb 13+80         ; X 7,6
  defb s_stonewallvert
  defb 12+100         ; X 7,6
  defb s_stonewallbottomright
  defb 0+100         ; X 7,6
  defb s_stonewallhoriz
  defb 5+100         ; X 7,6
  defb s_stonewallhoriz
  defb 8+100         ; X 7,6
  defb s_stonewallhoriz
  defb 13+40         ; X 7,6
  defb s_stonewallvert
  defb 255          ; END OF LIST

buildstonewallbottomrightuw:
  call makeseapalette
  call buildstonewallbottomright
  jp buildkelp
buildstonewallbottomright:
  ld hl,buildstonewallbottomrightdata
  jp domystaticroomwater

; STONE WALL WITH DUNGEON ENTRANCE
buildstonewallvertdungeonentrance:
  ld a,s_dungeonentrance
  ld bc,&0605
  call insertspritetilesxy_dolookup
buildstonewallvert:
  ld a,s_stonewallvert
  ld hl,buildstonewallvertdata2
  buildstaticroomdefmazenewwater:
  call buildstaticroomdefmazenew_dolookup
  jp domystaticroomwater
; UNDER WATER PALETTE
buildstonewallvertuw:
  call makeseapalette
  call buildstonewallvert
  jp buildkelp

buildstonewallhorizuw:
  call makeseapalette
  call buildstonewallhoriz
  jp buildkelp
buildstonewallhoriz:
  ld a,s_stonewallhoriz
  ld hl,buildstonewallhorizdata2
  jr buildstaticroomdefmazenewwater
  ;call buildstaticroomdefmazenew
  ;jp domystaticroomwater

buildstonewallarchwaydata:
  defb 0+100         ; X 7,6
  defb s_stonewallhoriz
  defb 4+100         ; X 7,6
  defb s_stonewallhoriz
  defb 11+100         ; X 7,6
  defb s_stonewallhoriz
  defb 15+100         ; X 7,6
  defb s_stonewallhoriz
  defb 8+100
  defb s_stonewallarchway
  defb 255          ; END OF LIST

buildstonewallarchwayuw:
  call makeseapalette
  call buildstonewallarchway
  jp buildkelp
buildstonewallarchway:
  ld hl,buildstonewallarchwaydata
  jp domystaticroomwater

buildstonewallarchwaycastledata:
  defb 6+20         ; X, Y
  defb s_bigtree
  defb 12+20        ; X, Y
  defb s_bigtree     
  defb 255          ; END OF LIST

buildstonewallarchwaycastle:
  ld hl,buildstonewallarchwaycastledata
  call buildstaticroomdef
  ld hl,lanefilldata
  call buildfill
  ld hl,buildstonewallarchwaydata
  jp domystaticroomwater

; ------------ MOUNTAIN RANGE ----------------

buildmountainrangetopdata:
  defb 2+180 ; X
  defb s_bignewmountaintophalf
  defb 255 ; END OF LIST

buildmountainrangetop:
  ld hl, buildmountainrangetopdata
  call buildstaticroomdef
  buildmountainrange:
  ld b,3 ; MAX RAND OF WIGWAMS TO INSERT
  ld a,s_newmountain
  call insertspriterandtimes_dolookup
  ld b,2 ; MAX RAND OF WIGWAMS TO INSERT
  ld a,s_bignewmountain
  call insertspriterandtimes_dolookup
  jp buildwaterjumpback

buildmountainrangebottomdata:
  defb 2+40 ; X
  defb s_bignewmountain
  defb 255 ; END OF LIST

buildmountainrangebottom:
  ld hl,buildmountainrangebottomdata
  domystaticroommountain:
  call buildstaticroomdef
  jr buildmountainrange

buildmountainrangeleftdata:
  defb 16+140 ; X
  defb s_bignewmountainleft
  defb 255 ; END OF LIST

buildmountainrangeleft:
  ld hl,buildmountainrangeleftdata
  jr domystaticroommountain

buildmountainrangerightdata:
  defb 0+140 ; X
  defb s_bignewmountainright
  defb 255 ; END OF LIST

buildmountainrangeright:
  ld hl,buildmountainrangerightdata
  jr domystaticroommountain

buildborderfencehorizfilldata:
  defb 0+20,1,20,83,1
  defb 255

buildborderfencehoriz:
  ld hl,buildborderfencehorizfilldata
  jp buildfill

; FENCE DEFINITIONS
buildmountainblockbottom:
  call buildborderfencehoriz
  jr buildmountainrangebottom
buildlandfence:
  call buildborderfencehoriz
  jp buildwaterjumpback
buildsealandfenceleft:
  call buildborderfencehoriz
  jp buildlakeright
buildsealandfenceright:
  call buildborderfencehoriz
  jp buildlakeleft

; CHECK FOR STATIC MAP DEFINITIONS
checkstaticmapdefunderwater:
  ld hl,static_map_table_underwater
  jr checkstaticmapdefs2
checkstaticmapdefs:
  ld hl,static_map_table
checkstaticmapdefs2:
  ld de,gamemap2
  ld a,(currblockid)
  ld b,a ; GET CURR BLOCK ID IN B
  staticmaploop:
    ld a,(hl)
    cp 255
    ret z  ; END OF LIST

    ; CHECK IF CURRENT MAP IS IN LIST
    cp b
    jr z,insertstaticmapid
    inc hl
    inc hl
    inc hl
    jr staticmaploop
    
    insertstaticmapid:
    inc hl
    ld e,(hl)               ; GET POSITION OF ROOM IN BLOCK
    inc hl
    ld a,(hl)               ; GET ROOM ID TO INSERT

    ; INSERT BYTE INTO CURRENT LOCAL MAP TABLE
    ld (de),a
    ; CHECK NEXT DEFINITION
    inc hl
  jr staticmaploop

; INPUTS
; A = TILE SPRITE LOOKUP
insspriterandpos_dolookup:
  ld hl,spritelookuptable
  call vectorlookup ; GET SPRITE DEFINITION IN DE

; INPUTS
; DE = TILE SPRITE ADDRESS
insspriterandpos:
  push bc
  push de

  ld a,(de) ; GET WIDTH / HEIGHT OF SPRITE IN DE
  push af
  and %00001111     
  ld e,a             ; WIDTH IN E

  pop af
  srl a
  srl a              ; HEIGHT IN D
  srl a
  srl a
  ld d,a

  ld a,tilemap_width_tiles-1   ; GET WIDTH OF SCREEN
  sub e                        ; SUB WIDTH OF SPRITE
  ld b,a                       ; STORE IN B
  call randmax32               ; GET RANDOM NUMBER
  ld c,a                       ; BACKUP A TO C

  ld b,tilemap_height_tiles+1  ; GET HEIGHT OF SCREEN (ALLOW SLIGHTLY OFF SCREEN)
  call randmax32
  sub d                        ; CHECK WE AREN'T OFF TOP OF SCREEN
  jr c, setminypos
  add d
  ld b,a                       ; BACKUP A TO B
  jr convxy

  setminypos:
  ld b,d

  convxy:
  pop de
  call insertspritetilesxy
  pop bc
ret

; LOOKUP SPRITE IN TABLE
; A = SPRITE DEFINITION TO LOOK UP IN TABLE. GET IT INTO DE
insertspritetiles_cf_dolookup:
  ld hl,spritelookuptable
  call vectorlookup       ; GET SPRITE DEFINITION INTO DE FROM PTR IN A
  jr insertspritetiles_cf

; INSERT A LARGER SPRITE INTO THE TILEMAP ARRAY AUTOMATICALLY
; INPUTS 
; A = SPRITE DEF PTR
; C = X COORD TILE
; B = Y COORD TILE
insertspritetilesxy_dolookup:
  ld hl,spritelookuptable
  call vectorlookup
insertspritetilesxy:
  call convxytotilenum
  ld b,a

; INSERT A LARGER SPRITE INTO THE TILEMAP ARRAY AUTOMATICALLY
; DE = POINTER TO ARRAY OF SPRITE TILE IDS
; B = TILE NUMBER TO START DISPLAYING AT

; OUTPUT
; CARRY SET   = WE INSERTED SPRITE
; CARRY CLEAR = BLOCKED FROM INSERTION
insertspritetiles_cf:
  push bc ; STORE START POSITION FOR LOOPS
  push de ; BACK UP SPRITE ADDRESS IF WE HAVE TO CALL MULTIPLE TIMES
  ld c,b  ; BACK UP B

  ; CHECK OBJECT TILEMAP TO MAKE SURE WE DON'T OVERWRITE EXISTING SPRITE
  ld h,tilemap2h
  ld l,b
 
  push de ; MOVE DE TO IX
  pop ix

  ld a,(de)    
  and %00001111 ; SEPARATE WIDTH HEIGHT
  ld b,a       ; GET SPRITE WIDTH IN TILES IN B
  inc de  ; SKIP DEFAULT OBJECT TYPE
  inc de
  ; CHECK TILEMAP FOR OBSTACLES TO INSERTING SPRITE
  checkloop:
    ; DON'T CHECK MAP TILE IF IT RELATES TO EMPTY PART OF SPRITE
    ; E.G. CUTTING DOWN CACTUS IN FRONT OF BUILDING COULD PREVENT FARM FROM
    ; REAPPEARING IF YOU GO OUT AND INTO SCREEN AGAIN.
    ld a,(de) 
    or a
    jr z,skipemptyspritebytecheck

    ; SKIP REPEAT BYTE
    cp 1
    jr nz,notrepeatbyte
   
    inc l
    inc l
    inc l
    inc l

    notrepeatbyte:

    ld a,(hl)
    cp 0:emptytileid ; LAND = 00, SEA = 02
    jp nz,popoff ; DO NOT INSERT IF WE FIND SPACE OCCUPIED
    skipemptyspritebytecheck:
    inc l
    inc de
  djnz checkloop
  ; CHECK TO SEE IF WE HAVE REACHED END OF SPRITE DEFINITION
  ld a,(de)
  cp 254
  jr z,donecheck ; FINISHED CHECKING LOWER LEVEL
  cp 255
  jr z,donecheck ; FINISHED CHECKING LOWER LEVEL

  ; MOVE UP ROW
  ld a,(ix+0)              ; RESTORE WIDTH COUNT 
  and %00001111
  ld b,a
  ld a,l                   ; MOVE UP A ROW
  sub tilemap_width_tiles
  sub b
  jp c,popoff ; WE HAVE MOVED OFF SCREEN - DON'T INSERT SPRITE
  ld l,a
  inc de
  jr checkloop

  donecheck:
  ; ENTER TILES ON TO ACTUAL SPRITE TILE MAP
  ; FIND LEFT TOP POSITION TO PRINT SPRITE AT ON TILEMAP
  ld h,tilemap0h
  ld l,c
  pop de

  push de ; MOVE DE TO IX
  pop ix

  push de ; BACK UP SPRITE ADDRESS IF WE HAVE TO CALL MULTIPLE TIMES 
  inc de  ; MOVE FROM WIDTH PARAMETER TO TILE DATA
  ;inc de  ; SKIP HEIGHT PARAMETER

  ; SELF MODIFY CODE TO INSERT DEFAULT OBJECT TYPE
  ; 1 = STANDARD OBJECT
  ; 2 = WATER
  ; 3 = MOUNTAIN
  ; 4 = VERTICALLY FLIPPED STANDARD OBJECT 
  ; 5 = VERTICALLY FLIPPED NON OBSTRUCTIONAL OBJECT
  ; 6 = LEFT TREE TRUNK
  ; 7 = RIGHT TREE TRUNK
  ld a,(de)
  ld (selfmodify_objtype-1),a 
  inc de           ; SKIP DEFAULT OBJECT TYPE PARAMETER
  ld bc, 0         ; B = STORE X POS / C = SET LEVEL CHECK
  myloop:
    ld a,(de)
    or a          
    jr z,skipmarkoccupied  ; EMPTY TILE INSIDE SPRITE
    cp 253
    jp z,newrow            ; WE MOVED TO ANOTHER HORIZONTAL ROW ON SPRITE
    cp 254
    jp z,levelup           ; WE MOVED TO THE UPPER LEVEL TILE MAP
    cp 255
    jp z,endofsprite       ; WE REACHED THE END OF THE SPRITE DATA
    cp 1                   ; REPEAT LAST CHAR FOUR TIMES
    jr z,repeatlastcharfourtimes
    cp 5                   ; REPEAT PREVIOUS ROW
    jr z,repeatlastspriterow
    ; NO COMMANDS FOUND, JUST COPY SPRITE DATA
    ld (hl),a
    
    ; CHECK IF WE HAVE MOVED ON TO TOP LEVEL
    ; IF SO DO NOT MARK TILEMAP AS OCCUPIED
    ld a,c
    cp 1
    jr z,skipmarkoccupied

    ld a,(de)
    ; CHECK IF OBJECT IS EMPTY TRANSVERSABLE, IF SO AMEND OBJECT TILEMAP
    cp 252
    jp z,checkfilledtransversableid

    ; MARK OCCUPIED IN TILEMAP 2
    push hl
    ; MOVE TO OBJECT TILE MAP
    ld h,tilemap2h    
    ld (hl),1:selfmodify_objtype ; SELF MODIFYING CODE FOR OBJECT TYPE
    pop hl

    skipmarkoccupied:
    inc l
    inc de
    inc b ; REMEMBER WIDTH OF SPRITE
  jr myloop

  repeatlastspriterow:
    push de
    push hl      ; STORE POSITION
    
    ; SWAP SCREEN DESTINATION FROM HL TO DE
    push hl
    pop de
   
    ; GET NEW SOURCE IN HL - FIND PREVIOUS ROW (COPY FROM SCREEN)
    ld a,l
    add tilemap_width_tiles
    ld l,a
    ; COPY FOR WIDTH OF SPRITE
    ld a,(ix+0)              ; RESTORE WIDTH COUNT 
    and %00001111
    ld c,a
    push bc     ; PRESERVE SPRITE WIDTH
    ldir  
    pop bc                  

    ; REPEAT ABOVE COPY, ONLY ON OBJECT MAP THIS TIME (IN REVERSE TO SAVE MEMORY)
    dec hl
    dec de
    ld h,tilemap2h
    ld d,tilemap2h
    lddr

    pop hl
    pop de

    ; MOVE TO NEXT SPRITE DATA
    inc de
  jr myloop

  repeatlastcharfourtimes:
    push hl
    ; REPEAT LAST BYTE FOUR TIMES WE HAVE COPIED OBJECT TILEMAP
    ld h,tilemap2h    ;call movetotilemap2

    dec l
    ld a,(hl)
    inc l
    ld (hl),a  
    inc l
    ld (hl),a  
    inc l
    ld (hl),a  
    inc l
    ld (hl),a  
    pop hl

    ; REPEAT LAST BYTE FOUR TIMES WE HAVE COPIED GRAPHIC TILEMAP
    dec l
    ld a,(hl)
    inc l
    ld (hl),a  
    inc l
    inc b ; REMEMBER WIDTH OF SPRITE
    ld (hl),a  
    inc l
    inc b ; REMEMBER WIDTH OF SPRITE
    ld (hl),a  
    inc l
    inc b ; REMEMBER WIDTH OF SPRITE
    ld (hl),a  
    inc l
    inc b ; REMEMBER WIDTH OF SPRITE

    inc de ; MOVE PAST REPEAT CHAR
  jp myloop

  levelup:
    ld h,tilemap1h    ;call movetotilemap1
    ld c,1 ; SET CURRENT LEVEL CHECK

    newrow: ; MOVE UP A TILE ROW ON SCREEN BUT NOT IN HEIGHT - EG WATER/FIELD
    ld a,l
    sub tilemap_width_tiles ; FIND NEXT ROW POSITION (MINUS AS WE ARE GOING UP IN HEIGHT)
    sub b                   ; FIND LEFT POSITION OF SPRITE AGAIN
    jr c, endofsprite       ; DO NOT PRINT IF OUT OF SCREEN
    ld b,0                  ; RESET ROW COUNT
    ld l,a 
    inc de
  jp myloop
 
  endofsprite:
  
  ; CHECK IF WE NEED TO MODIFY OBJECT TILE MAP TO INSERT DOOR, ETC
  inc de
  ld a,(de)
  or a
  jr z, popoff
  ; KEEP COPY OF END OF SPRITE DATA LOCATION
  push de
  pop ix
  ; FIND START OF SPRITE IN TILE MAP AGAIN
  pop de
  pop bc
  ld hl,tilemap2
  ; ADD X / Y LOCATION TO FIND DOOR, ETC
  ld a,b
  add (ix+1)
  ld b,(ix+2)
  loopyloop: 
    sub tilemap_width_tiles
  djnz loopyloop
  ld l,a

  ; SAVE LAST INSERT POSITION IN CASE WE NEED TO ADD SHOP TITLE
  ld (lastinsertpos2),a  

  ; ENTER CUSTOM OBJECT TILEMAP NUMBER
  ld a,(ix+0)
  ld (hl),a

  ; RETURN TRUE IF WE INSERTED IT
  scf 
  ret
  
  popoff:
  pop de
  pop bc  
  or a ; REURN FALSE
  ret

; MARKS OBJECT TILEMAP AS TRANSVERSABLE
; BUT OTHER OBJECTS CANNOT OCCUPY IT.
; I.E. STOPS FOLIAGE BLOCKING UP DOORWAYS
checkfilledtransversableid:
  ld a,(inbuilding)
  or a
  jr z,transversegrasstile
  xor a
  jr maketransversetile
  transversegrasstile:
  ld a,2
  maketransversetile:
  ld (hl),a     ; LOAD TILE IMAGE WITH EMPTY TILE IF IN DUNGEON AND DIRT GRASS IF NOT
  ld h,tilemap2h  
  ld (hl),254   ; MAKE TRANSVERSABLE ON OBJECT MAP
  ld h,tilemap0h
  jp skipmarkoccupied

; INSERT A LARGER SPRITE INTO THE TILEMAP ARRAY AUTOMATICALLY
; THIS ROUTINE DOES NOT CHECK FOR EXISTING SPRITE DATA
; USE THIS TO BUILD LARGE SPRITES, EG. RIVERS, OUT OF SMALLER OBJECTS
; INPUTS 
; DE = SPRITE DATA
; C = X COORD TILE
; B = Y COORD TILE
insertspritetilesxynocheck:
  call convxytotilenum
  ld b,a

; INSERT A LARGER SPRITE INTO THE TILEMAP ARRAY AUTOMATICALLY
; DE = POINTER TO ARRAY OF SPRITE TILE IDS
; B = TILE NUMBER TO START DISPLAYING AT
insertspritetilesnocheck:
  push bc ; STORE START POSITION FOR LOOPS
  push de
  ld c,b  ; BACK UP B
  jp donecheck ; JUMP STRAIGHT TO SPRITE INSERTION

minemountaindata:
  defb 12+80;,5         ; X, Y
  defb s_dungeonmountain;s_minemountain ; SPRITE
  defb 14+120;,5         ; X, Y
  defb s_smallmountain ; SPRITE
  defb 255          ; END OF LIST

buildminemountain:
  ld hl,minemountaindata
  call buildstaticroomdef
  ;ld hl,str_welcometo
  ;ld de,str_abandonedmine
  ;call statusbarprintparagraphnoscroll
  jp buildwaterjumpback

minemountain2data:
  defb 12+80;,5         ; X, Y
  defb s_dungeonmountain ; SPRITE
  defb 255          ; END OF LIST

buildminemountain2:
  ld hl,minemountain2data
  jp domystaticroomwater

archeryrangedata:
  defb 4+100;,6         ; X, Y
  defb s_target         ; SPRITE
  defb 7+80;,5          ; X, Y
  defb s_target         ; SPRITE
  defb 10+60;,4         ; X, Y
  defb s_target         ; SPRITE
  defb 13+40;,3         ; X, Y
  defb s_target         ; SPRITE
  defb 16+20;,2         ; X, Y
  defb s_target         ; SPRITE
  defb 255              ; END OF LIST

buildarcheryrange:
  ld hl,archeryrangedata
  call buildstaticroomdef
  ; DON'T BUILD TREES
  jp jumpbackscreenfoliagey

; INPUTS
; HL = PTR TO DATA BLOCK FOR FILL
; DATA BLOCK
; A = START TILE
; B = FILL HEIGHT IN TILES
; C = FILL WIDTH IN TILES
; D = TILE ID GRAPHIC
; E = OBJECT TILE ID
buildfill:
  ld a,(hl)     ; START TILE
  cp 255        ; IF END OF LIST
  ret z

  ; LOAD FILL DATA BLOCK INTO REGISTERS AND CALL FILL ROUTINE
  inc hl
  ld b,(hl)     ; FILL HEIGHT    
  inc hl
  ld c,(hl)     ; FILL WIDTH   
  inc hl
  ld d,(hl)     ; TILE ID    
  inc hl
  ld e,(hl)     ; OBJ TILE ID    
  inc hl
  
  push hl
  call fillmap ; FILL ROUTINE
  pop hl

  jr buildfill

topleftfilldata:
  defb 109,5,11,water,2
  defb 255 ; END OF LIST

buildlaketopleft:
  ld hl,buildrivertopleftdata
  call buildstaticroomdef
  ld hl,topleftfilldata
  jr dobuildfill
;------------------------------------
; ISLAND
;------------------------------------

islandtopleftfilldata:
  defb 0,5,20,water,2
  defb 100,5,6,water,2
  defb 255

buildislandtopleft:
  ld hl,buildrivertopleftdata
  call buildstaticroomdef
  ld hl,islandtopleftfilldata
  jr dobuildfill

islandtoprightfilldata:
  defb 0,5,20,water,2
  defb 109,5,11,water,2
  defb 255

buildislandtopright:
  ld hl,buildrivertoprightdata
  call buildstaticroomdef
  ld hl,islandtoprightfilldata
  jr dobuildfill

islandbottomrightfilldata:
  defb 100,5,20,water,2
  defb 8,5,12,water,2
  defb 255

buildislandbottomright:
  ld hl,buildriverbottomrightdata
  call buildstaticroomdef
  ld hl,islandbottomrightfilldata
  jr dobuildfill

islandbottomleftfilldata:
  defb 100,5,20,water,2
  defb 0,5,7,water,2
  defb 255

buildislandbottomleft:
  ld hl,buildriverbottomleftdata
  call buildstaticroomdef
  ld hl,islandbottomleftfilldata
  jr dobuildfill

;-----------------------------------
; LAKE
;-----------------------------------

lakebottomfilldata:
  defb 0,5,20,water,2
  defb 255

buildlakebottom:
  ld hl,buildriverhorizdata
  call buildstaticroomdef
  ld hl,lakebottomfilldata
  jr dobuildfill

laketopfilldata:
  defb 100,5,20,water,2
  defb 255

buildlaketop:
  ld hl,buildriverhorizdata
  call buildstaticroomdef
  ld hl,laketopfilldata
  dobuildfill:
  call buildfill
  jp buildwaterjumpback

lakemidfilldata:
  defb 0,10,20,water,2
  defb 255

buildlakemid:
  call buildsea
  jp buildwaterjumpback

laketoprightfilldata:
  defb 100,5,6,water,2
  defb 255

buildlaketopright:
  ld hl, buildrivertoprightdata
  call buildstaticroomdef
  ld hl,laketoprightfilldata
  jr dobuildfill

lakeleftfilldata2:
  defb 9,10,11,water,2
  defb 255

buildlakeleft:
  ld hl,buildriververtleftdata
  call buildstaticroomdef
  ld hl,lakeleftfilldata2
  jr dobuildfill

lakerightfilldata:
  defb 0,10,7,water,2
  defb 255

buildlakeright:
  ld hl,buildriververtleftdata
  call buildstaticroomdef
  ld hl,lakerightfilldata
  jp dobuildfill

lakebottomleftfilldata:
  defb 9,5,11,water,2
  defb 255

buildlakebottomleft:
  ld hl, buildriverbottomleftdata
  call buildstaticroomdef
  ld hl,lakebottomleftfilldata
  jp dobuildfill

lakebottomrightfilldata:
  defb 0,5,6,water,2
  defb 255

buildlakebottomright:
  ld hl, buildriverbottomrightdata
  call buildstaticroomdef
  ld hl,lakebottomrightfilldata
  jp dobuildfill

;--------------------------------------------
; SEA
; -------------------------------------------

makeseapalette:
  call setseapalette
makesea:
  ld hl,lakemidfilldata
  call buildfill
  ; CHECK IF WE HAVE SNORKEL
  bit 7,(ix+2) ; CHECK IF WE HAVE SNORKEL
  jr nz,clearscreenwithtransp
  ; CLEAR WITH BLUE - FASTER THAN REDRAWING EVERY TILE
  ld a,15
  jp ClearScreen
  clearscreenwithtransp:
  xor a
  jp ClearScreen

buildsea:
  call makesea
  
  bit 7,(ix+2) ; CHECK IF WE HAVE SNORKEL
  jp z,buildwaterjumpback

  ; SET TO USE SEA PALETTE
  call setseapalette

  buildkelp:
  ; MAKE SURE WE CAN INSERT TILES IN SEA
  ld a,2   ; OBJECT ID
  ld (emptytileid-1),a
  ld a,100 ; GRAPHIC ID
  ld (emptytileid2-1),a
  ld hl,domyseaata
  call dofoliage
  ; MAKE SURE WE CANT INSERT TILES IN SEA
  xor a   ; OBJECT ID
  ld (emptytileid-1),a
jp buildwaterjumpback

setseapalette:
  ld a,(nighttime)
  set 1,a
  ld (nighttime),a
ret

domyseaata:
  defb 4              ; MAX RAND OF TREES TO INSERT
  defb s_kelp         ; SPRITE DEFINITION
  defb 3
  defb s_smallmountain
  defb 2
  defb s_newmountain
  ;defb 2
  ;defw s_cavemountain
  defb 255

underwaterentrancedata:
  defb 5+100;,8 ; X, Y
  defb s_cryptentrance ; SPRITE
  defb 9+80 ; X, Y
  defb s_thatchhouse
  defb 13+140 ; X, Y
  defb s_thatchhousefrontunderwater
  defb 255 ; END OF LIST

buildunderwaterentrance:
  call makeseapalette

  ; MAKE SURE WE CAN INSERT TILES IN SEA
  ld a,2
  ld (emptytileid-1),a
  ld a,0 ; GRAPHIC ID
  ld (emptytileid2-1),a
  ld hl,underwaterentrancedata
  buildunderwaterstatic:
  call buildstaticroomdef
  xor a
  ld (emptytileid-1),a
  jr buildkelp

underwaterruinsdata:
  defb 3              ; MAX RAND OF TREES TO INSERT
  defb s_castle         ; SPRITE DEFINITION
  defb 5
  defb s_towerroof
  defb 4              ; MAX RAND OF TREES TO INSERT
  defb s_kelp         ; SPRITE DEFINITION
  defb 3
  defb s_smallmountain
  defb 255

buildunderwaterruins:
  call makeseapalette

  ; MAKE SURE WE CAN INSERT TILES IN SEA
  ld a,2
  ld (emptytileid-1),a
  ld a,0 ; GRAPHIC ID
  ld (emptytileid2-1),a
  ld hl,underwaterruinsdata
  call dofoliage
  jp buildwaterjumpback; dofoliage

;--------------------------------------------
; RIVER ISLAND
;--------------------------------------------

buildrivertopleftdata:
  defb 5+140;,8 ; X, Y
  defb s_water ; SPRITE
  defb 10+140;,8
  defb s_waterhoriz
  defb 5+220;,12
  defb s_watervertical
  defb 15+140;,8
  defb s_waterhoriz
  defb 255 ; END OF LIST

buildrivertopleft:
  ld hl,buildrivertopleftdata
  call buildstaticroomdef
  ld b,anim_watershimmer1 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,107                ; TILE NUMBER
  call activatetileanim 
  ld b,anim_watershimmer2 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,128                ; TILE NUMBER
  domyactivetileanimwater:
  call activatetileanim 
  jp buildwaterjumpback

buildrivertoprightdata:
  defb 4+140;,8
  defb s_water
  defb 0+140;,8
  defb s_waterhoriz
  defb 5+220;,12
  defb s_watervertical2
  defb 255 ; END OF LIST

buildrivertopright:
  ld hl,buildrivertoprightdata
  call buildstaticroomdef
  ld b,anim_watershimmer1 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,106                ; TILE NUMBER
  call activatetileanim 
  ld b,anim_watershimmer2 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,127                ; TILE NUMBER
  jr domyactivetileanimwater

buildriverhorizdata:
  defb 10+120;,7 ; X, Y
  defb s_waterhorizthin ; SPRITE
  defb 15+140;,8
  defb s_waterhoriz
  defb 5+140;,8
  defb s_waterhoriz
  defb 0+140;,8
  defb s_waterhoriz
  defb 255 ; END OF LIST

buildriverhoriz:
  ld hl,buildriverhorizdata
  call buildstaticroomdef
  ld b,anim_watershimmer1 ; LOWER SPRITE ID IN  TABLE
  ld c,87                 ; TILE NUMBER
  call activatetileanim 
  ld b,anim_watershimmer2 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,108                ; TILE NUMBER
  jr domyactivetileanimwater

buildriverhoriz2data:
  defb 15+140;,8 ; X, Y
  defb s_waterhoriz ; SPRITE
  defb 10+140;,8
  defb s_waterhoriz
  defb 5+120;,7
  defb s_waterhorizthin
  defb 0+140;,8
  defb s_waterhoriz
  defb 6+140;,8
  defb s_bridge
  defb 255 ; END OF LIST

buildriverhoriz2:
  ld hl, buildriverhoriz2data
  call buildstaticroomdef
  ld bc,&0502
  ;ld b,5 ; HEIGHT
  ;ld c,2 ; WIDTH
  ld a,67 ; START TILE
  call clearobjectmapbridge  
  ld b,anim_watershimmer1 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,92                 ; TILE NUMBER
  call activatetileanim 
  ld b,anim_watershimmer2 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,113                ; TILE NUMBER
  jr domyactivetileanimwater

buildriververtleftdata:
  defb 5+20;,2           ; X, Y
  defb s_watervertical ; SPRITE
  defb 6+120;,7
  defb s_watervertical2
  defb 5+220;,12
  defb s_watervertical
  defb 255

buildriververtleft:
  ld hl,buildriververtleftdata
  call buildstaticroomdef
  ld b,anim_watershimmer1 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,87                 ; TILE NUMBER
  call activatetileanim 
  ld b,anim_watershimmer2 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,108                ; TILE NUMBER
  jp domyactivetileanimwater

buildwaterfalldata:
  defb 5+20;,2           ; X, Y
  defb s_watervertical ; SPRITE
  defb 6+120;,7
  defb s_watervertical2
  defb 6+140;,7
  defb s_watervertical2
  defb 5+220;,12
  defb s_watervertical
  defb 3+100;,12
  defb s_waterfall2
  defb 255

buildwaterfall:
  ld hl,buildwaterfalldata
  call buildstaticroomdef
  jp buildwaterjumpback
  ;ld b,anim_watershimmer1 ; LOWER SPRITE ID IN ANIM TABLE
  ;ld c,129                 ; TILE NUMBER
  ;call activatetileanim 
  ;ld b,anim_watershimmer1 ; LOWER SPRITE ID IN ANIM TABLE
  ;ld c,127                 ; TILE NUMBER
  ;call activatetileanim 
  ;ld b,anim_watershimmer2 ; LOWER SPRITE ID IN ANIM TABLE
  ;ld c,128                ; TILE NUMBER
  ;jp domyactivetileanimwater

buildriverbottomrightdata:
  defb 4+140;,8
  defb s_water
  defb 5+60;,4
  defb s_watervertical2
  defb 0+140;,8
  defb s_waterhoriz
  defb 255

buildriverbottomright:
  ld hl, buildriverbottomrightdata
  call buildstaticroomdef
  ld b,anim_watershimmer1 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,106                ; TILE NUMBER
  call activatetileanim 
  ld b,anim_watershimmer2 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,127                ; TILE NUMBER
  jp domyactivetileanimwater

buildriverseatopdata:
  defb 5+140;,7
  defb s_waterhoriz
  defb 10+140;,8
  defb s_waterhoriz
  defb 5+60;,12
  defb s_watervertical2
  defb 0+140;,8
  defb s_waterhoriz
  defb 15+140;,8
  defb s_waterhoriz
  defb 5+220;,12
  defb s_watervertical3
  defb 255

riverseatopfilldata:
  defb 0,6,20,water,2
  defb 126,1,5,water,2
  defb 255

buildriverseatop:
  ld hl,buildriverseatopdata
  call buildstaticroomdef
  ld hl,riverseatopfilldata
  jp dobuildfill

riverseabottomfilldata:
  defb 100,5,20,water,2
  defb 85,1,1,water,2
  defb 68,1,1,water,2
  defb 255

buildriverseabottom:
  ld hl,buildriverseatopdata
  call buildstaticroomdef
  ld hl,riverseabottomfilldata
  jp dobuildfill

buildriverbottomleftdata:
  defb 5+140;,8   ; X, Y
  defb s_water ; SPRITE
  defb 5+60;,4
  defb s_watervertical
  defb 15+140;,8
  defb s_waterhoriz
  defb 10+140;,8
  defb s_waterhoriz
  defb 255

buildriverbottomleft:
  ld hl, buildriverbottomleftdata
  call buildstaticroomdef
  ld b,anim_watershimmer1 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,106                ; TILE NUMBER
  call activatetileanim 
  ld b,anim_watershimmer2 ; LOWER SPRITE ID IN ANIM TABLE
  ld c,127                ; TILE NUMBER
  jp domyactivetileanimwater

buildcastle:
  ld hl, buildcastledata
  call buildstaticroomdef
  ; DON'T BUILD TREES
  jp jumpbackscreenfoliagey

buildcastledata:
  defb 8+80;,6
  defb s_woodenroof1
  defb 8+40;,6
  defb s_woodenroof2
  defb 5+80;,6
  defb s_castle
  defb 12+80;,6
  defb s_castle
  defb 8+120;,8
  defb s_castlegate
  defb 5+140;,9
  defb s_castle
  defb 12+140;,9
  defb s_castle
  defb 6+180         ; X 7,6
  defb s_bigtree 
  defb 12+180         ; X 7,6
  defb s_bigtree 
  defb 255              ; END OF LIST

; TAKE A TABLE OF SPRITE DEFINITIONS AND INSERT THEM INTO THE TILEMAP
; INPUTS 
; HL = TABLE OF SPRITE LOCATIONS / PTRS
buildstaticroomdef:
  ld a,(hl)
  cp 255 ; HAVE WE REACHED END OF LIST?
  ret z

  ; BUILD ROOM
  ld b,a ; GET TILE POSITION IN B
  inc hl

  ; LOAD SPRITE DATA PTR
  ld a,(hl)
  inc hl

  push hl
  ld hl,spritelookuptable
  call vectorlookup               ; GET SPRITE DEFINITION IN DE
  call insertspritetilesnocheck
  pop hl
  jr buildstaticroomdef

; TAKE A TABLE OF SPRITE DEFINITIONS AND INSERT THEM INTO THE TILEMAP
; SKIP SOME SPRITES AND REPLACE OTHERS WITH HEDGES AND TREES
buildstaticroomdefrandomtree:
  ld a,(hl)
  cp 255 ; HAVE WE REACHED END OF LIST?
  ret z

  ; LOAD SPRITE DATA
  ld b,4
  call randmax
  cp 1
  jr z,dorandomtree
  cp 2
  jr z,dorandomhedge
  cp 3
  jr z,skipthisspritebyrandom

  ; INSERT SPECIFIED TOWN SPRITE
  ld b,(hl)    ; GET TILE POSITION IN B
  inc hl
  ; GET SPECIFIED SPRITE IN DE
  ld a,(hl)  
  push hl
  ld hl,spritelookuptable
  call vectorlookup ; GET SPRITE DATA INTO DE
  jr finishrandomspriteinsert

  ; RANDOM INSERT HEDGE OR TREE
  dorandomhedge:
  ; INSERT SPECIFIED TOWN SPRITE
  ld b,(hl)    ; GET TILE POSITION IN B
  inc hl
  push hl
  ld hl,tablehedges
  jr dofinishrandomtreeinsert

  dorandomtree:
  ; INSERT SPECIFIED TOWN SPRITE
  ld b,(hl)    ; GET TILE POSITION IN B
  inc hl
  push hl
  ld hl,tabletrees

  dofinishrandomtreeinsert:
  ld a,(currzonedata)
  call vectorlookupsingle   ; GET TREE TYPE IN A
  ld hl,spritelookuptable
  call vectorlookup         ; GET SPRITE DATA FOR TREE INTO DE

  ; NEED TO MOVE HEDGE SLIGHTLY AS HOUSES ARE WIDER THAN HEDGE
  ld a,0:movehedge_selfmod
  or a
  jr z,finishrandomspriteinsert
  ld a,b
  sub tilemap_width_tiles
  ld b,a

  finishrandomspriteinsert:
  call insertspritetilesnocheck
  pop hl

  inc hl
  jr buildstaticroomdefrandomtree

  skipthisspritebyrandom:
  inc hl
  inc hl
  jr buildstaticroomdefrandomtree

  ;jr buildstaticroomdefrandomtree

  ;pop hl 
  
  ;ld a,(hl)
  ;sub 20 ; ADJUST FOR OFFSET OF HOUSES
  ;ld b,a
  ;inc hl
  ;inc hl
  ;jr continuebuildstaticroomdef

  ; RANDOMLY SKIP INSERTING TOWN SPRITE


;randomtreehoriztable
;  defw s_bigtree2
;  defw s_hedge
  ;defw s_fencehoriz

;buildstaticroomdefrandomskip
;  ld a,(hl)
;  cp 255 ; HAVE WE REACHED END OF LIST?
;  ret z

;  ; LOAD SPRITE DATA
;  ld b,2
;  call randmax32
;  or a
;  jr z,skipthisspritebyrandom2

;  ; INSERT SPECIFIED TOWN SPRITE
;  ld b,(hl)    ; GET TILE POSITION IN B
;  inc hl
;  ; GET SPECIFIED SPRITE IN DE
;  ld a,(hl)  
;  inc hl
;  ;ld d,(hl)
;  ;inc hl
;  push hl
;  ld hl,spritelookuptable
;  call vectorlookup
;  call insertspritetilesnocheck
;  pop hl
;  jr buildstaticroomdefrandomskip

;  ; RANDOMLY SKIP INSERTING TOWN SPRITE
;  skipthisspritebyrandom2:
;  inc hl
;  ;inc hl
;  inc hl
;  jr buildstaticroomdefrandomskip

; INSERT STATIC CHARACTERS ON TILEMAP FOR QUESTS
checkinsertquestspritesstatic:
  xor a
  ld (doroomidcheck_minusone-1),a ; SKIP ROOM IDS FOR STATIC QUEST OBJECTS
  ld iy,quest_data
  ld bc,11 ; DATA OBJECT SIZE
  jr checkinsertquestspritesloop
; INSERT RANDOM CHARACTERS ON TILEMAP FOR QUESTS
checkinsertquestspritesrandom:
  ld iy,quest_data_handsfull
  ld bc,11 ; DATA OBJECT SIZE
  jr checkinsertquestspritesloop
; INSERT STATIC OBJECTS ON TILEMAP FOR QUESTS
checkinsertquestsprites:
  ld iy,quests_fixed_sprites
  ld bc,7  ; DATA OBJECT SIZE
  ld a,c
  ld (questdatasize-1),a; STORE DATA OBJECT SIZE FOR CHECKING LATER
  checkinsertquestspritesloop:
  push bc
  ; REURN IF WE REACH END OF LIST
  ld a,(iy+0)
  cp 255
  jr z,fininsquestspri        
  ; CHECK IF STILL ACTIVE
  or a
  jr z,checknextsprite

  ld a,0:questdatasize ; CHECK SIZE OF OBJECT, IF WE ARE INSERTING OBJECT OR CHARACTER?
  cp 7
  jr z,skiplockcheck
  ; SKIP INSERTION IF QUEST IS LOCKED
  ld a,(iy+9)
  or a
  jr z,checknextsprite
  skiplockcheck:

  ; CHECK IF QUEST SPRITE IS IN CURRENT TILEMAP
  ld a,(tilemap_cur)       
  cp (iy+1)
  jr nz,checknextsprite
  ld a,(tilemap_cury)
  cp (iy+2)
  jr nz,checknextsprite
  ; IF THE OBJECT IS IN A BUILDING AND WE ARE NOT, SKIP 
  ld a,(inbuilding)
  cp (iy+3)
  jr nz,checknextsprite 
  ; IF OBJECT IS NOT IN BUILDING THEN SKIP BUILDING ID CHECK
  ld a,(iy+3)
  or a
  jr z,insquestspr
  ; IF WE ARE CHECKING RANDOM SPRITE DATA, WE HAVE TO CHECK EXTRA ROOM ID NUMBER
  ; IF WE ARE CHECKING FIXED SPRITES WE MUST SKIP THIS PART
  ; AS THE FIXED SPRITE STRUCTURE DOESN'T HAVE THIS INFORMATION
  ld a,1:doroomidcheck_minusone
  or a
  jr z,insquestspr
  ; CHECK BUILDING ID
  ld a,(tilenum_cur)
  cp (iy+10)
  jr nz,checknextsprite  
  insquestspr:
  ; INSERT QUEST SPRITE
  ld b,(iy+4) ; LOAD TILE POSITION

  ; IF SELECTED TILE IS OCCUPIED
  ; CHECK / FIND EMPTY SPACE TO MAKE SURE IT DEFINITELY GETS INSERTED
  ld h,tilemap2h
  checkanotheremptyspace:
    ld l,b
    ld a,(hl)
    or a
    jr z,foundemptyspace
    inc b
    jr checkanotheremptyspace

  foundemptyspace:
    ld (iy+4),b ; RECORD NEW TILE LOCATION IN QUEST DATA IF WE MOVED TO EMPTY SPACE
    ld a,(iy+6) ; LOAD TILE SPRITE DATA PTR INTO A
    call insertspritetiles_cf_dolookup

  checknextsprite:
    pop bc
    add iy,bc
  jr checkinsertquestspritesloop
   
  fininsquestspri:
  pop bc
ret


