; returns 8-bit-Random in A
; hl and bc saved
;

; RANDOMIZE BASED ON ROOM LOCATION AND TIME - FOR QUESTS
resetpseudorandomquest:
  call resetpseudorandom
  call rand
  ld a,(daycount-1)
  ld (rndf),a
ret

; RANDOMIZE BASED ON ROOM LOCATION - FOR BUILDINGS
resetpseudorandom:
  ld a,(inbuilding)  
  or a
  jr z,resetpseudorandomnormal
  resetpseudorandomtile:
  call resetpseudorandomnormal
  call rand
  ; MAKE INDIVIDUAL BUILDING RANDOM PSEUDO NUMBER
  ; THIS IS BASED ON TILE NUMBER OF DOORWAY ON MAIN MAP
  ld a,(tilenum_cur)
  ld (rndf),a
ret

restorestartingseed:
  ; RESET PSEUDORANDOM SEED
  ld de,rnd0
  ld hl,mydata
  jp useLDI16

; RANDOMIZE BASED ON MAP LOCATION - FOR SCENERY
resetpseudorandomnormal:
  ; RESET PSEUDORANDOM SEED
  call restorestartingseed

  ; MAKE SEED BASED ON SCREEN ID NUMBER   
  ; LOAD X COORD INTO RANDOM STRING
  ld a,(tilemap_cur)
  ld (rndf),a
  call rand
  ; LOAD Y COORD INTO RANDOM STRING
  ld a,(tilemap_cury)
  ld (rndf),a
ret

; SET CURRENT SEED TO TOWN BASED ON DESTINATION COORDINATES
setdesttownseed:
   ; RESET PSEUDORANDOM SEED
  call restorestartingseed
  
  ld a,(deltownx-1) ; STORE COORDINATE IN QUEST STRING FOR DISPLAYING COORDINATE OF TOWN
  ld (rndf),a
  call rand
  ; LOAD Y COORD INTO RANDOM STRING
  ld a,(deltowny-1) ; STORE COORDINATE IN QUEST STRING FOR DISPLAYING COORDINATE OF TOWN
  ld (rndf),a
ret

; RANDOMIZE BASED ON BLOCK ID - FOR MAP
resetpseudorandomblock:
  call restorestartingseed

  ; MAKE SEED BASED ON BLOCK ID NUMBER   
  ; LOAD X COORD INTO RANDOM STRING
  ld a,(tilemap_name+1)
  ld (rndf),a
  call rand
  ; LOAD Y COORD INTO RANDOM STRING
  ld a,(tilemap_name+5)
  ld (rndf),a
ret

; CREATE NEW RANDOM SEED
createnewrandomseed:
    push hl
    push bc
    or a                 ; RESET CARRY FLAG
    ld a,(rndf_seed)     ; LOAD END OF LINE INTO A
    ld hl,rnde_seed      ; LOAD END OF LINE MINUS 1 INTO HL
    ld bc,rnd0_seed
    jr calcrand
; CREATE A PSEUDO RANDOM NUMBER WITHOUT RESETTING THE SEED
; SO IT IS COMPLETELY RANDOM
randnoseed:  
    push hl
    push bc
    or a            ; RESET CARRY FLAG
    ld a,(brndf)
    ld hl,brnde
    ld bc,brnd0
    jr calcrand
rand:  
    push hl
    push bc
    or a            ; RESET CARRY FLAG
    ld a,(rndf)     ; LOAD END OF LINE INTO A
    ld hl,rnde      ; LOAD END OF LINE MINUS 1 INTO HL
    ld bc,rnd0
    calcrand:
    adc a,(hl)      ; ADD + CARRY END OF LINE MINUS ONE TO END OF LINE
    ld (hl),a       ; LOAD RESULT INTO END OF LINE MINUS 1
    dec l           ; MOVE BACK ONE 
    adc a,(hl)      ; ADD + CARRY END OF LINE MINUS ONE TO END OF LINE
    ld (hl),a       ; LOAD RESULT INTO END OF LINE MINUS 1
    dec l           ; MOVE BACK ONE 
    adc a,(hl)      ; ADD + CARRY END OF LINE MINUS ONE TO END OF LINE
    ld (hl),a       ; LOAD RESULT INTO END OF LINE MINUS 1
    dec l           ; MOVE BACK ONE 
    adc a,(hl)      ; ADD + CARRY END OF LINE MINUS ONE TO END OF LINE
    ld (hl),a       ; LOAD RESULT INTO END OF LINE MINUS 1
    dec l           ; MOVE BACK ONE 
    adc a,(hl)      ; ADD + CARRY END OF LINE MINUS ONE TO END OF LINE
    ld (hl),a       ; LOAD RESULT INTO END OF LINE MINUS 1
    dec l           ; MOVE BACK ONE 
    adc a,(hl)      ; ADD + CARRY END OF LINE MINUS ONE TO END OF LINE
    ld (hl),a       ; LOAD RESULT INTO END OF LINE MINUS 1
    dec l           ; MOVE BACK ONE 
    adc a,(hl)      ; ADD + CARRY END OF LINE MINUS ONE TO END OF LINE
    ld (hl),a       ; LOAD RESULT INTO END OF LINE MINUS 1
    dec l           ; MOVE BACK ONE 
    adc a,(hl)      ; ADD + CARRY END OF LINE MINUS ONE TO END OF LINE
    ld (hl),a       ; LOAD RESULT INTO END OF LINE MINUS 1
    dec l           ; MOVE BACK ONE 
    adc a,(hl)      ; ADD + CARRY END OF LINE MINUS ONE TO END OF LINE
    ld (hl),a       ; LOAD RESULT INTO END OF LINE MINUS 1
    dec l           ; MOVE BACK ONE 
    adc a,(hl)      ; ADD + CARRY END OF LINE MINUS ONE TO END OF LINE
    ld (hl),a       ; LOAD RESULT INTO END OF LINE MINUS 1
    dec l           ; MOVE BACK ONE 
    adc a,(hl)      ; ADD + CARRY END OF LINE MINUS ONE TO END OF LINE
    ld (hl),a       ; LOAD RESULT INTO END OF LINE MINUS 1
    dec l           ; MOVE BACK ONE 
    adc a,(hl)      ; ADD + CARRY END OF LINE MINUS ONE TO END OF LINE
    ld (hl),a       ; LOAD RESULT INTO END OF LINE MINUS 1
    dec l           ; MOVE BACK ONE 
    adc a,(hl)      ; ADD + CARRY END OF LINE MINUS ONE TO END OF LINE
    ld (hl),a       ; LOAD RESULT INTO END OF LINE MINUS 1
    dec l           ; MOVE BACK ONE 
    adc a,(hl)      ; ADD + CARRY END OF LINE MINUS ONE TO END OF LINE
    ld (hl),a       ; LOAD RESULT INTO END OF LINE MINUS 1
    dec l           ; MOVE BACK ONE 
    adc a,(hl)      ; ADD + CARRY END OF LINE MINUS ONE TO END OF LINE

    inc a
    ld (hl),a       ; LOAD RESULT INTO END OF LINE MINUS 1

    inc l
    inc (hl)
    inc l
    inc (hl)
    inc l
    inc (hl)
    inc l
    inc (hl)
    inc l
    inc (hl)
    inc l
    inc (hl)
    inc l
    inc (hl)
    inc l  
    inc (hl)
    inc l
    inc (hl)
    inc l
    inc (hl)
    inc l
    inc (hl)
    inc l
    inc (hl)
    inc l
    inc (hl)
    inc l
    inc (hl)
    inc l
    inc (hl)
    inc l
    ld a,(bc)     ; LOAD FIRST NUMBER INTO A
    and a           ; AND IT WITH ITSELF
    pop bc
    pop hl
ret

; RANDOM NUMBER OF 256 IS CALCULATED
; THEN TAKE AWAY MAX UNTIL WE GET A MINUS FIGURE
; ADD B AGAIN TO GET NUMBER BETWEEN 0 AND MAX
; INPUTS
; B = MAX RAND
; OUTPUTS
; A = RAND NUM BETWEEN 0 AND B
randmax:
    ld a,b
    or a
    ret z
    call rand
    rand20loop:
    or a
    ret z
    loopsub20:
      sub b
    jr nc,loopsub20
    add b
ret

; USE EXISTING RANDOM GENERATED NUMBER
; INPUTS
; B = MAX RAND
;rand20existing
;  ld a,(rnd0)
;  jr rand20loop

;randexisting
;  ld a,(rnd0)
;  ret

;rand32existing
;  ld a,(rnd0)
;  jr rand32loop
;rand33existing
;  ld a,(rnd1)
;  jr rand32loop

; RETURN A RANDOM VALUE EITHER 1 OR 0
; USEFUL FOR YES OR NO SITUATIONS
randbool_cf:
   or a
   call rand
   add 80
   ;jp c,returntrue2
   ;or a
ret;jp returnfalse

; RANDOM NUMBER OF 32 IS CALCULATED
; THEN TAKE AWAY MAX UNTIL WE GET A MINUS FIGURE
; ADD B AGAIN TO GET NUMBER BETWEEN 0 AND MAX
; INPUTS
; B = MAX RAND
; OUTPUTS
; A = RAND NUM BETWEEN 0 AND B
randmax32:
    ld a,b
    or a
    ret z
    call rand
    rand32loop:
    or a
    ret z
    and %00011111 ; REDUCE TO 32 MAX
    jr loopsub20

; SAME AS RAND20 BUT DOESN'T RESET THE SEED WHEN MOVING
; SCREEN SO IT IS RANDOM!
randmaxnoseed:
    ld a,b
    or a
    ret z
    call randnoseed
    or a
    ret z
    jr loopsub20

align 16 ; KEEP ALIGNED SO WE ONLY HAVE TO INC L INSTEAD OF HL

;; COPY OF INITIAL SEED FOR PSEUDO RANDOM GENERATOR
;; THIS DATA IS USED TO RESET THE SEQUENCE SO EACH SCREEN WILL
;; KEEP THE SAME OBJECTS EACH TIME
mydata: 
  rnd0_seed: db &64,&76,&85,&54,&f6,&5c,&76,&1f,&e7,&12,&a7,&6b,&93,&c4
  rnde_seed: db &6e
  rndf_seed: db &1b

rnd0: db &64
rnd1: db &76
rnd2: db &85
rnd3: db &54,&f6,&5c,&76,&1f,&e7,&12,&a7,&6b,&93,&c4
rnde: db &6e
rndf: db &1b

; RANDOM SEED WHICH IS NOT RESET ON CHANGING SCREEN. USEFUL FOR 
; RANDOM SPRITE MOVEMENT
brnd0: db &64
brnd1: db &76
brnd2: db &85
brnd3: db &54,&f6,&5c,&76,&1f,&e7,&12,&a7,&6b,&93,&c4
brnde: db &6e
brndf: db &1b