; RANDOM CHARACTERS FOR ZONES

num_random_chars_indian equ 2
random_chars_indian:
  defb s_indianmanrandom   ; SPRITE DEFINITION 
  defb s_indianwomanrandom 
  ;defw s_indianmanconv

num_random_chars_forest equ 4
random_chars_forest:
  defb s_settlermanrandom 
  defb s_oldmanrandom
  defb s_girlblonderandom
  defb s_oldmanrandom 

num_random_chars_loghouse equ 4
random_chars_loghouse:
  defb s_settlermanrandom
  defb s_girlrandom 
  defb s_oldmanrandom 
  defb s_girlblonderandom

num_random_chars_wigwam equ 2
random_chars_wigwam:
  defb s_indianmanrandom   
  defb s_indianwomanrandom 

; LOOKUP TABLE OF LOOKUP TABLES FOR QUESTS

randomobjectnumsbyzone:
   defb rand_quest_object_num  ; zone_empty                   equ 0
   defb rand_quest_object_num  ; zone_forest                  equ 1
   defb rand_quest_object_num  ; zone_indian                  equ 2
   defb rand_quest_object_num  ; zone_knights                 equ 3
   defb rand_cowboy_object_num ; zone_western                 equ 4
   defb rand_quest_object_num  ; zone_tropical                equ 5
   defb rand_quest_object_num  ; zone_sea                     equ 6
   defb rand_viking_object_num ; zone_winter                  equ 7
   defb rand_quest_object_num  ; zone_autumn                  equ 8
   defb rand_indian_object_num ; zone_westernindian           equ 9
   defb rand_quest_object_num  ; zone_forestmountain          equ 10
   defb rand_indian_object_num ; zone_westernmountain         equ 11
   defb rand_indian_object_num ; zone_westerntropical         equ 12
   defb rand_indian_object_num ; zone_westerntropicalmountain equ 13

randomobjectlistsbyzone:
   defw rand_quest_object_ids ; zone_empty                   equ 0
   defw rand_quest_object_ids ; zone_forest                  equ 1
   defw rand_quest_object_ids ; zone_indian                  equ 2
   defw rand_quest_object_ids ; zone_knights                 equ 3
   defw cowboyobjects         ; zone_western                 equ 4
   defw rand_quest_object_ids ; zone_tropical                equ 5
   defw rand_quest_object_ids ; zone_sea                     equ 6
   defw vikingobjects         ; zone_winter                  equ 7
   defw rand_quest_object_ids ; zone_autumn                  equ 8
   defw indianquestobjects    ; zone_westernindian           equ 9
   defw rand_quest_object_ids ; zone_forestmountain          equ 10
   defw indianquestobjects    ; zone_westernmountain         equ 11
   defw indianquestobjects    ; zone_westerntropical         equ 12
   defw indianquestobjects    ; zone_westerntropicalmountain equ 13

; MAIN OBJECT LIST
rand_quest_objects equ 32
rand_quest_object_strs:
  defw str_empty         ; 0 EMPTY - CAN'T USE OBJECT WITH 0 ID, AS OUR INVENTORY IS FULL OF IT
  defw str_arrow         ; 1
  defw str_spanner       ; 2
  defw str_worldmap      ; 3
  defw str_localmap      ; 4
  defw str_bow           ; 5
  defw str_saddle        ; 6
  defw str_tobacco       ; 7
  defw str_bakedbeans    ; 8
  defw str_shootingirons ; 9
  defw str_eatingirons   ; 10
  defw str_peacepipe     ; 11
  defw str_rabbitmeat    ; 12
  defw str_feather       ; 13
  defw str_axe           ; 14
  defw str_flippers      ; 15
  defw str_bagofgold     ; 16
  defw str_pelts         ; 17
  defw str_pickaxe       ; 18
  defw str_longbow       ; 19
  defw str_dynamite      ; 20
  defw str_bagofgold     ; 21
  defw str_milk          ; 22
  defw str_bread         ; 23
  defw str_eggs          ; 24
  defw str_rope          ; 25
  defw str_lumber        ; 26
  defw str_treasuremap   ; 27
  defw str_flowers       ; 28
  defw str_compass       ; 29
  defw str_housekey      ; 30
  defw str_snorkel       ; 31
  defw str_locket        ; 32

; EACH ZONE HAS A LIST OF RANDOM OBJECT IDS THAT ARE ASSOCIATED WITH IT
; THESE ARE REFERENCED AGAINST A MAIN LIST OF DESCRIPTIONS/PRICES/ETC
; GENERAL OBJECT IDS
rand_quest_object_num equ 4
rand_quest_object_ids:
   defb 24 ; 1 EGGS
   defb 22 ; 2 MILK
   defb 23 ; 3 BREAD
   defb 8  ; 4 BAKED BEANS

rand_indian_object_num equ 8
indianquestobjects:
  defb arrow_id ; 1 ARROW
  defb bow_id   ; 2 BOW
  defb 6        ; 3 SADDLE
  defb 7        ; 4 TOBACCO
  defb 11       ; 5 PEACE PIPE
  defb 13       ; 6 FEATHER
  defb 17       ; 7 PELTS
  defb 20       ; 8 DYNAMITE

rand_cowboy_object_num equ 9
cowboyobjects:
  defb 8  ; 1 BAKED BEANS
  defb 9  ; 2 SHOOTING IRONS
  defb 10 ; 3 EATING IRONS
  defb 12 ; 4 RABBIT MEAT
  defb 7  ; 5 TOBACCO
  defb 17 ; 6 PELTS
  defb 25 ; 7 CLIMBING ROPE
  defb 6  ; 8 SADDLE
  defb 18 ; 9 PICKAXE

rand_viking_object_num equ 3
vikingobjects:
  defb 18       ; 1 PICKAXE
  defb 19       ; 2 LONGBOW
  defb 14       ; 3 AXE

; QUEST TYPES BASED ON RANDOM OBJECT ID
; NUMBER IS LOOKUP IN STATIC QUEST CONVERSATION TABLES
; ITEM ID, CORRESPONDING quest_vector NUMBER (SEE QUEST3.ASM)
; DEFAULT = TRADE - RETURN 7,8,9 FOR INDIAN COWBOY OR VIKING BASED ON ZONE ID
rand_quest_types_lookups:
  defb 20, 6    ; INDIAN WAR   - 20 DYNAMITE
  defb 12, 2    ; FAMINE       - 12 RABBIT MEAT
  defb 11, 10   ; LOST PEACE PIPE - 14 PEACE PIPE
  defb 255      ; END OF LIST

; CLEAR INACTIVE AND COMPLETED QUESTS
; THIS IS CALLED ON THE NEXT DAY, SO THAT CHARACTERS WHOSE QUESTS HAVE
; BEEN COMPLETED WILL ASK FOR A NEW QUEST
clearcompletedquests:
  ld b,0 ; CLEAR ALL 
  jr clearquestroutine
; CLEAR UNACCEPTED QUESTS WHEN MOVING SCREEN
; WE NEED TO DO THIS SO THERE IS ROOM TO GENERATE A NEW QUEST
clearinactivequests:
  ld b,1 ; ONLY CLEAR INACTIVE QUESTS, LEAVE COMPLETED ONES INTACT
clearquestroutine:
  ld iy,quest_data_handsfull
  checkrandomquestblock5:
    ld a,(iy+0)
    inc a;cp 255 ; END OF LIST
    ret z
    ld a,(iy+9)
    cp 2 ; SKIP IF QUEST IS ACTIVE
    jr z,movenextrandomquestblock5
    cp 3 ; SKIP IF PLAYER WAITING REWARD
    jr z,movenextrandomquestblock5

    ld a,b
    or a
    jr z,skipclearcompletedquests

    ld a,(iy+9)
    cp 4 ; SKIP IF QUEST IS COMPLETE - FORCES CHARACTERS NOT TO ASK FOR NEW QUEST STRAIGHT AWAY
    jr z,movenextrandomquestblock5

    skipclearcompletedquests:

    ld (iy+0),0 ; MARK BLOCK AS EMPTY AGAIN

    movenextrandomquestblock5:
      call movenextrandomquestblock
    jr checkrandomquestblock5

movenextrandomquestblock:
  push bc
  ld bc,11
  add iy,bc
  pop bc
ret

; CHECK MAP LOCATION TO SEE IF ACCEPTED QUEST ALREADY EXISTS HERE
; IF SO, DON'T GENERATE ANOTHER ONE
; INPUT
; IY = QUEST DATA BLOCK
; OUTPUT
; A = 0 NOT FOUND MATCH, 1 FOUND MATCH
checkduplicatequest_cf:
  ld iy,quest_data_randoms
  checkduplicatequestloop:
    ; IF WE REACH END OF LIST, RETURN
    ld a,(iy+0)
    cp 255 ; CHECK END OF LIST
    jp z,returnfalse2 
    or a   ; CHECK ACTIVE
    jr z,movenextrandomquestblock3

    call matchquestdata
    jr nc,movenextrandomquestblock3

    ; FOUND MATCH
    jp returntrue2
    
  movenextrandomquestblock3:
    call movenextrandomquestblock
  jr checkduplicatequestloop

findemptyrandquestslot_cf:
  ld iy,quest_data_randoms
  ; FIND FIRST INACTIVE QUEST BLOCK
  checkrandomquestblock_cf:
    ld a,(iy+0)
    cp 255 ; END OF LIST
    jp z,returnfalse2
    or a   ; SKIP IF ACTIVE
    jp z,returntrue2

    call movenextrandomquestblock
  jr checkrandomquestblock_cf

; GENERATE A RANDOM QUEST.
; A RANDOM QUEST IS GENERATED WHEN A PLAYER ENTERS A ROOM IF...
;   1) A QUEST HAS NOT ALREADY BEEN ACCEPTED FOR THIS MAP ID AND ROOM ID
;   2) IF THE ROOM CONTAINS WIFEY, MAKE A SPECIAL QUEST
genrandomquest2:
  ; CHECK IF RANDOM QUEST SPRITE ALREADY OCCUPYING SPACE
  ; CHARACTER MAY HAVE ALREADY ACCEPTED RANDOM QUEST AND INSERTING
  ; ANOTHER SPRITE WOULD CREATE A DUPLICATE
  call checkduplicatequest_cf
  ret c

  ; FIND FIRST EMPTY QUEST SLOT - IF NONE EXIST USED HANDS FULL SLOT
  call findemptyrandquestslot_cf
  jr c,createrandquest
 
  ; WE HAVE RUN OUT OF SPACE AS PLAYER HAS FILLED QUEST TABLE WITH COMPLETED OR UNCOMPLETED QUESTS
  ; CREATE A RANDOM CHARACTER JUST TO MAKE CONVERSATION
  createrandquesthandsfull:
    ld iy,quest_data_handsfull
    ld (iy+9),5                 ; 9 STATUS MAKE QUEST HANDS FULL CONVERSATION = 5
    jr createrandquestspritepos

    createrandquest:
    ; SOMETIMES DO A RANDOM GREETING
    call resetpseudorandomquest
    call rand
    adc 50
    jp c,createrandquesthandsfull

    ld (iy+9),1                 ; 9 MAKE QUEST ACTIVE

    createrandquestspritepos:
    ; MAKE SURE QUEST CHARACTER STAYS THE SAME OVER TIME
    ;call resetpseudorandomquest
    ; CREATE RANDOM QUEST CHARACTER FOR CURRENT SCREEN
    ld (iy+0),1                 ; 0 MARK ACTIVE 

    ld bc,(tilemap_cur)
    ld (iy+1),c                 ; 1 X MAP SCREEN
    ld (iy+2),b                 ; 2 Y MAP SCREEN 
    ld a,(inbuilding)
    ld (iy+3),a                 ; 3 IN BUILDING
    call resetpseudorandom      ; LOCATION NOT BASED ON DAY
    ld b,200
    call randmax
    ld (iy+4),a                 ; 4 X TILE LOCATION

    ; GET RANDOM CHARACTER SPRITE BASED ON ZONE INTO D
    call getrandomsprite
    ;ld (iy+5),e                 ; 5-6 PTR TO SPRITE DATA 
    ld (iy+6),a                 ; 5-6 PTR TO SPRITE DATA 

    ; BUT MAKE SURE QUEST IS BASED ON RANDOMIZATION OF TIME
    call resetpseudorandomquest

    ; SOMETIMES DO A TRADE QUEST
    ; SOMETIMES DO A DELIVERY QUEST
    call rand
    adc 100
    jr c,dodeliveryquest

    setrandquestobj:
    ; SET REWARD ITEM
    call getdesiredrandomobjectid
    ld (iy+7),a                 ; 7 ITEM REWARD

    ; GET RANDOM OBJECT CHARACTER NEEDS
    call getrandomobjectid      ; GET RANDOM OBJECT ID - THESE ARE DIFFERENT FROM NORMAL OBJECT IDS
    ld (iy+8),a                 ; 8 ITEM SOUGHT - 0 IF DELIVERY
    jr finishsettingquest

    ; GET RANDOM TOWN FOR DELIVERING PARCEL
    dodeliveryquest:
    ; SET REWARD ITEM
    call getrandomobjectid
    ld (iy+7),a                 ; 7 ITEM REWARD
    ld (iy+8),254               ; 8 ITEM SOUGHT - 254 IF DELIVERY

    ; IN ORDER TO DO A DELIVERY QUEST WE NEED TO KNOW
    ; 1) ARE THERE SPARE SLOTS AVAILABLE TO STORE QUEST RECEIVING CHARACTER DATA
    ; 2) HAVE WE DISCOVERED ANY TOWNS YET?
    ; IF EITHER OF THESE ARE FALSE THEN WE CAN'T DO A DELIVERY QUEST

    ; CHECK IF WE KNOW ANY TOWNS
    ld a,(discoveredtownstable)
    or a                        ; WE DON'T KNOW ANY TOWNS - JUST DO NORMAL QUEST
    jr z,setrandquestobj
    ; CHECK IF WE HAVE SPARE QUEST CHARACTER SPACE TO CREATE CHARACTER TO RECEIVE PARCEL!
    push iy
    call findemptyrandquestslot_cf
    pop iy                   
    jr nc,setrandquestobj       ; NO SLOTS AVAILABLE, DO NORMAL QUEST!

    call getrandtown_cf         ; GET A RANDOM TOWN COORDINATE TO USE FOR THIS QUEST
    
    finishsettingquest:
    ; IF WE ARE NOT IN BUILDING, NO ROOM ID PLEASE
    ld a,(inbuilding)
    or a
    jr z,clearroomid
    ld a,(tilenum_cur) 
    clearroomid:         
    ld (iy+10),a                ; 10 ROOM ID
  ret

; INPUTS
; B = OBJECT ID
; OUTPUT
; DE = PTR TO OBJECT STR
getrandobjectstr:
  ld a,b
  ld hl,rand_quest_object_strs
  jp vectorlookup

; INPUTS 
; B = OBJECT ID
; OUTPUT
; A = QUEST LOOKUP ID
getrandobjectquesttype:
  ; CHECK MEMORY ADDRESS OF TABLE
  ; IF WE ARE A RANDOM QUEST, USE TABLE TO LOOK UP QUEST STRINGS
  ; IF NOT, GO BY STATIC QUEST ID
  ld a,iyh
  cp &0A 
  jr z,skipgetstaticquestid
  ld a,(iy+0)
  ret

  skipgetstaticquestid:
    ld a,b
    cp 254                         ; IF THIS IS A DELIVERY QUEST, QUEST ID IS 7
    jr z,setdeliveryquestid

    ld hl,rand_quest_types_lookups
    getrandobjquestloop:
      ld a,(hl)
      cp 255
      jr z,randobjidnotfound
      inc hl
      cp b
      jr z,randobjidfound
      inc hl
    jr getrandobjquestloop

randobjidfound:
  ld a,(hl)
ret

setdeliveryquestid:
  ld a,7
ret

; FIND WHICH TRADABLE ITEM CONVERSATION TO USE BASED ON ZONE TYPE
; OUTPUTS
; A = 7,8 OR 9 BASED ON ZONE ID
randobjidnotfound:
  ld a,(currzonedata)
  ld hl,tradespeechesbyzone
  jp vectorlookupsingle

; CHECK IF A RANDOM QUEST HAS BEEN COMPLETED
; A QUEST BLOCK IS CREATED WHEN A SCREEN IS DRAWN
; IT IS UP TO THE PLAYER TO ACCEPT THE QUEST OR NOT
; THIS ROUTINE JUST CHECKS TO SEE IF WE BUMPED INTO A QUEST CHARACTER
; AND IF SO CHECKS WHAT STATUS THE RELATED QUEST IS AT
; INPUTS
; C = TILENUMBER OF QUEST SPRITE

checkstaticquestcomplete:
  ;ld a,1 ; A = WHETHER THIS IS STATIC OR RANDOM QUEST 0 = RANDOM QUEST
  ;ld (selfmod_israndomquest-1),a
  ld iy,quest_data
  jr checkrandomquestblock2
checkrandomquestcomplete:
  ;xor a ; A = WHETHER THIS IS STATIC OR RANDOM QUEST 0 = RANDOM QUEST
  ;ld (selfmod_israndomquest-1),a
  ld iy,quest_data_handsfull 

  ; FIND FIRST ACTIVE QUEST BLOCK
  checkrandomquestblock2:    
    ld a,(iy+0)
    cp 255 ; END OF LIST
    ret z 
    ; QUEST IS LOCKED
    or a
    jr z,movenextrandomquestblock2

    foundrandomquestblock2:
      ; CHECK TILE NUMBER OF CHARACTER SPRITE AGAINST TILE NUMBER OF QUEST
      ; IN CASE WE HAVE BUMPED INTO A DIFFERENT QUEST CHARACTER ON THE SAME SCREEN
      call checkplayerbumpedquestsprite_cf
      jr nc,movenextrandomquestblock2

      ; CHECK TIME OF DAY
      call checknighttime
      jr z,skipprintnighttime

      ; IS NIGHT TIME, PRINT ZZZZ...
      ld b,num_rand_asleep
      call randmaxnoseed
      ld hl,quest_vector_asleep
      call vectorlookuphl
      call statusbarprintparagraph ; PRINT STRING
      jp checknokeyspressed

      skipprintnighttime:

      ; PLAYER HAS BUMPED INTO SPRITE THAT RELATES TO QUEST
      ; CHECK STATUS OF QUEST
      ld a,(iy+9)
      
      dec a;cp 1 ; QUEST NOT YET ACCEPTED
      jr z,checkacceptrandomquest
      dec a;cp 2 ; QUEST IS ACCEPTED - CHECK IF PLAYER HAS DESIRED OBJECT
      jr z,checkifrandomquestcomplete
      dec a;cp 3 ; GIVE PLAYER REWARD ITEM - NEED TO CHECK IF THEY HAVE ROOM!
      jp z,giverewardonacceptance
      dec a;cp 4 ; QUEST HAS BEEN COMPLETED - PRINT THANKS... AGAIN!
      jp z,randomquestiscomplete
      dec a;cp 5 ; PLAYER HAS FILLED QUEST TABLE - JUST MAKE CONVERSATION
      jp z,randomgreeting
      ret

      movenextrandomquestblock2:
        call movenextrandomquestblock
      jr checkrandomquestblock2

      checkacceptrandomquest:
        call resetpseudorandomquest

        ; CHECK MEMORY ADDRESS OF TABLE - IF $0A, THIS IS A RANDOM QUEST
        ld a,iyh
        cp &0A 
        jr nz,askacceptqueststatic

        ; JUST SPEAK TO PLAYER INSTEAD OF GIVING THEM QUEST - SOMETIMES
        call rand
        sub 100
        jp c,randomgreeting

      ; SEE IF PLAYER WANTS TO ACCEPT QUEST
      askacceptquest:
        ;ld b,(iy+8)
        ;ld a,(selfmod_israndomquest-1)
        ;or a
        ;jr skipemptyquestitemcheck
        ; CHECK IF OBJECT ID IS 0, IF SO WE DON'T HAVE A PROPER QUEST GENERATED! AS THERE IS NO QUEST LIST FOR THIS ZONE.
        ; IF B IS 0, JUST MAKE CONVERSATION
        ; BUT IF DESIRED OBJECT IS 254, THEN GIVE PLAYER REWARD OBJECT IMMEDIATELY, AS IT IS A PARCEL TO DELIVER
        ld a,(iy+8)
        or a   ; MAKE RANDOM CONVERSATION
        jp z,randomgreeting
        
        askacceptqueststatic:
        ld b,a
        push bc
        call getrandobjectstr          ; GET OBJECT STR INTO DE
        pop bc
        call getrandobjectquesttype    ; FIND WHICH QUEST TO USE BASED ON OBJECT ID
        ld hl,quest_vector_help        ; SET VECTOR TABLE
        call outputqueststringsrandom  ; OUTPUT STRING
        call waityesno
        cp "n" 
        jr z,questrejected2

        ; QUEST ACCEPTED - BUT IF DELIVERY CHECK WE HAVE ROOM BEFORE MARKING AS ACCEPTED
        ld b,(iy+8)
        ld a,b
        cp 254                         ; 254 = IF WE DO NOT REQUIRE OBJECT, GIVE PLAYER REWARD OBJECT IMMEDIATELY (EG PARCEL TO DELIVER)
        jr z,giverewardonacceptance

        ld (iy+9),2                    ; MARK QUEST ACCEPTED
        call getrandobjectstr          ; GET DESCRIPTION OF OBJECT FROM TABLE
        call getrandobjectquesttype
        ld hl,quest_vector_accept
        call outputqueststringsrandom

        ; STOP HERE IF WE ARE RANDOM QUEST
        ; CHECK MEMORY ADDRESS OF TABLE
        ; IF WE ARE STATIC QUEST, THEN TRY TO UNLOCK NEXT QUEST NUMBER
        ld a,iyh
        cp &0A 
        ret z

        ; TRY TO UNLOCK NEXT STATIC QUEST IF AVAILABLE
        ; RELATED QUESTS MUST HAVE SEQUENTIAL NUMBERS
        ld b,(iy+0)
        inc b
        jp checkunlockquest

      ; QUEST REJECTED
      questrejected2:
        ld b,(iy+8)
        ld a,b
        cp 254 ; DELIVERY
        jr z,rejectdelivery

        call getrandobjectstr         ; GET DESCRIPTION OF OBJECT FROM TABLE

        rejectdelivery:
        call getrandobjectquesttype
        ld hl,quest_vector_reject
        jp outputqueststringsrandom

      ; CHECK IF PLAYER HAS DESIRED OBJECT
      checkifrandomquestcomplete:
        ld b,(iy+8)
        call checkplayerinvrand_cf
        jr c,markrandomquestcomplete
        ; QUEST NOT COMPLETE YET, PRINT COMPLAINT
        call getrandobjectstr        ; GET DESCRIPTION OF OBJECT FROM TABLE
        call getrandobjectquesttype
        ld hl,quest_vector_ongoing   ; *** AMEND TO PUT IN ACTUAL QUEST DETAILS
        jp outputqueststringsrandom

      markrandomquestcomplete:
        ; TAKE DESIRED OBJECT FROM PLAYER
        call remplayerinvrand
        ld (iy+9),3                  ; MARK QUEST COMPLETE - READY TO REWARD ITEM

        giverewardonacceptance:
        ld b,(iy+7)
        ld a,b
        cp 254                       ; IF DELIVERY, REWARD GOLD BUT PRINT SPECIFIC TEXT
        jr z,setrewardfordelivery

        call addplayerinvrand_cf
        jr nc,playerinventoryfull    ; INVENTORY MAY BE FULL, DON'T GIVE PLAYER REWARD UNTIL HE HAS SPACE - UNLESS REWARD IS CASH

        call getrandobjectstr        ; GET DESCRIPTION OF OBJECT FROM TABLE
        ld (iy+9),4                  ; MARK THAT WE HAVE GIVEN PLAYER REWARD
        
        ; UPDATE ROMANCE LEVEL IF CHARACTER IS A GIRL
        ;call advanceromance

        ; PLAYER HAS COMPLETED QUEST, GIVE REWARD        
        ld a,(iy+8)
        cp 254                       ; CHECK IF WE ARE DELIVERING PARCEL, IF SO CHOOSE PARCEL SPEECH
        jr z,setrewardparcelspeech

        ; PLAYER HAS COMPLETED NORMAL QUEST ITEM
        call getrandobjectquesttype
        ld hl,quest_vector_reward  
        jp outputqueststringsrandom

        ; PLAYER HAS ACCEPTED TO DELIVER PARCEL
        setrewardparcelspeech:
        ld b,a                             ; FORCE SPEECH AS PARCEL DELIVERY ID 7/254
        call getrandobjectquesttype
        ld hl,quest_vector_reward  
        call outputqueststringsrandom

        ; IF WE ARE IN THE STATIC QUEST TABLE, DON'T CREATE DELIVERY CHARACTER
        ; OTHERWISE WE NEED TO CREATE A CHARACTER TO RECEIVE THE PARCEL
        ; WE DO THIS BY CHECKING THE TABLE ADDRESS. IF IT IS IN RANGE &0A00 THEN IT IS A RANDOM QUEST
        ld a,iyh
        cp &0A 
        ret nz

        ; SET UP RECEIVING CHARACTER FOR PARCEL RECEPTION
        ld b,(iy+7)                        ; GET DESIRED ITEM FOR DELIVERY 
        ; NEED TO MAKE SURE WE HAVE SPACE FOR DELIVERY CHARACTER FIRST
        jp createdeliverycharacterquest

      setrewardfordelivery:
        ld (iy+9),4                  ; MARK THAT WE HAVE GIVEN PLAYER REWARD
        ld b,16
        call addplayerinvrand_cf
        ld hl,quest_parcel_received
        jp printstronce

      playerinventoryfull:
        ld hl,str_hands_full
        jp printstronce

      randomquestiscomplete:
        ld b,(iy+8)
        call getrandobjectstr        ; GET DESCRIPTION OF OWN OBJECT FROM TABLE
        call getrandobjectquesttype
        ld hl,quest_vector_complete  
        jp outputqueststringsrandom

; GET RANDOM CHAR SPRITE INTO A
getrandomsprite:
  ; INSIDE SPRITES
  ld a,(inbuilding)
  cp 16 ; UNDERWATER NO CHARACTERS YET
  ret z
  or a
  jr z,skipbuildcheck ; DON'T MAKE RANDOM CHARACTERS IN DUNGEON
  cp 1 ; FOREST LOG HOUSE
  jr z,loadrandomloghousesprite
  cp 3 ; INDIAN WIGWAM
  jr z,loadrandomindiansprite
  cp 4 ; KNIGHT HOUSE
  jr z,loadrandomknightsprite

  skipbuildcheck:
  ; OUTSIDE SPRITES
  ; CHECK WHAT ZONE WE ARE IN
  ld a,(currzonedata)
  ld hl,randcharbyzone
  jp vectortablelaunchcode

loadrandomforestsprite:
  ld hl,random_chars_forest
  ld b,num_random_chars_forest
  jr getrandvector
loadrandomloghousesprite:
  ld hl,random_chars_loghouse
  ld b,num_random_chars_loghouse
  jr getrandvector
loadrandomknightsprite:
  ld hl,random_chars_knights
  ld b,num_random_chars_knights
  jr getrandvector
loadrandomindiansprite:
  ld hl,random_chars_indian
  ld b,num_random_chars_indian
  getrandvector:
  call randmax32
  jp vectorlookupsingle

getrandomobjectid:
  ; GET NUMBER OF RANDOM OBJECT ITEMS FOR THIS ZONE
  ld hl,randomobjectnumsbyzone   
  ld a,(currzonedata)            ; GET CURRENT ZONE
  call vectorlookupsingle

  ; RETURN 0 IF WE HAVE NO QUEST ITEMS FOR THIS ZONE  
  ; THIS MAKES CHARACTER MAKE CONVERSATION INSTEAD OF OFFERING QUEST
  or a
  ret z

  ; GET RANDOM OBJECT NUMBER FOR THIS ZONE
  ld b,a
  call randmax
  push af                        ; SAVE OBJECT NUMBER    
      
  ; GET APPROPRIATE OBJECT LIST ZONE TABLE
  ld hl,randomobjectlistsbyzone
  ld a,(currzonedata)            ; GET CURRENT ZONE AGAIN
  call vectorlookuphl
           
  ; FIND CORRESPONDING ITEM IN ZONE LIST
  pop af   ; RESTORE QUEST NUMBER
  ; READ OBJECT ID FROM THIS LIST
  jp vectorlookupsingle

; GET RANDOM OBJECT ID FOR REWARD
; IF IT IS THE SAME AS THE OBJECT WE ARE LOOKING FOR
; THEN JUST GIVE MONEY
; OUTPUTS
; A = RANDOM OBJECT ID
getdesiredrandomobjectid:
  call getrandomobjectid
  cp (iy+8)
  ret nz
  ld a,16 ; REWARD MONEY IF DESIRED OBJECT SAME AS EXCHANGE OBJECT
ret

showqueststr:
  defb 14,0:xcoordmin1
  defb ":"
  defb 14,0:ycoordmin1
  defb " ",11
  defb 255 ; END OF LINE

showgamequests:
  ld iy,quest_data
  jr showquests
showrandomquests:
  ld iy,quest_data_randoms
  showquests:
  ld c,255 ; KEEP COUNT FOR SCROLLING
  checkrandomquestblock6:
    ld a,(iy+0)
    inc a;cp 255 ; END OF LIST
    jp z,finishprinttextquests ; DO A NICE SCROLL TO CLEAR THE STATUS BAR
    ld a,(iy+9)
    cp 2 ; IF QUEST IS ACCEPTED
    jr nz,movenextrandomquestblock6

    ; POPULATE SHOW QUEST STR
    ld a,(iy+1) ; X MAP POS
    ld (xcoordmin1-1),a
    ld a,(iy+2) ; Y MAP POS
    ld (ycoordmin1-1),a
    ld b,(iy+8)
    call getrandobjectstr          ; GET OBJECT STR INTO DE
    
    inc c                          ; KEEP COUNT OF LINES

    ld hl,showqueststr
    call statusbarprintparagraphnoscroll ; PRINT STRING

    movenextrandomquestblock6:
      call movenextrandomquestblock
    jr checkrandomquestblock6

finishprinttextquests:
  ; SCROLL TEXT SO INVENTORY STARTS AT TOP
  ld a,c
  ld (linecount),a
  jp scrolltopofpage

; CREATE A CHARACTER TO RECEIVE A PARCEL - REWARD IS MONEY
; INPUTS
; B = DESIRED ITEM ID
createdeliverycharacterquest:
  call findemptyrandquestslot_cf
  ret nc
  
  ; CREATE RANDOM QUEST CHARACTER FOR CURRENT SCREEN
  ld (iy+0),1                 ; 0 MARK ACTIVE 
  ld (iy+9),2                 ; 9 MAKE QUEST ACCEPTED
  ; SET REQUIRED ITEM
  ld (iy+8),b                 ; 8 ITEM SOUGHT
  ; SET REWARD ITEM
  ; WE NEED TO MARK THAT THIS IS A DELIVERY REWARD, SO USE 254
  ; SO WE CAN PRINT SPECIFIC TEXT UPON DELIVERY
  ; CONVERT TO GOLD WHEN ADDING TO INVENTORY
  ld (iy+7),254               ; 7 ITEM REWARD - GOLD / DELIVERY

  ; SET LOCATION OF CHARACTER
  ld a,(deltownx-1)
  ld (iy+1),a                 ; 1 X MAP SCREEN
  ld a,(deltowny-1)
  ld (iy+2),a                 ; 2 Y MAP SCREEN 
  ld (iy+3),0                 ; 3 IN BUILDING
  ld b,200
  call randmaxnoseed
  ld (iy+4),a                 ; 4 TILE LOCATION

  ; GET RANDOM CHARACTER SPRITE BASED ON ZONE INTO DE
  call getrandomsprite
  ;ld (iy+5),e                 ; 5-6 PTR TO SPRITE DATA 
  ld (iy+6),a                 ; 5-6 PTR TO SPRITE DATA 
ret