; REUSABLE CODE - WE ONLY NEED TO DRAW THE SCROLL ONCE,
; SO WE CAN REUSE THESE BYTES FOR OTHER THINGS ONCE WE HAVE DRAWN IT

; REUSABLE RANGE = &0E00 TO $1030 APPROX

scrollright2:
        DB      #0C, #08, #00
        DB      #30, #8C, #00
        DB      #7C, #64, #08
        DB      #3C, #B8, #88
        DB      #94, #B8, #08
        DB      #94, #7C, #88
        DB      #C0, #7C, #08
        DB      #C0, #7C, #88
        DB      #C0, #38, #08
        DB      #C0, #EC, #00
        DB      #94, #88, #00
        DB      #C0, #AC, #00
        DB      #C0, #6C, #00
        DB      #C0, #2C, #00
        DB      #94, #88, #00
        DB      #C0, #EC, #00
        DB      #C0, #6C, #00
        DB      #C0, #2C, #00
        DB      #C0, #6C, #00
        DB      #C0, #2C, #00
        DB      #C0, #6C, #00
        DB      #94, #EC, #00
        DB      #C0, #88, #00
        DB      #C0, #6C, #00
        DB      #C0, #6C, #00
        DB      #C0, #2C, #00
        DB      #94, #B8, #88
        DB      #C0, #7C, #88
        DB      #C0, #3C, #08
        DB      #C0, #94, #88
        DB      #C0, #94, #08
        DB      #C0, #94, #88
        DB      #C0, #94, #08
        DB      #C0, #D4, #88
        DB      #C0, #94, #08
        DB      #C0, #7C, #08
        DB      #C0, #38, #08
        DB      #3C, #B8, #08
        DB      #B8, #64, #08
        DB      #CC, #8C, #00
scrollleft:
        DB      #00, #0C, #0C, #0C
        DB      #04, #8C, #CC, #30
        DB      #4C, #30, #18, #BC
        DB      #98, #FC, #DC, #3C
        DB      #18, #3C, #5C, #68
        DB      #98, #68, #DC, #68
        DB      #4C, #C4, #1C, #68
        DB      #04, #88, #DC, #C0
        DB      #00, #00, #1C, #C0
        DB      #00, #00, #9C, #C0
        DB      #00, #44, #34, #C0
        DB      #00, #04, #E8, #C0
        DB      #00, #44, #68, #C0
        DB      #00, #04, #68, #C0
        DB      #00, #44, #E8, #C0
        DB      #00, #00, #DC, #C0
        DB      #00, #44, #E8, #C0
        DB      #00, #04, #68, #C0
        DB      #00, #44, #68, #C0
        DB      #00, #44, #E8, #C0
        DB      #00, #00, #DC, #68
        DB      #00, #44, #BC, #C0
        DB      #00, #04, #68, #C0
        DB      #00, #44, #68, #C0
        DB      #00, #44, #68, #C0
        DB      #00, #04, #E8, #C0
        DB      #00, #00, #9C, #68
        DB      #00, #00, #9C, #C0
        DB      #00, #00, #5C, #C0
        DB      #00, #00, #9C, #C0
        DB      #00, #00, #1C, #C0
        DB      #00, #00, #DC, #C0
        DB      #00, #00, #4C, #E8
        DB      #4C, #00, #DC, #C0
        DB      #5C, #CC, #1C, #C0
        DB      #9C, #7C, #1C, #C0
        DB      #9C, #C0, #5C, #68
        DB      #5C, #3C, #18, #BC
        DB      #18, #EC, #4C, #74
        DB      #04, #8C, #CC, #CC

endofblockmarkerlen equ 16
endofblockmarkertable:
  defw lastblockid                ; 0 - MAKE SURE WE CALCULATE LOCAL GAME MAP ON STARTUP
  defw bytetostring+3             ; 1
  defw wordtostr+5                ; 2
  defw str_temp+28                ; 3
  defw screentext4+28             ; 4
  defw quest_data_randoms+55      ; 5
  defw animtiles+15               ; 6
  defw player_inventory_rand+15   ; 7
  defw tilemap_name+7             ; 8
  defw tilemap_name3+7            ; 9 
  defw shopitemdisplaylist+10     ; 10
  defw mcps+28+28+28+28+28        ; 11 FIVE SPRITES AND ONE PLAYER
  defw shopinventory+60           ; 12 4 DATA X 5 ITEMS X 3 SHOPS
  defw discoveredtownstable+1+100 ; 13 50 DISCOVERED TOWNS
  defw quests_fixed_sprites+105   ; 14 15 X 7 BYTES = 105 + ENDS IN 255
  defw treedamagetable+25         ; 15 5 X 5 BYTES = 25 + ENDS IN 255

; WE ONLY NEED TO CREATE THESE TABLES ONCE AT THE START, SO WE CAN REUSE THE MEMORY FOR
; SOMETHING ELSE ONCE WE HAVE DONE IT.

; HIT BOX AREA OF SPRITE - HORIZONTAL
; POSITION 0 IS LEFT SIDE OF SPRITE

;              245,246,247,248,249,250,251,252,253,254,255
hitboxxl: defb   3,  3,  3,  3,  3,  3,  3,  3,  3,  2,  1
;                0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12
hitboxxr: defb   1,  1,  1,  2,  3,  3,  3,  3,  3,  3,  3,  3,  3

createlookuptables:
  ; GENERATE LOOKUP TABLES
  call init_mask_table
  call make_scr_table
  ld ix,letters_ptr_table
  ld hl,letters_gfx     ;; start of tile pixels (tile 0)
  ld de,font_data_size  ;; size of each tile (all tiles same size in bytes)
  ld b,59               ;; number of tiles to generate information for
  call make_ptr_table

  ld a,"$"
  ld (tilemap_name3),a

  ; CLEAR SCREEN TEXT IN STATUS BAR
  ;ld hl,screentext4
  ;ld a,255;" "
  ;ld b,28
  ;call fillloop5

  ; CLEAR LOADER DATA
ifndef iscart
  ld hl,&0900
  ld bc,255 
  call clearmem
endif

  ; INSERT END OF STRING MARKER AT END OF BLOCKS OF ALLOCATED STRINGS
  ; END OF DATA BLOCK MARKER
  ld a,255                          
  ld b,endofblockmarkerlen
  ld hl,endofblockmarkertable
  setendofblockmarkerloop:
    ld e,(hl)
    inc hl
    ld d,(hl)
    inc hl
    ld (de),a
  djnz setendofblockmarkerloop

  ; GENERATE TILE CALC TABLES - ON BYTE BOUNDARY
  ; CONVERTS BYTE POSITION TO TILE COLUMN

  ld hl,tilecalchoriz
  ld de,tilecalchoriz+1
  ld b,20
  xor a
  tilecalcloop:
    push bc
    ld (hl),a
    ld bc,4
    ldir
    inc a
    pop bc
  djnz tilecalcloop

  ; CONVERTS LINE POSITION PIXEL TO TILE ROW
  ld hl,tilecalcvert
  ld de,tilecalcvert+1
  ld b,10
  xor a
  tilecalcloop2:
    push bc
    ld (hl),a
    ld bc,16
    ldir
    inc a
    pop bc
  djnz tilecalcloop2

  ; CONVERTS TILE NUMBER POSITION TO HORIZONTAL BYTE
  ld hl,tiletablex
  ld b,20
  xor a
  tilecalcloop2x:
    ld (hl),a
    inc hl
    add 4
  djnz tilecalcloop2x

  ; CONVERTS TILE NUMBER POSITION TO VERTICAL PIXEL
  ld hl,tiletabley
  ld b,10
  xor a
  tilecalcloop2y:
    ld (hl),a
    inc hl
    add 16
  djnz tilecalcloop2y

  ; HIT BOX TABLES
  ; SPECIFIES NUMBER OF BYTES/LINES BETWEEN TWO POINTS IN WHICH A HIT IS RECORDED
  ; 0 IS CENTRE OF TWO SPRITES
  ; EITHER SIDE OF THAT WITHIN A CERTAIN RANGE IS CONSIDERED A HIT

  ; FILL WITH 1
  ; X = 255,0,1,2
  ; Y = 250,251,252,253,254,255,0,1,2,3,4,5,6,7

  ld hl,hitboxxl
  ld de,hitboxtablex+247
  ld bc,11
  ldir

  ld hl,hitboxxr
  ld de,hitboxtablex
  ld bc,13
  ldir

  ld a,1
  ;ld (hitboxtablex+255),a
  ;ld (hitboxtablex+0),a
  ;ld (hitboxtablex+1),a
  ;ld (hitboxtablex+2),a

  ld hl,hitboxtabley+0
  ld b,7
  call fillloop5

  ld hl,hitboxtabley+250
  ld b,6
  call fillloop5

  ; SET UP GRAZE AREA OF SPRITE
  ; FILL hitboxtabley-20 TO hitboxtabley+10 WITH 2

  ; FILL WITH 2
  ; X = 254,-,-,-,-,3
  ; Y = 235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,  -  8,9,10,11
  
  ld a,2
  ;ld (hitboxtablex+3),a
  ;ld (hitboxtablex+254),a

  ld hl,hitboxtabley+235
  ld b,15
  call fillloop5
  ld hl,hitboxtabley+7
  ld b,4
  call fillloop5

  ; SET UP 'AWARE' AREA OF SPRITE (FOR GUARDS) - X 3 BYTES AND Y 20 LINES DISTANCE
  ld a,3
  ;ld (hitboxtablex+10),a
  ;ld (hitboxtablex+247),a

  ld hl,hitboxtabley+200
  ld b,40
  call fillloop5
  ld hl,hitboxtabley+11
  ld b,25
  call fillloop5

  ; SET PALETTE
  ; PALETTE AND MODE FOR CARTRIDGE IS SET BY LOADER
  ; ALSO IN 128K VERSION, BUT WE KEEP HERE FOR DEVELOPMENT SAKE
ifndef iscart
  xor a
  call scr_set_mode
endif
ifndef isplus
  ;; set border to black
  ld bc,0
  call scr_set_border

  ld hl,pens
  call dopens
endif

  ; DRAW NON CHANGE GRAPHICS
  call ClearStatusBar
  call drawstatusbar

  ; MUSIC AND SOUND EFFECTS
ifndef iscart
  call setupsounds
endif
ifndef iscart
ifdef is128k
  ; DETECT RAM EXPANSION
  ld hl,&c000
  ld a,255
  ld (hl),a

  ; WE HAVE 64K
  ld a,&C3
  call bankswitch
  ld a,(hl)
  cp 255
  ret z

  ; WE HAVE EXTRA MEM
  call bankswitchnormal

  ld a,1:hasextramem
  ld (hasextramem-1),a
endif
endif
ret

;; generate table of screen addresses
;; one address per scanline. The address
;; is for the first byte of each line.
make_scr_table:
  ld ix,scr_addr_table ;; address to store table
  ld hl,&c000          ;; start address of first scanline
  ld b,200             ;; number of scanlines on screen
  mst1:
    ld (ix+0),l
    ld (ix+1),h
    inc ix
    inc ix
    push bc
    call scr_next_line_hl
    pop bc
  djnz mst1
ret

;; generate table/array of tile pixel ptrs
;; so that we can access tile pixels quickly based
;; on tile index 
make_ptr_table:
  mtpt1:
    ld (ix+0),l
    ld (ix+1),h
    inc ix
    inc ix
    add hl,de
  djnz mtpt1
ret