;b_nothing                   equ 0

;b_laketopleft               equ 1
;b_laketop                   equ 2
;b_laketopright              equ 3
;b_lakeleft                  equ 4
;b_lakemid                   equ 5
;b_lakeright                 equ 6
;b_lakebottomleft            equ 7
;b_lakebottom                equ 8
;b_lakebottomright           equ 9

;b_rivertopleft              equ 10
;b_riververtleft             equ 11
;b_rivertopright             equ 12
;b_riverhoriz                equ 13
;b_riverhoriz2               equ 14
;b_riverbottomleft           equ 15
;b_riverbottomright          equ 16

;b_islandtopleft             equ 17
;b_islandtopright            equ 18
;b_islandbottomleft          equ 19
;b_islandbottomright         equ 20

;b_buildmountainrangetop     equ 38
;b_buildmountainrangebottom  equ 39
;b_riverseatop               equ 42
;b_riverseabottom            equ 43
;b_buildforest               equ 44
;b_narniahouse               equ 45
;b_mountainblockbottom       equ 46 
;b_landfence                 equ 47
;b_sealandfenceleft          equ 48
;b_sealandfenceright         equ 49
;b_buildmountainrange        equ 50
;b_buildmountainrangeleft    equ 51
;b_buildmountainrangeright   equ 52
;b_buildcrossroad            equ 53
;b_buildvertroad             equ 54
;b_buildhorizroad            equ 55
;b_buildcampfirewestern      equ 56
;b_waterfall                 equ 86

; LOCAL MAP BLOCKS 10x10 SQUARES
; RLE COMPESSION USED
; 255 = REPEAT LAST DE ROW
; 254 = REPEAT LAST VALUE FOUR TIMES
; 253 = REPEAT LAST TWO DE ROWS
; 252 = REPEAT LAST VALUE THREE TIMES
; 251 = REPEAT LAST VALUE TWICE

bloodylake:
  defb 0, 254, 0, 254
  defb 255
  defb 0, 254, 1, 2, 3, 0, 0
  defb 0, 251, 1, 3, 4, 5,19, 3, 0
  defb 0, 1, 2,20,19,20, 5, 5, 6, 0
  defb 0, 7, 8,18, 5, 252, 6, 0
  defb 0, 251, 7, 8,18,17, 8, 9, 0
  defb 0, 254, 7, 9, 0, 251
  defb 0, 254, 0, 254
  defb 255

largeisland:
  defb 5, 254, 5, 254
  defb 5, 5,17, 8, 8,18, 5, 252
  defb 5, 5, 6, 0, 0, 4, 5, 252
  defb 5,17, 9, 0, 0, 7, 8,18, 5, 5
  defb 5, 6, 0, 252, 1,20, 5, 5
  defb 5, 6, 0, 252, 4, 5, 251
  defb 5, 6, 0, 1, 2, 3, 4, 5, 251
  defb 5,19, 2,20, 5, 6, 7,18, 5, 5
  defb 5, 254,19, 2,20, 5, 5
  defb 5, 254, 5, 254

; LANDS WITH RIVER
; OPTIMIZED
;seamapdividinglandtop
;  defb 0,254, 0, 254
;  defb 255
;  defb 253
;  defb 0, 254, 0, 251, 1, 3
;  defb 2, 3, 0, 254, 1,20,19
;  defb 5, 6, 0, 252, 38, 4, 5, 5
;  defb 5, 19, 2, 3,44,38,39, 7,18, 5
;  defb 5, 251,48,47,46,47,47,49, 5 ; FENCE
;  defb 5, 5,17, 9,51,52,44, 1,20, 5
; OPTIMIZED
;seamapdividinglandbottom
;  defb 5, 5, 6, 0, 252, 4, 5, 5
;  defb 5, 5, 19, 3, 0, 251, 7,18, 5
;  defb 5, 251, 6, 0, 252, 4, 5
;  defb 5, 5, 17, 9, 0, 251, 1,20, 5
;  defb 18,5, 6, 0, 252, 4,17, 8
;  defb 7, 8, 9, 0, 252, 7, 9, 0
;  defb 0, 254, 0, 254
;  defb 255
;  defb 253
; OPTIMIZED
seamaptopleftriver:
  defb 5,254,5,254
  defb 255
  defb 255
  defb 5,254,5,17,8,18,5
  defb 5,252,17,8,9,0,7,42
  defb 5,252,6,0,252,11
  defb 5,251,17,9,0,252,86;11
  defb 5,251,6,0,254,11
  defb 5,251,19,3,10,14,13,13,16
  defb 5,252,6,11,0,252
; OPTIMIZED
seamapbottomleftriver:
  defb 5,251,17,9,11,0,252
  defb 5,251,6,0,15,12,0,251
  defb 5,251,6,0,0,11,0,251
  defb 5,251,19,3,0,15,13,12,0
  defb 5,252,6,1,2,3,11,0
  defb 5,252,19,20,5,19,43,2
  defb 5,254,5,254
  defb 255
  defb 253
; LAND
; OPTIMIZED
seamapbottomrightland:
  defb 5,252,6,0,254
  defb 5,252,19,3,0,252
  defb 5,254,6,0,252
  defb 5,252,17,9,0,252
  defb 18,5,251,6,0,254
  defb 4,5,5,17,9,0,254
  defb 7,8,8,9,0,0,254
  defb 0,254,0,254
  defb 255
  defb 255
; OPTIMIZED
seamaptopleftland:
  defb 0,254,0,254
  defb 255
  defb 253
  defb 0,254,0,1,2,3,0
  defb 0,254,0,4,5,19,2
  defb 0,252,0,1,20,5,251
  defb 0,251,0,1,20,5,252
  defb 0,251,0,4,5,254
  defb 0,251,0,7,18,5,252
;OPTIMIZED
seamaptoprightland:
  defb 0,254,0,254
  defb 255
  defb 253
  defb 1,3,1,3,0,0,254
  defb 20,19,20,19,2,3,0,252
  defb 5,252,17,9,0,252
  defb 5,252,19,3,0,252
  defb 5,254,6,0,252
  defb 5,252,17,9,0,252
;OPTIMIZED
seamapbottomleftland:
  defb 0,254,4,5,252
  defb 255
  defb 0,252,1,20,5,252
  defb 0,251,1,20,5,254
  defb 0,251,7,18,5,5,17,8,8
  defb 0,252,7,8,8,9,0,0
  defb 0,254,0,254
  defb 255
  defb 253
; OPTIMIZED
seamapsea:
  defb 5,254,5,254
  defb 255
  defb 253
  defb 253
  defb 253
  defb 253
; OPTIMIZED
seamaprightland:
  defb 5,252,6,0,254
  defb 5,251,17,9,0,254
  defb 5,251,6,0,0,254
  defb 5,251,19,3,0,254
  defb 5,252,19,3,0,252
  defb 5,252,5,6,0,252
  defb 5,252,17,9,0,252
  defb 5,251,17,9,0,254
  defb 5,251,19,3,0,254
  defb 5,252,6,0,254
; OPTIMIZED
seamaptopland:
  defb 0,254,0,254
  defb 255
  defb 0,0,1,2,2,3,0,252
  defb 0,0,4,5,5,6,0,252
  defb 0,0,4,5,5,19,2,3,0,0
  defb 2,2,20,5,5,251,19,2,2
  defb 5,254,5,254
  defb 255
  defb 253
; OPTIMIZED
seamapbottomrightsea:
  defb 0,254,4,5,252
  defb 0,254,7,18,5,251
  defb 0,254,0,4,5,251
  defb 0,254,1,20,5,251
  defb 0,254,4,5,252
  defb 2,3,0,1,2,20,5,252
  defb 5,19,2,20,5,5,254
  defb 5,254,5,254
  defb 255
  defb 255
; OPTIMIZED
seamaptoprightsea:
  defb 5,254,5,254
  defb 255
  defb 253
  defb 8,18,5,17,8,18,5,252
  defb 0,7,8,9,0,4,5,252
  defb 0,254,7,18,5,251
  defb 0,254,0,4,5,251
  defb 255
  defb 0,254,1,20,5,251
; OPTIMIZED
seamapbottomleftsea:
  defb 5,251,17,9,0,254
  defb 5,251,6,0,0,254
  defb 255
  defb 5,251,19,3,0,254
  defb 5,252,6,1,2,3,0,0
  defb 5,252,19,20,5,19,2,2
  defb 5,254,5,254
  defb 255
  defb 253
; OPTIMIZED
seamaptopleftsea:
  defb 5,254,5,254
  defb 255
  defb 255
  defb 5,254,5,17,8,18,5
  defb 5,252,17,8,9,0,7,8
  defb 5,252,6,0,254
  defb 5,251,17,9,0,44,38,44,0
  defb 5,251,6,0,44,38,39,44,0
  defb 5,251,19,3,0,39,44,0,0
  defb 5,252,6,0,254
; OPTIMIZED
seamapleftland:
  defb 0,254,4,5,252
  defb 0,254,7,18,5,251
  defb 0,254,0,7,18,5,5
  defb 0,254,0,0,4,5,5
  defb 255
  defb 0,254,0,1,20,5,5
  defb 0,252,1,2,20,5,251
  defb 0,252,4,5,254
  defb 0,252,7,18,5,252
  defb 0,254,4,5,252
; OPTIMIZED
seamapland:
  defb 0,254,0,254
  defb 255
  defb 253
  defb 253
  defb 253
  defb 253
; OPTIMIZED
seamapbottomland:
  defb 5,254,5,254
  defb 255
  defb 255
  defb 5,254,17,8,18,5,5
  defb 8,18,5,17,8,9,0,7,8,8
  defb 0,7,8,9,0,0,254
  defb 0,254,0,254
  defb 255
  defb 253

; MAX RAND 5 AS OUR INSERTION SPRITES ARE 3 WIDTH AND 3 HEIGHT (0-9 tiles)
getranlocalmappos:
  ld b,5
  call randmax32
  ld c,a
  call randmax32
  ld b,a
  call convxytotilenum
  ld c,a
ret

buildthesea:
  ld a,(currscreendata)
  ld hl,buildseadatatable
  call vectorlookuphl
  ld de,gamemap2
 
  ; EXPAND MAP
  ld b,10 ; 10 ROWS
  buildsealoop:
    ld a,(hl)
    cp 255 ; REPEAT LAST ROW
    jr z,repeatlastrow
    cp 253 ; REPEAT LAST TWO ROWS
    jr z,repeatlasttworows

    push bc
    ld b,10
    buildseacolloop:
      ld a,(hl)
      cp 254 ; REPEAT LAST VALUE 4 TIMES
      jr z,repeatlastfourtimes
      cp 252 ; REPEAT LAST VALUE 3 TIMES
      jr z,repeatlastthreetimes
      cp 251 ; REPEAT LAST VALUE 2 TIMES
      jr z,repeatlasttwotimes
      ld (de),a
      inc hl
      inc de
      repeatlastbytejumpback:
    djnz buildseacolloop
    pop bc

    repeatlastrowjumpback:
  djnz buildsealoop
ret

; REPEAT THE LAST CHAR 2 TIMES IN DE
repeatlastthreetimes:
  dec de
  ld a,(de)
  jr repeat3times
repeatlasttwotimes:
  dec de
  ld a,(de)
  jr repeat2times

; REPEAT THE LAST CHAR 3 TIMES IN DE
repeatlastfourtimes:
  dec de
  ld a,(de)

  dec b
  inc de
  ld (de),a
  repeat3times:
  dec b
  inc de
  ld (de),a
  repeat2times:
  dec b
  inc de
  ld (de),a
  inc de
  ld (de),a
  inc de
  inc hl ; GO TO NEXT CHAR
  jr repeatlastbytejumpback

repeatlastrow:
  ld a,10
  jr repeatlastrows
repeatlasttworows:
  ld a,20

; REPEAT THE LAST ROW IN DE
repeatlastrows:
  ld (numrows_minus1-1),a
  ld (numrows2_minus1-1),a
  push hl ; SAVE POS
  ld h,d  ; FIND PREVIOUS ROW IN DE
  ld l,e
  push bc
  ld b,10:numrows_minus1
  loopdec:
    dec hl
  djnz loopdec
  ld b,0
  ld c,10:numrows2_minus1 ; COPY IT
  ldir
  pop bc
  pop hl
  inc hl ; GO TO NEXT CHAR
  jr repeatlastrowjumpback
