; WHEN PLAYER BUYS ITEM, SHOP QUANTITY MUST STAY SAME UNTIL NEXT DAY
; MAX FIVE OBJECTS PER SHOP
; IF SHOP RUNS OUT OF ITEM, IT WILL BE REPLACED NEXT DAY
; IF SHOP WITH SAME ZONE AND MAP EXISTS IN TABLE, USE THAT
; OTHERWISE GENERATE NEW SHOP INVENTORY OVER EXISTING ITEMS

; ITEM IDS LISTED BY KEYPRESS NUMBER, 1-5
; INV LOOKUP
;shopitemdisplaylist
;  defw 0
;  defw 0
;  defw 0
;  defw 0
;  defw 0
;  defb 255

; GLOBAL INVENTORY LIST
; BLOCK ID, SCREEN ID, ITEM ID, QTY AVAIL
; PRICE IS GENERATED WHEN PLAYER SPEAKS TO SHOP KEEPER
;shopinventory
;  defb 0, 0, 0, 0
;  defb 0, 0, 0, 0
;  defb 0, 0, 0, 0
;  defb 0, 0, 0, 0
;  defb 0, 0, 0, 0
;  defb 0, 0, 0, 0
;  defb 0, 0, 0, 0
;  defb 0, 0, 0, 0
;  defb 0, 0, 0, 0
;  defb 0, 0, 0, 0
;  defb 0, 0, 0, 0
;  defb 0, 0, 0, 0
;  defb 0, 0, 0, 0
;  defb 0, 0, 0, 0
;  defb 0, 0, 0, 0
;  defb 255 ; END OF LIST

; IN ORDER TO MAKE BUYING AND SELLING MORE INTERESTING, WE NEED TO DECREMENT SOME
; SHOP ITEMS EACH DAY TO MAKE IT LOOK LIKE OTHER PEOPLE ARE BUYING ITEMS
; ANY ITEMS THAT ARE SOLD OUT WILL BE REPLACED WITH NEW STOCK

decrementinventoryeachday:
  ld ix,shopinventory
  decrementinventoryeachdayloop:
    ld a,(ix+0)
    cp 255
    ret z

    ld b,(ix+3)           ; MAKE AMOUNT TO DEDUCT RANDOM OF MAXIMUM AVAILABLE
    call randmaxnoseed
    ld (ix+3),a

    or a                  ; CHECK IF STOCK HAS REACHED 0
    jr nz,movenextshopinv2
        
    ld (ix+0),a ; REMOVE EMPTY STOCK ITEM - IF BLOCK IS 0 AND QTY IS 0 ITEM IS REMOVED
  
    movenextshopinv2:
      call movenextslot  
  jr decrementinventoryeachdayloop

; BASE PRICES
; PRICE GETS CHEAPER IF SHOP HAVE LOTS OF ITEM IN STOCK
; ITEM, PRICE
basepricesbyitemid:
  defb 0   ;  0 EMPTY
  defb 2   ;  1 ARROWS
  defb 2   ;  2 SPANNER
  defb 30  ;  3 WORLD MAP
  defb 20  ;  4 LOCAL MAP
  defb 10  ;  5 BOW
  defb 15  ;  6 SADDLE
  defb 2   ;  7 TOBACCO
  defb 1   ;  8 BAKED BEANS
  defb 40  ;  9 SHOOTING IRONS
  defb 3   ; 10 EATING IRONS
  defb 2   ; 11 PEACE PIPE
  defb 3   ; 12 RABBIT MEAT
  defb 1   ; 13 FEATHER
  defb 30  ; 14 AXE
  defb 10  ; 15 FLIPPERS
  defb 0   ; 16 BAG OF GOLD - PRICE BASED ON TRADABLE ITEM
  defb 2   ; 17 PELTS
  defb 50  ; 18 PICKAXE
  defb 20  ; 19 LONGBOW
  defb 15  ; 20 DYNAMITE
  defb 200 ; 21 GOLD
  defb 2   ; 22 MILK
  defb 2   ; 23 BREAD
  defb 2   ; 24 EGGS
  defb 30  ; 25 CLIMBING ROPE
  defb 10  ; 26 LUMBER
  defb 30  ; 27 TREAURE MAP
  defb 5   ; 28 FLOWER
  defb 100 ; 29 COMPASS
  defb 200 ; 30 KEY FOR DOOR
  defb 30  ; 31 SNORKEL
  defb 100 ; 32 PRINCESS'S LOCKET

; DEFINE WHETHER ITEM IS FOOD OR A TOOL FOR RANDOM CONVERSATIONS
; 18 = FOOD
; 19 = TOOL
; 20 = USEABLE ITEM FOR ACCESSING PLACES, IE ROPE, FLIPPERS

; %00000000
; BIT 7    = SALEABLE IN SHOP
; BITS 0-3 = DESCRIPTION ID 0 = FOOD, 1 = TOOL, 2 = USEABLE ITEM
foodortoolbyitemid:
  defb %00000000   ;  0 EMPTY
  defb %10000001   ;  1 ARROWS
  defb %10000001   ;  2 SPANNER
  defb %10000010   ;  3 WORLD MAP
  defb %10000010   ;  4 LOCAL MAP
  defb %10000001   ;  5 BOW
  defb %10000001   ;  6 SADDLE
  defb %10000000   ;  7 TOBACCO
  defb %10000000   ;  8 BAKED BEANS
  defb %10000001   ;  9 SHOOTING IRONS
  defb %10000001   ; 10 EATING IRONS
  defb %10000001   ; 11 PEACE PIPE
  defb %10000000   ; 12 RABBIT MEAT
  defb %10000001   ; 13 QUILL
  defb %00000001   ; 14 AXE
  defb %00000010   ; 15 FLIPPERS
  defb %00000001   ; 16 BAG OF GOLD - PRICE BASED ON TRADABLE ITEM
  defb %10000001   ; 17 PELTS
  defb %10000001   ; 18 PICKAXE
  defb %10000001   ; 19 LONGBOW
  defb %10000001   ; 20 DYNAMITE
  defb %00000001   ; 21 GOLD
  defb %10000000   ; 22 MILK
  defb %10000000   ; 23 BREAD
  defb %10000000   ; 24 EGGS
  defb %00000010   ; 25 CLIMBING ROPE
  defb %10000001   ; 26 LUMBER
  defb %00000001   ; 27 TREASURE MAP
  defb %10000001   ; 28 FLOWER
  defb %10000001   ; 29 COMPASS
  defb %00000001   ; 30 KEY
  defb %00000001   ; 31 SNORKEL
  defb %00000001   ; 32 LOCKET

; FIND IF INVENTORY ALREADY GENERATED
; IF SO COUNT ITEMS
; THEN WE SHOULD ONLY REGENERATE REMAINING ITEMS UP TO 5 MAX
; OUTPUTS
; D = ITEM COUNT FOR THIS SHOP
countshopinv:
  ld d,0
  ld ix,shopinventory
  findinvloop:
    ld a,(ix+0)
    cp 255
    ret z
    
    call checkblockiscurrentshop_cf
    jr nc,movenextshopinv

    inc d  ; INCREMENT ITEM COUNT

    movenextshopinv:
      call movenextslot
  jr findinvloop

shopinvcount: defb 0

; CHECK IF CURRENT IX BLOCK IS SHOP PLAYER IS IN
; INPUTS:
;   X+0 = MAP BLOCK ID
;   X+1 = MAP SCREEN ID
; OUTPUTS:
;   A = 0 NOT CURRENT SHOP
;   A = 1 CURRENT SHOP
checkblockiscurrentshop_cf:
  ld a,(currblockid)
  cp (ix+0)
  jp nz,returnfalse2
  ld a,(currscreenid)
  cp (ix+1)
  jp nz,returnfalse2
  scf ; SET CARRY FLAG
  ret

; POPULATES GLOBAL SHOP INVENTORY WITH 5 ITEMS FOR OUR LOCATION
generateshopinv:
  ; FIND IF INVENTORY EXISTS FOR THIS LOCATION
  ; IF NOT, CREATE NEW ONE
  ; IF IT DOES, REPLENISH STOCK UNTIL WE HAVE 5 ITEMS 
  call countshopinv
  ld a,d
  ld (shopinvcount),a
  sub 5                 ; IF WE HAVE FIVE ITEMS ALREADY, DON'T MAKE ANY MORE
  ret nc

  ; CREATE INVENTORY
  ; PREFER EMPTY SPACES FIRST
  ; OVERWRITE IF NO SPACE AVAIL
  ; CREATE MAX FIVE ITEMS
  makeshopinvloop:
    ; GET A RANDOM OBJECT ID
    ld b,rand_quest_objects
    call randmaxnoseed
    ld b,a ; STORE A

    ; CHECK IF ITEM IS SALEABLE - IF NOT TRY ANOTHER ITEM
    ld hl,foodortoolbyitemid
    call vectorlookupsingle
    bit 7,a
    jr z,makeshopinvloop

    ; CHECK IF WE HAVE ALREADY THIS IS STOCK, IF SO GET ANOTHER RANDOM ID
    call findshopqty
    or a
    jr nz,makeshopinvloop

    ; MAKE AN ITEM
    ld a,b
    ld (shopinvitem-1),a
    xor a                  ; MAKE RANDOM QTY
    call makeshopinv

    ; INCREMENT CREATED ITEMS COUNT
    ld a,(shopinvcount)
    inc a
    ld (shopinvcount),a

    ; CHECK IF MAX INVENTORY HAS BEEN REACHED
    cp 5
    ret z
  jr makeshopinvloop

; ADJUST STOCK QUANTITY OF AN ITEM IN A SHOP
; INPUTS
; A = 0 - NEW RANDOM STOCK, 1 = INCREMENT STOCK, 2 = DECREMENT STOCK
makeshopinv:
  push af
  call findnextemptyinvslot 
  ; FILL IN SLOT DETAILS
  ; SHOP LOCATION
  ld a,(currblockid)
  ld (ix+0),a
  ld a,(currscreenid)
  ld (ix+1),a
  ; ITEM
  ld (ix+2),1:shopinvitem
  pop af
  ; QTY
  or a
  jr z,makerandomstockqty
  cp 1
  jr z,incstockqty
  dec (ix+3)            ; DECREASE STOCK QTY BY 1
  ld a,(ix+3)
  or a                  ; CHECK IF STOCK HAS REACHED 0
  ret nz            
  ld (ix+0),0           ; REMOVE EMPTY STOCK ITEM - IF BLOCK IS 0 AND QTY IS 0 ITEM IS REMOVED
ret  
incstockqty:
  inc (ix+3)              ; INCREASE STOCK QTY BY 1
ret
makerandomstockqty:
  ; GET RANDOM QTY
  ld b,15
  call randmax32
  or a
  jr z,makeoneqty       ; DON'T ALLOW 0 QTY STOCK
  resumemakerandstock:
  ld (ix+3),a
ret
makeoneqty:
  ld a,1
  jr resumemakerandstock

; FIND EMPTY SLOT TO FILL UP INVENTORY
; OUTPUTS
; HL = INVENTORY SLOT TO WRITE TO

movenextslot:
  push bc
  ld bc,4
  add ix,bc
  pop bc
ret

; FIND IF SHOP HAS CERTAIN ITEM IN STOCK
; INPUTS
; B = SHOP ITEM TO CHECK
; OUTPUTS
; A = QTY OR 0 IF NOT IN STOCK
findshopqty:
   ld ix,shopinventory
   ; CHECK IF SHOP ALREADY HAS SLOT FOR THIS ITEM FIRST
   findinvloop5:
     ld a,(ix+0)
     cp 255
     jp z,returnfalse ; END OF LIST

     ; CHECK MATCHING BLOCK ID
     call checkblockiscurrentshop_cf
     jr nc,donextinvitem2
     ; CHECK MATCHING ITEM ID
     ld a,b
     cp (ix+2)  
     jr nz,donextinvitem2
     ; RETURN QTY
     ld a,(ix+3) 
     ret

     donextinvitem2:
       call movenextslot
   jr findinvloop5
  
findnextemptyinvslot:
   ; CHECK IF SHOP ALREADY HAS SLOT FOR THIS ITEM FIRST
   ld a,(shopinvitem-1)
   ld b,a
   call findshopqty
   or a              ; WILL BE 0 IF NOT IN STOCK
   ret nz

   ; IF ITEM IS UNIQUE CHECK IF BLANK SLOT EXISTS
   checkblankslot:
   ld ix,shopinventory
   findinvloop2:
     ld a,(ix+0)
     cp 255
     jr z,checkoverwrite ; END OF LIST
     or a                ; CHECK FOR EMPTY BLOCK
     ret z
     call movenextslot
   jr findinvloop2
    
   ; NO BLANK SLOTS, OVERWRITE EXISTING SLOT
   checkoverwrite:
   ld ix,shopinventory
   findinvloop3:
     ld a,(ix+0)
     cp 255
     jr z,gettopstockslot
     ; CHECK MATCHING BLOCK ID
     call checkblockiscurrentshop_cf
     ret nc
     ; SLOT NOT YET FOUND
     call movenextslot
   jr findinvloop3

; WE CAN'T FIND A SUITABLE SLOT
; JUST OVERWRITE FIRST ONE IN LIST THAT DOESN'T MATCH OUR ID
; SHOULD NEVER THEORETICALLY HAPPEN ANYWAY UNLESS PLAYER VISITS
; FOUR DIFFERENT SHOPS

gettopstockslot:
  ld ix,shopinventory
ret
; RETURN FIRST STOCK SLOT AS ALL OUR SLOTS ARE FROM SAME SCREEN!?!?
; NEVERY GOING TO HAPPEN, BUT STILL

askyesnoplayer:
  call statusbarprintparagraph
  call checknokeyspressed ; PAUSE TO MAKE SURE PLAYER ISN'T HOLDING DOWN KEYS
  call waityesno
  cp "n"
ret

; RECORD NUMBER OF ITEM PLAYER IS LOOKING AT
;itempick defb 0

; REFUSE TRADE IF PLAYER IS "WANTED"
refusetrade:
  ld hl,str_shopkeeperrefuse
  jp statusbarprintparagraph

; SHOP KEEPER BUY AND SELL ROUTINE
speaktoshopkeeper:
  ; CHECK IF PLAYER IS WANTED
  ld a,(bountyreward-2)
  or a
  jr nz,refusetrade
  call generateshopinv ; GENERATE SHOP STOCK IF WE NEED TO
  ld hl,str_shopkeeperhello
  call askyesnoplayer
  jp z,shopkeeperbuying

  call createshopinvdisplay ; RECORD INVENTORY LOOKUPS BASED ON KEY PRESSES
  call printshopinvdisplay
  ld a,5 ; CHECK 1-5 KEYPRESS
  call waitoption_1_2_3_4_5ss
  ; PLAYER HAS PRESSED KEY - GIVE STOCK BREAKDOWN

  ; CHECK ITEM DETAILS 
  ;sub "1" ; CONVERT TO ORDINARY LOOKUP NUMBER STARTING AT 0
  ld (itempick-1),a
  ; GET LOOKUP TO ITEM INTO DE AND SWITCH TO HL
  call shopdisplaypick
  ; SKIP BLOCK ID AND SCREEN ID
  inc hl
  inc hl
  ; GET OBJECT ID IN DE
  ld b,(hl) 
  push hl
  call getrandobjectstr
  pop hl
  inc hl
  ; GET QTY
  ld a,(hl)
  ld (shopitemqty-1),a
  ; GET PRICE
  call makecurritemprice
  ld (shopitemprice-1),a

  ld hl,str_shopkeeperinstock
  call askyesnoplayer
  jp z,shopkeepergoodbye
  jp buyitem

; INPUTS
; A  = SHOP ITEM ID
; OUTPUTS
; HL = LOOKUP TO GLOBAL SHOP INVENTORY ITEM 
shopdisplaypick:
  ld hl,shopitemdisplaylist
  ; GET LOOKUP TO ITEM INTO DE AND SWITCH TO HL
  rlca
  ld b,0
  ld c,a
  add hl,bc
  ld d,(hl)
  inc hl
  ld e,(hl)
  ex de,hl
ret

; INPUTS
; B = ITEM ID
; OUTPUT
; A = ITEM PRICE
makecurritemprice:
  push hl
  ld hl,basepricesbyitemid
  ld a,b
  call vectorlookupsingle
  pop hl
  ; INCREASE/DECREASE ITEM PRICE BASED ON QUANTITY AVAILABLE
  push af
  ld a,(shopitemqty-1)
  sub 2
  jr c,qtyrare
  sub 3
  jr c,qtylessrare
  sub 5
  jr c,qtycommon
  ; PLENTY OF THEM
  pop af
  sub 3
  jr c,onedollar           ; DON'T LET PRICE GO BELOW 1
  or a
  jr z,onedollar
ret
qtyrare:
  pop af
  add 5
ret
qtylessrare:
  pop af
  add 3
ret
qtycommon:
  pop af
ret
onedollar:
  ld a,1
ret

buyitem:
  ld a,0:itempick
  call shopdisplaypick
  ; GET PRICE
  ld a,(shopitemprice-1)
  ld c,a
  ld b,0
  ; SEE IF PLAYER HAS ENOUGH MONEY
  push hl
  ld hl,(player_cash2)
  sbc hl,bc
  pop hl
  jr c,printnotenoughcash

  ; TRY TO ADD STOCK. DO THIS FIRST IN CASE WE HAVE NO INVENTORY SPACE LEFT
  inc hl
  inc hl
  ld b,(hl)            ; INCREMENT PLAYER STOCK
  ld a,b
  ld (shopinvitem-1),a ; RECORD ITEM ID FOR LATER USE
  push hl
  call addplayerinvrand_cf
  pop hl
  jr nc,printnotenoughspace ; NOT ENOUGH SPACE

  ; DEDUCT CASH AND ADD ITEM TO PLAYER INVENTORY
  ld a,(shopitemprice-1)
  ld c,a
  ld b,0
  push hl
  ld hl,(player_cash2)
  sbc hl,bc
  ld (player_cash2),hl
  pop hl

  ; DRECREMENT SHOP STOCK
  ld a,2
  call makeshopinv

  call updatestatusbarmoney
  ld hl,str_shopkeeperthanks
  jp statusbarprintparagraph

printnotenoughcash:
  ld hl,str_shopkeeperlowcash
  jp statusbarprintparagraph
printnotenoughspace:
  ld hl,str_shopkeeperlowspace
  jp statusbarprintparagraph

shopkeeperbuying:
  ld hl,str_shopkeeperbuying
  call askyesnoplayer
  jp z,shopkeepergoodbye
  call countplayerinventory      ; CHECK IF PLAYER HAS SOMETHING TO SELL
  or a
  jr z,shopkeepernoitems

  call showinventory
  inc a
  call waitoption_1_2_3_4_5ss
  call shopkeepermakeoffer
  call askyesnoplayer
  jr z,shopkeepergoodbye
  ; PLAYER ACCEPTED OFFER

  ; ADD CASH AND DEDUCT ITEM FROM PLAYER INVENTORY
  ld a,(shopitemoffer-1)
  ld c,a
  ld b,0
  ld hl,(player_cash2)
  add hl,bc
  ld (player_cash2),hl

  ; DEC PLAYER STOCK
  ld a,(shopinvitem-1)          
  ld b,a
  call remplayerinvrand

  ; INCREMENT SHOP STOCK
  ld a,1                   
  call makeshopinv

  call updatestatusbarmoney
 
  shopkeepergoodbye:
  call loadrandgoodbye
  jp printstronce

shopkeepernoitems:
  ld hl,str_shopkeepernoitems
  jp printstronce
shopkeepermakeoffer:
  ;sub "0"                                 ; CONVERT KEYPRESS TO ORDINARY LOOKUP NUMBER STARTING AT 0
  inc a                                    ; FORCE RESULT STARTING AT 1 INSTEAD OF 0
  ld hl,player_inventory_rand

  ; FIND SLOT BY NUMBER SELECTED BY PLAYER
  ; WE NEED TO SKIP BLANK SLOTS!!!
  ; SO WE CAN'T DO A SIMPLE LOOKUP HERE
  ld c,a
  findcorrectitemslot:
    ld a,(hl)
    cp 255
    jr z,shopkeepergoodbye ; END OF LIST!

    or a   ; BLANK SLOT - SKIP TO NEXT SLOT
    jr z,movenextitemslot

    dec c  ; DECREMENT ITEM NUMBER AND CHECK IF WE HAVE REACHED CORRECT ITEM
    ld a,c
    or a
    jr z,foundcorrectitemslot

    movenextitemslot:
      inc hl
      inc hl
      inc hl
    jr findcorrectitemslot

  foundcorrectitemslot:
  ld a,(hl)
  ld b,a
  ld (shopinvitem-1),a                    ; RECORD ITEM PLAYER WANTS TO SELL
  call getrandobjectstr                   ; GET OBJECT STRING IN DE
  call findshopqty                        ; GET CURRENT SHOP QTY FOR PRICE
  inc a                                   ; INCLUDE PLAYER'S QTY SO PLAYER CAN'T BUY AND SELL SAME ITEM TO MAKE MONEY
  ld (shopitemqty-1),a
  call makecurritemprice
  ld (shopitemoffer-1),a
  ld hl,str_shopkeeperoffer
ret

; SCAN THROUGH ALL SHOP INVENTORIES AND MOVE THIS SHOPS ITEMS TO TABLE
createshopinvdisplay:
  ; CLEAR SHOP DISPLAY TABLE
  call clearshopinvdisplay
  xor a
  ld (shopitemkeyrecord-1),a
  ld ix,shopinventory
  printshopinvloop:
     ld a,(ix)
     cp 255                 ; END OF LIST
     ret z 
  
     ; CHECK IF INVENTORY ITEM IS FROM THIS SHOP
     call checkblockiscurrentshop_cf
     jr nc,nextshopinv2

     ; RECORD LOOKUP TO INVENTORY ITEM DATA
     ld a,1:shopitemkeyrecord
     call recordshopinvdisplay
     
     ; REMEMBER ITEM NUMBER
     ld a,(shopitemkeyrecord-1)
     inc a
     ld (shopitemkeyrecord-1),a
     cp 5                       ; DON'T DISPLAY TOO MANY PRODUCTS
     ret z     

     nextshopinv2:
       call movenextslot
  jr printshopinvloop

; RECORD THE ITEM LOOKUP BEING DISPLAYED TO THE PLAYER
; INPUTS
; IX = INVENTORY ITEM LOOKUP
; A  = INVENTORY NUMBER
recordshopinvdisplay:
   ld hl,shopitemdisplaylist
   rlca
   ld c,a
   ld b,0
   add hl,bc ; ADD TWICE AS WE ARE LOOKING UP 16BIT ADDRESS
   ld a,ixh
   ld (hl),a
   inc hl
   ld a,ixl
   ld (hl),a
ret 
   
clearshopinvdisplay:
  ld hl,shopitemdisplaylist
  ld bc,10
  jp clearmem

; SCAN THROUGH DISPLAY TABLE AND CONVERT LOOKUP TO INVENTORY ITEM NAME
printshopinvdisplay:
  ld hl,shopitemdisplaylist
  printshopinvdisplayloop:
    ld a,(hl)
    cp 255         ; END OF LIST
    ret z      
    or a
    jr z,skipblankitem

    push hl

    ; GET LOOKUP IN DE AND SWITCH TO HL
    ld d,(hl)      
    inc hl
    ld e,(hl)
    inc hl
    ex de,hl

    inc hl    ; SKIP BLOCK ID
    inc hl    ; SKIP SCREEN ID

    ; GET OBJECT STRING IN DE
    ld b,(hl)
    call getrandobjectstr  

    ld hl,str_shopkeeperinvent
    call statusbarprintparagraphnoscroll

    pop hl
    skipblankitem:
    inc hl
    inc hl
  jr printshopinvdisplayloop