;sound_reset         equ &bca7
sound_queue         equ &bcaa
sound_check         equ &bcad
;sound_arm_event     equ &bcb0
;sound_release       equ &bcb3
;sound_hold          equ &bcb6
;sound_continue      equ &bcb9
sound_ampl_envelope equ &bcbc
sound_tone_envelope equ &bcbf
;sound_a_address     equ &bcc2
;sound_t_address     equ &bcc5

;soundtable
;  defw snd_arrow  ; ARROW SOUND
;  defw snd_door   ; DOOR KNOCK
;  defw snd_axe    ; AXE SOUND

splashsound:
  ld hl,snd_splash2
  call sound_queue
  ld hl,snd_splash
  jp sound_queue
axesound:
  ld hl,snd_axe
  jp sound_queue
doorknock:
  ld hl,snd_door
  jp sound_queue
arrowsound:
  ld hl,snd_arrow
  jp sound_queue
dingsound:
  ld hl,snd_ding2
  call sound_queue
  ld hl,snd_ding
  jp sound_queue

soundtable2len equ 5
soundtable2:
  defw silencet,  silencea    ; 1 - SILENCE
  defw ent_arrow, env_arrow   ; 2 - ARROW SOUND
  defw ent_door,  env_door    ; 3 - DOOR KNOCK
  defw ent_piano, env_piano   ; 4 - PIANO SOUND
  defw ent_ding,  env_ding    ; 5 - DING SOUND
  ;defw ent_axe,   env_axe    ; 5 - AXE SOUND

; SET UP TONE AND AMPLITUDE FOR SOUND EFFECTS
; THIS IS RUN ONCE AT THE START
; UP TO 15 ENVELOPES CAN BE DEFINED
setupsounds:
  ld iy,soundtable2
  ld b,soundtable2len
  xor a
  setsoundtoneamp:
    push bc
    inc a
    ld l,(iy+0)
    ld h,(iy+1)
    push af
    call sound_tone_envelope
    pop af
    ld l,(iy+2)
    ld h,(iy+3)
    push af
    call sound_ampl_envelope
    pop af

    ; MOVE TO NEXT ENTRY
    inc iy
    inc iy
    inc iy
    inc iy
    pop bc
  djnz setsoundtoneamp
ret

; PIANO SOUND
; -----------

ent_piano: defb 1 ; NUMBER OF SECTIONS
           ; STEP COUNT, STEP SIZE, PAUSE TIME
           defb 1,1,1
env_piano: defb 1 ; NUMBER OF SECTIONS
           ; STEP COUNT, STEP SIZE, PAUSE TIME
           defb 1,1,1

; SILENCE
; -------

silencet:  defb 1 ; NUMBER OF SECTIONS
           ; STEP COUNT, STEP SIZE, PAUSE TIME
           defb 0,0,0
silencea:  defb 1 ; NUMBER OF SECTIONS
           ; STEP COUNT, STEP SIZE, PAUSE TIME
           defb 0,0,0

; AXE SOUND
; ---------

;ent_axe   defb 1       ; NUMBER OF SECTIONS
;           defb 40,20,10 ; STEP COUNT, STEP SIZE, PAUSE TIME

;env_axe   defb 1        ; NUMBER OF SECTIONS
;           defb 40,10,10 ; STEP COUNT, STEP SIZE, PAUSE TIME


;snd_axe   defb 4     ; CHANNEL STATUS
;           defb 5     ; VOL ENV
;           defb 5     ; TONE ENV
;           defw 0300  ; TONE PERIOD - PITCH
;           defb 3     ; NOISE PERIOD
;           defb 6     ; START VOL
;           defw 200    ; DURATION

snd_axe:   defb 4;128+4 ; CHANNEL STATUS
           defb 2     ; VOL ENV
           defb 2     ; TONE ENV
           defw 0700  ; TONE PERIOD - PITCH
           defb 12    ; NOISE PERIOD
           defb 0     ; START VOL
           defw 20    ; DURATION


; 128 = FLUSH CHANNEL, 1 OR 2 OR 4 = USE CHANNEL A OR B OR C

snd_splash: defb 2;128+2 ; CHANNEL STATUS
            defb 5     ; VOL ENV
            defb 5     ; TONE ENV
            defw 0250  ; TONE PERIOD - PITCH
            defb 15     ; NOISE PERIOD
            defb 15    ; START VOL
            defw 50    ; DURATION

snd_splash2: defb 4;128+4 ; CHANNEL STATUS
             defb 5     ; VOL ENV
             defb 5     ; TONE ENV
             defw 0280  ; TONE PERIOD - PITCH
             defb 15     ; NOISE PERIOD
             defb 15    ; START VOL
             defw 50    ; DURATION


; DOOR KNOCK SOUND
; ----------------

ent_door:  defb 1 ; NUMBER OF SECTIONS
           ; STEP COUNT, STEP SIZE, PAUSE TIME
           defb 4,26,1
env_door:  defb 3 ; NUMBER OF SECTIONS
           ; STEP COUNT, STEP SIZE, PAUSE TIME
           defb 3,2,3
           defb 3,2,7
           defb 3,-3,4

;snd_door  defb 4      ; CHANNEL STATUS
;           defb 2     ; VOL ENV
;           defb 2     ; TONE ENV
;           defw 0040  ; TONE PERIOD
;           defb 7     ; NOISE PERIOD
;           defb 0     ; START VOL
;           defw 0     ; DURATION

snd_door:  defb 4;128+4 ; CHANNEL STATUS
           defb 2     ; VOL ENV
           defb 2     ; TONE ENV
           defw 0700  ; TONE PERIOD - PITCH
           defb 12    ; NOISE PERIOD
           defb 0     ; START VOL
           defw 60    ; DURATION

; ARROW SOUND
; -----------

; NUMBER OF SECTIONS, STEP COUNT, STEP SIZE, PAUSE TIME
ent_arrow: defb 1
           defb 10,-10,1
env_arrow: defb 1
           defb 14,-3,4

snd_arrow: defb 4;128+4 ; CHANNEL STATUS
           defb 3     ; VOL ENV
           defb 3     ; TONE ENV
           defw 0050  ; TONE PERIOD - PITCH
           defb 12    ; NOISE PERIOD
           defb 0     ; START VOL
           defw 50    ; DURATION

; DING SOUND
; -----------

; PICKING UP OBJECT
; TWO SLIGHTLY DIFFERENT TONES PLAYED THROUGH TWO CHANNELS MAKE NICE CHIME SOUND

; NUMBER OF SECTIONS, STEP COUNT, STEP SIZE, PAUSE TIME
ent_ding:  defb 1
           defb 10,-1,4
env_ding:  defb 1
           defb 10,-1,4

; 128 = FLUSH CHANNEL, 1 OR 2 OR 4 = USE CHANNEL A OR B OR C

snd_ding:  defb 2;128+2 ; CHANNEL STATUS
           defb 5     ; VOL ENV
           defb 5     ; TONE ENV
           defw 0050  ; TONE PERIOD - PITCH
           defb 0     ; NOISE PERIOD
           defb 15    ; START VOL
           defw 30    ; DURATION

snd_ding2: defb 4;128+4 ; CHANNEL STATUS
           defb 5     ; VOL ENV
           defb 5     ; TONE ENV
           defw 0080  ; TONE PERIOD - PITCH
           defb 0     ; NOISE PERIOD
           defb 15    ; START VOL
           defw 30    ; DURATION

; ----- MUSIC -------------------------------------------

; 1st BYTE = 
; 1-15 - SET TONE / ENVELOPE
; 255  - END OF LIST
; 254  - SET VOLUME
; 253  - DO SILENCE FOR DURATION OF FOLLOWING BYTE
; 252  - SET DURATION
; 251  - TAKE RANDOM BREAK
; 250  - SET NOISE LEVEL
; 249  - SET RANDOM VOLUME
; 2nd+3rd BYTE = PITCH
; 4th+5th BYTE = DURATION

ifdef isoldmusicmusic
tones4:
  defb 249;, 15  ; SET VOLUME 15
  defb 252, 10  ; DURATION
  defb 3        ; TONE/AMP ENV
  defw tE       ; NOTE, DURATION
  defb 3
  defw tDs
  defb 3
  defw tC
  defb 3
  defw tDs
  defb 3
  defw tE
  defb 3
  defw tE
  defb 3
  defw tE

  defb 251  ; RANDOM BREAK

  defb 3
  defw tD
  defb 3
  defw tDs
  defb 3
  defw tD

  defb 251  ; RANDOM BREAK
   
  defb 3
  defw tE
  defb 3
  defw tG
  defb 3
  defw tG

  defb 251   ; RANDOM BREAK

  defb 3
  defw tE
  defb 3
  defw tD
  defb 3
  defw tCs
  defb 3
  defw tD 
  defb 3
  defw tE
  defb 3
  defw tE
  defb 3
  defw tE

  defb 251   ; RANDOM BREAK

  defb 3
  defw tD
  defb 3
  defw tDs
  defb 3
  defw tE 
  defb 3
  defw tDs
  defb 3
  defw tC

  defb 255 ; END OF LIST

; HOLDS LAST NOTE NUMBER FOR EACH CHANNEL SUCCESSFULLY ADDED TO QUEUE
soundqueues:
  defw tones4
  defw tones4
  defw tones4
  defw tones4
  defw tones4
; HOLDS PTR TO BEGINNING OF EACH TUNE FOR EACH CHANNEL FOR LOOPING
startsoundqueues:
  defw tones4
  defw tones4
  defw tones4
  defw tones4
  defw tones4

currchannoteptr: defw tones4

playmusic:
  ; CHANNEL TO USE
  push ix ; DON'T LET SOUND CORRUPT IX PLAYER DATA REGISTER
  ld a,1 
  call makemusic
  ;ld a,2
  ;call makemusic
  pop ix
  ret

; INPUTS
; A = CHANNEL TO PLAY SOUND
makemusic:
  ld (chan-1),a
  ld (chan2-1),a
  call sound_check
  and %00000111    ; CONVERT CHANNEL CHECK DIGITS TO DECIMAL 
  or a             ; RESULT IS NUMBER OF FREE PLACES IN QUEUE
  ret z            ; SKIP IF WE HAVE NO PLACES IN CHANNEL
  ld (soundstoqueue-1),a

  ; FIND LAST SOUND PLAYED FOR THIS CHANNEL FROM LOOKUP LIST
  ld hl,soundqueues
  ld a,(chan-1)
  rlca
  ld c,a
  ld b,0
  add hl,bc

  push hl
  pop de   ; SAVE COPY OF HL TO DE
 
  ; GET PTR TO NOTE IN MEMORY IN HL
  ld a,(hl)
  inc hl
  ld h,(hl)
  ld l,a

  ld b,1:soundstoqueue
  makemusicloop:
    ; SET TONE/AMP
    ld a,(hl)
    cp 255 ; END OF LIST
    jp z, doresetsoundqueue2
    cp 254 ; SET VOLUME
    jp z, setvolume
    cp 252 ; SET DURATION
    jr z, setduration
    cp 253 ; SILENT BREAK
    jr z, dosilence
    cp 251 ; RANDOM BREAK
    jr z, dorandomsilence
    cp 250 ; SET NOISE
    jr z, setnoise
    cp 249 ; SET RANDOM VOLUME
    jr z, setrandvolume

    ld (volenv-1),a
    ld (tonenv-1),a
    inc hl

    ; SET PITCH
    ld a,(hl)
    ld (pitch-2),a
    inc hl
    ld a,(hl)
    ld (pitch-1),a
    inc hl

    push hl
    push bc
    push de
    ld hl,mus
    call sound_queue
    pop de
    pop bc
    pop hl
    finishedsound:
  djnz makemusicloop
   
  ; RECORD LAST POS IN TUNE
  ld a,l
  ld (de),a
  inc de
  ld a,h
  ld (de),a
ret

    dorandomsilence:
    inc hl
    ld b,5
    call randmax32
    ld (duration2-1),a
    call randnoseed
    ld (duration2-2),a
    jr makesilentnoise

    ; MAKE A SILENT NOISE FOR THE FOLLOWING DURATION
    dosilence:
    ; DO SILENCE
    inc hl
    xor a
    ld (duration2-1),a
    ld a,(hl)
    ld (duration2-2),a
    inc hl

    makesilentnoise:
    push hl
    push bc
    push de
    ld hl,sil
    call sound_queue
    pop de
    pop bc
    pop hl
    jr finishedsound

    ; SET DURATION FOR FOLLOWING NOTES
    setduration:
    inc hl
    xor a
    ld (duration-1),a
    ld a,(hl)
    ld (duration-2),a
    jr movenextmusicloop

    ; FOLLOWING BYTE SETS VOLUME
    setrandvolume:
    inc hl
    ld b,4
    call randmax
    ld (startvol-1),a
    jp makemusicloop

    setvolume:
    inc hl
    ld a,(hl)
    ld (startvol-1),a
    jr movenextmusicloop

    ; FOLLOWING BYTE SETS NOISE
    setnoise:
    inc hl
    ld a,(hl)
    ld (noise-1),a
    movenextmusicloop:
    inc hl
    jp makemusicloop
    
doresetsoundqueue2:
  ; FIND LAST SOUND PLAYED FOR THIS CHANNEL FROM LOOKUP LIST
  ld hl,startsoundqueues
  ld a,(chan-1)
  call vectorlookuphl
  ld (currchannoteptr),hl
  jp makemusicloop

; CHANNEL STATUSES
;DECIMAL BIT COMMAND
; 1 send SOUND to channel A
; 2 send SOUND to channel B
; 4 send SOUND to channel C
; 8 rendezvous with channel A
;16 rendezvous with channel B
;32 rendezvous with channel C
;64 hold
;128 flush

; LEFT CHANNEL
sil: defb 1     :chan2      ; CHANNEL STATUS
     defb 4                 ; VOL ENV
     defb 4                 ; TONE ENV
     defw 0000              ; TONE PERIOD - PITCH
     defb 0                 ; NOISE PERIOD
     defb 0                 ; START VOL
     defw 0030  :duration2  ; DURATION

mus: defb 1     :chan      ; CHANNEL STATUS
     defb 3     :volenv    ; VOL ENV
     defb 3     :tonenv    ; TONE ENV
     defw 0040  :pitch     ; TONE PERIOD - PITCH
     defb 0     :noise     ; NOISE PERIOD
     defb 15    :startvol  ; START VOL
     defw 0030  :duration  ; DURATION

; RIGHT CHANNEL
;musr defb 2                ; CHANNEL STATUS
;      defb 1                ; VOL ENV
;      defb 1                ; TONE ENV
;      defw 0040  pitchr    ; TONE PERIOD - PITCH
;      defb 0                ; NOISE PERIOD
;      defb 15                ; START VOL
;      defw 0030  durationr ; DURATION

; MID CHANNEL
;musm defb 3                ; CHANNEL STATUS
;      defb 1                ; VOL ENV
;      defb 1                ; TONE ENV
;      defw 0040  pitchm    ; TONE PERIOD - PITCH
;      defb 0                ; NOISE PERIOD
;      defb 15                ; START VOL
;      defw 0030  durationm ; DURATION

;silence- defb 4,0,0,0,0

;killsound:
;  ld hl,silence
;  call sound_queue
;ret
endif
