; CLEAR GAME MAP DATA
cleargamemap:
ifdef isinter
  di
endif
  ld (backupsp-2),sp
  ld sp,endofgamemap
  ld de,0
  ld b,2
  jr loopyloop2

; CLEAR MEMORY USING THE STACK POINTER
; CLEARS 128 BYTES ON EACH PASS
;backupsp  defw 0
clearsp:
ifdef isinter
  di
endif
  ld (backupsp-2),sp
  ld sp,endoftilemaps
  ld de,0
  ld b,6
  loopyloop2:
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de

  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de

  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de

  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  push de
  djnz loopyloop2
  ld sp,0:backupsp ;(backupsp)
ifdef isinter
  ei
endif
ret

; SPEED UP LDIR
useLDI79:
  call useLDI50
useLDI29:
  ldi
useLDI28:
  call useLDI20
  jr useLDI8

useLDI16:
  call useLDI8
  jr useLDI8

useLDI199:
  call useLDI60
  call useLDI79
useLDI60:
  call useLDI10
useLDI50:
  call useLDI20
  call useLDI10
useLDI20:
  call useLDI10
useLDI10:
  ldi
useLDI9:
  ldi
useLDI8:
  ldi
  ldi
useLDI6:
  ldi
  ldi
  ldi
  ldi
  ldi
  ldi
ret

; LOOKUP TABLE WITH SINGLE BYTE VALUES
; INPUT
; HL = TABLE
; A  = ROW TO LOOK UP
; OUTPUT 
; A  = VALUE
vectorlookupsingle:
  push bc
  ld b,0
  ld c,a
  add hl,bc
  ld a,(hl)
  pop bc
ret

; LOOKS UP A SPRITE GRAPHIC FROM THE ANIMATION VECTOR TABLE
; BY NUMBER
; INPUTS
; A = IMAGE NUMBER
; RESULTS
; DE = SPRITE DATA
vectorspritelookup:
  push hl
  ld hl,spriteanimtable 
  vlookup:
  call vectorlookup
  pop hl
ret
; LOOKS UP A TILE GRAPHIC FROM THE VECTOR TABLE
; BY NUMBER
; INPUTS
; A = IMAGE NUMBER
; RESULTS
; DE = SPRITE DATA
vectorobjectlookup:
  push hl
  dec a ; MAKE START FROM 0
  dec a
  ld hl,tile_ptr_table 
  jr vlookup

; INPUTS
; A = DOUBLE BUFFER ID IMAGE
vectorbufferlookup:
  push hl
  ld hl,doublebuffertable 
  jr vlookup

; INPUTS
; HL = VECTOR TABLE
; A = IMAGE NUMBER
; RESULTS
; DE = SPRITE DATA
vectorlookup:
  call vectorlookuphl
  ex de,hl   ; COPY SPRITE DATA TO DE
ret

; RETURN FIRST VALUE IN A OF DOUBLE BYTE TABLE
; INPUTS
; HL = TABLE
; OUTPUTS
; A  = FIRST BYTE OF DOUBLE BYTE LOOKUP
vectorlookupreturnfirstval:
  push bc
  ;rlca ; DOES NOT WORK OVER TABLE LENGTH > 128
  ld b,0
  ld c,a
  add hl,bc
  add hl,bc
  ld a,(hl) ; LOAD HL WITH ADDRESS OF VECTOR TABLE
  pop bc
ret

vectorlookuphl:
  push bc
  ;rlca ; DOES NOT WORK OVER TABLE LENGTH > 128
  ld b,0
  ld c,a
  add hl,bc
  add hl,bc
  ld a,(hl)
  inc hl
  ld h,(hl)
  ld l,a
  pop bc
ret

; MOVE BASED ON DIRECTION JUMP TABLE
; VECTOR TABLE LAUNCH CODE
; INPUTS 
; A = ID NUMBER
; HL = LOOKUP TABLE
vectortablelaunchcode:
  call vectorlookuphl
  jp (hl)     ; JUMP TO VECTOR TABLE FUNCTION