; TILE MAP INDEXES TO BUILD BIGGER SPRITE
; ---------------------------------------
; 255 = END OF SPRITE
; 254 = END OF LINE, MOVE UP LEVEL IN HEIGHT
; 253 = END OF LINE, MOVE BACK IN DEPTH
; 252 = NON OBSTRUCTIONAL LINE - STOPS CACTUS GROWING OUTSIDE DOOR

; OBJECT TYPES
; WIDTH, HEIGHT, TILE NUMBERS
; ---------------------------
; CHECK OBJECT TILE TO SEE IF WE NEED TO FLIP SPRITE VERTICALLY
; OBJECT TYPES
; 1 = STANDARD OBJECT
; 2 = WATER
; 3 = MOUNTAIN
; 4 = VERTICALLY FLIPPED STANDARD OBJECT 
; 5 = VERTICALLY FLIPPED NON OBSTRUCTIONAL OBJECT
; 6 = LEFT TREE TRUNK
; 7 = RIGHT TREE TRUNK
; LEFT AND RIGHT OBJECT TYPES FOR TREE DETERMINE WHICH SIDE PLAYER IS CHOPPING

; TILE TYPES
; ------------
; 246 = VERTICALLY FLIPPED SPRITE

; CUSTOM TILE VALUES
; ------------------
; 1   = REPEAT PREVIOUS TILE FOUR TIMES
; 5   = REPEAT LAST ROW
; 252 = TILE NUMBER DIRT/GRASS THAT IS TRANSVERSABLE
; USE IN FRONT OF DOOR WAYS TO STOP THEM BEING BLOCKED
s2_dirt:
  defb %00010001,254 ; W / H / DEFAULT OBJECT TYPE
  defb 0,255 
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_treasuremap:
  defb %00010001,250 ; W / H / DEFAULT OBJECT TYPE
  defb 152,255 
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_axe:
  defb %00010001,250 ; W / H / DEFAULT OBJECT TYPE
  defb 151,255 
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_kelp:
  defb %00100001,1 ; W / H / DEFAULT OBJECT TYPE
  defb 148,254
  defb 104,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_lumber:
  defb %00010001,250 ; W / H / DEFAULT OBJECT TYPE
  defb 62,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_bed:
  defb %00110010,1 ; W / H / DEFAULT OBJECT TYPE
  defb 44,244,253
  defb 43,243,253
  defb 42,242,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_bar:
  defb %00101101,1 ; W / H / DEFAULT OBJECT TYPE
  defb 216,1,1,1,253
  defb 114,1,1,1,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
;s2_rainbow
;  defb 1,2,1  ; W / H / DEFAULT OBJECT TYPE
;  defb 27,254
;  defb 46,255
;  defb 0 ; OBJECT TYPE, TILE X, TILE Y
;s2_rainbow2
;  defb 1,2,1  ; W / H / DEFAULT OBJECT TYPE
;  defb 227,254
;  defb 246,255
;  defb 0 ; OBJECT TYPE, TILE X, TILE Y

s2_narniadoor:
  defb %00010001,243 ; W / H/ DEF OBJ TYPE
  defb 124,255
  defb 0 ; FROM MAZE TO NARNIA
s2_narniadoorback:
  defb %00010001,241 ; W / H/ DEF OBJ TYPE
  defb 124,255
  defb 0 ; FROM NARNIA TO MAZE
s2_doorbig:
  defb %00100011,4 ; W / H / DEFAULT OBJECT TYPE (FLIPPED)
  defb 0,0,0,254 ; MOVE TO UPPER LEVEL
  defb 20,7,220,255
  defb 0
s2_doorforest:
  defb %00100011,1 ; W / H / DEFAULT OBJECT TYPE
  defb 0,0,0,254 ; MOVE TO UPPER LEVEL
  defb 20,7,220,255
  defb 0
s2_saloondoorinside:
  defb %00100011,1 ; W / H / DEFAULT OBJECT TYPE
  defb 0,0,0,254 ; MOVE TO UPPER LEVEL
  defb 47,67,247,255
  defb 0
s2_windowwestern:
  defb %00100010,1 ; W / H / DEFAULT OBJECT TYPE
  defb 0,0,254 ; MOVE TO UPPER LEVEL
  defb 214,14,255
  defb 0
s2_windowforest:
  defb %00100010,1 ; W / H / DEFAULT OBJECT TYPE
  defb 0,0,254 ; MOVE TO UPPER LEVEL
  defb 41,241,255
  defb 0
s2_farm:
  defb %01101100,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb 83,83,83,83,134,0,0,83,83,83,83,134,253
  defb 218,0,1,0,1,18,253
  defb 218,0,1,0,1,18,253
  defb 218,0,1,0,1,18,253
  defb 218,91,102,125,91,0,1,0,18,253
  defb 83,93,93,93,93,83,1,83,134,255
  defb 255,2,4; OBJECT TYPE, TILE X, TILE Y
s2_church:
  defb %01000110,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb 0,0,252,0,253
  defb 0,68,69,70,253
  defb 0,71,72,73,254
  defb 0,74,75,76,255
  defb 231,2,1 ; OBJECT TYPE, TILE X, TILE Y
;s2_brickhouse:
;  defb 4,3,1 ; WIDTH IN TILES / DEFAULT OBJECT TYPE
;  defb 88,53,92,88,253 ; LOWER
;  defb 62,62,62,62,253 ; UPPER
;  defb 90,90,90,90,255 ; UPPER
;  defb 255,1,0; OBJECT TYPE, TILE X, TILE Y
s2_wheelhouse:
  defb %00100100,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb 125,125,102,125,253 ; LOWER
  defb 93,93,93,93,255 ; UPPER
  defb 228,2,0; OBJECT TYPE, TILE X, TILE Y
s2_loghouse:
  defb %00110100,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb 0,252,0,0,253 ; LOWER
  defb 91,102,125,91,253 ; LOWER
  defb 93,93,93,93,255 ; UPPER
  defb 255,1,1; OBJECT TYPE, TILE X, TILE Y
s2_jail:
  defb %00110100,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb 0,252,0,0,253 ; LOWER
  defb 91,102,53,91,253 ; LOWER
  defb 93,93,93,93,255 ; UPPER
  defb 223,2,1; OBJECT TYPE, TILE X, TILE Y
s2_generalstore:
  defb %00110100,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb 0,0,252,0,253 
  defb 125,125,102,125,253 ; LOWER 
  defb 93,93,93,93,255 ; UPPER
  defb 236,2,1; OBJECT TYPE, TILE X, TILE Y
s2_saloon:
  defb %00110100,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb 0,252,0,0,253 
  defb 125,66,125,125,253 ; LOWER 
  defb 93,93,93,93,255 ; UPPER
  defb 233,1,1; OBJECT TYPE, TILE X, TILE Y
s2_bank:
  defb %00110100,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb 0,252,0,0,253 
  defb 125,102,125,125,253 ; LOWER 
  defb 93,93,93,93,255 ; UPPER
  defb 221,1,1; OBJECT TYPE, TILE X, TILE Y
s2_wigwam:
  defb %00110010,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb 252,0,253 
  defb 34,35,254 ; LOWER
  defb 32,33,255 ; UPPER
  defb 248,0,1; OBJECT TYPE, TILE X, TILE Y

s2_target:
  defb %00010001,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb 52,255 ; UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_hedge:
  defb %00010100,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb bigtreelefttop,bigtreerighttop,bigtreelefttop,bigtreerighttop,255 ; UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_deadhedge:
  defb %00010100,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb bigtreeleftbare,bigtreerightbare,bigtreeleftbare,bigtreerightbare,255 ; UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_bush:
  defb %00010010,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb bigtreelefttop,bigtreerighttop,255 ; UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_deadbush:
  defb %00010010,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb bigtreeleftbare,bigtreerightbare,255 ; UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_bushclump:
  defb %00100100,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb bigtreelefttop,bigtreerighttop,bigtreelefttop,bigtreerighttop,253 ; UPPER
  defb 0,bigtreelefttop,bigtreerighttop,0,255 ; UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y
;s2_hedgehoriz
;  defb 8,1,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
;  defb bigtreelefttop,bigtreerighttop,bigtreelefttop,bigtreerighttop,bigtreelefttop,bigtreerighttop,bigtreelefttop,bigtreerighttop,255 ; UPPER
;  defb 0; OBJECT TYPE, TILE X, TILE Y
;s2_hedgevert
;  defb 2,3,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
;  defb bigtreelefttop,bigtreerighttop,253
;  defb bigtreelefttop,bigtreerighttop,253
;  defb bigtreelefttop,bigtreerighttop,255 ; UPPER
;  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_bigtree:
  defb %00100010,6 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb bigtreetrunkleft,bigtreetrunkright,254 ; LOWER
  defb bigtreelefttop,bigtreerighttop,255 ; UPPER
  defb 7,1,0; OBJECT TYPE, TILE X, TILE Y
;s2_bigtree2
;  defb 4,2,6 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
;  defb bigtreetrunkleft,bigtreetrunkright,bigtreetrunkleft,bigtreetrunkright,254 ; LOWER
;  defb bigtreelefttop,bigtreerighttop,bigtreelefttop,bigtreerighttop,255 ; UPPER
;  defb 7,1,0; OBJECT TYPE, TILE X, TILE Y
s2_bigtreebare:
  defb %00100010,6 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb bigtreetrunkleft,bigtreetrunkright,254 ; LOWER
  defb bigtreeleftbare,bigtreerightbare,255 ; UPPER
  defb 7,1,0; OBJECT TYPE, TILE X, TILE Y
s2_pinetree:
  defb %00100010,6 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb pinetreebottomleft,82,254 ; LOWER
  defb pinetreetopleft,pinetreetopright,255 ; UPPER
  defb 7,1,0; OBJECT TYPE, TILE X, TILE Y
s2_bigcactus:
  defb %00100010,6 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb 80,26,254   ; LOWER
  defb 135,150,255 ; UPPER
  defb 7,1,0       ; OBJECT TYPE, TILE X, TILE Y

; ----- MOUNTAINS ------------------------------------

s2_smallmountain:
  defb %00100011,8 ;W/H / DEFAULT OBJECT TYPE
  defb 251,49,51,253 ; LOWER
  defb 29,78,229,255 ; MID
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_newmountain:
  defb %01000101,3 ;W/H / DEFAULT OBJECT TYPE
  defb 251,49,49,49,51,253 ; LOWER
  defb 48,37,84,237,248,253 ; MID
  defb 29,25,81,225,229,254 ; MID
  defb 0,29,78,229,0,255 ;UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_bignewmountain:
  defb %01101000,3 ;W/H / DEFAULT OBJECT TYPE
  defb 251,49,1,49,51,253 ; LOWER
  defb 48,37,84,84,84,84,237,248,253 ; LOWER
  defb 48,25,37,84,84,237,225,248,253 ; MID
  defb 29,25,25,81,81,225,225,229,253 ; MID
  defb 0,29,25,81,81,225,229,0,254 ; MID
  defb 0,0,29,78,78,229,0,0,255 ;UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_bignewmountaintophalf:
  defb %00111000,3 ;W/H / DEFAULT OBJECT TYPE
  defb 29,25,25,81,81,225,225,229,253 ; MID
  defb 0,29,25,81,81,225,229,0,254 ; MID
  defb 0,0,29,78,78,229,0,0,255 ;UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_bignewmountainleft:
  defb %01100100,3 ;W/H / DEFAULT OBJECT TYPE
  defb 251,49,49,49,253 ; LOWER
  defb 48,37,84,84,253 ; LOWER
  defb 48,25,37,84,253 ; MID
  defb 29,25,25,81,253 ; MID
  defb 0,29,25,81,254 ; MID
  defb 0,0,29,78,255 ;UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_bignewmountainright:
  defb %01100100,3 ;W/H / DEFAULT OBJECT TYPE
  defb 49,49,49,51,253 ; LOWER
  defb 84,84,237,248,253 ; LOWER
  defb 84,237,225,248,253 ; MID
  defb 81,225,225,229,253 ; MID
  defb 81,225,229,0,254 ; MID
  defb 78,229,0,0,255 ;UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y

; 37 BOTTOM LEFT CORNER RIDGE
; 48 LEFT RIDGE TRANSP
; 49 BOTTOM RIDGE TRANSPARENT
; 25 LEFT RIDGE OPAQUE (WAS 80)
; 78 TOP RIDGE TRANSP
; 81 PURE ORANGE
; 225 RIGHT RIDGE OPAQUE (WAS 82)
; 84 BOTTOM RIDGE OPAQUE
;s2_massivemountainorangeblock:
;  defb 5,5,1 ;W/H / DEFAULT OBJECT TYPE
;  defb 81,1,253
;  defb 5,253
;  defb 5,253
;  defb 5,253
;  defb 5,255
 ; defb 0; OBJECT TYPE, TILE X, TILE Y

s2_massivemountainleft:
  defb %01000100,3 ;W/H / DEFAULT OBJECT TYPE
  defb 48,25,25,253 ; LOWER
  defb 5,253 ; LOWER
  defb 5,253 ; LOWER
  defb 5,255 ; END
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_massivemountainright:
  defb %01000011,3 ;W/H / DEFAULT OBJECT TYPE
  defb 225,225,248,253 ; LOWER
  defb 5,253 ; LOWER
  defb 5,253 ; LOWER
  defb 5,255 ; END
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_massivemountainbottomright:
  defb %01000100,3 ;W/H / DEFAULT OBJECT TYPE
  defb 49,49,49,51,253 ; LOWER
  defb 84,84,237,248,253 ; LOWER
  defb 84,237,225,248,253 ; LOWER
  defb 0,225,225,248,255 ; END
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_massivemountainbottomright2:
  defb %00110100,3 ;W/H / DEFAULT OBJECT TYPE
  defb 225,225,28,49,253 ; LOWER
  defb 225,28,84,84,253 ; LOWER
  defb 28,84,84,84,255 ; MID
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_massivemountainbottomleft:
  defb %01000100,3 ;W/H / DEFAULT OBJECT TYPE
  defb 251,49,49,49,253 ; LOWER
  defb 48,37,84,84,253 ; LOWER
  defb 48,25,37,84,253 ; MID
  defb 48,25,25,0,255 ; MID
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_massivemountainbottomleft2:
  defb %00110100,3 ;W/H / DEFAULT OBJECT TYPE
  defb 49,228,25,25,253 ; LOWER
  defb 84,84,228,25,253 ; LOWER
  defb 84,84,84,228,255 ; MID
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_massivemountainbottom:
  defb %00110101,3 ;W/H / DEFAULT OBJECT TYPE
  defb 49,1,253 ; LOWER
  defb 84,1,253 ; LOWER
  defb 5,255 ; MID
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_massivemountaintopleft:
  defb %00110100,3 ;W/H / DEFAULT OBJECT TYPE
  defb 29,25,25,81,253 ; MID
  defb 0,29,25,81,254 ; MID
  defb 0,0,29,78,255 ;UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_massivemountaintopright:
  defb %00110100,3 ;W/H / DEFAULT OBJECT TYPE
  defb 81,225,225,229,253 ; MID
  defb 81,225,229,0,254 ; MID
  defb 78,229,0,0,255 ;UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_massivemountaintop:
  defb %00100101,3 ;W/H / DEFAULT OBJECT TYPE
  defb 81,1,254 ; MID
  defb 78,1,255 ;UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y

; ----- FOLIAGE ------------------------------------

s2_palm:
  defb %00100010,6 ; W/H / DEFAULT OBJECT TYPE
  defb 57,18,254 ; LOWER
  defb 55,56,255 ; UPPER
  defb 7,1,0; OBJECT TYPE, TILE X, TILE Y

; ----- MEDIEVAL WORLD ------------------------------------

s2_castle:
  defb %01000011,1 ; W / H / DEFAULT OBJECT TYPE
  defb 222,126,22,253
  defb 238,123,38,253
  defb 119,120,121,254
  defb 116,117,118,255
  defb 9,1,0; OBJECT TYPE, TILE X, TILE Y - HIDDEN ENTRANCE FOR PICKAXE TO FIND

s2_towerroof:
  defb %00110011,1 ; W / H / DEFAULT OBJECT TYPE
  defb 222,126,22,253
  defb 119,120,121,254
  defb 116,117,118,255
  defb 9,1,0; OBJECT TYPE, TILE X, TILE Y - HIDDEN ENTRANCE FOR PICKAXE TO FIND

; 149 - newwall top
; 150 - backright corner
; 151 - backright
; 152 - backleft corner
; 153 - backleft
; 154 - right top
; 155 - left top
; 156 - right front top
; 157 - left front top

s2_roundhouse:
  defb %01000011,1 ; W / H / DEFAULT OBJECT TYPE
  defb 0,252,0,253
  defb 222,123,22,253
  defb 119,120,121,254
  defb 116,117,118,255
  defb 247,1,1; OBJECT TYPE, TILE X, TILE Y
s2_castlegate:
  defb %00100100,1 ; W / H / DEFAULT OBJECT TYPE
  defb 126,216,216,126,254
  defb 126,126,126,126,255
  defb 0; OBJECT TYPE, TILE X, TILE Y

; ----- FAMINE WORLD --------------------------------

s2_cryptentrance:
  defb %00100001,1 ; W / H / DEF OBJ
  defb 124,253
  defb 64,255
  defb 226,0,0; OBJECT TYPE, TILE X, TILE Y
s2_gravestone:
  defb %00010001,214 ; W / H / DEF OBJ
  defb 64,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_gravestone2:
  defb %00010001,214 ; W / H / DEF OBJ
  defb 63,255
  defb 0; OBJECT TYPE, TILE X, TILE Y

s2_thatchhouse:
  defb %01000011,1 ; W / H / DEFAULT OBJECT TYPE
  defb 11,112,211,253
  defb 108,109,110,253
  defb 105,106,107,254
  defb 116,117,118,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_thatchhouseback: 
  defb %00110100,1 ; W / H / DEFAULT OBJECT TYPE
  defb 11,122,112,211,253
  defb 6,131,131,206,254
  defb 128,130,130,127,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_thatchhousefront: 
  defb %01000100,1 ; W / H / DEFAULT OBJECT TYPE
  defb 0,252,0,0,253
  defb 11,99,122,211,253
  defb 6,131,131,206,254
  defb 128,130,130,127,255
  defb 255,1,1; OBJECT TYPE, TILE X, TILE Y
s2_thatchhousefrontunderwater: 
  defb %01000100,1 ; W / H / DEFAULT OBJECT TYPE
  defb 0,252,0,0,253
  defb 11,99,122,211,253
  defb 6,131,131,206,254
  defb 128,130,130,127,255
  defb 217,1,1; OBJECT TYPE, TILE X, TILE Y

; RUGGED STONE WALL
; -----------------

;s2_stonewallback:
;  defb 6,5,1 ; W / H / DEFAULT OBJ TYPE
;  defb 10,0,0,0,0,210,253;
;  defb 21,0,0,0,0,221,253;
;  defb 88,0,0,0,0,88,253;
;  defb 88,92,92,92,92,88,254;
;  defb 8,90,90,90,90,208,255
;  defb 0; OBJECT TYPE, TILE X, TILE Y
; RUGGED STONE WALL
;s2_stonewallfront:
;  defb 4,2,1 ; W / H / DEFAULT OBJ TYPE
;  defb 92,9,0,209,254;
;  defb 90,90,90,90,255
;  defb 0; OBJECT TYPE, TILE X, TILE Y

; ----- RUGGED STONE ARCHITECTURE --------------------------------

s2_stonewallhoriz:
  defb %00100101,8 ; W / H / DEFAULT OBJ TYPE
  defb 92,1,254
  defb 90,1,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_stonewallvert:
  defb %01000001,8 ; W / H / DEFAULT OBJ TYPE
  defb 88,253
  defb 88,253
  defb 88,253
  defb 88,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_stonewalltopleft:
  defb %00100010,8 ; W / H / DEFAULT OBJ TYPE
  defb 88,92,254
  defb 8,90,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_stonewalltopright:
  defb %00100010,8 ; W / H / DEFAULT OBJ TYPE
  defb 92,88,254
  defb 90,208,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_stonewallbottomleft:
  defb %00100010,8 ; W / H / DEFAULT OBJ TYPE
  defb 10,92,254
  defb 21,90,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_stonewallbottomright:
  defb %00100010,8 ; W / H / DEFAULT OBJ TYPE
  defb 92,210,254
  defb 90,221,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_stonewallarchway:
  defb %00100100,8 ; W / H / DEFAULT OBJ TYPE
  defb 9,0,0,209,254
  defb 90,90,90,90,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

; --- ABBEY -----------------------------------------

s2_abbeytower:
  defb %10000110, 1 ; W / H/ DEF OBJ TYPE
  defb 10,  92,  92,  92,  92, 210, 253
  defb 5, 253
  defb 5, 253
  defb 5, 253
  defb 5, 254
  defb 88, 126, 126, 126, 126,  88, 253
  defb 88, 126, 126, 126, 126,  88, 253
  defb 8,   90,  90,  90,  90, 208, 255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

s2_abbeytowerbottom:
  defb %01110110, 1 ; W / H/ DEF OBJ TYPE
  defb 10,  92,  92,  92,  92, 210, 253
  defb 5, 253
  defb 5, 253
  defb 5, 253
  defb 5, 253
  defb 5, 253
  defb 5, 255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

s2_abbeyroof:
  defb %01010101,1 ; W / H/ DEF OBJ TYPE
  defb 114, 1, 253
  defb 5, 253
  defb 5, 253
  defb 5, 253
  defb 85, 1, 255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

s2_abbeybuildingl:
  defb %01100101, 1 ; W / H/ DEF OBJ TYPE
  defb 92, 1, 253
  defb 92, 92 ,92, 133, 92, 253
  defb 92, 1, 253
  defb 114, 1, 253
  defb 5, 253
  defb 5, 255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

s2_abbeybuildingr:
  defb %01101011, 1 ; W / H/ DEF OBJ TYPE
  defb 92,  92, 1, 1, 210, 253
  defb 92,  133, 92,92,133,92, 92,133,92,92, 210, 253
  defb 92,  92, 1, 1, 210, 253
  defb 114, 114, 114, 1, 1, 253
  defb 5, 253
  defb 5, 255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

; DOOR OPENS WITH KEY AND MOVES TO LOWER LEVEL
s2_abbeydoor:
  defb %00100010,213 ; W / H/ DEF OBJ TYPE
  defb 216,216,253
  defb 216,216,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

; DOOR OPENS WITH KEY BUT MOVES SCREEN INSTEAD OF LEVEL
s2_dungeondoor:
  defb %00100001,211 ; W / H/ DEF OBJ TYPE
  defb 216,216,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

;--------------------------------------------
; INSIDE BUILDINGS
;--------------------------------------------

; WOOD BUILDING

s2_shippwheelhousewallh:
  defb %00101111,4; W / H / DEFAULT OBJECT TYPE
  defb 0,0,1,1,0,1,1,254
  defb 0,0,214,14,0,0,0,214,14,0,0,214,14,0,0,0,214,14,0,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y - 254 = INTERNAL DOOR

; ROOM DIVISION
s2_cabinwalldiv:
  defb %01010010,1; W / H / DEFAULT OBJECT TYPE
  defb 16,216,253
  defb 5,253
  defb 5,253
  defb 5,254
  defb 212,12,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_cabinwalldivend:
  defb %00010010,4; W / H / DEFAULT OBJECT TYPE
  defb 23,223,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

s2_woodenroof1:
  defb %01010100,4; W / H / DEFAULT OBJECT TYPE
  defb 23,85,85,223,253
  defb 16,23,223,216,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_woodenroof2:
  defb %00110100,1; W / H / DEFAULT OBJECT TYPE
  defb 16,16,216,216,253
  defb 217,16,216,17,254
  defb 0,217,17,0,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

; TABLE
s2_table:
  defb %00110100,1 ; W / H / DEFAULT OBJECT TYPE
  defb 111,0,0,111,253 
  defb 85,85,85,85,253
  defb 5,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_tablelegs:
  defb %00100100,1 ; W / H / DEFAULT OBJECT TYPE
  defb 0,0,0,0,254
  defb 111,0,0,111,255 
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_pew:
  defb %00100011,1 ; W / H / DEFAULT OBJECT TYPE
  defb 114,114,114,254
  defb 113,113,113,255
  defb 0; OBJECT TYPE, TILE X, TILE Y

; STONE BUILDING / CAVE
; ---------------------

; DUNGEONS

s2_dungeonentrance:
  defb %00010001,226 ; W / H/ DEF OBJ TYPE
  defb 124,255
  defb 0       ; FROM ABOVE GROUND TO DUNGEON
s2_dungeonexit:
  defb %00010001,239 ; W / H/ DEF OBJ TYPE
  defb 124,255
  defb 0       ; FROM DUNGEON TO ABOVE GROUND

s2_basemententrance:
  defb %00010001,224 ; W / H/ DEF OBJ TYPE
  defb 124,255
  defb 0       ; FROM HOUSE TO BASEMENT - REMEMBER POSITION
;s2_basementexit
;  defb 1,1,239 ; W / H/ DEF OBJ TYPE
;  defb 124,255
;  defb 0       ; FROM BASEMENT TO ABOVE GROUND - REMEMBER POSITION

; |   |
; |   |
; |   |
; |   |

s2_stonecorridorvert:
  defb %01000100,1; W / H / OBJECT TYPE
  defb 240,0,0,40,253
  defb 5,253
  defb 5,253
  defb 5,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

;  ----
;  |  |

s2_stonecorridordeadendtop:
  defb %00010100,1; W / H / OBJECT TYPE
  defb 246,252,252,46,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

;  |  |
;  ----

s2_stonecorridordeadendbottom:
  defb %00010100,4; W / H / OBJECT TYPE
  defb 246,252,252,46,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

;  -|  |-

s2_stonecorridorentrancetop:
  defb %00010100,4; W / H / OBJECT TYPE
  defb 246,252,252,46,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

;   |
;  -
;  

s2_stonecorridorentrancelefttop:
  defb %00100101,4; W / H / OBJECT TYPE
  defb 252,1,253
  defb 136,136,136,136,246,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_stonecorridorentrancelefttopshort:
  defb %00100001,4; W / H / OBJECT TYPE
  defb 252,253
  defb 246,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

; -
;  |

s2_stonecorridorentranceleftbottom:
  defb %00010101,1; W / H / OBJECT TYPE
  defb 136,136,136,136,246,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_stonecorridorentranceleftbottomshort:
  defb %00100001,1; W / H / OBJECT TYPE
  defb 246,253
  defb 252,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

s2_stonecorridorclearentrancehoriz:
  defb %00100101,1; W / H / OBJECT TYPE
  defb 252,1,253
  defb 5,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

;  |
;   -
;  
s2_stonecorridorentrancerighttop:
  defb %00010101,4; W / H / OBJECT TYPE
  defb 46,136,136,136,136,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

;   _
;  |

s2_stonecorridorentrancerightbottom:
  defb %00100101,1; W / H / OBJECT TYPE
  defb 46,136,136,136,136,253
  defb 252,1,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

;  -|  |-

s2_stonecorridorentrancebottom:
  defb %00010100,1; W / H / OBJECT TYPE
  defb 246,252,252,46,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

;  |  |
;  |  |
;  |  |
; -|  |-

s2_stonecorridortop:
  defb %01000100,4; W / H / OBJECT TYPE
  defb 246,252,252,46,253
  defb 240,0,0,40,253
  defb 5,253
  defb 5,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

; -|  |-
;  |  |
;  |  |
;  |  |

s2_stonecorridorbottom:
  defb %01000100,1; W / H / OBJECT TYPE
  defb 240,0,0,40,253
  defb 5,253
  defb 5,253
  defb 246,252,252,46,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

; -----
; |
; |
; -----

s2_stonecorridorleftbottom:
  defb %00100101,1; W / H / OBJECT TYPE
  defb 245,136,136,136,136,253
  defb 240,0,0,0,0,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_stonecorridorlefttop:
  defb %00100101,4; W / H / OBJECT TYPE
  defb 240,0,0,0,0,253
  defb 245,136,136,136,136,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

; -----
;     |
;     |
; -----

s2_stonecorridorrightbottom:
  defb %00100101,1; W / H / OBJECT TYPE
  defb 136,136,136,136,45,253
  defb 0,0,0,0,40,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_stonecorridorrighttop:
  defb %00100101,4; W / H / OBJECT TYPE
  defb 0,0,0,0,40,253
  defb 136,136,136,136,45,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

; -----
;
; -----
s2_stonecorridorhorizbottomshort:
  defb %00010101,1; W / H / OBJECT TYPE
  defb 136,1,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_stonecorridorhoriztopshort:
  defb %00010101,4; W / H / OBJECT TYPE
  defb 136,1,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

; --------------------

; --------------------
s2_stonecorridorhorizbottom:
  defb %00011111,1; W / H / OBJECT TYPE
  defb 136,1,136,1,136,1,136,1,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_stonecorridorhoriztop:
  defb %00011111,4; W / H / OBJECT TYPE
  defb 136,1,136,1,136,1,136,1,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

s2_stoneroomtophoriz:
  defb %00011111,1; W / H / OBJECT TYPE
  defb 245,136,1,136,1,136,1,136,136,136,45,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_stoneroombottomhoriz:
  defb %00011111,4; W / H / OBJECT TYPE
  defb 245,136,1,136,1,136,1,136,136,136,45,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

; ------------

s2_stonebuildingwallh:
  defb %00011100,4; W / H / DEFAULT OBJECT TYPE
  defb 245,136,1,1,136,45,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

; |                    
; |                    
; |                    
; |                    
; |                    
; |                    
; |                    
; |                    

s2_stonebuildingwallleft:
  defb %10100001,1; W / H / DEFAULT OBJECT TYPE
  defb 240,253
  defb 240,253
  defb 240,253
  defb 240,253
  defb 240,253
  defb 240,253
  defb 240,253
  defb 240,253
  defb 240,253
  defb 240,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

;                     |
;                     |
;                     |
;                     |
;                     |
;                     |
;                     |
;                     |

s2_stonebuildingwallright:
  defb %10100001,1; W / H / DEFAULT OBJECT TYPE
  defb 40,253
  defb 40,253
  defb 40,253
  defb 40,253
  defb 40,253
  defb 40,253
  defb 40,253
  defb 40,253
  defb 40,253
  defb 40,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

;  ||
; ----

s2_stonewalldivisionbottom:
  defb %00010100,1; W / H / OBJECT TYPE
  defb 45,245,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

; ----
;  ||

s2_stonewalldivisiontop:
  defb %00010100,4; W / H / OBJECT TYPE
  defb 45,245,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

; ------------

s2_stonebuildingwallhbottom:
  defb %00011100,1; W / H / DEFAULT OBJECT TYPE
  defb 245,136,1,136,1,45,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

; SINGLE INSIDE CORNER TILES
s2_stonebuildingwallcornerbl:
  defb %00010001,1; W / H / OBJECT TYPE
  defb 245,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_stonebuildingwallcornerbr:
  defb %00010001,1; W / H / OBJECT TYPE
  defb 45,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_stonebuildingwallcornertl:
  defb %00010001,4; W / H / OBJECT TYPE
  defb 245,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_stonebuildingwallcornertr:
  defb %00010001,4; W / H / OBJECT TYPE
  defb 45,255
  defb 0 ; OBJECT TYPE, TILE X, TILE Y

;--------------------------------------------
; WATER
;--------------------------------------------
s2_waterfall2:
  defb %00111011,1 ; W / H/ DEF OBJ TYPE
  defb 0,  0,209,149,1,9,0,0,253
  defb 0, 209,92,149,1,92,9,0,253
  defb 209,92,92,149,1,92,92,9,255
  defb 215,5,0 ; OBJECT TYPE, TILE X, TILE Y - DUNGEON ENTRANCE

;s2_stonebridge4:
;  defb 6, 2, 1 ; W / H/ DEF OBJ TYPE
;  defb 92, 92, 92,  92, 92,  92 ,254
;  defb 92, 92, 92,  92, 92,  92 ,255
;s2_stonebridge3:
;  defb 6, 1, 1 ; W / H/ DEF OBJ TYPE
;  defb 92, 92, 92,  92, 92,  92 ,255
;s2_stonebridge2:
;  defb 6, 2, 254 ; W / H/ DEF OBJ TYPE
;  defb 126, 126, 126,  126, 126,  126 ,253
;  defb 126, 126, 126,  126, 126,  126 ,255
;  ;defb 92, 92, 92,  92, 92,  92 ,255
;  defb 0 ; OBJECT TYPE, TILE X, TILE Y
;s2_stonebridge:
;  defb 6, 3, 1 ; W / H/ DEF OBJ TYPE
;  defb 0,  0,  0,   0,  0,   0,  254  
;  defb 9,  0,  0,   0,  0,   209,253
;  defb 92, 9,  0,   0,  209, 92, 255
;  defb 0 ; OBJECT TYPE, TILE X, TILE Y


s2_water:
  defb %01010110,2 ; W / H / DEFAULT OBJECT TYPE
  defb 0,19,103,103,219,0,253       ; UPPER
  defb 19,100,100,100,100,219,253   ; MID
  defb 230,100,100,100,100,30,253   ; MID
  defb 96,100,100,100,100,98,253    ; MID
  defb 0,96,97,97,98,0,255          ; LOWER
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_watervertical:
  defb %01010101,2 ; W / H / DEFAULT OBJECT TYPE
  defb 0,230,100,100,30,253 ; UPPER
  defb 19,100,100,100,30,253 ; UPPER
  defb 230,100,100,100,30,253 ; UPPER
  defb 5,253 ; UPPER
  defb 96,100,100,100,30,255 ; UPPER
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_watervertical2:
  defb %01010101,2 ; W / H / DEFAULT OBJECT TYPE
  defb 230,100,100,30,0,253 ; UPPER
  defb 230,100,100,100,219,253 ; UPPER
  defb 230,100,100,100,30,253 ; UPPER
  defb 5,253 ; UPPER
  defb 230,100,100,100,98,255 ; LOWER
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_watervertical3:
  defb %01010101,2 ; W / H / DEFAULT OBJECT TYPE
  defb 230,100,100,100,30,253 ; UPPER
  defb 5,253 ; UPPER
  defb 5,253 ; UPPER
  defb 5,253 ; UPPER
  defb 5,255 ; LOWER
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_waterhoriz:
  defb %01010101,2 ; W / H / DEFAULT OBJECT TYPE
  defb 19,103,219,0,0,253 ; LOWER
  defb 100,100,100,103,103,253 ; UPPER
  defb 100,1,253 ; UPPER
  defb 97,100,100,100,100,253 ; UPPER
  defb 0,96,97,97,98,255 ; UPPER
  defb 0 ; OBJECT TYPE, TILE X, TILE Y
s2_waterhorizthin:
  defb %00110101,2 ; W / H / DEFAULT OBJECT TYPE
  defb 103,1,253 ; LOWER
  defb 100,1,253 ; UPPER
  defb 97,1,255 ; UPPER
  defb 0 ; OBJECT TYPE, TILE X, TILE Y




;s2_woodenroof1
;  defb 4,5,4; W / H / DEFAULT OBJECT TYPE
;  defb 23,85,85,223,253
;  defb 16,23,223,216,255
;  defb 0 ; OBJECT TYPE, TILE X, TILE Y
;s2_woodenroof2
;  defb 4,3,1; W / H / DEFAULT OBJECT TYPE
;  defb 16,16,216,216,253
;  defb 217,16,216,17,254
;  defb 0,217,17,0,255
;  defb 0 ; OBJECT TYPE, TILE X, TILE Y


; SHIP WALL
s2_shipwall:
  defb %00011100,1 ; W / H / DEFAULT OBJECT TYPE
  ;defb 0,1,0,1,0,254
  defb 23,85,1,114,114,85,85,85,223,255 ; LOWER
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_shipwall2:
  defb %00011100,4 ; W / H / DEFAULT OBJECT TYPE
  defb 23,85,1,85,1,223,255 ; LOWER
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_shipdeck:
  defb %01001010,254 ; W / H / DEFAULT OBJECT TYPE
  defb 16,1,16,1,253 ; LOWER
  defb 5,253 ; LOWER
  defb 5,253 ; LOWER
  defb 5,255 ; LOWER
  defb 0; OBJECT TYPE, TILE X, TILE Y

s2_shipleftwall:
  defb %01000001,1 ; W / H / DEFAULT OBJECT TYPE
  defb 16,253 ; LOWER
  defb 16,253 ; LOWER
  defb 16,253 ; LOWER
  defb 16,255 ; LOWER
  defb 0; OBJECT TYPE, TILE X, TILE Y

s2_shiprightwall:
  defb %01000001,1 ; W / H / DEFAULT OBJECT TYPE
  defb 216,253 ; LOWER
  defb 216,253 ; LOWER
  defb 216,253 ; LOWER
  defb 216,255 ; LOWER
  defb 0; OBJECT TYPE, TILE X, TILE Y




;s2_woodenroof1:
;  defb 4,5,4; W / H / DEFAULT OBJECT TYPE
;  defb 23,85,85,223,253
;  defb 16,23,223,216,255
;  defb 0 ; OBJECT TYPE, TILE X, TILE Y
;s2_woodenroof2:
;  defb 4,3,1; W / H / DEFAULT OBJECT TYPE
;  defb 16,16,216,216,253
;  defb 217,16,216,17,254
;  defb 0,217,17,0,255
;  defb 0 ; OBJECT TYPE, TILE X, TILE Y



;s2_shipleftwall:
;  defb 1,2,2 ; W / H / DEFAULT OBJECT TYPE
;  defb 114,254 ; LOWER
;  defb 23,255 ; LOWER
;  defb 0; OBJECT TYPE, TILE X, TILE Y
;s2_shipleftwall2:
;  defb 1,2,4 ; W / H / DEFAULT OBJECT TYPE
;  defb 23,253 ; LOWER
;  defb 114,255 ; LOWER
;  defb 0; OBJECT TYPE, TILE X, TILE Y
;s2_shiprightwall:
;  defb 1,2,2 ; W / H / DEFAULT OBJECT TYPE
;  defb 114,254 ; LOWER
;  defb 223,255 ; LOWER
;  defb 0; OBJECT TYPE, TILE X, TILE Y
;s2_shiprightwall2:
;  defb 1,2,4 ; W / H / DEFAULT OBJECT TYPE
;  defb 223,253 ; LOWER
;  defb 114,255 ; LOWER
;  defb 0; OBJECT TYPE, TILE X, TILE Y
; BRIDGE
s2_bridge:
  defb %01010100,1 ; W / H / DEFAULT OBJECT TYPE
  defb 79,114,114,79,253
  defb 5,253
  defb 5,253
  defb 5,253
  defb 5,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_cavemountain:
  defb %01000101,1 ;W/H/ DEFAULT OBJECT TYPE
  defb 251,49,50,49,51,253 ; LOWER
  defb 48,37,84,237,248,253 ; MID
  defb 29,25,81,225,229,254 ; MID
  defb 0,29,78,229,0,255 ;UPPER
  defb 216,2,0; OBJECT TYPE, TILE X, TILE Y
s2_dungeonmountain:
  defb %01000101,1 ;W/H/ DEFAULT OBJECT TYPE
  defb 251,49,50,49,51,253 ; LOWER
  defb 48,37,84,237,248,253 ; MID
  defb 29,25,81,225,229,254 ; MID
  defb 0,29,78,229,0,255 ;UPPER
  defb 215,2,0; OBJECT TYPE, TILE X, TILE Y
;s2_minemountain
;  defb %01000101,1 ;W/H/ DEFAULT OBJECT TYPE
;  defb 251,49,50,49,51,253 ; LOWER
;  defb 48,37,84,237,248,253 ; MID
;  defb 29,25,81,225,229,254 ; MID
;  defb 0,29,78,229,0,255 ;UPPER
;  defb 253,2,0; OBJECT TYPE, TILE X, TILE Y
;s2_minemountain2
;  defb %01000101,1 ;W/H/ DEFAULT OBJECT TYPE
;  defb 251,49,50,49,51,253 ; LOWER
;  defb 48,37,84,237,248,253 ; MID
;  defb 29,25,81,225,229,254 ; MID
;  defb 0,29,78,229,0,255 ;UPPER
;  defb 245,2,0; OBJECT TYPE, TILE X, TILE Y
s2_minetunneltop:
  defb %01010011,1 ; W/H / DEFAULT OBJECT TYPE
  defb 13,252,213,253
  defb 5,253
  defb 5,253
  defb 5,253
  defb 5,255
  defb 251,1,4; OBJECT TYPE, TILE X, TILE Y - 254 = ENTER CACTUS LAND
; MINE TOP 2 TIlE OBJ = 241 GO TO NARNIA WORLD
s2_minetunnelbottom:
  defb %01010011,1 ; W/H / DEFAULT OBJECT TYPE
  defb 13,252,213,253 
  defb 5,253
  defb 5,253
  defb 5,253
  defb 5,255
  defb 252,1,0; OBJECT TYPE, TILE X, TILE Y - 253 - ENTER FOREST LAND
; MINE BOTTOM 2 TIlE OBJ = 242 GO BACK TO MAZE HOUSE

;--------------------------------------------
; QUEST SPRITES
;--------------------------------------------
;s2_indianman
;  defb 1,2,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
;  defb 61,254 ; LOWER
;  defb 60,255 ; UPPER
;  defb 234,0,0; OBJECT TYPE, TILE X, TILE Y
; OBJECTS THAT CAN BE PICKED UP
s2_moneybag:
  defb %00010001,250 ; W/H / DEFAULT OBJECT TYPE
  defb moneybag,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_pickaxe:
  defb %00010001,250 ; W/H / DEFAULT OBJECT TYPE
  defb 151,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
;s2_peacepipe:
;  defb 1,1,1 ; W/H / DEFAULT OBJECT TYPE
;  defb peacepipe,255
;  defb 250,0,0; OBJECT TYPE, TILE X, TILE Y
;s2_parcel
;  defb 1,1,250 ; W/H / DEFAULT OBJECT TYPE
;  defb parcel,255
;  defb 0; OBJECT TYPE, TILE X, TILE Y
;s2_key
;  defb 1,1,250 ; W/H / DEFAULT OBJECT TYPE
;  defb key,255
;  defb 0; OBJECT TYPE, TILE X, TILE Y
;s2_feather:
;  defb 1,1,1 ; W/H / DEFAULT OBJECT TYPE
;  defb feather,255
;  defb 250,0,0; OBJECT TYPE, TILE X, TILE Y
;s2_flippers:
;  defb 1,1,1 ; W/H / DEFAULT OBJECT TYPE
;  defb flipper_id,255
;  defb 250,0,0; OBJECT TYPE, TILE X, TILE Y
;s2_rope:
;  defb 1,1,1 ; W/H / DEFAULT OBJECT TYPE
;  defb rope_id,255
;  defb 250,0,0; OBJECT TYPE, TILE X, TILE Y


; QUEST CHARACTERS
; OBJECT TYPE 238 - RANDOM CONVERSATION
; OBJECT TYPE 246 - FLIPPED SPRITE
; OBJECT TYPE 249 - RANDOM QUEST
;s2_indianwoman
;  defb 1,1,1 ; W/H / DEFAULT OBJECT TYPE
;  defb 95,255
;  defb 234,0,0; OBJECT TYPE, TILE X, TILE Y
;s2_indianmanlove
;  defb 1,2,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
;  defb 61,254 ; LOWER
;  defb 60,255 ; UPPER
;  defb 234,0,0; OBJECT TYPE, TILE X, TILE Y
s2_indianmanquest:
  defb %00010001,234 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb 61,254 ; LOWER
  defb 60,255 ; UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_indianmanrandom:
  defb %00100001,249 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
  defb 61,254 ; LOWER
  defb 60,255 ; UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y
;s2_indianmanconv:
;  defb 1,2,1 ; WIDTH / HEIGHT / DEFAULT OBJECT TYPE
;  defb 61,254 ; LOWER
;  defb 60,255 ; UPPER
;  defb 238,0,0; OBJECT TYPE, TILE X, TILE Y 
s2_settlerman:
  defb %00010001,234 ; W/H / DEFAULT OBJECT TYPE
  defb 59,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_settlermanchurch:
  defb %00010001,229 ; W/H / DEFAULT OBJECT TYPE
  defb 139,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_shopkeeper:
  defb %00010001,235 ; W/H / DEFAULT OBJECT TYPE
  defb 87,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_minister:
  defb %00010001,230 ; W/H / DEFAULT OBJECT TYPE
  defb 87,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
;s2_guard
;  defb %00010001,212 ; W/H / DEFAULT OBJECT TYPE
;  defb 87,255
;  defb 0; OBJECT TYPE, TILE X, TILE Y
;s2_arrowman
;  defb 1,1,1 ; W/H / DEFAULT OBJECT TYPE
;  defb 59,255
;  defb 234,0,0; OBJECT TYPE, TILE X, TILE Y
s2_settlermanrandom:
  defb %00010001,249 ; W/H / DEFAULT OBJECT TYPE
  defb 59,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_settlermanquest:
  defb %00010001,234 ; W/H / DEFAULT OBJECT TYPE
  defb 59,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_townbanker:
  defb %00010001,232 ; W/H / DEFAULT OBJECT TYPE
  defb 59,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_oldmanrandom:
  defb %00010001,249 ; W/H / DEFAULT OBJECT TYPE
  defb 87,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_oldmansaloongame:
  defb %00010001,218 ; W/H / DEFAULT OBJECT TYPE
  defb 87,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_indianwomanrandom:
  defb %00010001,249 ; W/H / DEFAULT OBJECT TYPE
  defb 95,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_girlrandom:
  defb %00010001,249 ; W/H / DEFAULT OBJECT TYPE
  defb 129,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_pegleg:
  defb %00010001,227 ; W/H / DEFAULT OBJECT TYPE
  defb 86,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_girlblonderandom:
  defb %00010001,249 ; W/H / DEFAULT OBJECT TYPE
  defb 138,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_girlnarnia:
  defb %00010001,244 ; W/H / DEFAULT OBJECT TYPE
  defb 129,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_mimomum:
  defb %00010001,237 ; W/H / DEFAULT OBJECT TYPE
  defb 129,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_oldmanquest:
  defb %00010001,234 ; W/H / DEFAULT OBJECT TYPE
  defb 87,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_girlblondequest:
  defb %00010001,234 ; W/H / DEFAULT OBJECT TYPE
  defb 138,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_oldmanjailor:
  defb %00010001,222 ; W/H / DEFAULT OBJECT TYPE
  defb 87,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_sailorquest:
  defb %00010001,234 ; W/H / DEFAULT OBJECT TYPE
  defb 86,255
  defb 0; OBJECT TYPE, TILE X, TILE Y

s2_turret:
  defb %00010001,219 ; W/H / DEFAULT OBJECT TYPE
  defb 87,255
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_turrettarget:
  defb %00010101,220 ; W/H / DEFAULT OBJECT TYPE
  defb grass,0,grass,0,grass,0,255
  defb 0; OBJECT TYPE, TILE X, TILE Y

s2_indianhostile:
  defb %00100001,219 ; W/H / DEFAULT OBJECT TYPE
  defb 61,254 ; LOWER
  defb 60,255 ; UPPER
  defb 0; OBJECT TYPE, TILE X, TILE Y
s2_indiantarget:
  defb %00010001,220 ; W/H / DEFAULT OBJECT TYPE
  defb longgrass,255
  defb 0; OBJECT TYPE, TILE X, TILE Y

;s2_letter
;  defb 1,1,1 ; W/H / DEFAULT OBJECT TYPE
;  defb letter,255
;  defb 250,0,0 ; OBJECT TYPE, TILE X, TILE Y
;s2_map
;  defb 1,1,1 ; W/H / DEFAULT OBJECT TYPE
;  defb map_id,255
;  defb 250,0,0 ; OBJECT TYPE, TILE X, TILE Y

s2_fencehorizleft:
  defb %00011000,1 ; W/H / DEFAULT OBJECT TYPE
  defb 83,1,83,83,134,255
  defb 0; OBJECT TYPE, TILE X, TILE Y

s2_fencehoriz:
  defb %00011000,1 ; W/H / DEFAULT OBJECT TYPE
  defb 83,1,83,83,83,255
  defb 0; OBJECT TYPE, TILE X, TILE Y

s2_fencevertleft:
  defb %01000001,1 ; W/H / DEFAULT OBJECT TYPE
  defb 18,253
  defb 18,253
  defb 18,253
  defb 18,255
  defb 0; OBJECT TYPE, TILE X, TILE Y

s2_fencevertright:
  defb %01000001,1 ; W/H / DEFAULT OBJECT TYPE
  defb 218,253
  defb 218,253
  defb 218,253
  defb 218,255
  defb 0; OBJECT TYPE, TILE X, TILE Y

; OBJECT TILE TYPES
; 0 = EMPTY SPACE
; 1 = PHYSICAL OBSTRUCTION
; 2 = WATER
; 3 = MOUNTAIN
; 249 = RANDOM QUEST
; 250 = MONEY
; 254 = CAN MOVE BUT STILL OBJECT, EG. BRIDGE OBJECT
; 255 = LOCKED DOOR