; LOOKUP TABLE FOR ANIMATION FRAMES
spriteanimtable:
  defw weemanl1      ; 0
  defw weemanl2      ; 1
  defw torchright    ; 2
  defw torchright2   ; 3
  defw weemand1      ; 4 
  defw weemand2      ; 5
  defw weemanu1      ; 6
  defw weemanu2      ; 7
  defw rabbitleft    ; 8
  defw rabbitleft2   ; 9
  defw tumbleweed1   ; 10
  defw tumbleweed2   ; 11
  defw fire1         ; 12
  defw fire2         ; 13
  defw watershimmer1 ; 14
  defw watershimmer2 ; 15
  defw watershimmer1 ; 16
  defw arrowleft     ; 17
  defw arrowleft     ; 18
  defw arrowup       ; 19
  defw arrowup       ; 20
  defw axeleft       ; 21
  defw axeleft       ; 22
  defw pickaxeleft   ; 23
  defw pickaxeleft   ; 24
  defw oldmandown1   ; 25
  defw oldmandown2   ; 26
  defw oldmanup1     ; 27
  defw oldmanup2     ; 28
  defw oldmanright1  ; 29
  defw oldmanright2  ; 30

  anim_weemanl1      equ 0
  anim_weemanl2      equ 1
  anim_torchright    equ 2
  anim_torchright2   equ 3
  anim_weemand1      equ 4 
  anim_weemand2      equ 5
  anim_weemanu1      equ 6
  anim_weemanu2      equ 7
  anim_rabbitleft    equ 8
  anim_rabbitleft2   equ 9
  anim_tumbleweed1   equ 10
  anim_tumbleweed2   equ 11
  anim_fire1         equ 12
  anim_fire2         equ 13
  anim_watershimmer1 equ 14
  anim_watershimmer2 equ 15
  anim_arrowleft     equ 17
  anim_arrowleft2    equ 18
  anim_arrowup       equ 19
  anim_arrowup2      equ 20
  anim_axeleft       equ 21
  anim_axeleft2      equ 22
  anim_pickaxeleft   equ 23
  anim_pickaxeleft2  equ 24
  anim_oldmand1      equ 25
  anim_oldmand2      equ 26
  anim_oldmanu1      equ 27
  anim_oldmanu2      equ 28
  anim_oldmanr1      equ 29
  anim_oldmanr2      equ 30

doublebuffertable:
  defw rabbitbuff    ; USE EMPTY 0 TILE TO SAVE MEMORY
  defw rabbitbuff2
  defw rabbitbuff3
  defw rabbitbuff4
  defw rabbitbuff5
  defw rabbitbuff6
  defw rabbitbuff7

; SPRITE MOVEMENT DEALS WITH OBTACLES IN THE TILE MAP,
; AS OPPOSED TO COLLISIONS BETWEEN SPRITES, WHICH IS DEALT WITH BY COLLISION.ASM

; DEACTIVATE SPRITE BUFFER ON MOVING SCREEN
; PREVENTS SPRITE BUFFER BEING DRAWN WITH PREVIOUS SCREEN GRAPHICS

spritetablearrow:
  defw mcparrowdata
  defw playerarrowdata

spritetableforward:
  defw mcps
  defw mcps+28
  defw mcps+28+28
  defw mcps+28+28+28
spritetablebackward:
  defw mcps+28+28+28+28
  defw mcps+28+28+28
  defw mcps+28+28
  defw mcps+28
  defw mcps

numsprites equ 5

clearkilledcharactersfunc:
  ld a,(hl)      ; IGNORE INACTIVE SPRITES
  or a
  ret z
  push hl
  pop ix
  bit 0,(ix+2)   ; CHARACTER IS DEAD IF SET  
  ret z
  jp deactivatesprite
; CONVERT ACTIVE WEE MEN TO BOUNTY HUNTERS
convertweementobountyhuntersfunc:
  ld a,(hl)        ; IGNORE INACTIVE SPRITES
  or a
  ret z
  push hl
  pop ix
  bit 0,(ix+2)     ; CHARACTER IS DEAD IF SET  
  ret nz
  ld a,(ix+27)     ; MAKE SURE ITS A WEE MAN
  cp 1
  ret nz
  set 6,(ix+2)     ; SET TO BOUNTY HUNTER MODE
  ld (ix+24),2     ; SET DIRECTION TOWARD PLAYER
ret
convertbountyhunterstoweemenfunc:
  ld a,(hl)        ; IGNORE INACTIVE SPRITES
  or a
  ret z
  push hl
  pop ix
  bit 0,(ix+2)     ; CHARACTER IS DEAD IF SET  
  ret nz
  ld a,(ix+27)     ; MAKE SURE ITS A WEE MAN
  cp 1
  ret nz
  res 6,(ix+2)     ; SET TO BOUNTY HUNTER MODE
  ld (ix+24),0     ; SET DIRECTION TO RANDOM
ret

; FUNCTIONS FOR CALLING IN OBJECT SCANNING ROUTINE
; DEACTIVATE SPRITE DOUBLE BUFFER ON MOVING SCREENS
deactivatemcpsdoublebufferfunc:
  inc hl
  inc hl
  res 1,(hl)  ; MARK DOUBLE BUFFER AS CLEARED 
ret
; MARK SPRITE TO REDRAW IF ACTIVE AND NOT PLAYER
markspriteredrawfunc:
  ld a,(hl)
  or a   ; CHECK IF ACTIVE
  ret z
  cp 2   ; PLAYER SPRITE - SKIP IT !!! JUST DEACTIVATED, ERASE SPRITE FROM SCREEN
  ret z

  inc hl
  inc hl
  res 3,(hl)
ret
updatecharfunc:
  ld a,(hl)
  or a  ; CHECK IF ACTIVE
  ret z
  cp 2  ; PLAYER SPRITE - SKIP IT !!! JUST DEACTIVATED, ERASE SPRITE FROM SCREEN
  ret z

  push hl
  pop ix
  ; ONLY REDRAW IF WE HAVE ACTUALLY MOVED
  bit 3,(ix+2)
  jr nz,updatespritepos ; IF WE HAVEN'T MOVED THEN CALL MOVE ROUTINE

  call updatethissprite
  set 3,(ix+2)          ; SET MOVE MARKER SO WE DON'T REDRAW AGAIN

  updatespritepos:
  jp getnewspritedirection
 
;  jumpback
;ret


; FUNCTIONS FOR SETTING UP SPRITE OBJECT SCANNING FUNCTION
; HL = LOOKUP TABLE OF OBJECT PTRS
; BC = USED TO SET FUNCTION OF ROUTINE TO CALL IN LOOP
; B  = NUMBER OF ITEMS IN LIST TO SCAN

; UPDATE ARROW SPRITE ONLY - NEEDS TO MOVE QUICKLY
updatecharacterspritesarrow:
  ld hl,spritetablearrow
  ld bc,updatecharfunc
  ld (spritefunc-2),bc
  ld b,2
  jr scanspritetable
; ON MOVING SCREENS, WE WANT TO SET ALL SPRITES TO REDRAW THEIR POSITIONS
markallcharacterspritesredraw: 
  ld bc,markspriteredrawfunc
  jr dofullspritelist

; EVERY DAY, CLEAR KILLED CHARACTERS SO WE HAVE MORE ROOM FOR SPRITES
clearkilledcharacters:
  ld bc,clearkilledcharactersfunc
  jr dofullspritelist

; ALTERNATE SPRITE UPDATE FROM FORWARDS TO BACKWARDS SO BUFFER DOESN'T GET TRASHED
updatecharactersprites:
  ld a,0:redrawdirection
  cpl                          ; INVERT BITS IN A
  ld (redrawdirection-1),a
  or a
  jr z,updatecharacterspritesforward
updatecharacterspritesrev:
  ld hl,spritetablebackward
  ld bc,updatecharfunc
  jr dofullspritelist2
updatecharacterspritesforward:
  ld bc,updatecharfunc
  jr dofullspritelist
convertweementobountyhunters:
  ld bc,convertweementobountyhuntersfunc
  jr dofullspritelist
convertbountyhunterstoweemen:
  ld bc,convertbountyhunterstoweemenfunc
  jr dofullspritelist
; DEACTIVATE ANIMATIONS ON MOVING SCREEN
; THEY NEED TO BE REGENERATED ON NEW SCREEN
deactivatemcpsdoublebuffer:
  ld bc,deactivatemcpsdoublebufferfunc
  dofullspritelist:
  ld hl,spritetableforward
  dofullspritelist2:
  ld (spritefunc-2),bc
  ld b,numsprites

; SCAN A LOOKUP TABLE OF DATA OBJECTS, THEN CALL A FUNCTION FOR EACH ONE 
; THIS ENABLES US TO TRAVERSE TABLES BACKWARDS AND FORWARDS EASLIER
; INPUTS
; HL = LOOKUP TABLE OF OBJECTS
; B  = NUMBER OF OBJECTS TO SCAN
; FUNCTION INPUT
; HL = BEGINNING OF OBJECT
scanspritetable:
    push bc
    push hl
    ld a,(hl)
    inc hl
    ld h,(hl)
    ld l,a
 
    call deactivatemcpsdoublebuffer  :spritefunc
    
    pop hl
    inc hl
    inc hl
    pop bc
  djnz scanspritetable
ret

; DEACTIVATE ANIMATIONS ON MOVING SCREEN
; THEY NEED TO BE REGENERATED ON NEW SCREEN
;deactivateanimations
;  ld hl,animtiles
;  ld bc,5

  ; DEACTIVATE ALL ITEM FROM LIST
  ; INPUTS
  ; HL = LIST
  ; BC = ITEM SIZE
;  deactivateitemlist:
;  ld a,(hl)
;  ; RETURN IF WE GET TO END OF LIST
;  cp 255
;  ret z
;  ; DEACTIVATE
;  ld (hl),0
;  add hl,bc
;jr deactivateitemlist



;ret
; MOVEMENT
; 0 = RANDOM
; 1 = MOVE TO DESTINATION
; 2 = MOVE TO PLAYER
; 3 = MOVE IN STRAIGHT LINE
; 4 = STATIONARY 
; CHAR TYPE
; 1 = COMPUTER CONTROLLED PERSON
; 2 = ANIMAL
; 3 = ARROW
; 4 = PICKABLE OBJECT
; 5 = OBSTRUCTION OBJECT

randommcpstable:
  ; RABBIT GUARD - WESTERN CASTLE
  defb zone_westernmountain; ZONE
  defb anim_oldmanr1     ; SPRITE LEFT
  defb anim_oldmand1     ; SPRITE DOWN
  defb anim_oldmanu1     ; SPRITE UP
  defb 5                 ; MOVEMENT PATTERN UP DOWN GUARD
  defb 1                 ; CHAR TYPE PERSON - FOR OBJECT COLLISION CODE
  defb 2                 ; 0 = NONE, 1 = BOUNTY HUNTER, 2 = GUARD
  defb 17                ; MAP POS X
  defb 37                ; MAP POS Y

  ; RABBIT
  defb zone_forest         ; ZONE
  defb anim_rabbitleft     ; SPRITE LEFT
  defb anim_rabbitleft     ; SPRITE DOWN
  defb anim_rabbitleft     ; SPRITE UP
  defb 0                   ; MOVEMENT RANDOM
  defb 2                   ; CHAR TYPE ANIMAL
  defb 0                   ; BOUNTY HUNTER
  defb 0                   ; MAP POS X
  defb 0                   ; MAP POS Y
  ; RABBIT
  defb zone_winter         ; NARNIA - ZONE
  defb anim_rabbitleft     ; SPRITE LEFT
  defb anim_rabbitleft     ; SPRITE DOWN
  defb anim_rabbitleft     ; SPRITE UP
  defb 0                   ; MOVEMENT RANDOM
  defb 2                   ; CHAR TYPE ANIMAL
  defb 0                   ; BOUNTY HUNTER
  defb 0                   ; MAP POS X
  defb 0                   ; MAP POS Y
  ; RABBIT
  defb zone_autumn         ; AUTUMN - ZONE
  defb anim_rabbitleft     ; SPRITE LEFT
  defb anim_rabbitleft     ; SPRITE DOWN
  defb anim_rabbitleft     ; SPRITE UP
  defb 0                   ; MOVEMENT RANDOM
  defb 2                   ; CHAR TYPE ANIMAL
  defb 0                   ; BOUNTY HUNTER
  defb 0                   ; MAP POS X
  defb 0                   ; MAP POS Y

  ; WEE MAN - TRAVELLER
  defb zone_western        ; ZONE
  defb anim_weemanl1       ; SPRITE LEFT
  defb anim_weemand1       ; SPRITE DOWN
  defb anim_weemanu1       ; SPRITE UP
  defb 1                   ; MOVEMENT TO DESTINATION
  defb 1                   ; CHAR TYPE PERSON
  defb 0                   ; BOUNTY HUNTER
  defb 0                   ; MAP POS X
  defb 0                   ; MAP POS Y
  ; WEE MAN - BOUNTY
  defb zone_western        ; ZONE
  defb anim_weemanl1       ; SPRITE LEFT
  defb anim_weemand1       ; SPRITE DOWN
  defb anim_weemanu1       ; SPRITE UP
  defb 1                   ; MOVEMENT TO DESTINATION
  defb 1                   ; CHAR TYPE PERSON
  defb 1                   ; BOUNTY HUNTER
  defb 0                   ; MAP POS X
  defb 0                   ; MAP POS Y
  ; TUMBLEWEED
  defb zone_western        ; ZONE
  defb anim_tumbleweed1    ; SPRITE LEFT
  defb anim_tumbleweed1    ; SPRITE DOWN
  defb anim_tumbleweed1    ; SPRITE UP
  defb 0                   ; MOVEMENT TO RANDOM / PLAYER
  defb 5                   ; CHAR TYPE OBJECT
  defb 0                   ; BOUNTY HUNTER
  defb 0                   ; MAP POS X
  defb 0                   ; MAP POS Y

  ; WEE MAN - TRAVELLER
  defb zone_westernmountain; ZONE
  defb anim_weemanl1       ; SPRITE LEFT
  defb anim_weemand1       ; SPRITE DOWN
  defb anim_weemanu1       ; SPRITE UP
  defb 1                   ; MOVEMENT TO DESTINATION
  defb 1                   ; CHAR TYPE PERSON
  defb 0                   ; BOUNTY HUNTER
  defb 0                   ; MAP POS X
  defb 0                   ; MAP POS Y
  ; WEE MAN - BOUNTY
  defb zone_westernmountain; ZONE
  defb anim_weemanl1       ; SPRITE LEFT
  defb anim_weemand1       ; SPRITE DOWN
  defb anim_weemanu1       ; SPRITE UP
  defb 1                   ; MOVEMENT TO DESTINATION
  defb 1                   ; CHAR TYPE PERSON
  defb 1                   ; BOUNTY HUNTER
  defb 0                   ; MAP POS X
  defb 0                   ; MAP POS Y
  ; TUMBLEWEED
  defb zone_westernmountain; ZONE
  defb anim_tumbleweed1    ; SPRITE LEFT
  defb anim_tumbleweed1    ; SPRITE DOWN
  defb anim_tumbleweed1    ; SPRITE UP
  defb 0                   ; MOVEMENT TO RANDOM / PLAYER
  defb 5                   ; CHAR TYPE PERSON
  defb 0                   ; BOUNTY HUNTER
  defb 0                   ; MAP POS X
  defb 0                   ; MAP POS Y
  ; TUMBLEWEED
  defb zone_westernindian  ; ZONE
  defb anim_tumbleweed1    ; SPRITE LEFT
  defb anim_tumbleweed1    ; SPRITE DOWN
  defb anim_tumbleweed1    ; SPRITE UP
  defb 0                   ; MOVEMENT RANDOM
  defb 5                   ; CHAR TYPE OBSTRUCTION OBJECT
  defb 0                   ; BOUNTY HUNTER
  defb 0                   ; MAP POS X
  defb 0                   ; MAP POS Y

  defb 255 ; END OF LIST

settowndestination:
  ; SET DESTINATION FROM RANDOM TOWN LIST IF WE HAVE ONE!
  call getrandtown_cf
  ret nc

  ; SET MAP DESTINATION TO RANDOM TOWN COORDINATE
  ld a,(deltownx-1)
  ld (ix+21),a
  ld a,(deltowny-1)
  ld (ix+22),a
  ld (ix+23),90
  ld a,1         ; SET MOVEMENT TO DESTINATION LOCATION
ret

setbountyhunter:
  ; CHECK IF PLAYER IS WANTED, IF SO SET HIM AS DESTINATION AND FIRE!
  ld a,(bountyreward-2)
  or a
  ret z
  ld (ix+24),2  ; SET MOVEMENT TO FIND PLAYER 
  set 6,(ix+2)  ; SET SPRITE AS BOUNTY HUNTER
ret
setguard:
  ld (ix+15),1  ; SET SPRITE AS GUARD
  ;set 6,(ix+2)  ; SET SPRITE AS BOUNTY HUNTER
ret

spawnrandommcps:
  ; DON'T SPAWN ANIMALS IF WE ARE IN BUILDING
  ld a,(inbuilding)
  or a
  ret nz

  ; DON'T SPAWN AT NIGHT
  ; CHECK TIME OF DAY
  call checknighttime
  ret nz

  ld ix,mcps
  ld iy,randommcpstable

  nextdef:
    ld a,(iy+0)
    ; RETURN IF WE GET TO END OF LIST
    cp 255
    ret z
    ld a,(currzonedata) ; CHECK IF PLAYER IS IN RIGHT ZONE FOR SPRITE
    cp (iy+0)
    jp nz,nextrndmcp    ; SKIP DEFINITION IF SPRITE IS NOT SUITABLE

    ; CHECK IF SPRITE HAS SPECIFIC LOCATION
    ld a,(iy+7)
    or a
    jr z,nextmcp ; IF NO LOCATION SPECIFIED, ALLOW INSERTION

    cp (ix+4)         ; CHECK MAP X LOCATION AGAINST PLAYER
    jp nz,nextrndmcp
    ld a,(iy+8)       ; CHECK MAP Y LOCATION AGAINST PLAYER
    cp (ix+5)
    jp nz,nextrndmcp

    nop

    ; FOUND MATCH, MAKE SPRITE IN NEXT EMPTY SPRITE DEF
    nextmcp:
      ld a,(ix+0)
      ; RETURN IF WE GET TO END OF LIST
      cp 255
      ret z
      or a ; CHECK IF SPRITE IS INACTIVE
      jp nz,skipmcp

      ; GENERATE RANDOM POSITION
      ld b,tilemap_win_tiles
      call randmaxnoseed
      ; FIND IF WE SPAWNED ON BUILDING OR SEA
      ; IF SO, DO NOT SPAWN
      ; WE MAY BE IN A SEA SCENE WERE THERE ARE NO EMPTY TILES!
      call checktileoccupiedobjtilemap
      or a
      jp nz,skipmcp

      call gettilepixelpos
      ld (ix+6),h
      ld (ix+7),l

      ; CHECK IF WE HAVE SPARE SPRITE BUFFER
      call findunusedspriteid ; SPRITE BUFFERS ALL USED
      ret nc
      ld (ix+26),c           ; SET SPRITE ID

      ; CLEAR SPRITE BUFFER SO IT DOESN'T TRASH NEW SCREEN
      res 1,(ix+2)
      ; CLEAR OBJECT PICKUP ID
      ld (ix+18),0
      ; COPY SPRITE IMAGE DEFINITIONS - UP LEFT DOWN
      ld a,(iy+1)   
      ld (ix+1),a       
      ld (ix+10),a       
      ld a,(iy+2)
      ld (ix+11),a       
      ld a,(iy+3)
      ld (ix+12),a 
 
      ; SET DEFAULT MOVEMENT
      ld a,(iy+4)
      
      ; SPRITE MOVEMENT - IF = 1, WE NEED TO SET RANDOM DESTINATION FROM TOWNS LIST
      cp 1
      call z,settowndestination
      ld (ix+24),a

      ; OBSTRUCTION TYPE FOR COLLISION DETECTION
      ld a,(iy+5)
      ld (ix+27),a

      ; ARE WE BOUNTY HUNTER?
      res 6,(ix+2) ; CLEAR BOUNTY HUNTER STATUS
      ld a,(iy+6)
      cp 1
      call z,setbountyhunter
      cp 2
      call z,setguard

      ; SET NAME
      call genrandommanname
      ld (ix+20),a

      ; SAVE MAP LOCATION
      ld a,(inbuilding)
      ld (ix+3),a
      ld bc,(tilemap_cur)
      ld (ix+4),c
      ld (ix+5),b
      ld (ix+9),5            ; SET MOVE COUNTER

      ; ACTIVATE SPRITE
      ld (ix+0),1

      ; MOVE TO NEXT SPRITE DEFINITION
      nextrndmcp:
         ld bc,9
         add iy,bc
      jp nextdef

    skipmcp:
      call findnextmcpupdate
    jp nextmcp


; SPRITE ID LIST - PLAYER, PLAYER ARROW, MCP ARROW, EMPTY, EMPTY...
; SHOWS WHICH BUFFERS ARE IN USE
spriteidlist:  defb 1,1,1,0,0,0,0

; THIS ROUTINE FINDS AN UNUSED BUFFER FOR THE NEWLY SPAWNED SPRITE TO USE
; OUTPUT
; C = SPRITE ID TO USE
; 0 IF NONE FOUND

findunusedspriteid:
  ld hl,spriteidlist+7-1 ; START AT END OF BLOCK, AS WE USE C OF BC TO RETURN WHICH ID TO USE
  ld bc,numsprites
  xor a
  cpdr                            ; COMPARE BLOCK UNTIL WE FIND 0
  ld a,c
  or a
  ret z                           ; BUFFERS ALL USED
  ; FOUND UNUSED ID - MARK AS USED
  inc hl                          ; NEED TO INC HL AGAIN, AS CPDR DEC'S HL FIRST BEFORE DEC'ING BC
  ld (hl),1                       ; MARK ID AS USED
  scf                             ; SET CARRY FLAG
  ret

; CHECK IF A COMPUTER SPRITE HAS GONE PAST
; ONE SCREEN AWAY FROM PLAYER, IF SO DEACTIVATE IT
checkmcpoutofscope:
  ld a,(tilemap_cur)
  sub (ix+4)
  cp 2   ; CHECK IF SPRITE IS TWO SCREENS AWAY
  jr z,deactivatesprite
  cp 97  ; CHECK IF SPRITE IS TWO SCREENS AWAY
  jr z,deactivatesprite
  ld a,(tilemap_cury)
  sub (ix+5)
  cp 2   ; CHECK IF SPRITE IS TWO SCREENS AWAY
  jr z,deactivatesprite
  cp 97  ; CHECK IF SPRITE IS TWO SCREENS AWAY
  jr z,deactivatesprite
ret

; MAKE SURE SCREEN ID DOESNT GO OVER 100
limitmapsizexplus:
  ld a,(ix+4) ; X
  cp 100
  ret nz
  ld (ix+4),0
ret
limitmapsizexminus:
  ld a,(ix+4) ; X
  inc a;cp 255
  ret nz
  ld (ix+4),99
ret
limitmapsizeyplus:
  ld a,(ix+5) ; Y
  cp 100
  ret nz
  ld (ix+5),0 ; RESET MAP POS TO 0
ret
limitmapsizeyminus:
  ld a,(ix+5) ; Y
  inc a;cp 255
  ret nz
  ld (ix+5),99 ; RESET MAP POS TO 0
ret

; INPUT
; IX = SPRITE BLOCK TO DEACTIVATE
deactivatesprite:
  res 1,(ix+2)            ; CLEAR BUFFER
  ld (ix+0),0             ; MARK INACTIVE
  ld a,(ix+26)            ; CLEAR SPRITE ID
  jr clearspriteid

deactivatespriteiy:
  res 1,(iy+2)            ; CLEAR BUFFER
  ld (iy+0),0             ; MARK INACTIVE
  ld a,(iy+26)            ; CLEAR SPRITE ID
  ; INPUT
  ; A = SPRITE ID TO CLEAR  
  clearspriteid:
  cp 1  ; DO NOT CLEAR PLAYER ARROW SPRITE ID
  ret z
  cp 2  ; DO NOT CLEAR MCP ARROW SPRITE ID
  ret z
  ld hl,spriteidlist
  ld b,0
  ld c,a
  add hl,bc
  ld (hl),0
ret

movespritenorthwest:
  call movespritenorth
  jp movespritewest

movespritewest:
  ; MAKE SURE SPRITE IMAGE IS FACING LEFT
  ld (ix+13),0            
  ld a,(ix+10)
  ld (ix+1),a

  ld a,(ix+6)              ; GET X PIXEL
  sub 1                    ; ARE WE PAST EDGE OF SCREEN   
  jr c,moveleftscreen

  moveleftpix:
    ld d,a                 ; GET X PIXEL
    ; DO OBJECT COLLISION DETECTION
    ; IF WE HAVEN'T COLLIDED WITH AN OBJECT, LET PLAYER PROCEED
    ld a,(ix+7)            ; LOAD Y POSITION INTO E
    add 12                 ; MOVE COLLISION DETECTION HALF WAY UP SPRITE 
    ld e,a

    call checkifmovementok_cf
    ret c                  ; DO NOT ALLOW SPRITE TO MOVE
    dec (ix+6)             ; DEC X PIXEL
    res 3,(ix+2)           ; RECORD THAT WE HAVE ACTUALLY MOVED SPRITE
    ret
  
  moveleftscreen:
    dec (ix+4)
    call limitmapsizexminus
    ld (ix+6),scr_width_bytes_right   ; SET X PIXEL TO RIGHT OF SCREEN
    movescreen:
    ld a,(ix+0)                       ; CHECK IF MCP OR PLAYER
    cp 2 
    jp z,set_tilemap_view
    
    ; DEACTIVATE MCP SPRITE IF IT GOES PAST TWO SCREENS
    jp checkmcpoutofscope

; PLAYER FUNCTIONS JUMP BACK TO DIFFERENT LOCATION
movespritenorthwestp:
  call movespritenorth
movespritewp:
  call movespritewest
  jp updateplayersprite

movespritenp:
  call movespritenorth
  jp updateplayersprite

movespritenorth:
  ; MAKE SURE SPRITE IMAGE IS FACING UP
  ld (ix+13),1       ; HORIZ FLIP SPRITE
  ld a,(ix+12)       ; CHANGE GRAPHIC TO NORTH FACING MAN
  ld (ix+1),a

  ld a,(ix+7)        ; GET Y PIXEL
  sub 4              ; ARE WE PAST EDGE OF SCREEN   
  jr c,moveupscreen

  moveuppix:
    call adjustcollisiondetectiony
    call checkifmovementok_cf
    ret c           ; DO NOT ALLOW PLAYER TO MOVE
    ld a,(ix+7)      ; GET Y PIXEL
    sub 4
    ld (ix+7),a      ; SET Y PIXEL
    res 3,(ix+2)     ; RECORD THAT WE HAVE ACTUALLY MOVED SPRITE
    ret

  moveupscreen:
    dec (ix+5)
    call limitmapsizeyminus
    ld (ix+7),scr_height_pixels_bottom ; SET Y PIXEL TO BOTTOM OF SCREEN
    jr movescreen

movespritenortheast:
  call movespritenorth
  jp movespriteeast

checkifmovementok_cf:
  ; SKIP IF WE ARE NOT IN SAME SCREEN AS PLAYER
  ; SO ARROW SPRITES IN SAME MAP COORD DON'T INTERACT WITH SPRITES INSIDE BUILDING

  ; STOPPING ARROWS GOING OUTSIDE OF SCREEN VVVV
 
  ;ld a,(tilemap_cur)                   ; SKIP IF NOT IN SAME X SCREEN
  ;cp (ix+4)
  ;jp nz,returntrue2
  ;ld a,(tilemap_cury)                  ; SKIP IF NOT IN SAME Y SCREEN
  ;cp (ix+5)
  ;jp nz,returntrue2
  ld a,(inbuilding)                    ; SKIP IF NOT IN SAME BUILDING
  cp (ix+3)
  jp nz,returntrue2

  call checktileoccupied               ; CHECK IF OCCUPIED
  call checkmovementok_cf              ; CHECK OBJECT TILEGRID FOR OBSTACLES
  ret c  ; DO NOT ALLOW PLAYER TO MOVE
  push bc
  call checkcollisionsprite_cf         ; CHECK IF SPRITES NEARBY
  pop bc
ret

; PLAYER FUNCTIONS JUMP BACK TO DIFFERENT LOCATION
movespritenortheastp:
  call movespritenorth
movespriteep:
  call movespriteeast
  jp updateplayersprite 

movespriteeast:
  ; MAKE SURE SPRITE IMAGE IS FACING RIGHT
  ld (ix+13),1       ; HORIZ FLIP SPRITE
  ld a,(ix+10)
  ld (ix+1),a

  ld a,(ix+6)                 ; GET X PIXEL
  add 255-scr_width_bytes+5   ; ARE WE PAST EDGE OF SCREEN   
  jr c,moverightscreen

  moverightpix:
    ld a,(ix+6)      ; GET X PIXEL
    add 4            ; MOVE COLLISION DETECTION TO RIGHT SIDE OF SPRITE
    ; DO OBJECT COLLISION DETECTION
    ; IF WE HAVEN'T COLLIDED WITH AN OBJECT, LET PLAYER PROCEED
    ld d,a           ; LOAD X POSITION INTO D
    ld a,(ix+7)      ; LOAD Y POSITION INTO E
    add 12           ; MOVE COLLISION DETECTION HALF WAY UP SPRITE 
    ld e,a

    call checkifmovementok_cf
    ret c            ; DO NOT ALLOW PLAYER TO MOVE
    inc (ix+6)       ; INC X PIXEL
    res 3,(ix+2)     ; RECORD THAT WE HAVE ACTUALLY MOVED SPRITE
    ret

  moverightscreen:
    inc (ix+4)
    call limitmapsizexplus
    ld (ix+6),0      ; SET X PIXEL TO LEFT OF SCREEN
    jp movescreen
    
movespritesoutheast:
  call movespritesouth
  jp movespriteeast

movespritesouthwest:
  call movespritesouth
  jp movespritewest

; PLAYER FUNCTIONS JUMP BACK TO DIFFERENT LOCATION
movespritesoutheastp:
  call movespritesouth
  call movespriteeast
  jp updateplayersprite

movespritesouthwestp:
  call movespritesouth
  call movespritewest
  jp updateplayersprite

movespritesp:
  call movespritesouth
  jp updateplayersprite

checkrunquestchooser:
  ld a,(runquestchooser)
  or a
  ret z
  call questchooser
  xor a
  ld (runquestchooser),a
ret

; INPUT
; A = Y POS OF SPRITE
; OUTPUT
; D = Y POS OF COLLISION DETECTION ON SPRITE
adjustcollisiondetectiony:
  add 12                 ; MOVE COLLISION DETECTION HALF WAY UP SPRITE 
  ld e,a                 ; LOAD Y POSITION INTO E
  ; DO OBJECT COLLISION DETECTION
  ; IF WE HAVEN'T COLLIDED WITH AN OBJECT, LET PLAYER PROCEED
  ld d,(ix+6)            ; LOAD X POSITION INTO D
  inc d                  ; MOVE X COLLISION DETECTION TO MIDDLE OF SPRITE
  inc d
ret

movespritesouth:
  ; MAKE SURE SPRITE IMAGE IS FACING DOWN
  ld (ix+13),2 ; VERTICALLY FLIP SPRITE
  ld a,(ix+11)
  ld (ix+1),a

  ld a,(ix+7) ; GET Y PIXEL
  add 80+32   ; ARE WE PAST EDGE OF SCREEN    
  jr c,movedownscreen

  movedownpix:
    ld a,(ix+7)              ; GET Y PIXEL
    add 4
    call adjustcollisiondetectiony

    call checkifmovementok_cf
    ret c                   ; DO NOT ALLOW PLAYER TO MOVE
    ld a,(ix+7)             ; GET Y PIXEL
    add 4
    ld (ix+7),a             ; SET Y PIXEL
    res 3,(ix+2)            ; RECORD THAT WE HAVE ACTUALLY MOVED SPRITE
    ret

  movedownscreen:
    inc (ix+5)
    call limitmapsizeyplus
    ld (ix+7),0             ; SET Y PIXEL TO TOP OF SCREEN
    jp movescreen
    
; INPUTS
; A = TILE OBJECT ID TO CHECK
; OUTPUTS
; A = 0, MOVE OK
; A = 1, MOVE NOT OK
checkmovementok_cf:
  push af
  ld a,(ix+0)
  cp 2                       ; ARE WE A PLAYER OR AN MCP?
  jp z,checkmovementokplayer
  cp 3                       ; ARE WE AN ARROW? OR AXE?
  jr z,checkmovementokarrow
  cp 4                       ; ARE WE PICK AXE?
  jr z,checkmovementokpickaxe

checkmovementokmcp:
    pop af
    or a                      ; EMPTY SPACE
    ret z
    cp 254                    ; BRIDGE, ETC
    jp z,returnfalse2
    cp 246                    ; BRIDGE, ETC FLIPPED
    jp z,returnfalse2
    scf 
    ret                       ; DO NOT ALLOW SPRITE TO MOVE

checkmovementokarrow:
    pop af
    or a                      ; EMPTY SPACE
    ret z
    cp 254                    ; BRIDGE, ETC
    jp z,returnfalse2
    cp 246                    ; BRIDGE, ETC FLIPPED
    jp z,returnfalse2
    cp 250                    ; PICKABLE OBJECT
    jp z,returnfalse2
    cp 2                      ; WATER
    jp z,returnfalse2
    cp 220                    ; TURRET TARGET
    jp z,returnfalse2
    cp 6                      ; TREE TRUNK LEFT
    jp z,arrowhittreeleft
    cp 7                      ; TREE TRUNK RIGHT
    jp z,arrowhittreeright    
    jp deactivatesprite       ; WE HIT AN OBJECT, DISABLE ARROW BUT DON'T ERASE IT

checkmovementokpickaxe:
    pop af
    or a                      ; EMPTY SPACE
    ret z
    cp 254                    ; BRIDGE, ETC
    jp z,returnfalse2
    cp 246                    ; BRIDGE, ETC FLIPPED
    jp z,returnfalse2
    cp 250                    ; PICKABLE OBJECT
    jp z,returnfalse2
    cp 2                      ; WATER
    jp z,returnfalse2
    cp 8                      ; ROCK / WALL
    jp z,pickhitrock
    cp 9                      ; HIDDEN ENTRANCE IN STONEWORK
    jp z,pickhitrockentrance
    jp deactivatesprite       ; WE HIT AN OBJECT, DISABLE ARROW BUT DON'T ERASE IT

deactivateandclearsprite:
  call forceredrawbufferthissprite ; ERASE WEAPON SPRITE IF WE HIT DESTRUCTABLE OBJECT
  jp deactivatesprite            ; WE HIT AN OBJECT, DISABLE ARROW

checkmovementokplayer:
    pop af
    ;bit 2,(ix+2)              ; CHECK SUBMERGED STATUS
    ;jr nz,resetsumbergedstatus
 
    or a
    jr z,checksubmergedstatus
    ;ret
    ;resetsumbergedstatus:
    ; WE HAVE BEEN SUBMERGED - RESET STATUS
    ;res 2,(ix+2)              ; RESET SUBMERGED STATUS
    ;or a                      ; EMPTY SPACE
    ;ret z
    cp 1                      ; OBJECT
    jp z,returntrue2         
    cp 254                    ; BRIDGE, ETC
    jp z,returnfalse2
    cp 220                    ; TURRET TARGET
    jp z,checkturrettarget
    cp 246                    ; BRIDGE, ETC FLIPPED
    jp z,returnfalse2
    cp 2                      ; WATER
    jr z,setmovementifflipper
    cp 3                      ; MOUNTAIN
    jr z,setmovementifrope
    ; DON'T RUN QUEST CHOOSER UNTIL AFTER WE HAVE COMPLETED MOVE - OTHERWISE DIAGONAL MOVEMENT WILL RUN IT TWICE
    ; RUNQUESTCHOOSER HOLDS THE VALUE OF THE TILE TYPE WE BUMPED INTO 
    ld (runquestchooser),a 
    ld (questchoosertileid),bc
    scf 
    ret

checkturrettarget:
  call checkturretfire
  or a                     ; CLEAR CARRY FLAG - ALLOW PLAYER TO MOVE THROUGH TURRET TARGET
  ret

checksubmergedstatus:
  bit 2,(ix+2)              ; CHECK SUBMERGED STATUS
  ret z
  ; WE HAVE BEEN SUBMERGED! RESET STATUS
  res 2,(ix+2)              ; RESET SUBMERGED STATUS
  or a
  ret
    
setmovementifflipper:
  bit 4,(ix+2)                   ; WE HAVE NO FLIPPERS
  jp z,returntrue2
  ; CHECK IF WE ARE ENTERING WATER!
  bit 2,(ix+2)
  jr nz,skipsplashsound

  push ix
  call splashsound
  pop ix

  skipsplashsound:
  set 2,(ix+2)                   ; RECORD THAT PLAYER IS SUBMERGED
  or a                           ; RESET CARRY FLAG
  ret

setmovementifrope:
  bit 5,(ix+2)                   ; IF WE HAVE NO ROPE...
  jp z,returntrue2                        
  or a                          ; ALLOW TO CLIMB MOUNTAIN
  ret

; WORK OUT IF WE HAVE LINE OF FIRE FROM TWO SETS OF COORDS

; INPUTS
; B = CURR X COORD
; C = CURR Y COORD
; D = DEST X COORD
; E = DEST Y COORD
; OUTPUT
; A = 0 NO LINE OF FIRE, 1 = LINE OF FIRE
;checklineoffire:
;  ; CHECK IF X=X2 OR Y=Y2
;  ld a,d
;  cp b
;  or a
;  jp z,returntrue
;  ld a,e
;  cp c
;  or a
;  jp z,returntrue
;  ; CHECK IF X/X2 IS SAME DISTANCE FROM Y/Y2
;  sub c  ; DO Y
;  ld c,a ; LOAD RESULT INTO C
;  ld a,d ; DO X
;  sub b  ; LOAD RESULT INTO A
  
;  ; COMPARE A WITH C IF SAME OR NEGATIVE SAME
;  cp c   ; COMPARE Y
;  jp z,returntrue
;  neg    ; CHECK NEGATIVE VALUE FOR OPPOSITE DIAGONAL
;  cp c
;  jp z,returntrue
;  xor a
;ret ;jp returnfalse

; WORK OUT DIRECTION OF TRAVEL FROM TWO SETS OF COORDINATES

; INPUTS
; B = CURR X COORD
; C = CURR Y COORD
; D = DEST X COORD
; E = DEST Y COORD
; OUTPUTS
; A = DIRECTION, 1 = NORTH, 2 = NE
; REACHED DESTINATION
; A = 0

; DIRECTION TABLE
; X DIRECTIONS
; 8 1 2
; 7 0 3
; 6 5 4

updir:   defb 8,1,2
middir:  defb 7,0,3
downdir: defb 6,5,4

getdirectionfromcoords:
  ld a,e
  sbc c
  jr c,setup
  or a 
  jr z,setmid

  setdown:
    ld hl,downdir+1
    jr gethdir
  setup:
    ld hl,updir+1
    jr gethdir
  setmid:
    ld hl,middir+1

  gethdir:
    ld a,d
    sbc b
    jr c,setleft
    or a
    jr z,setdir

    setright:
    inc hl
    jr setdir
    setleft:
    dec hl
    setdir:
    ld a,(hl)
    ret

; GET NEW SPRITE DIRECTION - RANDOM SLOW TURNING
getnewspritedirection:
  dec (ix+9)
  ld a,(ix+9)
  or a
  jp nz,movesprite

  ld (ix+9),5 ; RESET MOVE COUNTER
   
  ; CHECK IF WE HAVE A MAP DESTINATION, OTHERWISE MOVE RANDOMLY
  ld a,(ix+24) ; X
  or a ; RANDOM
  jp z,moverandomly
  cp 1 ; MOVE DESTINATION
  jr z,findnewdirection
  cp 4 ; STATIONARY OBJECT - ONLY MOVE 7 PIXELS AND THEN STOP
  jp z,deactivateandclearsprite
  cp 5 ; MOVE UP AND DOWN IN PATTERN
  jp z,movepatternupdown
  cp 3 ; MOVE IN STRAIGHT LINE TOWARDS DESTINATION - ARROW
  jp z,movesprite

  ; 2 = MOVE TO PLAYER - SET DEST SCREEN TO SAME AS PLAYER
  findplayerloc:
  ld b,(ix+4) ; CURRENT SPRITE X LOCATION
  ld c,(ix+5) ; CURRENT SPRITE Y LOCATION
  push ix
  ld ix,playerspritedata
  ld d,(ix+4) ; COPY PLAYER X SCREEN LOCATION AS DEST
  ld e,(ix+5) ; COPY PLAYER Y SCREEN LOCATION AS DEST
  inc e       ; DON'T KNOW WHY THIS IS HAPPENING. MCPS SEEM TO CONGREGATE AT SCREEN ABOVE PLAYER?
  pop ix
  call getdirectionfromcoords
  or a ; IF WE HAVE REACHED DESTINATION SCREEN, GO TO PLAYER
  jr z,findnewdirectiontilenum
  jp savedirection

  ; 5 - MOVE UP AND DOWN IN PATTERN
  movepatternupdown:
  ld a,30
  ld (ix+9),a ; SET AMOUNT OF LINES TO TO MOVE
  ld a,(ix+8) ; GET DIRECTION - IF GOING UP, CHANGE TO DOWN, ETC
  cp 3;1
  jr z,movepatterndown 
  ; MOVE PATTERN UP
  ld a,3;1
  jr savedirection
  movepatterndown:
  ld a,7;5
  jr savedirection
  
  ;defb 0  ; 8 - CURR DIRECTION 0 - NOTHING, 1 - NORTH, 2 - NE, 3 - EAST
  ;defb 0  ; 9 - MOVE COUNTER BETWEEN TILES, 0-5, 0 MEANS WE HAVE ARRIVED
  

  ; IF WE HAVE REACHED SCREEN DESTINATION. HEAD FOR PLAYER TILE
  findnewdirectiontilenum:
  ld b,(ix+6) ; CURRENT X BYTE 
  ld c,(ix+7) ; CURRENT Y LINE
  push ix
  ld ix,playerspritedata
  ld d,(ix+6) ; PLAYER X BYTE POS
  ld e,(ix+7) ; PLAYER Y PIXEL POS
  pop ix
  call getdirectionfromcoords
  ld (ix+8),a

  ; FIRE ARROW IF WE ARE BOUNTY HUNTING
  bit 6,(ix+2)
  jr z,skipfiremcparrow
  ; IF WE ARE BOUNTY HUNTER, FIRE ARROW
  push ix ; SOUND QUEUE CORRUPTS THESE REGISTERS SO WE NEED TO PRESERVE THEM
  push iy ; SOUND QUEUE CORRUPTS THESE REGISTERS SO WE NEED TO PRESERVE THEM
  call firemcparrow
  pop iy
  pop ix
  skipfiremcparrow:

  ; A RANDOM JIGGLE STOPS THE CHARACTER GETTING STUCK BEHIND A TREE... SOMETIMES!
  call randnoseed
  adc 200
  jp c,movesprite

  ld b,8
  call randmax32
  jr savedirection

  ; MOVE TOWARDS SCREEN
  findnewdirection:
  ; LIMIT DIRECTION TO THREE CLOSEST POINTS OF COMPASS TO WHERE WE NEED TO GO
  ld b,(ix+4)    ; X CURR
  ld c,(ix+5)    ; Y CURR
  ld d,(ix+21)   ; X DEST
  ld e,(ix+22)   ; Y DEST
  call getdirectionfromcoords
  or a ; IF WE HAVE REACHED DESTINATION SCREEN, JUST MOVE RANDOM 
  jr z,founddestinationscreenmoverandom
  jr savedirection

  founddestinationscreenmoverandom:
  ld (ix+24),0
  jr savedirection

  moverandomly:
  ; GET DIRECTION OF SPRITE, ROTATE SLOWLY TO MAKE LESS JERKY 
  call rand
  adc 128
  jr c,turnspriteright

  turnspriteleft:
  ld a,(ix+8)
  dec a
  cp 255 ; IF WE HAVE TURNED TOO FAR, DO NOTHING  
  jp z,movesprite
  jr savedirection

  turnspriteright:
  ld a,(ix+8)
  inc a
  cp 9 ; IF WE HAVE TURNED TOO FAR, DO NOTHING  
  jp z,movesprite

  savedirection:
  ld (ix+8),a
  jp movesprite     ; RETURN TO OUR PREVIOUS FUNCTION

updateplayersprite:
  call checkrunquestchooser
  ; LOAD CHARACTER TABLE DATA
  ld ix,playerspritedata
  updatethissprite:
  ; SWAP SPRITE NUMBERS FOR WALKING ANIMATION
  ld a,(ix+19)
  inc a
  cp 2
  jr nz,skipanimcounter2
  xor a                  ; RESET ANIM COUNTER
  skipanimcounter2:
  ld (ix+19),a

  ; RESTORE IF WE HAVE BUFFER
  bit 1,(ix+2)
  jr z,skiprestorebufferpl
  call restoremybuffer

  skiprestorebufferpl:
  ; GRAB BACKGROUND INTO BUFFER
  jp grabbgdrawsprite

; INPUT
; IX = SPRITE DATA DEFINITION
restoremybuffer:
  ; RESTORE OLD BACKGROUND FROM DOUBLE BUFFER
  res 1,(ix+2) ; RECORD THAT WE USED DOUBLE BUFFER
  ld a,(ix+26) ; GET SPRITE DOUBLE BUFFER ID IMAGE
  call vectorbufferlookup
  ld h,(ix+16) ; GET X COORD
  ld l,(ix+17) ; GET Y COORD
  jr restorebuff
; IY = SPRITE DATA DEFINITION
restoremybufferiy:
  ; RESTORE OLD BACKGROUND FROM DOUBLE BUFFER
  res 1,(iy+2) ; RECORD THAT WE USED DOUBLE BUFFER
  ld a,(iy+26) ; GET SPRITE DOUBLE BUFFER ID IMAGE
  call vectorbufferlookup
  ld h,(iy+16) ; GET X COORD
  ld l,(iy+17) ; GET Y COORD
  restorebuff:
  call get_scr_addr
  jp tile_restore

; ON MOVING SCREENS, WE WANT TO SET ALL SPRITES TO REDRAW THEIR POSITIONS
;markallcharacterspritesredraw:
;  ld ix,mcps
;  updatecharloop2
;  ld a,(ix)
;  cp 255 ; CHECK IF END OF LIST
;  ret z
;  or a   ; CHECK IF ACTIVE
;  jr z, nextmcpupdate2
;  cp 2   ; PLAYER SPRITE - SKIP IT !!! JUST DEACTIVATED, ERASE SPRITE FROM SCREEN
;  jr z,nextmcpupdate2

;  ld (ix+20),1 ; MARK SPRITE HAS HAVING MOVED SO IT NEEDS TO BE REDRAWN
  
;  nextmcpupdate2
;    call findnextmcpupdate
;  jp updatecharloop2

findnextmcpupdate:
  ld bc,28
  add ix,bc
ret


; INPUTS 
; HL = JUMP TABLE TO USE
movespritep:
  ld hl,directionjumptableplayer
  ; A = DIRECTION TO MOVE
  ; GENERATED BY JOYSTICK FUNCTION
  jp vectortablelaunchcode

movesprite:
  ld hl,directionjumptable
  ; GET DIRECTION TO MOVE FROM MCP SPRITE DATA
  ld a,(ix+8) 
  jp vectortablelaunchcode

; PLAYER VECTOR TABLE JUMPS BACK TO JOYSTICK CONTROL FUNCTION INSTEAD
; OF MCP DIRECTION CONTROL FUNCTION
directionjumptable:
  defw jumpback              ; COUNTER IS 0 - DO NOTHING
  defw movespritenorth       ; COUNTER IS 1...
  defw movespritenortheast
  defw movespriteeast
  defw movespritesoutheast
  defw movespritesouth
  defw movespritesouthwest
  defw movespritewest
  defw movespritenorthwest

; PLAYER VECTOR TABLE JUMPS BACK TO JOYSTICK CONTROL FUNCTION INSTEAD
; OF MCP DIRECTION CONTROL FUNCTION
directionjumptableplayer:
  defw updateplayersprite     ; COUNTER IS 0 - DO NOTHING
  defw movespritenp           ; COUNTER IS 1...
  defw movespritenortheastp
  defw movespriteep
  defw movespritesoutheastp
  defw movespritesp
  defw movespritesouthwestp
  defw movespritewp
  defw movespritenorthwestp
  
; INPUTS
; D = X BYTE
; E = Y LINE
; RESULT
; A = TILE NUMBER
convpixeltotiles:
  ; DIVIDE WIDTH BY 4 (BYTES)
  ; DIVIDE HEIGHT BY 16 (LINES)
 
  ; CONVERT VERT LINE POSITION TO TILE ROW
  ld h,tilecalcverth
  ld l,e
  ld b,(hl) ; C = VERTICAL ROW NUMBER

  xor a
  loopyloop8:
    add tilemap_width_tiles
  djnz loopyloop8
  ; CONVERT VERT TILE ROW TO TILE ID
  ld c,a

  ; HORIZ
  ld h,tilecalchorizh
  ld l,d
  ; GET HORIZ POS FIRST
  ld a,(hl)
  add c     ; ADD VERT POS
ret
; INPUTS
; D = X BYTE
; E = Y LINE
; RESULTS
; A = CONTENTS OF OCCUPIED TILE (OBJECT TILEMAP ID)
; B = CONTENTS OF OCCUPIED TILE (GRAPHIC TILEMAP ID)
; C = CURRENT TILE NUMBER


; 0BJECT TYPES
; 0 - EMPTY SPACE
; 255 - ENTER LOG CABIN
; 254 - TRAVERSABLE PART OF SPRITE
; 253 - ENTER MINE
; 252 - EXIT BUILDING
; 251 - ENTER WESTERN ZONE
; 250 - PICK UP OBJECT
; 249 - RANDOM QUEST
; 248 - ENTER WIG WAM
; 247 - ENTER STONE BUILDING
; 246 - VERTICALLY FLIPPED SPRITE OBJECT
; 220 - TURRET TARGET
checktileoccupied:
  call convpixeltotiles   ; GET TILE NUMBER FROM COORDS D E
  ld c,a                  ; RETURN CURRENT TILE NUMBER

  ld h,tilemap0h
  ld l,a
  ld b,(hl)
  checktileoccupiedobjtilemap:
  ld h,tilemap2h
  ld l,a
  ld a,(hl)
ret