statusbar_iconpos equ screenadr+&36E4
space_iconpos     equ statusbar_iconpos+40+40
space_seasonpos   equ screenadr+&3EE4

;str_temp    defb "                            ",255 ; SIZE 28 + EOL (END IN 255)
screentext4: defb "                                                        ",255
; SIZE 28 + EOL (END IN 255) - NEED OVERRUN BUFFER FOR WORDWRAP HERE SO DOUBLE THIS

str_menu: defb "INVENTORY",10,"STORY ",13,quest,"S",10,"OTHER ",13,quest,"S",10,"RESTART GAME",10,"EXIT",255

menufunctions:
  defw showinventoryactivateitem        ; 0 
  defw showgamequests                   ; 1
  defw showrandomquests                 ; 2 
  defw restartgame                      ; 5
  defw 0                                ; EXIT MENU = 5
  ;defw newrandomseed                   ; MAKE RANDOM SEED = 6

showinventoryactivateitem:
  call showinventory
  jp setactiveitem

;newrandomseed
;  call createnewrandomseed
;  call genlocalgamemaps ; REGENERATE LOCAL MAP IN CASE WE CHANGED SEED
;  jp restartgame

showmenu:
  ld hl,str_menu
  call statusbarprintparagraph
  ld a,6
  call waitoption_1_2_3_4_5ss
  cp 4
  jr z,clearmenu
  ld hl,menufunctions
  jp vectortablelaunchcode
  
;dotogglemap
;  call togglemap
  clearmenu:
  ld a,255
  ld (linecount),a
  jp scrolltopofpage
  
;wordtostr  defb "00000"

; CONVERT A 16 BIT HEX TO STRING - EG FOR PLAYER MONEY
; INPUTS
; HL = NUMBER TO CONVERT
convwordtostr:
  ld bc,10000
  call convwordtostrloop
  ld (wordtostr+0),a  ; SAVE RESULT IN STRING
  ld bc,1000
  call convwordtostrloop
  ld (wordtostr+1),a  ; SAVE RESULT IN STRING
  ld bc,100
  call convwordtostrloop
  ld (wordtostr+2),a  ; SAVE RESULT IN STRING
  ld bc,10
  call convwordtostrloop
  ld (wordtostr+3),a  ; SAVE RESULT IN STRING
  ld a,l
  add 48
  ld (wordtostr+4),a  ; SAVE RESULT IN STRING
ret

; INPUTS
; BC = TENS HUNDREDS UNIT TO CHECK FOR
convwordtostrloop:
  xor a      ; RESET COUNTER
  convwordtostrloop2:
    sbc hl,bc
    inc a
  jr nc,convwordtostrloop2
  add hl,bc
  dec a
  add 48               ; CONVERT TO ASCII
ret

; VARIOUS FUNCTIONS
; CONVERT TENS AND HUNDREDS INTEGER OF BYTE TO STRING
; INPUTS
; C = AMOUNT TO CHECK, EITHER 10 OR 100
convbytetenshundreds:
  ld b,255
  hundredsloop:
    sub c
    inc b
  jr nc,hundredsloop
  add c
  ; WRITE TO MEMORY / ADD 48 TO CONVERT FROM DECIMAL TO CHAR
  ld d,a
  ld a,b
  add 48
  ld (hl),a
  inc hl
  ld a,d
ret
; CONVERT BYTE TO INTEGER STRING
; A = BYTE TO CONVERT
; RESULT LOADED INTO BYTETOSTRING

convbytetostr:
  push hl
  push de ; BACK UP D
  ld hl,bytetostring

  ; HUNDREDS
  ld c,100
  call convbytetenshundreds
  ld c,10
  call convbytetenshundreds

  ; SINGLES
  add 48
  ld (hl),a  

  pop de
  pop hl
ret

; CONVERT 001 TO 1 FOR SHOP PRICES
raligncoord:
  ld hl,bytetostring
  ld a,(hl)
  cp "0"
  ret nz
  inc hl
  ld a,(hl)
  cp "0"
  jr z,justsingles
  dec hl
  ld (hl),a
  ld a,(bytetostring+2)
  inc hl
  finishendofcoord:
  ld (hl),a
  inc hl
  ld (hl),255
ret

justsingles:
  inc hl
  ld a,(hl)
  dec hl
  dec hl
  jr finishendofcoord

;bytetostring defb "000",255

; UPDATE STATUS BAR ICON INVENTORY
; INPUTS
; B = TILEMAP NUMBER OF ICON TO DISPLAY
;updatestatusbaricon:
;  ; CLEAR AREA FIRST
;  call clearstatusbaricon
;  push hl
;  push bc ; BACKUP B
;  ; DRAW ICON WE PICKED UP
;  ld a,b
;  ld de,tile_ptr_table
;  dec a ; MAKE TILES START FROM 1
;  call get_tile_ptr    ;; lookup ptr to tile pixels
;  ld hl,statusbar_iconpos
;  call tile_draw    ;; now draw tile  
;  pop bc
;  pop hl
;ret

genmoneystring:
  ; X COORD
  ld hl,(player_cash2)
  call convwordtostr
  ld hl,wordtostr
  
  ld a,"0"
  ld (tilemap_name3+1),a
  ld de,tilemap_name3+2 ; SKIP DOLLAR SIGN
  ldi
  ldi
  jr finishgenstring

gencoordstr:
  ; X COORD
  ld a,(tilemap_cur)
  call convbytetostr
  ld hl,bytetostring
  ld de,tilemap_name
  ldi
  ldi 
  ldi
  ; PERIOD
  ld a,":"
  ld (de),a
  inc de
  ; Y COORD
  ld a,(tilemap_cury)
  call convbytetostr
  ld hl,bytetostring
  finishgenstring:
  ldi
  ldi
  ldi
ret

; DRAW HORIZONTAL LINE ALL WAY ACROSS SCREEN
; INPUTS
; A = LINE COLOUR
; A PRESERVED
DrawHorizLine:
  push af
  push hl
  ld (hl),a ; LINE COL
  push hl ; COPY HL TO DE
  pop de 
  inc de
  call useLDI79
  pop hl
  call scr_next_line_hl
  pop af
ret

ClearStatusBar:
  ld hl,screenadr+1600
  ld a,&0C
  call DrawHorizLine
  ld a,&30 ; RED LINE
  call DrawHorizLine
  ld a,&68 ; YELLOW LINE
  call DrawHorizLine
  ld b,36
  ld a,&C0 ; WHITE LINE
  loopylooa:
    push bc
    call DrawHorizLine
    pop bc
  djnz loopylooa
  ld a,&30 ; RED
  jp DrawHorizLine

drawstatusbar:
  ld hl,screenadr+1600+80-3
  ld de,scrollright2
  call tile_restore_scroll2
  ld hl,screenadr+1600
  ld de,scrollleft
  jp tile_restore_scroll

updatestatusbar:
  ld hl,screenadr+1600+80+4
  push de
  ld de,tilemap_name
  call gra_wr_string2
  pop de
updatestatusbarmoney:
  call genmoneystring
  ld hl,screenadr+1600+160+4
  push de
  ld de,tilemap_name3
  ; INPUTS 
  ; DE = STRING TO WRITE TO STATUS BAR
  dowritestring:
  call gra_wr_string2
  ;call updatestatusbartime
  pop de
ret

updatestatusbartext:
  ld hl,screenadr+1600+320+20
  push de
  ld de,screentext4
  jr dowritestring

statusbarscrollnewline:
  push de
  push hl
  push bc

  call updatestatusbartext

  ld de,topstatusbarline     ; TOP STRING
  ld hl,secondstatusbarline  ; BOTTOM STRING
  ld b,24                    ; ROWS OF PIXELS TO COPY
  loopyman: 
    push bc ; PRESERVE COUNT

    push hl
    push de
    call useLDI28
    call useLDI28
    pop de
    pop hl
    call scr_next_line_hl
    ex de,hl
    call scr_next_line_hl
    ex de,hl

    pop bc
  djnz loopyman
  call clearnewline        ; ERASE STATUS BAR STRING WITH SPACES
  call updatestatusbartext ; DRAW SPACES ON SCREEN IN CASE NEXT LINE DOES NOT REACH TO END, I.E WORDWRAPPED
  pop bc
  pop hl
  pop de
ret

underlinenewline:
  ld a,"-"
  jr fillnewline
clearnewline:
  ld a," "
fillnewline:
  ; CLEAR NEW LINE
  ld hl,screentext4
  ld (hl),a
  ld de,screentext4+1
  call useLDI29
  dec de
  ex de,hl
  ld (hl),255
  ex de,hl
ret

; WRITE STRING TO BUFFER screentext4
; INPUTS
; HL = LINE OF TEXT TO PRINT
; DE = OBJECT TEXT TO INSERT IN PLACE OF CHAR 11
; A = 1, DO PAGE SCROLL
;str_backup_ptr  defw 0

; SCROLL ANY NEW CHARACTER SPEECHES TO TOP OF PAGE. THIS CLEARS
; THE PAGE OF ANY OLD INFORMATION, MAKES IT LOOK LESS CLUTTERED
scrolltopofpage:
  ld a,(linecount)
  scrollpageloop:
     cp 4
     ret z
     inc a
     push af
     call statusbarscrollnewline
     pop af
  jr scrollpageloop
ret

; IF WE REACH 5 LINES, ASK FOR SPACE TO CONTINUE PRINTING
statusbarprintparagraph:
  ld a,1 ; DO SCROLL UP
  jr dostatusbarprintparagraph
statusbarprintparagraphnoscroll:
  xor a
dostatusbarprintparagraph:
  push af                ; STORE WHETHER WE DO PAGE SCROLL
  push bc
  ld (str_backup_ptr),de ; BACKUP INSERT TEXT (OBJECT STR)

  ; RESET LINE COUNT
  xor a
  ld (linecount),a

  statusbarprintpara:
  call statusbarscrollnewline
  ld de,screentext4
  ld (spacecounthl),hl   ; RESET LAST SPACE POS
  ld (spacecountde),de   ; RESET LAST SPACE POS

  printloop:
    ld a,(hl)
    cp 255 ; WE MUST ALWAYS END BEFORE 28 CHARS
    jp z,finishtextprint
    cp " "; RECORD SPACE POS
    jr z,recordlastspace
    cp 10 ; MAKE NEW LINE
    jr z,makenewline
    cp 11 ; PRINT OBJECT TEXT
    jr z,printobjecttext
    cp 12 ; PRINT UNDERLINE
    jr z,makeunderline
    cp 13 ; PRINT DICTIONARY WORD
    jr z,printdictionaryword
    cp 14 ; PRINT COORDINATE AS TEXT
    jp z,printcoord
    cp 15 ; PRINT CURRENT TOWN NAME
    jp z,printtownname
    cp 16 ; PRINT DESTINATION TOWN NAME BY 2 BYTE COORDINATES
    jp z,printtownname2
    cp 17 ; PRINT 16BIT NUMBER AS TEXT
    jp z,print16bitnumber
    cp 20 ; PRINT ADJECTIVE
    jp z,printadjective 
    cp 18 ; PRINT ADJECTIVE FOOD
    jp z,printadjectivefood
    cp 19 ; PRINT ADJECTIVE TOOL
    jp z,printadjectivetool
    cp 21 ; PRINT WANTED MAN NAME FROM NIBBLES
    jp z,printwantedmanname
    ; COPY CHAR
    printloopjustcopychar:
    ldi
  jr printloop
  
  ; MAKE NEW LINE
  makenewline:
    inc hl
    ; INCREMENT LINE COUNT
    ld a,(linecount)
    inc a
    ld (linecount),a
    ; CHECK IF WE HAVE RUN OUT OF SPACE
    call checkreachedendofpage
    jr statusbarprintpara

  checkbufferoverrun:
    push hl
    push de
    ld hl,screentext4
    sbc hl,de               ; SUB SCREENTEXT 4 FROM DE 4 TO GET CURRENT LENGTH OF STRING (NEGATIVE)
    ld a,l                  ; LOAD RESULT IN A
    pop de
    pop hl
    sub 255-27              ; IF OVER 28, GO BACK TO LAST SPACE COUNT
    ret              

  recordlastspace:
    call checkbufferoverrun
    jr c,recoverlastspace
    ld (spacecounthl),hl    ; ELSE SAVE CURRENT SPACE POSITION
    ld (spacecountde),de  
    jr printloopjustcopychar
 
  recoverlastspace:
    ld hl,(spacecounthl)    ; LOAD LAST SPACE POSITION
    ld de,(spacecountde)
    ex de,hl
    ld (hl),255             ; MARK AS EOL
    ex de,hl
    jr makenewline    

  makeunderline:
    inc hl
    push hl
    call underlinenewline
    pop hl
    jp printloop

  ; PRINT OBJECT TEXT
  ; INSERT TEXT INTO STRING
  ; HL = TEXT TO INSERT (ENDING IN 255)
  ; DE = MAIN STRING TO INSERT INTO
  printobjecttext:
    inc hl
    push hl ; BACK UP MAIN STRING PTR
    ld hl,(str_backup_ptr)
    printstr:
    call copystr
    pop hl
    call checkbufferoverrun
    jr c,recoverlastspace
    jp printloop
  
  printdictionaryword:
    ; DE = SCREENTEXT4
    inc hl
    ld a,(hl)           ; GET NUMBER OF WORD TO INSERT
    inc hl
    push hl             ; STORE POS IN STRING TO READ FROM
    ld hl,dictionary
    printmyword:
    call vectorlookuphl ; GET WORD INTO HL
    jr printstr

  printcoord:
    ; DE = SCREENTEXT4
    inc hl
    ld a,(hl)           ; GET NUMBER OF BYTE TO INSERT
    inc hl
    push hl             ; STORE POS IN STRING TO READ FROM
    call convbytetostr
    call raligncoord
    ld hl,bytetostring
    jr printstr

  ; PRINT CURRENT TOWN NAME
  printtownname:
    ; DE = SCREENTEXT4
    inc hl
    push hl

    push de
    call resetpseudorandom ; MAKE SURE WE ARE CALCULATING SAME SCREEN NAME EVERY TIME
    printtownnamefunc:
    call genrandomtownname
    call getrandomtownname
    call resetpseudorandom ; MAKE SURE WE ARE CALCULATING SAME SCREEN NAME EVERY TIME
    pop de

    ld hl,str_temp
    jr printstr

  printtownname2:
    ; DE = SCREENTEXT4
    inc hl
    push hl

    push de
    call setdesttownseed  ; SET RANDOM SEED TO TOWN LOCATION TO GET CORRECT NAME
    jr printtownnamefunc

  print16bitnumber:
    ; DE = SCREENTEXT4
    inc hl
    ld c,(hl)
    inc hl
    ld b,(hl)
    inc hl
    push hl

    push bc
    pop hl
    call convwordtostr
    ld hl,wordtostr
    jr printstr

  printwantedmanname:
    ; DE = SCREENTEXT4
    inc hl
    ld a,(hl)           ; GET FIRST NAME TO INSERT
    inc hl
    push hl             ; STORE POS IN STRING TO READ FROM
    call getrandomwantedmanname
    ld hl,str_temp
    jr printstr

  printadjective:
    ; DE = SCREENTEXT4
    inc hl
    push hl             ; STORE POS IN STRING TO READ FROM
    ld b,numadjectives
    call randmaxnoseed
    ld hl,adjectivedictionary
    jr printmyword

  printadjectivefood:
    ; DE = SCREENTEXT4
    inc hl
    push hl             ; STORE POS IN STRING TO READ FROM
    ld b,numadjectivesfood
    call randmaxnoseed
    ld hl,adjectivedictionaryfood
    jr printmyword

  printadjectivetool:
    ; DE = SCREENTEXT4
    inc hl
    push hl             ; STORE POS IN STRING TO READ FROM
    ld b,numadjectivestool
    call randmaxnoseed
    ld hl,adjectivedictionarytool
    jr printmyword

  finishtextprint:
    call checkbufferoverrun  ; WE NEED TO CHECK IF WE ARE THE LAST WORD IN THE TEXT AND HAVE OVERRUN
    jp c,recoverlastspace    ; IN WHICH CASE WORD WRAP WON'T HAVE BEEN TRIGGERED AS WE HAVE NO SPACES LEFT.
    call updatestatusbartext
    pop bc
    pop af                   ; RESTORE PAGE SCROLL VARIABLE
    or a
    ret z
    jp scrolltopofpage
    
; INPUTS
; A = CURRENT LINE COUNT
checkreachedendofpage:
   cp 5
   ret nz
   ; RESET LINE COUNT
   xor a
   ld (linecount),a
   push hl ; BACK UP POSITION IN ORIGINAL STRING
   push de ; BACK UP OBJECT WORD
   ; SHOW PRESS SPACE TEXT
   call waitspace
   pop de ; RESTORE OBJECT WORD
   pop hl ; RESTORE POSITION IN ORIGINAL STRING
ret

; GENERATE RANDOM TOWN / PERSON'S NAME FROM CURRENT SEED
; OUTPUT
; A = FIRST NAME LAST NAME OF TOWN IN NIBBLES
genrandomtownname:
   ld b,numrandnames
   jr genrandomname
genrandommanname:
   ld b,outlawfirstnameslen
genrandomname:
   call randmax32   ; GET FIRST RANDOM NUMBER
   push af
   call randmax32   ; GET LAST RANDOM NUMBER
   rlca
   rlca
   rlca
   rlca
   ld b,a
   pop af
   or b
ret

; OUTPUTS
; A = FIRST AND LAST NAMES IN NIBBLES
getrandomwantedmanname:
   ; CHANGE TABLE LOOKUPS TO PEOPLE
   ld bc,outlawfirstnames
   ld (doubletable1-2),bc
   ld bc,outlawlastnames
   jr extractdoublename

; GENERATE RANDOM TOWN NAME FROM CURRENT SEED
getrandomtownname:
   ; CHANGE TABLE LOOKUPS TO TOWNS
   ld bc,firstrandnameslist
   ld (doubletable1-2),bc
   ld bc,lastrandnameslist

; GET PERSONS NAME FROM NIBBLES
; INPUTS
; A = FIRST NAME | LAST NAME IN NIBBLES
; OUTPUTS
; DE = STRING OF SPRITE NAME
extractdoublename:
   ld (doubletable2-2),bc
   push de
   ; USE STR_TEMP TO GENERATE TOWN NAME TEXT
   ld de,str_temp
   ; GET RANDOM NAME
   push af
   and %11110000 ; GET LEFT NIBBLE
   rrca
   rrca
   rrca
   rrca
   ld hl,outlawfirstnames:doubletable1
   call vectorlookuphl
   ; GET FIRST NAME INTO DE
   call copystr

   ; CREATE SPACE
   ld hl,str_space
   call copystr
   pop af
 
   and %00001111 ; GET RIGHT NIBBLE
   ; COPY SECOND RANDOM NAME
   ;ld b,numrandnames
   ;call randmax32
   ld hl,outlawlastnames:doubletable2
   call vectorlookuphl
   ; COPY 255 MARKER
   call copystr2 
   pop de
ret



yesno_text:   defb "  YES NO",255
space_text:   defb "(FIRE) ",255
clear_text:   defb "        ",255

;clearstatusbaricon
;   push hl
;   push af
;   ; CLEAR STATUS BAR OBJECT AREA
;   ld hl,statusbar_iconpos
;   ld a,&C0
;   call ClearTile
;   ld hl,statusbar_iconpos+4
;   call ClearTile
;   ld hl,statusbar_iconpos+8
;   call ClearTile
;   pop af
;   pop hl
;ret
clearstatusbarinput:
   push hl
   push de
   push bc
   ; CLEAR STATUS BAR OBJECT AREA
   ld hl,space_iconpos
   ld de,clear_text
   call gra_wr_string2
   pop bc
   pop de
   pop hl
ret

waityesno:
   ld de,yesno_text
   ld hl,space_iconpos
   call gra_wr_string2
   ; WAIT FOR PLAYER TO PRESS BUTTON
   call waitoption_yes_no 
   jp clearstatusbarinput
waitspace:
   ld de,space_text
   ld hl,space_iconpos
   call gra_wr_string2
   ; WAIT FOR PLAYER TO PRESS BUTTON
   call waitoption_spacebar
   jp clearstatusbarinput