; CONVERT X / Y COORD TO TILE NUMBER
; INPUTS 
; C = X COORD
; B = Y COORD
; RESULT
; A = TILE NUMBER

convxytotilenum:
  ; CONVERT VERT TILE ROW TO TILE ID
  xor a
  loopyloop6:
    add tilemap_width_tiles
  djnz loopyloop6
  sub tilemap_width_tiles
  add c     ; ADD X COORD
ret

; TILEMAP AND TILE DRAWING CODE
; ESSENTIAL CODE - MUST NOT BE IN RANGE &4000-&7FFF

; REDRAW SCREEN ON TILEMAP CHANGE
check_tilemap:
  call deactivatemcpsdoublebuffer
  call deactivateanimations
  call clearinactivequests             ; CLEAR UNUSED QUEST IDS SO WE CAN CREATE MORE
  call gentilemapa
  call drawtilemap
  call spawnrandommcps
  call markallcharacterspritesredraw
  call printseason                     ; MAKE SURE WE ALWAYS DISPLAY SEASON/DAY WHEN MOVING SCREEN
  ; MARK TILEMAP AS BEING CHANGED - CHANGE CALL FUNCTION IN MAIN LOOP TO NOPs
  xor a
  ld bc,0
  modifytilemapcallfunc:
  ld (tilemapcallfunc-1),a
  ld (tilemapchangedfunc-2),bc
ret

; SELF MODIFY CODE TO INSERT CALL TO REDRAW TILEMAP IN MAIN ROUTINE
marktilemapchanged:
  ld bc,check_tilemap
  ld a,&CD ; CD = CALL
  ld (tilemapcallfunc-1),a
  ld (tilemapchangedfunc-2),bc
ret
; SELF MODIFY CODE TO INSERT CALL TO REDRAW ANIMATIONS IN MAIN ROUTINE
marktileanimactive:
  ld bc,updatetileanims
  ld a,&CD ; CD = CALL
  ld (tileanimcallfunc-1),a
  ld (tileanimchangedfunc-2),bc
ret

;togglemap
  ; CHECK IF WE HAVE MAP
  ;ld a,(viewmap)
  ;cpl               ; INVERT BITS
  ;ld (viewmap),a

  ;or a
;  jr z,clearmaps;marktilemapchanged ; CLEAR SCREEN
;  jp drawmap

;clearmaps:
;  call ClearScreen
;jp drawtilemap

;; based on current tilemap, move to next tilemap up
set_tilemap_view:
  ld c,(ix+4)
  ld b,(ix+5)
  ld (tilemap_cur),bc
  jp marktilemapchanged

tilemap_draw:
  ; CHECK IF DRAWING JUST SEA, IF SO SKIP
  ;ld a,(currscreendata2)
  ;cp 5 ; ALL SEA, SKIP
  ;ret z
  ld hl,0  ;; H = X screen coord of top-left of tilemap
           ;; L = Y screen coord of top-left of tilemap
           ;; width and height of tilemap in tiles
  ld b,tilemap_height_tiles
tilemap_draw_y:
  push hl
  push bc
  ;; calc screen address
  ;; from x,y coord
  call get_scr_addr

  ; UNWRAPPED LOOP
  ld bc,tile_width_bytes ;; increment by width of tile in bytes
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  call tilemap_draw_x
  
  pop bc
  pop hl
  ;; H = x coordinate
  ;; L = y coordinate

  ;; update Y coordinate for next tilemap line
  ld a,l
  add tile_height
  ld l,a
  djnz tilemap_draw_y
ret

drawwater:
  ; CHECK IF WE ARE USING SEA PALETTE, IF SO DON'T DRAW ANYTHING AS WE HAVE ALREADY CLEARED SCREEN TO TRANSPARENT COLOUR 0
  ;ld ix,playerspritedata 
  ld a,(nighttime)
  bit 3,a
  jr nz,skip
  drawbluewater:
  ld a,&0F ; BLUE
  push de
  push hl
  call ClearTile 
  pop hl
  pop de
  jr skip

; DRAW TILE ON SCREEN
; INPUT
; HL = SCREEN ADDRESS
; BC = TILE WIDTH
tilemap_draw_x:
  ;; read tile index
  ld a,(de)
  ; SELF MODIFYING CODE.
  ; IF WE ARE DRAWING SEA, WE WANT TO SKIP DRAWING EMPTY TILES. EMPTY TILE IS 100
  ; IF WE ARE DRAWING LAND, WE WANT TO SKIP DRAWING EMPTY TILES. EMPTY TILE IS 0
  cp 0:emptytileid2 ; LAND = 00, SEA = 100
  jr z,skip ;; SKIP DRAWING IF TILE NUM IS 0 (LAND) OR 100 (SEA)
  cp 100   ; WATER - DRAW WATER TILE MANUALLY - THIS SAVES 64 BYTES
  jr z,drawwater
 
  push af ; STORE TILE ID

  ; CHECK OBJECT TILE MAP TO SEE IF WE NEED TO FLIP SPRITE VERTICALLY
  ; 1   = NORMAL OBJECT
  ; 4   = VERTICALLY FLIPPED OBJECT
  ; 5   = VERTICALLY FLIPPED NON OBSTRUCTIONAL OBJECT
  ; 246 = FLIPPED NON OBSTRUCTING SPRITE

  ld a,e
  push de
  ld d,tilemap2h
  ld e,a
  ld a,(de)
  pop de
  cp 4
  jr z,spriteflippedvert
  cp 246 
  jr z,spriteflippedvert

  pop af ; RESTORE TILE ID

  push hl
  push de
  ld de,tile_ptr_table
  ; FLIP TILE IF IT IS OVER 200
  ; SUBTRACT 200 TO GET TILE GRAPHIC TO FLIP
  sub 201
  jr c,spritenotflipped

  call get_tile_ptr               ;; lookup ptr to tile pixels
  call tile_restore_flip          ;; now draw tile    
  pop de
  pop hl
  jr skip

  spritenotflipped:
  add 200
  call get_tile_ptr               ;; lookup ptr to tile pixels
  call tile_draw     :tiledrawfunction_selfmod             ;; now draw tile  
  pop de
  pop hl
  skip:
  inc e
  ;; HL = screen address
  add hl,bc
ret

  spriteflippedvert:
  pop af ; RESTORE TILE ID
  push hl
  push de
  ld de,tile_ptr_table
  ; FLIP TILE IF IT IS OVER 200
  ; SUBTRACT 200 TO GET TILE GRAPHIC TO FLIP
  sub 201
  jr c,spritenothorizflipped

  call get_tile_ptr               ;; lookup ptr to tile pixels
  call tile_restore_flip_vflip    ;; now draw tile    
  pop de
  pop hl
  jr skip

  spritenothorizflipped:
  add 200
  call get_tile_ptr               ;; lookup ptr to tile pixels
  call tile_restore_vflip         ;; now draw tile  
  pop de
  pop hl
  jr skip



;; IN:
;; A = tile index
;; DE = tile_ptr_table
;; OUT:
;; DE = tile pixel data
get_tile_ptr:
  push hl
  ld l,a
  ld h,0
  add hl,hl
  add hl,de
  ld e,(hl)
  inc hl
  ld d,(hl)
  pop hl
ret

;; From our x,y coordinates generate
;; a screen address for top-left of sprite to be drawn at.

;; IN:
;; H = x byte coord
;; L = y line
;; OUT:
;; HL = screen address
get_scr_addr:
  push bc
  push de
  ld c,h    ; STORE X BYTE

  ld h,0    ; GET MEMORY ADDRESS OF Y LINE
  add hl,hl
  ld de,scr_addr_table
  add hl,de
  ld a,(hl)
  inc hl
  ld h,(hl)
  ld l,a

  ld b,0    ; ADD X BYTE TO Y LINE ADDRESS
  add hl,bc
  pop de
  pop bc
ret

; GRAB FROM SCREEN HL AND STORE IT IN DE BUFFER
tile_grab:
  ld b,tile_height
tile_grab_height:
  push bc
  push hl

  ldi
  ldi
  ldi
  ldi

  pop hl
  call scr_next_line_hl
  pop bc
  djnz tile_grab_height
ret

; GRAB FROM DE BUFFER AND RESTORE TO SCREEN
; INPUTS
; DE = TILE GRAPHIC
; HL = SCREEN LOCATION
tile_restore:
  ld b,tile_height
tile_restore_height:
  push bc
  push hl

  ex de,hl
  ldi
  ldi
  ldi
  ; 2 x NOP IS PLACE HOLDER FOR 4TH PIXEL LDI - 3 PIXELS ARE USED FOR RIGHT STATUS BAR SCROLL IMAGE
  ; THIS IS REPLACED WITH LDI (ED A0) AS SOON AS THE STATUS BAR IS DRAWN
  nop                  
  nop :makerestore3pix 
  ex de,hl

  pop hl
  call scr_next_line_hl
  pop bc
  djnz tile_restore_height
ret

; GRAB FROM DE BUFFER AND RESTORE TO SCREEN UPSIDE DOWN
; INPUTS
; DE = TILE GRAPHIC
; HL = SCREEN LOCATION
tile_restore_vflip:
  ex de,hl
  push bc
  ld bc,60 ; MOVE TO LAST ROW OF PIXELS IN SPRITE DATA
  add hl,bc
  pop bc
  ex de,hl
  ld b,tile_height
tile_restore_height_vflip:
  push bc
  ld bc,mask_table
  push hl
  push de ; STORE POSITION IN SPRITE DATA

  ld a,(de)
  call maketransparent
  inc hl
  inc de
  ld a,(de)
  call maketransparent
  inc hl
  inc de
  ld a,(de)
  call maketransparent
  inc hl
  inc de
  ld a,(de)
  call maketransparent
  inc hl

  pop de  ; RESTORE POSITION IN SPRITE DATA AND MOVE BACK ONE ROW
  dec de
  dec de
  dec de
  dec de

  pop hl
  call scr_next_line_hl
  pop bc
  djnz tile_restore_height_vflip
ret

tile_restore_flip:
  ld b,tile_height
  ; MOVE TO RIGHT SIDE OF SPRITE
  inc hl
  inc hl
  inc hl
tile_restore_height_flip:
  push bc
  ld bc,mask_table
  push hl

  call maketransparentswapped
  dec hl
  inc de
  call maketransparentswapped
  dec hl
  inc de
  call maketransparentswapped
  dec hl
  inc de
  call maketransparentswapped
  inc de

  pop hl
  call scr_next_line_hl
  pop bc
  djnz tile_restore_height_flip
ret

; INPUTS 
; BC = MASK TABLE
; DE = PIXEL DATA
; HL = SCREEN DATA
maketransparentswapped:
  ld a,(de)
  or a             ; DO NOT SWAP IF WE JUST HAVE AN EMPTY PIXEL
  jr z,maketransparent
  push af
  ; SWAP PIXELS IN BYTE
  and %01010101    ; REMOVE LEFT PIXEL 
  sla a            ; SHIFT TO LEFT
  ld c,a           ; BACKUP TO C
  pop af
   
  and %10101010    ; REMOVE RIGHT PIXEL
  srl a            ; SHIFT TO RIGHT
  or c             ; INSERT SHIFTED PIXEL 
  maketransparent:
  ld c,a           ;; C = byte of sprite pixel data/look-up table value
                   ;; BC = address (in look-up table) of mask corresponding to this sprite pixel data
  ld a,(bc)        ;; lookup mask from table
  and (hl)         ;; mask pixels on screen (remove pixels which will be replaced)
  or c             ;; combine with sprite pixel data
  ld (hl),a
ret

tile_restore_flip_vflip:
  ld b,tile_height
  ; MOVE TO END OF SPRITE DATA
  ex de,hl
  push bc
  ld bc,63
  add hl,bc
  pop bc
  ex de,hl
tile_restore_height_flip_vflip:
  push bc
  ld bc,mask_table
  push hl

  call maketransparentswapped
  inc hl
  dec de
  call maketransparentswapped
  inc hl
  dec de
  call maketransparentswapped
  inc hl
  dec de
  call maketransparentswapped
  dec de

  pop hl
  call scr_next_line_hl
  pop bc
  djnz tile_restore_height_flip_vflip
ret

myldi equ &A0ED ; MACHINE CODE FOR LDI COMMAND

; GRAB FROM DE BUFFER AND RESTORE TO SCREEN
tile_restore_scroll:
  ld b,40
  jp tile_restore_height
; GRAB FROM DE BUFFER AND RESTORE TO SCREEN
tile_restore_scroll2:
  ld b,40
  call tile_restore_height
  ; FIX TILE DRAW FUNCTION TO PRINT 4 PIXELS WIDE TILES INSTEAD OF 3 FOR RIGHT HAND STATUS BAR
  ld bc,myldi
  ld (makerestore3pix-2),bc
ret
;set3pixelscrolldraw
;  ld bc,0
;  ld (makerestore3pix-2),bc
;ret

;; TILE DRAW ROUTINE UNWRAPPED. THIS WILL ONLY DRAW
;; SPRITES THAT ARE 8 PIXELS WIDE, BUT IT IS FASTER
;; THAN THE OLD ROUTINE.
;; IN:
;; DE = address of tile pixel data
;; HL = screen address

tile_draw_submerged_vflip:
  ; MOVE TO LAST ROW OF SPRITE DATA
  ex de,hl
  push bc
  ld bc,60
  add hl,bc
  pop bc
  ex de,hl
  
  ld bc,&0050             ; DRAW SUBMERGED
  add hl,bc
  ld b,8

  jp tile_restore_height_vflip

tile_draw_submerged:
  ld bc,&0050             ; DRAW SUBMERGED
  add hl,bc
  ld b,8
  jr tile_draw_height

tile_draw:
  ld b,tile_height
tile_draw_height:
  push bc
  ld bc,mask_table
  push hl

  ld a,(de)  ;; read from pixels
  ; TRANSPARENCY - COLOUR 0
  call maketransparent
  inc hl           ; WAS INC L, BUT DOESN'T WORK OVER 255?
  inc de

  ld a,(de)  ;; read from pixels
  ; TRANSPARENCY - COLOUR 0
  call maketransparent
  inc hl
  inc de

  ld a,(de)  ;; read from pixels
  ; TRANSPARENCY - COLOUR 0
  call maketransparent
  inc hl
  inc de

  ld a,(de)  ;; read from pixels
  ; TRANSPARENCY - COLOUR 0
  call maketransparent
  inc de

  pop hl
  call scr_next_line_hl
  pop bc
  djnz tile_draw_height
ret

tile_draw_flip_submerged:
  ld bc,&0050             ; DRAW SUBMERGED
  add hl,bc
  ld b,8
  jr movetorightsideofsprite ; MOVE TO RIGHT SIDE OF SPRITE AND WORK BACKWARDS

tile_draw_flip:
  ld b,tile_height
  movetorightsideofsprite:
  inc hl ; MOVE TO RIGHT SIDE OF SPRITE AND WORK BACKWARDS
  inc hl
  inc hl

tile_draw_height_flip:
  push bc
  ld bc,mask_table
  push hl

  ; TRANSPARENCY - COLOUR 0
  call maketransparentswapped 
  dec hl ; WAS INC L, BUT DOESN'T WORK OVER 255?
  inc de

  ; TRANSPARENCY - COLOUR 0
  call maketransparentswapped
  dec hl
  inc de

  ; TRANSPARENCY - COLOUR 0
  call maketransparentswapped
  dec hl
  inc de

  ; TRANSPARENCY - COLOUR 0
  call maketransparentswapped
  inc de

  pop hl
  call scr_next_line_hl
  pop bc
  djnz tile_draw_height_flip
ret

;; TILE DRAW ROUTINE UNWRAPPED. THIS WILL ONLY DRAW
;; SPRITES THAT ARE 4 PIXELS WIDE, BUT IT IS FASTER
;; THAN THE OLD ROUTINE.
;; IN:
;; DE = address of tile pixel data
;; HL = screen address
font_draw:
  ld b,5 ; PIXELS HIGH
font_draw_height:
  push bc
  push hl
  ex de,hl
  ldi
  ldi
  ex de,hl
  pop hl
  call scr_next_line_hl
  pop bc
  djnz font_draw_height
ret


; SO BUFFERS DO NOT GET CORRUPTED, WE NEED TO DRAW THE SPRITES FROM 0 TO 7
; AND WHEN WE UPDATE THEM WE NEED TO REDRAW THEM FROM 7 TO 0
; INPUTS
; IX = SPRITE DATA TABLE TO UPDATE
;updatecharactersprites
;  updatecharloop
;  ld a,(ix)
;  or a  ; CHECK IF ACTIVE
;  jr z, nextmcpupdate
;  cp 255; CHECK IF END OF LIST
;  ret z
;  cp 2  ; PLAYER SPRITE - SKIP IT !!! JUST DEACTIVATED, ERASE SPRITE FROM SCREEN
;  jr z,nextmcpupdate

;  ; ONLY REDRAW IF WE HAVE ACTUALLY MOVED
;  ld a,(ix+20)
;  or a 
;  jr z,updatespritepos ; IF WE HAVEN'T MOVED THEN CALL MOVE ROUTINE

;  call updatethissprite
;  ld (ix+20),0  ; CLEAR MOVE MARKER SO WE DON'T REDRAW AGAIN

;  updatespritepos
;  jp getnewspritedirection
 
;  jumpback

;  nextmcpupdate
;    call findnextmcpupdate
;  jp updatecharloop

; INPUT
; IX = SPRITE DEFINITION
grabbgdrawsprite:
  ; DO NOT DRAW IF SPRITE IS NOT IN SCREEN
  ld a,(inbuilding)
  cp (ix+3)
  ret nz
  ld a,(tilemap_cur)
  cp (ix+4)
  ret nz
  ld a,(tilemap_cury)
  cp (ix+5)
  ret nz

  ; GRAB BACKGROUND INTO BUFFER
  ld a,(ix+26) ; GET SPRITE DOUBLE BUFFER ID IMAGE
  call vectorbufferlookup
  ld h,(ix+6) ; GET X COORD
  ld l,(ix+7) ; GET Y COORD

  ; RECORD PREVIOUS SPRITE COORDINATES
  ld (ix+16),h
  ld (ix+17),l
  call get_scr_addr
  push hl ; BACK UP COORDS
  call tile_grab
  set 1,(ix+2) ; RECORD THAT WE STORED DOUBLE BUFFER
  ; IF WE ARE PICKUPABLE OBJECT, DRAW THAT INSTEAD
  ; IF NOT, DRAW ANIMATION IMAGES
  ld a,(ix+18)
  or a
  jr nz,skipanimobject

  ; GET SPRITE IMAGE TO USE FOR ANIMATION
  ; THIS USES A LOOKUP TABLE
  ; A = SPRITE NUMBER
  ld a,(ix+1) ; GET SPRITE IMAGE
  add (ix+19) ; ADD SPRITE ANIMATION COUNTER OFFSET
  call vectorspritelookup

  finishdrawobject:
  ; DRAW SPRITE ON SCREEN
  pop hl ; RESTORE COORDS

  ; CHECK IF SPRITE IS HORIZONTALLY FLIPPED
  bit 2,(ix+2) ; CHECK IF SUBMERGED
  jr z,drawnotsubmerged

  ld a,(ix+13)  
  cp 1
  jr z,drawsubhorizflip
  cp 2
  jr z,drawsubvertflip
drawsubnorm:
  call tile_draw_submerged
  jr finisheddrawingsprite
  
  drawnotsubmerged:
  ld a,(ix+13)  
  or a
  jr z,drawnorm
  cp 1
  jr z,drawhorizflip
  cp 2
  jr z,drawvertflip
drawhorizvertflip:
  call tile_restore_flip_vflip
  jr finisheddrawingsprite
drawhorizflip:
  call tile_draw_flip
  jr finisheddrawingsprite
drawvertflip:
  call tile_restore_vflip
  jr finisheddrawingsprite
drawsubhorizflip:
  call tile_draw_flip_submerged
  jr finisheddrawingsprite
drawsubvertflip:
  call tile_draw_submerged_vflip
  jr finisheddrawingsprite

skipanimobject:
ifdef is128k
  push af
  ; BANK SWITCH SPRITES
  ld a,&C4
  ld b,&7F
  out (c),a
  pop af
endif
ifdef iscart
  call romswitchsprites
endif

  call vectorobjectlookup
  jr finishdrawobject

drawnorm:
  call tile_draw

  finisheddrawingsprite:

; WE MAY HAVE CHANGED TO SPRITE BANK TO DRAW RABBIT MEAT
; SO MAKE SURE WE DEFINITELY HAVE CHANGED BACK
ifdef is128k
  ; BANK SWITCH NORMAL
  ld a,&C0
  ld b,&7F
  out (c),a
endif
ifdef iscart
  call romswitchnormal
endif

  ; CHECK IF WE NEED TO RESTORE TREE TOPS
  ; PLAYER SPACE
  ld d,(ix+6) ; GET X COORD
  ld e,(ix+7) ; GET Y COORD
; INPUTS
; D = X COORD
; E = Y COORD
checkredrawsingletile:
  ; FIND TILE WE ARE OCCUPYING (ADJUST Y COLLISION DETECTION TO HEAD)
  ld a,e
  add 12
  ld e,a
  call convpixeltotiles
  ld hl,tilemap1
  ld l,a
 
  ; CHECK IF IT HOLDS CONTENT
  ; DO THREE TILES, ONE ON EACH SIDE OF SPRITE
  push hl
  call checkifredrawtreetops
  pop hl
  dec l 
  ld a,l  ; MAKE SURE WE DON'T UPDATE PAST TOP LEFT CORNER OF SCREEN
  or a
  ret z
  push hl 
  call checkifredrawtreetops
  pop hl
  inc l
  inc l
  ld a,l  ; MAKE SURE WE DON'T UPDATE PAST BOTTOM RIGHT CORNER OF SCREEN
  cp 201
  ret z

  ; REDRAW SINGLE TILE BELOW PLAYER
  ; INPUTS 
  ; HL = POINTER TO OBJECT TILEMAP TILE
  checkifredrawtreetops:
    ld a,(hl)
    or a
    ret z
  
    ; INPUTS
    ; A  = TILE MAP TILE CONTENT
    ; HL = TILE MAP NUMBER
    redrawsingletile:

ifdef is128k
  push af
  ; BANK SWITCH TILES
  ld a,&C4
  ld b,&7F
  out (c),a
  pop af
endif

ifdef iscart
  call romswitchtiles
endif

    push af ; SAVE TILE CONTENTS DATA
    call gettilepixelpos
    call get_scr_addr
    pop af ; RESTORE TILE CONTENTS DATA
    ld de,tile_ptr_table

    ; FLIP TILE IF IT IS OVER 200
    ; SUBTRACT 200 TO GET TILE GRAPHIC TO FLIP
    sub 201
    jr c,spritenotflipped3
    call get_tile_ptr    ;; lookup ptr to tile pixels
    call tile_draw_flip    ;; now draw tile    

ifdef is128k
  ; BANK SWITCH NORMAL
  ld a,&C0
  ld b,&7F
  out (c),a
endif
ifdef iscart
  call romswitchnormal
endif
    ret

    spritenotflipped3:
    add 200
    call get_tile_ptr ;; lookup ptr to tile pixels
    call tile_draw    ;; now draw tile  

ifdef is128k
  ; BANK SWITCH NORMAL
  ld a,&C0
  ld b,&7F
  out (c),a
endif
ifdef iscart
  call romswitchnormal
endif

    ret

; INPUT 
; A  = TILE MAP TILE CONTENT
; HL = TILE MAP NUMBER

redrawsingletile_notrans:
  push af ; SAVE TILE CONTENTS DATA
  call gettilepixelpos
  call get_scr_addr
  pop af ; RESTORE TILE CONTENTS DATA
  or a ; IF TILE IS EMPTY, JUST CLEAR IT AS WE HAVE NO SPRITE DATA FOR EMPTY
  jp z,ClearTile
  cp 100 ; IF TILE IS EMPTY WATER, JUST CLEAR IT AS WE HAVE NO SPRITE DATA FOR EMPTY
  jp z,drawbluewater ; MAKE SURE WE ACTUALLY DRAW BLUE TO ERASE EXISTING TILE
  ld de,tile_ptr_table

ifdef is128k
  push af
  ; BANK SWITCH TILES
  ld a,&C4
  ld b,&7F
  out (c),a
  pop af
endif

ifdef iscart
  call romswitchtiles
endif

  ; FLIP TILE IF IT IS OVER 200
  ; SUBTRACT 200 TO GET TILE GRAPHIC TO FLIP
  sub 201
  jr c,spritenotflipped4
  call get_tile_ptr    ;; lookup ptr to tile pixels
  call tile_restore_flip    ;; now draw tile    

ifdef is128k
  ; BANK SWITCH NORMAL
  ld a,&C0
  ld b,&7F
  out (c),a
endif
ifdef iscart
  call romswitchnormal
endif

  ret

  spritenotflipped4:
  add 200
  call get_tile_ptr ;; lookup ptr to tile pixels
  call tile_restore    ;; now draw tile  

ifdef is128k
  ; BANK SWITCH NORMAL
  ld a,&C0
  ld b,&7F
  out (c),a
endif
ifdef iscart
  call romswitchnormal
endif

  ret

; INPUT
; A = TILE NUMBER
; OUTPUT
; D = X COORD
; E = Y COORD
convtilenumtocoord:
  ld e,255
  loop1:
    sub tilemap_width_tiles
    inc e
  jr nc,loop1
  add tilemap_width_tiles
  ; GET X TILE POS
  ld d,a
ret

; INPUTS 
; L = TILE NUMBER
; OUTPUT
; H = X BYTE POS
; L = Y LINE POS
gettilepixelpos:
  ; CONVERT TILE NUMBER TO X / Y TILE NUMBER
  ; D = X TILES, E = Y TILES
  ld a,l
  call convtilenumtocoord

  ; D = X TILE NUM
  ; E = Y TILE NUM
  ld h,tiletableyh
  ld l,e
  ld e,(hl)

  ld h,tiletablexh
  ld l,d
  ld d,(hl)

  ex de,hl
jumpback:
ret