; BLOCK ID, SCREEN ID, (LEFT) TILE ID, IN BUILDING, DAMAGE COUNT                            
;treedamagetable
;  defb 0,0,0,0,0  
;  defb 0,0,0,0,0  
;  defb 0,0,0,0,0  
;  defb 0,0,0,0,0  
;  defb 0,0,0,0,0
;  defb 255

; FORCE ALL SPRITES TO DRAW THEIR BUFFER AS WE ARE ABOUT TO MAKE CHANGES TO THE TILES
; NEEDS TO BE DONE IN THE OPPOSITE WAY THEY WERE DRAWN TO PREVENT BUFFER OVERLAP ERRORS
forceredrawallspritesfunc:
  push hl
  pop ix
  jr forceredrawbufferthissprite
forceredrawallsprites:
  push hl
  ld hl,spritetablebackward
  ld bc,forceredrawallspritesfunc
  finishforcedrawallsprites:
  ld (spritefunc-2),bc
  ld b,numsprites
  call scanspritetable
  pop hl
ret

forceredrawallspritesfunc2:
  push hl
  pop ix
  jp grabbgdrawsprite
  ;jp findnextmcpupdate
; FORCE ALL SPRITES TO GRAB BUFFER AND REDRAW THEMSELVES AS WE JUST CHANGED SOME TILES
forceredrawallsprites2:
  push hl
  ld hl,spritetableforward
  ld bc,forceredrawallspritesfunc2
  jr finishforcedrawallsprites

; FORCE CURRENT SPRITE IN IX TO REDRAW BUFFER ERASING IT FROM SCREEN
; INPUTS
; IX = SPRITE TO ERASE
forceredrawbufferthissprite:
  ; RESTORE IF WE HAVE BUFFER
  bit 1,(ix+2)
  ret z
  push hl
  call restoremybuffer
  pop hl
ret

findexistingdamageslot_cf:
  ld a,(inbuilding)
  ld d,a
  ld bc,(currblockid)
  ; FIND EXISTING TREE DAMAGE SLOT
  ld ix,treedamagetable
  treedamageloop2:
    ld a,(ix+0) ; END OF LIST
    cp 255
    jp z,returnfalse2

    cp b ; BLOCK ID
    jr nz,gotonextslot
    ld a,(ix+1)
    cp c ; SCREEN ID
    jr nz,gotonextslot
    ld a,(ix+3)
    cp d ; IN BUILDING
    jr nz,gotonextslot
    ld a,(ix+2)
    cp l ; TILE ID
    jr nz,gotonextslot
    ; RETURN RESULT
    ld a,(ix+4)
    scf
    ret

    gotonextslot:
      call movenextdamageslot
  jr treedamageloop2

createnewdamageslot:
  ; FIND EMPTY TREE DAMAGE SLOT
  ld ix,treedamagetable
  treedamageloop:
    ld a,(ix+0) ; END OF LIST
    inc a;cp 255
    jr z,overwriteexistingslot

    ld a,(ix+4) ; IF DAMAGE IS 0, IT IS EMPTY
    or a
    jr z,foundemptytreedamage

    call movenextdamageslot
  jr treedamageloop

overwriteexistingslot:
  ld ix,treedamagetable
foundemptytreedamage:
  ld bc,(currblockid)
  ld (ix+0),b
  ld (ix+1),c
  ld (ix+2),l  ; TILE ID
  ld a,(inbuilding)
  ld (ix+3),a  ; IN BUILDING ID
  ld a,10
  ld (ix+4),a ; SET MAX DAMAGE COUNT
ret

decexistingdamageslot_cf:
  ld a,(ix+4)
  dec a
  or a                 ; DON'T ALLOW LESS THAN 0
  jp z,cleardamageslot
  ld (ix+4),a
  ret
  cleardamageslot:
  ld (ix+0),0   ; CLEAR DAMAGE SLOT ONCE IT REACHES 0
  xor a         ; THIS FORCES CUT DOWN TREE TO CLEAR ITS DAMAGE, SO WE CAN GROW A NEW TREE
ret

movenextdamageslot:
  push bc
  ld bc,5
  add ix,bc
  pop bc
ret

; IF WE HIT A HIDDEN ENTRANCE WITH A PICK AXE
; E.G. ROUND TOWERS
; HL = OBJECT TILE WE HIT
pickhitrockentrance:
  call deactivateandclearsprite
  ; CHECK TO SEE IF WALL HAS DAMAGE ALREADY
  call advancedamage
  or a
  ; IF WE REACHED COMPLETE DAMAGE, ERASE TREE
  jp nz,axesound

  ld a,124                              ; SET SPAWNED OBJECT AS ENTRANCE TILE
  ld (spawnedobject_selfmod-1),a
  ld a,s_dungeonentrance                ; SET SPAWNED OBJECT AS ENTRANCE IN SPRITE LIST
  ld (spawnedobject_selfmod2-1),a
  ld a,247                              ; MAKE OBJECT STONE ROOM ENTRANCE
  ld (spawnedobjecttype_selfmod-1),a 
  jr cleartreeside

; IF WE HIT A ROCK WITH A PICK AXE
; HL = OBJECT TILE WE HIT
pickhitrock:
  call deactivateandclearsprite
  ; CHECK TO SEE IF ROCK HAS DAMAGE
  call advancedamage
  or a
  ; IF WE REACHED COMPLETE DAMAGE, ERASE TREE
  jp nz,axesound

  xor a                                  ; SET SPAWNED OBJECT AS EMPTY TILE
  ld (spawnedobject_selfmod-1),a
  ld a,s_dirt                            ; SET SPAWNED OBJECT AS DIRT IN SPRITE LIST
  ld (spawnedobject_selfmod2-1),a
  ld a,254                               ; MAKE OBJECT TRANSVERSABLE
  ld (spawnedobjecttype_selfmod-1),a
  jr cleartreeside

; IF WE HIT WOOD WITH AN ARROW / AXE
; HL = OBJECT TILE WE HIT
arrowhittreeright:
  dec hl                           ; CLEAR LEFT SIDE FIRST
arrowhittreeleft:
  call deactivateandclearsprite
  ; CHECK TO SEE IF TREE HAS DAMAGE
  call advancedamage
  or a
  ; IF WE REACHED COMPLETE DAMAGE, ERASE TREE
  jp nz,axesound
  ld a,62                          ; SET SPAWNED OBJECT AS LUMBER
  ld (spawnedobject_selfmod-1),a
  ld a,s_lumber
  ld (spawnedobject_selfmod2-1),a
  ld a,250                         ; MAKE OBJECT PICKABLE
  ld (spawnedobjecttype_selfmod-1),a

cleartreerock:
  ; ERASE TREE / ROCK
  call cleartreeside               ; CLEAR LEFT SIDE
  inc hl                           ; CLEAR RIGHT SIDE - BELOW

; CLEAR SIDE OF TRUNK AND BRANCHES OF TREE
; INPUTS
; HL = TILEMAP LOCATION OF OBJECT MAP
cleartreeside:
  ; CLEAR SPRITES BY FORCING ALL SPRITES TO DRAW THEIR BUFFER
  ; NEEDS TO BE DONE IN REVERSE ORDER SO BUFFER OVERLAPS DON'T CORRUPT SCREEN
  ; WE NEED TO DO THIS BEFORE CLEARING TREES AS SPRITES MAY BE IN VICINITY AND
  ; THEIR BUFFERS WILL BECOME INCORRECT
  call forceredrawallsprites

  ; CLEAR PLAYER SPRITE BUFFER FORCE TO REDRAW
  ; IN CASE WE WERE BEHIND TREE AND PLAYER SPRITE IS TRASHED
  push hl

  ; CLEAR OBJECT TILE MAP - MAKE PICKABLE OBJECT
  ld (hl),250:spawnedobjecttype_selfmod

  ; MOVE TO GRAPHIC TILE MAP - MAKE LUMBER 
  ld h,tilemap0h           
  ld a,62:spawnedobject_selfmod
  ld (hl),a     
  push hl
  call redrawsingletile_notrans  ; REDRAW EMPTY TILE
  pop hl

  ; REDRAW GROUND TILE BEHIND BRANCHES
  ld a,l
  sub tilemap_width_tiles
  ld l,a
  ld a,(hl)
  push hl
  call redrawsingletile_notrans  ; REDRAW EMPTY TILE
  pop hl

  ; MOVE TO UPPER LEVEL GRAPHIC TILE MAP  
  ; REDRAW ANY UPPER LEVEL TILE OBSCURING GROUND TILE
  ld h,tilemap1h    ;call movetotilemap1
  ; CLEAR BRANCHES SO THEY DON'T REDRAW
  ld (hl),0

  ; FORCE ALL SPRITES TO REDRAW AND GET BUFFERS AS WE HAVE FINISHED CHANGING BACKGROUND TILES
  call forceredrawallsprites2

  ld a,l
  add tilemap_width_tiles
  ld l,a
  ; REDRAW ANY BRANCHES THAT MAY BE OBSCURING CLEARED LOWER LEVEL TILE
  ld a,(hl)
  call checkifredrawtreetops  

  pop hl

  ; ADD A PICKABLE OBJECT TO THE FIXED QUEST SPRITE LIST
  ; THIS ENSURES LUMBER DOESN'T DISAPPEAR WHEN YOU MOVE SCREEN
  ; INPUTS
  ; DE = SPRITE DATA

  ;  defb 0               ; ACTIVE   
  ;  defb 96              ; X MAP SCREEN
  ;  defb 25              ; Y MAP SCREEN
  ;  defb 11              ; IN BUILDING
  ;  defb 65              ; X TILE LOCATION
  ;  defw s_moneybag      ; PTR TO SPRITE DATA


; INPUTS
; C  = X MAP SCREEN
; B  = Y MAP SCREEN
; A  = IN BUILDING
; L  = TILE LOCATION
; D  = PTR TO SPRITE DATA

  ld d,s_lumber:spawnedobject_selfmod2
  addfixedquestsprite:
  ld iy,quests_fixed_sprites
  findemptyfixedquestspriteloop:
    ld a,(iy+0)
    cp 255
    ret z   ; NO SPACES!
    or a
    jr z,foundemptyfixedquestsprite
   
    call movenextfixedspriteblock
  jr findemptyfixedquestspriteloop
ret
foundemptyfixedquestsprite:
  ld (iy+0),1       ; ACTIVE
  ld bc,(tilemap_cur)
  ld (iy+1),c       ; X MAP SCREEN
  ld (iy+2),b       ; Y MAP SCREEN
  ld a,(inbuilding)
  ld (iy+3),a       ; IN BUILDING
  ld (iy+4),l       ; X TILE LOCATION
  ;ld (iy+5),e       ; PTR TO SPRITE DATA
  ld (iy+6),d       ; PTR TO SPRITE DATA
ret