; FOR GENERATING CLIMATES
; WORLD MAP DIVIDED UP INTO 10x10 GRID
; EACH NUMBER IS A ZONE NUMBER FROM ABOVE LIST
;zonemap
;  defb 1,  0,  0,  0,  0,  2, 10, 10,  2,  2  ; 000
;  defb 0,  6,  6,  4,  4,  2,  2, 10,  2,  2  ; 010
;  defb 0,  6,  6,  4,  4,  9,  2,  2,  2,  2  ; 020
;  defb 0,  0,  0,  4,  4, 11,  9,  2,  2,  2  ; 030
;  defb 7,  7,  7,  4,  9, 11,  9,  2,  2,  2  ; 040
;  defb 7,  7,  7,  7, 12, 13,  9,  1,  5,  0  ; 050
;  defb 0,  7,  7,  7,  1,  1,  1,  1,  5,  0  ; 060
;  defb 8,  8,  1,  1,  1,  1,  1,  1,  5,  0  ; 070
;  defb 8,  8,  5,  5,  5,  5,  5,  5,  5,  0  ; 080
;  defb 0,  0,  0,  0,  0,  0,  0,  0,  0,  0  ; 090

dirtbyzone:
  defw donormalclimate    ;  0 PLAINS
  defw donormalclimate    ;  1 PRAIRIE
  defw donormalclimate    ;  2 FOREST
  defw donormalclimate    ;  3 KNIGHTS
  defw dowesternclimate   ;  4 WESTERN COWBOY
  defw donormalclimate    ;  5 SEA
  defw donormalclimate    ;  6 TROPICAL
  defw dowinterclimate    ;  7 WINTER
  defw donormalclimate    ;  8 AUTUMN
  defw dowesternclimate   ;  9 WESTERN INDIAN
  defw donormalclimate    ; 10 FOREST MOUNTAIN
  defw dowesternclimate   ; 11 WESTERN MOUNT INDIAN
  defw dowesternclimate   ; 12 WESTERN TROPICAL
  defw dowesternclimate   ; 13 WESTERN TROPICAL MOUNTAIN

zone_empty                   equ 0
zone_forest                  equ 1
zone_indian                  equ 2
zone_knights                 equ 3
zone_western                 equ 4
zone_tropical                equ 5
zone_sea                     equ 6 ; TROPICAL
zone_winter                  equ 7
zone_autumn                  equ 8
zone_westernindian           equ 9
zone_forestmountain          equ 10
zone_westernmountain         equ 11
zone_westerntropical         equ 12
zone_westerntropicalmountain equ 13

zonemap:
  defb  8,  8,  0,  0,  0,  0,  0,  0,  0,  0  ; 000
  defb  8,  8,  0,  0,  6,  6,  6,  0,  1,  1  ; 010
  defb  4,  4,  4,  4,  6,  6,  1,  2,  1,  1  ; 020
  defb  4, 11, 11,  4,  0,  0, 10, 10,  2,  2  ; 030
  defb  4, 11, 13,  6,  0, 10,  1,  1,  1,  1  ; 040
  defb  4, 11, 12, 12,  9,  0,  1,  1,  1,  1  ; 050
  defb  4,  4,  4,  4,  4,  4,  3,  3,  3,  2  ; 060
  defb  4,  4, 11, 11,  4,  4, 10,  3,  3,  2  ; 070
  defb  4,  4,  4,  4,  4,  3, 10, 10,  7,  7  ; 080
  defb  0,  0,  4,  0,  3, 10,  7,  7,  7,  7  ; 090

; INDEXED ON WORLD MAP BLOCK ID
buildseadatatable:
  defw seamapsea                ; 0
  defw seamapleftland           ; 1
  defw seamaptopland            ; 2
  defw seamaprightland          ; 3
  defw seamapbottomland         ; 4
  defw seamaptopleftland        ; 5
  defw seamaptopleftsea         ; 6
  defw seamaptoprightland       ; 7
  defw seamaptoprightsea        ; 8
  defw seamapbottomleftland     ; 9
  defw seamapbottomleftsea      ; 10
  defw seamapbottomrightland    ; 11
  defw seamapbottomrightsea     ; 12
  defw seamapland               ; 13
  defw seamaptopleftriver       ; 14
  defw seamapbottomleftriver    ; 15
  defw largeisland              ; 16
  defw bloodylake               ; 17

; FOR GENERATING ISLANDS
;align 256
;gamemap
;      ;000 010 020 030 040 050 060 070 080 090
;  defb  0,  0,  0,  0,  0,  6,  4,  4,  8,  0 ; 000
;  defb  0, 14,  8,  0,  0,  10, 7, 13,  9,  8 ; 010
;  defb  0, 15, 12,  0,  6,  8,  10, 2, 16, 12 ; 020
;  defb  0,  0,  0,  6, 11,  1,  0,  6, 17,  8 ; 030
;  defb 14,  4,  8, 10,  7,  9,  8, 10,  2, 12 ; 040
;  defb 10,  7,  9,  8, 10,  2,  12, 0,  0,  0 ; 050
;  defb  0, 10,  2, 12,  0,  0,  0,  0,  0,  0 ; 060
;  defb  6,  8,  0,  0,  0,  0,  0,  0,  0,  0 ; 070
;  defb 10, 12,  0,  0,  0,  0,  0,  0,  0,  0 ; 080
;  defb  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ; 090
gamemap:
  defb  6,  8,  0,  0,  0,  0,  0,  0,  0,  0   ; 000
  defb 10, 12,  0,  0, 14,  8,  0,  0,  6,  8   ; 010
  defb 14,  4,  4,  8, 15, 12,  6,  4, 11,  1   ; 020
  defb 15,  7,  5, 12,  0,  0,  3, 13, 13,  1   ; 030
  defb  6, 11,  1, 16,  0, 16,  3,  5,  7,  1   ; 040
  defb  3, 17,  9,  4,  8,  0, 10, 12, 10, 12   ; 050
  defb 10,  7, 13, 13,  9,  8,  6,  4,  8,  0   ; 060
  defb 14, 11,  5,  7,  5, 12,  3, 13,  9,  8   ; 070
  defb 15,  2, 12, 10, 12,  6, 11, 13, 13,  1   ; 080
  defb  0,  0, 16,  0,  0,  10,  2, 2,  2, 12   ; 090

randomtownbyzone:
  defb b_nothing               ;  0 EMPTY SEA
  defb b_randomtownplains      ;  1 PLAINS
  defb b_randomtownindian      ;  2 INDIAN PRAIRIE
  defb b_randomtownknights     ;  3 FOREST
  defb b_randomtownwestern     ;  4 WESTERN COWBOY
  defb b_nothing               ;  5 SEA
  defb b_randomtownforest      ;  6 TROPICAL
  defb b_randomtownknights     ;  7 WINTER
  defb b_randomtownplains      ;  8 AUTUMN
  defb b_randomtownindian      ;  9 WESTERN INDIAN
  defb b_randomtownforest      ; 10 FOREST MOUNTAIN
  defb b_randomtownindian      ; 11 MOUNTAIN WESTERN INDIAN
  defb b_randomtownindian      ; 12 WESTERN TROPICAL INDIAN
  defb b_randomtownindian      ; 13 WESTERN TROPICAL MOUNTAIN INDIAN

zone_transp_col:
  ; ZONE ID, DAY COL, NIGHT COL
  ; DAY COL = LEFT 4 BITS, NIGHT COL = RIGHT 4 BITS
  defb %10010000;9,  0     ; 0 zone_empty,PLAINS - GREEN
  defb %10010000;9,  0     ; 1 zone_forest,FOREST - GREEN
  defb %10010000;9,  0     ; 2 zone_indian,INDIAN - GREEN
  defb %10010000;9,  0     ; 3 zone_knights,KNIGHTS - GREEN
  defb %11110000;15, 0     ; 4 zone_western,WESTERN - ORANGE
  defb %10010000;9,  0     ; 5 zone_tropical,SEA - MAUVE
  defb %10010000;9,  0     ; 6 zone_sea,SEA - BLUE
  defb %10010000;9,  0     ; 7 zone_sea,WINTER - BLUE
  defb %11110000;15, 0     ; 8 zone_autumn,AUTUMN - YELLOW
  defb %11110000;15, 0     ; 9 zone_westernindian,WESTERN - ORANGE
  defb %10010000;9,  0     ; 10 zone_forestmountain,FOREST - GREEN
  defb %11110000;15, 0     ; 11 zone_westernmountainindian,WESTERN - ORANGE
  defb %11110000;15, 0     ; 12 zone_westerntropical,WESTERN - ORANGE
  defb %11110000;15, 0     ; 13 zone_westerntropicalmountain,WESTERN - ORANGE

;checkpixelcol defw 0
    
changecolonesprite:
  ld b,64 ; BYTES IN SPRITE/S * NUM OF SPRITES TO RECOLOUR
  snowloop:
    ld a,(hl)
    cp d         
    jr nz,nochangepixelcol
    ld (hl),e     
    nochangepixelcol:
    inc hl
  djnz snowloop
ret


; WE DON'T KNOW WHICH FUNCTION THIS IS BEING CALLED FROM, SO IT IS UP TO THE CALLING FUNCTION
; TO BANKSWITCH BACK TO WHATEVER BANK WAS BEING USED AFTER CHECKING CLIMATE
; I.E., ROOM GENERATION (SPRITE BANK), OR QUEST (NORMAL BANK)
checkscreenzoneclimate:
  ; CHECK IF WE HAVE MOVED SCREEN ZONES
  ld a,(currblockid)
  ld hl,lastblockid
  cp (hl)
  ret z
  ld (lastblockid),a
  call printzonedesc
  call genlocalgamemaps ; PSEUDO RANDOM GENERATE LOCAL MAP SINCE WE HAVE MOVED BLOCKS
  call resetpseudorandom

  ; INPUTS 
  checkclimate:
ifdef is128k
  ; BANK SWITCH TILES
  ld a,&C4
  ld b,&7F
  out (c),a
endif
ifdef iscart
  ret
endif

  ld a,(currzonedata)
  ld hl,dirtbyzone
  jp vectortablelaunchcode

  donormalclimate:
    call createmygrass
    jp makeallnotsnow 

  dowesternclimate:
    call createmydirt
    jp makeallnotsnow

  dowinterclimate:
    call createmygrass
    jp makeallsnow

; INSERT NON ESSENTIAL SPRITES INTO MAP
; INDEXED BY ZONE MAP ID VALUE
landscapetable:
  defw jumpbackscreenfoliagey ;  0 PLAINS
  defw domyprairie            ;  1 PRAIRIE
  defw domymountain           ;  2 MOUNTAIN
  defw domyforest             ;  3 KNIGHTS IN FOREST
  defw domywestern            ;  4 WESTERN COWBOY
  defw domylake               ;  5 SEA
  defw domytropical           ;  6 TROPICAL
  defw domyforest             ;  7 WINTER
  defw jumpbackscreenfoliagey ;  8 AUTUMN
  defw domywestern            ;  9 WESTERN INDIAN
  defw domyforestmountain     ; 10 FOREST MOUNTAIN
  defw domywesternmountain    ; 11 WESTERN MOUNTAIN INDIAN
  defw domytropical           ; 12 WESTERN TROPICAL INDIAN
  defw domytropicalmountain   ; 13 WESTERN TROPICAL MOUNTAIN

; INDEXED BY ZONE MAP ID VALUE
; INSERT NON ESSENTIAL GRASS INTO MAP FIRST
landscapetable3:
  defw dograss                 ;  0 plains
  defw dograssflowers          ;  1 prairie
  defw dograssflowers          ;  2 forest
  defw dograssflowers          ;  3 knights
  defw dograsswestern          ;  4 western cowboy - cow skulls
  defw dograss                 ;  5 sea
  defw dograss                 ;  6 tropical
  defw dograss                 ;  7 winter
  defw dograssflowers          ;  8 autumn
  defw dograsswesternnoflowers ;  9 western indian - cactus
  defw dograss                 ; 10 forest mountain
  defw dograsswestern          ; 11 mountain western indian - skulls
  defw dograsswesternnoflowers ; 12 western tropical - cactus
  defw dograsswesternnoflowers ; 13 western tropical mountain - cactus

; DEFAULT FOREST TREES INDEXED BY ZONE ID
tabletrees:
  defb s_bigtree     ;  0 PLAINS
  defb s_bigtree     ;  1 PRAIRIE
  defb s_pinetree    ;  2 FOREST
  defb s_bigtree     ;  3 KNIGHTS
  defb s_bigcactus   ;  4 WESTERN COWBOY
  defb s_bigtree     ;  5 SEA
  defb s_palm        ;  6 TROPICAL
  defb s_bigtree     ;  7 WINTER
  defb s_bigtreebare ;  8 AUTUMN
  defb s_bigcactus   ;  9 WESTERN INDIAN
  defb s_pinetree    ; 10 FOREST MOUNTAIN
  defb s_bigcactus   ; 11 WESTERN MOUNT INDIAN
  defb s_palm        ; 12 WESTERN TROPICAL
  defb s_palm        ; 13 WESTERN TROPICAL MOUNTAIN

; DEFAULT FOREST TREES INDEXED BY ZONE ID
tablehedges:
  defb s_hedge        ;  0 PLAINS
  defb s_hedge        ;  1 PRAIRIE
  defb s_hedge        ;  2 FOREST
  defb s_hedge        ;  3 KNIGHTS
  defb s_deadhedge    ;  4 WESTERN COWBOY
  defb s_hedge        ;  5 SEA
  defb s_hedge        ;  6 TROPICAL
  defb s_hedge        ;  7 WINTER
  defb s_deadhedge    ;  8 AUTUMN
  defb s_deadhedge    ;  9 WESTERN INDIAN
  defb s_hedge        ; 10 FOREST MOUNTAIN
  defb s_deadhedge    ; 11 WESTERN MOUNT INDIAN
  defb s_hedge        ; 12 WESTERN TROPICAL
  defb s_hedge        ; 13 WESTERN TROPICAL MOUNTAIN

; TRADE SPEECHES BY ZONE - ALLOWS THE USE OF ACCENTS FOR TRADE TALK
; 3 = QUEST ID FOR INDIAN TRADE
; 4 = QUEST ID FOR COWBOY TRADE
; 5 = QUEST ID FOR VIKING TRADE
tradespeechesbyzone:
  defb 5 ;zone_empty                   equ 0
  defb 5 ;zone_forest                  equ 1
  defb 3 ;zone_indian                  equ 2
  defb 5 ;zone_knights                 equ 3
  defb 4 ;zone_western                 equ 4
  defb 5 ;zone_tropical                equ 5
  defb 5 ;zone_sea                     equ 6 ; TROPICAL
  defb 5 ;zone_winter                  equ 7
  defb 5 ;zone_autumn                  equ 8
  defb 3 ;zone_westernindian           equ 9
  defb 4 ;zone_forestmountain          equ 10
  defb 3 ;zone_westernmountain         equ 11
  defb 4 ;zone_westerntropical         equ 12
  defb 4 ;zone_westerntropicalmountain equ 13

; RANDOM CHARACTERS BY ZONE
randcharbyzone:
  defw loadrandomforestsprite   ;  0 PLAINS
  defw loadrandomforestsprite   ;  1 PRAIRIE
  defw loadrandomloghousesprite ;  2 FOREST
  defw loadrandomknightsprite   ;  3 KNIGHTS
  defw loadrandomforestsprite   ;  4 WESTERN COWBOY
  defw loadrandomindiansprite   ;  5 SEA
  defw loadrandomindiansprite   ;  6 TROPICAL
  defw loadrandomforestsprite   ;  7 WINTER
  defw loadrandomforestsprite   ;  8 AUTUMN
  defw loadrandomindiansprite   ;  9 WESTERN INDIAN
  defw loadrandomloghousesprite ; 10 FOREST MOUNTAIN
  defw loadrandomindiansprite   ; 11 WESTERN MOUNTAIN
  defw loadrandomindiansprite   ; 12 WESTERN TROPICAL
  defw loadrandomindiansprite   ; 13 WESTERN TROPICAL MOUNTAIN


; ZONE DESCRIPTIONS
; X, Y, STR PTR
roomdescriptiontable:
  defb 1,1
  defw str_homesweethome
  defb 2,1
  defw str_abandonedmine
  defb 75,76
  defw str_abbey
  defb 255

; ZONE DESCRIPTIONS
; ZONE ID, NAME PTR
zonedescriptiontable:
  defb 0
  defw str_lonelyislands
  defb 16
  defw str_palmislands
  defb 19
  defw str_kingscape
  defb 21
  defw str_hiddenbay
  defb 25
  defw str_bluecape
  defb 41
  defw str_monumentvalley
  defb 43
  defw str_emeraldislands
  defb 46
  defw str_midlandport
  defb 48
  defw str_newportbay
  defb 51
  defw str_greatlakes
  defb 52
  defw str_monkeysbay
  defb 54
  defw str_turtlescape
  defb 61
  defw str_buccaneersbay
  defb 62
  defw str_shadowmountains
  defb 64
  defw str_greenbay
  defb 72
  defw str_bayoffogs
  defb 74
  defw str_whalesbay
  defb 77
  defw str_sherwoodforest
  defb 88
  defw str_goldenmountains
  defb 92
  defw str_snakeisland
  defb 255

; INPUT
; A = CURRENT ZONE ID
printzonedesc:
  ld b,a ; BACKUP ZONE ID
  ld hl,zonedescriptiontable
  printzonedescloop:
    ld a,(hl)
    cp 255
    ret z
    inc hl
    cp b
    jr z,printzone
    ; MOVE NEXT ZONE DESCRIPTION
    inc hl
    inc hl
  jr printzonedescloop

  printzone:
  ld e,(hl)
  inc hl
  ld d,(hl)
  ld hl,str_nowentering
  jp statusbarprintparagraphnoscroll

; INPUT
; A = CURRENT ZONE ID
printroomdesc:
  ld bc,(tilemap_cur)
  ld hl,roomdescriptiontable
  printroomdescloop:
    ld a,(hl)
    cp 255               ; X
    ret z
    
    cp c
    jr nz,movenextroom
    inc hl           
    ld a,(hl)            ; Y
    cp b
    jr nz,movenextroom2
    inc hl
    jr printroom
    
    ; MOVE NEXT ZONE DESCRIPTION
    movenextroom:
    inc hl
    movenextroom2:
    inc hl
    inc hl
    inc hl
  jr printroomdescloop

  printroom:
  ld a,(hl)
  inc hl
  ld h,(hl)
  ld l,a
  jp statusbarprintparagraphnoscroll

    